/*!
 * @certifaction/verification-vue-component 3.2.2
 *
 * @link https://certifaction.com
 * @source https://github.com/certifaction/verification/tree/master/packages/verification-vue-component
 * @copyright (c) 2019-2021 Certifaction AG
 * @license MIT
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var Vue = require('vue');
var VueScrollTo = require('vue-scrollto');
var verificationCore = require('@certifaction/verification-core');
var js = require('@mdi/js');
var axios = require('axios');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);
var VueScrollTo__default = /*#__PURE__*/_interopDefaultLegacy(VueScrollTo);
var axios__default = /*#__PURE__*/_interopDefaultLegacy(axios);

var i18nWrapperMixin = {
  methods: {
    _$t: function _$t(key) {
      if (typeof this.$t === 'function') {
        for (var _len = arguments.length, values = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          values[_key - 1] = arguments[_key];
        }

        return this.$t.apply(this, [key].concat(values));
      }

      return key;
    },
    _$tc: function _$tc(key, choice) {
      if (typeof this.$tc === 'function') {
        for (var _len2 = arguments.length, values = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
          values[_key2 - 2] = arguments[_key2];
        }

        return this.$tc.apply(this, [key, choice].concat(values));
      }

      return key;
    },
    _$te: function _$te(key, locale) {
      if (typeof this.$te === 'function') {
        return this.$te(key, locale);
      }

      return false;
    },
    _$d: function _$d(value) {
      if (typeof this.$d === 'function') {
        for (var _len3 = arguments.length, args = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
          args[_key3 - 1] = arguments[_key3];
        }

        return this.$d.apply(this, [value].concat(args));
      }

      return false;
    },
    _$n: function _$n(value) {
      if (typeof this.$n === 'function') {
        for (var _len4 = arguments.length, args = new Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
          args[_key4 - 1] = arguments[_key4];
        }

        return this.$n.apply(this, [value].concat(args));
      }

      return false;
    }
  }
};

//
//
//
//
//
//

var script = {
    name: 'MDIcon',
    props: {
        icon: {
            type: String,
            required: true
        }
    }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
  if (typeof shadowMode !== 'boolean') {
    createInjectorSSR = createInjector;
    createInjector = shadowMode;
    shadowMode = false;
  }

  var options = typeof script === 'function' ? script.options : script;

  if (template && template.render) {
    options.render = template.render;
    options.staticRenderFns = template.staticRenderFns;
    options._compiled = true;

    if (isFunctionalTemplate) {
      options.functional = true;
    }
  }

  if (scopeId) {
    options._scopeId = scopeId;
  }

  var hook;

  if (moduleIdentifier) {
    hook = function hook(context) {
      context = context || this.$vnode && this.$vnode.ssrContext || this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;

      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__;
      }

      if (style) {
        style.call(this, createInjectorSSR(context));
      }

      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };

    options._ssrRegister = hook;
  } else if (style) {
    hook = shadowMode ? function (context) {
      style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
    } : function (context) {
      style.call(this, createInjector(context));
    };
  }

  if (hook) {
    if (options.functional) {
      var originalRender = options.render;

      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }

  return script;
}

/* script */
const __vue_script__ = script;

/* template */
var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('svg',{staticClass:"md-icon",attrs:{"viewBox":"0 0 24 24"}},[_c('path',{attrs:{"fill":"currentColor","d":_vm.icon}})])};
var __vue_staticRenderFns__ = [];

  /* style */
  const __vue_inject_styles__ = undefined;
  /* scoped */
  const __vue_scope_id__ = undefined;
  /* module identifier */
  const __vue_module_identifier__ = undefined;
  /* functional template */
  const __vue_is_functional_template__ = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__ = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$1 = {
    name: 'VerificationDemo',
    mixins: [
        i18nWrapperMixin
    ],
    components: {
        MDIcon: __vue_component__
    },
    data() {
        return {
            mdiAlertCircle: js.mdiAlertCircle,
            mdiShield: js.mdiShield,
            mdiShieldCheck: js.mdiShieldCheck
        }
    },
    methods: {
        randomLineClass() {
            return (Math.random() > 0.5) ? 'line-long' : 'line-short'
        }
    }
};

/* script */
const __vue_script__$1 = script$1;

/* template */
var __vue_render__$1 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"verification-demo"},[_c('div',{staticClass:"sample-docs"},[_c('h3',[_vm._v(_vm._s(_vm._$t('verification.demo.title')))]),_vm._v(" "),_c('span',{staticClass:"click-to-verify"},[_vm._v(_vm._s(_vm._$t('verification.demo.clickToVerify')))]),_vm._v(" "),_c('div',{staticClass:"docs"},[_c('div',{staticClass:"paperbox"},[_c('div',{directives:[{name:"tooltip",rawName:"v-tooltip.top",value:(_vm._$t('verification.demo.notFound.tooltip')),expression:"_$t('verification.demo.notFound.tooltip')",modifiers:{"top":true}}],staticClass:"paper paper-not-found",attrs:{"draggable":""},on:{"click":function($event){return _vm.$emit('verify-demo', 'notFound')},"dragstart":function($event){return _vm.$emit('dragging-demo-doc', 'notFound')},"dragend":function($event){return _vm.$emit('dragging-demo-doc')}}},[_c('MDIcon',{attrs:{"icon":_vm.mdiAlertCircle}}),_vm._v(" "),_c('div',{staticClass:"lines"},_vm._l((4),function(n){return _c('div',{key:n,class:_vm.randomLineClass()})}),0)],1),_vm._v(" "),_c('div',{directives:[{name:"tooltip",rawName:"v-tooltip.top",value:(_vm._$t('verification.demo.technicalProblem.tooltip')),expression:"_$t('verification.demo.technicalProblem.tooltip')",modifiers:{"top":true}}],staticClass:"paper paper-technical-problem",attrs:{"draggable":""},on:{"click":function($event){return _vm.$emit('verify-demo', 'technicalProblem')},"dragstart":function($event){return _vm.$emit('dragging-demo-doc', 'technicalProblem')},"dragend":function($event){return _vm.$emit('dragging-demo-doc')}}},[_c('MDIcon',{attrs:{"icon":_vm.mdiAlertCircle}}),_vm._v(" "),_c('div',{staticClass:"lines"},_vm._l((4),function(n){return _c('div',{key:n,class:_vm.randomLineClass()})}),0)],1),_vm._v(" "),_c('div',{directives:[{name:"tooltip",rawName:"v-tooltip.top",value:(_vm._$t('verification.demo.verifiedProcessing.tooltip')),expression:"_$t('verification.demo.verifiedProcessing.tooltip')",modifiers:{"top":true}}],staticClass:"paper paper-verified-processing",attrs:{"draggable":""},on:{"click":function($event){return _vm.$emit('verify-demo', 'verifiedProcessing')},"dragstart":function($event){return _vm.$emit('dragging-demo-doc', 'verifiedProcessing')},"dragend":function($event){return _vm.$emit('dragging-demo-doc')}}},[_c('MDIcon',{attrs:{"icon":_vm.mdiShield}}),_vm._v(" "),_c('div',{staticClass:"lines"},_vm._l((4),function(n){return _c('div',{key:n,class:_vm.randomLineClass()})}),0)],1),_vm._v(" "),_c('div',{directives:[{name:"tooltip",rawName:"v-tooltip.top",value:(_vm._$t('verification.demo.verified.tooltip')),expression:"_$t('verification.demo.verified.tooltip')",modifiers:{"top":true}}],staticClass:"paper paper-verified",attrs:{"draggable":""},on:{"click":function($event){return _vm.$emit('verify-demo', 'verified')},"dragstart":function($event){return _vm.$emit('dragging-demo-doc', 'verified')},"dragend":function($event){return _vm.$emit('dragging-demo-doc')}}},[_c('MDIcon',{attrs:{"icon":_vm.mdiShieldCheck}}),_vm._v(" "),_c('div',{staticClass:"lines"},_vm._l((4),function(n){return _c('div',{key:n,class:_vm.randomLineClass()})}),0)],1),_vm._v(" "),_c('div',{directives:[{name:"tooltip",rawName:"v-tooltip.top",value:(_vm._$t('verification.demo.verifiedSelfDeclared.tooltip')),expression:"_$t('verification.demo.verifiedSelfDeclared.tooltip')",modifiers:{"top":true}}],staticClass:"paper paper-verified-self-declared",attrs:{"draggable":""},on:{"click":function($event){return _vm.$emit('verify-demo', 'verifiedSelfDeclared')},"dragstart":function($event){return _vm.$emit('dragging-demo-doc', 'verifiedSelfDeclared')},"dragend":function($event){return _vm.$emit('dragging-demo-doc')}}},[_c('MDIcon',{attrs:{"icon":_vm.mdiShieldCheck}}),_vm._v(" "),_c('div',{staticClass:"lines"},_vm._l((4),function(n){return _c('div',{key:n,class:_vm.randomLineClass()})}),0)],1),_vm._v(" "),_c('div',{directives:[{name:"tooltip",rawName:"v-tooltip.top",value:(_vm._$t('verification.demo.revokedVerified.tooltip')),expression:"_$t('verification.demo.revokedVerified.tooltip')",modifiers:{"top":true}}],staticClass:"paper paper-revoked-verified",attrs:{"draggable":""},on:{"click":function($event){return _vm.$emit('verify-demo', 'revokedVerified')},"dragstart":function($event){return _vm.$emit('dragging-demo-doc', 'revokedVerified')},"dragend":function($event){return _vm.$emit('dragging-demo-doc')}}},[_c('MDIcon',{attrs:{"icon":_vm.mdiShieldCheck}}),_vm._v(" "),_c('div',{staticClass:"lines"},_vm._l((4),function(n){return _c('div',{key:n,class:_vm.randomLineClass()})}),0)],1)])])])])};
var __vue_staticRenderFns__$1 = [];

  /* style */
  const __vue_inject_styles__$1 = undefined;
  /* scoped */
  const __vue_scope_id__$1 = undefined;
  /* module identifier */
  const __vue_module_identifier__$1 = undefined;
  /* functional template */
  const __vue_is_functional_template__$1 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$1 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
    __vue_inject_styles__$1,
    __vue_script__$1,
    __vue_scope_id__$1,
    __vue_is_functional_template__$1,
    __vue_module_identifier__$1,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$2 = {
    name: 'VerificationFileSelector',
    mixins: [
        i18nWrapperMixin
    ],
    props: {
        firstVerification: {
            type: Boolean,
            default: true
        }
    },
    computed: {
        titleLabel() {
            return this.firstVerification ? this._$t('verification.fileSelection.title.first') : this._$t('verification.fileSelection.title.following')
        }
    },
    methods: {
        filesSelected(target, files) {
            this.$emit('files-selected', files);
        }
    }
};

var img = "data:image/svg+xml,%3csvg width='44' height='54' viewBox='0 0 44 54' fill='none' xmlns='http://www.w3.org/2000/svg'%3e%3cg clip-path='url(%23clip0)'%3e%3cg filter='url(%23filter0_dd)'%3e%3cpath d='M36.3847 2.11768H2.53857V48.7059H36.3847V2.11768Z' fill='white'/%3e%3cpath d='M6.34619 6.77649H16.077' stroke='%2314213D' stroke-opacity='0.5' stroke-linecap='round' stroke-linejoin='round'/%3e%3cpath d='M6.34619 9.31775H16.077' stroke='%2314213D' stroke-opacity='0.5' stroke-linecap='round' stroke-linejoin='round'/%3e%3cpath d='M6.34619 16.0941H32.577' stroke='%2314213D' stroke-opacity='0.5' stroke-linecap='round' stroke-linejoin='round'/%3e%3cpath d='M6.34619 18.6353H32.577' stroke='%2314213D' stroke-opacity='0.5' stroke-linecap='round' stroke-linejoin='round'/%3e%3cpath d='M6.34619 21.1765H32.577' stroke='%2314213D' stroke-opacity='0.5' stroke-linecap='round' stroke-linejoin='round'/%3e%3cpath d='M6.34619 23.7177H32.577' stroke='%2314213D' stroke-opacity='0.5' stroke-linecap='round' stroke-linejoin='round'/%3e%3cpath d='M6.34619 26.2589H32.577' stroke='%2314213D' stroke-opacity='0.5' stroke-linecap='round' stroke-linejoin='round'/%3e%3cpath d='M6.34619 28.8H18.1923' stroke='%2314213D' stroke-opacity='0.5' stroke-linecap='round' stroke-linejoin='round'/%3e%3cpath d='M6.34619 44.8942H16.077' stroke='%2314213D' stroke-opacity='0.5' stroke-linecap='round' stroke-linejoin='round'/%3e%3cpath d='M23.0581 44.8942H32.5773' stroke='%2314213D' stroke-opacity='0.5' stroke-linecap='round' stroke-linejoin='round'/%3e%3c/g%3e%3cpath d='M41.9268 50.5755L39.705 48.3518C39.6925 48.3395 39.683 48.3247 39.677 48.3084C39.6711 48.2921 39.6688 48.2745 39.6703 48.2571C39.6718 48.2398 39.6773 48.2228 39.6859 48.2078C39.6948 48.1928 39.7069 48.1799 39.721 48.1699L41.1489 47.1788C41.2228 47.1278 41.2805 47.0569 41.3156 46.9743C41.3509 46.8919 41.3622 46.8011 41.348 46.7123C41.334 46.6238 41.2951 46.541 41.2361 46.4735C41.1771 46.4059 41.1003 46.3563 41.0144 46.3307L34.9705 44.5148C34.9088 44.4964 34.8434 44.4951 34.7808 44.511C34.7184 44.5269 34.6615 44.5593 34.6158 44.6048C34.5703 44.6504 34.5379 44.7075 34.5221 44.77C34.5064 44.8325 34.5077 44.8981 34.5261 44.96L36.3398 51.0111C36.3656 51.0971 36.4151 51.174 36.4826 51.2329C36.5501 51.2919 36.6328 51.3307 36.7214 51.3449C36.8099 51.3589 36.9006 51.3476 36.9829 51.3123C37.0654 51.2771 37.136 51.2193 37.187 51.1454L38.1766 49.716C38.1865 49.7018 38.1994 49.6897 38.2145 49.6808C38.2295 49.6722 38.2464 49.6667 38.2638 49.6652C38.2811 49.6635 38.2984 49.6658 38.3149 49.6717C38.3312 49.6777 38.346 49.687 38.3585 49.6993L40.5803 51.9234C40.6696 52.0128 40.7906 52.063 40.9167 52.063C41.0429 52.063 41.1639 52.0128 41.2532 51.9234L41.9268 51.2494C42.016 51.16 42.0662 51.0389 42.0662 50.9125C42.0662 50.786 42.016 50.6649 41.9268 50.5755Z' fill='%231376FF'/%3e%3c/g%3e%3cdefs%3e%3cfilter id='filter0_dd' x='-9.46143' y='-7.88232' width='57.8462' height='70.5882' filterUnits='userSpaceOnUse' color-interpolation-filters='sRGB'%3e%3cfeFlood flood-opacity='0' result='BackgroundImageFix'/%3e%3cfeColorMatrix in='SourceAlpha' type='matrix' values='0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0'/%3e%3cfeOffset dy='1'/%3e%3cfeGaussianBlur stdDeviation='2'/%3e%3cfeColorMatrix type='matrix' values='0 0 0 0 0.12549 0 0 0 0 0.2 0 0 0 0 0.27451 0 0 0 0.04 0'/%3e%3cfeBlend mode='normal' in2='BackgroundImageFix' result='effect1_dropShadow'/%3e%3cfeColorMatrix in='SourceAlpha' type='matrix' values='0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0'/%3e%3cfeOffset dy='2'/%3e%3cfeGaussianBlur stdDeviation='6'/%3e%3cfeColorMatrix type='matrix' values='0 0 0 0 0.12549 0 0 0 0 0.2 0 0 0 0 0.27451 0 0 0 0.09 0'/%3e%3cfeBlend mode='normal' in2='effect1_dropShadow' result='effect2_dropShadow'/%3e%3cfeBlend mode='normal' in='SourceGraphic' in2='effect2_dropShadow' result='shape'/%3e%3c/filter%3e%3cclipPath id='clip0'%3e%3crect width='44' height='54' fill='white'/%3e%3c/clipPath%3e%3c/defs%3e%3c/svg%3e";

/* script */
const __vue_script__$2 = script$2;
var __vue_render__$2 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"verification-file-selector"},[_c('div',{staticClass:"file-selector"},[_c('div',{staticClass:"content"},[_c('img',{attrs:{"src":img,"alt":"Certifaction"}}),_vm._v(" "),_c('div',{staticClass:"labels"},[_c('div',{staticClass:"label title"},[_vm._v(_vm._s(_vm.titleLabel))]),_vm._v(" "),_c('div',{staticClass:"label subtitle"},[_vm._v(_vm._s(_vm._$t('verification.fileSelection.subtitle.selector')))])])]),_vm._v(" "),_c('input',{staticClass:"input-file",attrs:{"type":"file","multiple":"","name":"uploadField","accept":"application/pdf"},on:{"change":function($event){return _vm.filesSelected($event.target.name, $event.target.files)}}})])])};
var __vue_staticRenderFns__$2 = [];

  /* style */
  const __vue_inject_styles__$2 = undefined;
  /* scoped */
  const __vue_scope_id__$2 = undefined;
  /* module identifier */
  const __vue_module_identifier__$2 = undefined;
  /* functional template */
  const __vue_is_functional_template__$2 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$2 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$2, staticRenderFns: __vue_staticRenderFns__$2 },
    __vue_inject_styles__$2,
    __vue_script__$2,
    __vue_scope_id__$2,
    __vue_is_functional_template__$2,
    __vue_module_identifier__$2,
    false,
    undefined,
    undefined,
    undefined
  );

//
var script$3 = {
    name: 'VerificationDropBox',
    mixins: [
        i18nWrapperMixin
    ],
    props: {
        firstVerification: {
            type: Boolean,
            default: true
        }
    },
    computed: {
        titleLabel() {
            return this.firstVerification ? this._$t('verification.fileSelection.title.first') : this._$t('verification.fileSelection.title.following')
        }
    }
};

/* script */
const __vue_script__$3 = script$3;
var __vue_render__$3 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"verification-dropbox"},[_c('div',{staticClass:"dropbox"},[_c('div',{staticClass:"content"},[_c('div',{staticClass:"labels"},[_c('div',{staticClass:"label title"},[_vm._v(_vm._s(_vm.titleLabel))]),_vm._v(" "),_c('div',{staticClass:"label subtitle"},[_vm._v(_vm._s(_vm._$t('verification.fileSelection.subtitle.dropbox')))])]),_vm._v(" "),_c('img',{attrs:{"src":img,"alt":"Certifaction"}})])])])};
var __vue_staticRenderFns__$3 = [];

  /* style */
  const __vue_inject_styles__$3 = undefined;
  /* scoped */
  const __vue_scope_id__$3 = undefined;
  /* module identifier */
  const __vue_module_identifier__$3 = undefined;
  /* functional template */
  const __vue_is_functional_template__$3 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$3 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$3, staticRenderFns: __vue_staticRenderFns__$3 },
    __vue_inject_styles__$3,
    __vue_script__$3,
    __vue_scope_id__$3,
    __vue_is_functional_template__$3,
    __vue_module_identifier__$3,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//

var script$4 = {
    name: 'ShadowItem'
};

/* script */
const __vue_script__$4 = script$4;

/* template */
var __vue_render__$4 = function () {var _vm=this;var _h=_vm.$createElement;_vm._self._c||_h;return _vm._m(0)};
var __vue_staticRenderFns__$4 = [function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"base-card verification-shadow-card"},[_c('div',{staticClass:"lines"},[_c('div',{staticClass:"line short"}),_vm._v(" "),_c('div',{staticClass:"divider"}),_vm._v(" "),_c('div',{staticClass:"line medium"}),_vm._v(" "),_c('div',{staticClass:"line long"}),_vm._v(" "),_c('div',{staticClass:"line long"}),_vm._v(" "),_c('div',{staticClass:"line short"}),_vm._v(" "),_c('div',{staticClass:"line medium"})])])}];

  /* style */
  const __vue_inject_styles__$4 = undefined;
  /* scoped */
  const __vue_scope_id__$4 = undefined;
  /* module identifier */
  const __vue_module_identifier__$4 = undefined;
  /* functional template */
  const __vue_is_functional_template__$4 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$4 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$4, staticRenderFns: __vue_staticRenderFns__$4 },
    __vue_inject_styles__$4,
    __vue_script__$4,
    __vue_scope_id__$4,
    __vue_is_functional_template__$4,
    __vue_module_identifier__$4,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//


var script$5 = {
    name: 'BaseCard'
};

/* script */
const __vue_script__$5 = script$5;

/* template */
var __vue_render__$5 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"base-card"},[_c('div',{staticClass:"card-header"},[_vm._t("header")],2),_vm._v(" "),_c('div',{staticClass:"card-body"},[_vm._t("body")],2),_vm._v(" "),_c('div',{staticClass:"card-footer"},[_vm._t("footer")],2)])};
var __vue_staticRenderFns__$5 = [];

  /* style */
  const __vue_inject_styles__$5 = undefined;
  /* scoped */
  const __vue_scope_id__$5 = undefined;
  /* module identifier */
  const __vue_module_identifier__$5 = undefined;
  /* functional template */
  const __vue_is_functional_template__$5 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$5 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$5, staticRenderFns: __vue_staticRenderFns__$5 },
    __vue_inject_styles__$5,
    __vue_script__$5,
    __vue_scope_id__$5,
    __vue_is_functional_template__$5,
    __vue_module_identifier__$5,
    false,
    undefined,
    undefined,
    undefined
  );

var img$1 = "data:image/svg+xml,%3csvg width='16' height='16' viewBox='0 0 16 16' fill='none' xmlns='http://www.w3.org/2000/svg'%3e%3cpath fill-rule='evenodd' clip-rule='evenodd' d='M14.073 1.57933C14.4375 1.74844 14.6695 2.11492 14.6664 2.51666V7.608C14.6719 10.9894 12.5987 14.0266 9.4477 15.2533L8.73637 15.5293C8.26237 15.7127 7.73704 15.7127 7.26304 15.5293L6.5517 15.2533C3.40068 14.0266 1.32753 10.9894 1.33304 7.608V2.51666C1.32996 2.11492 1.56194 1.74844 1.92637 1.57933C3.83979 0.738767 5.90988 0.314069 7.9997 0.33333C10.0895 0.314069 12.1596 0.738767 14.073 1.57933ZM8.31503 10.9807L12.3384 5.49266H12.3357C12.5168 5.25283 12.5548 4.93405 12.435 4.6584C12.3153 4.38275 12.0564 4.19293 11.7574 4.16165C11.4585 4.13036 11.1659 4.26245 10.9917 4.50733L7.65837 9.05466C7.62962 9.09402 7.58508 9.11883 7.53649 9.12255C7.48789 9.12627 7.4401 9.10853 7.4057 9.074L5.17837 6.846C4.85147 6.53009 4.33172 6.53446 4.01018 6.85582C3.68864 7.17717 3.68398 7.69692 3.9997 8.024L7.05103 11.074C7.20715 11.2306 7.41921 11.3187 7.64037 11.3187H7.70703C7.94926 11.2999 8.17127 11.1765 8.31503 10.9807Z' fill='%2300BF86'/%3e%3c/svg%3e";

var img$2 = "data:image/svg+xml,%3csvg width='16' height='16' viewBox='0 0 16 16' fill='none' xmlns='http://www.w3.org/2000/svg'%3e%3cpath fill-rule='evenodd' clip-rule='evenodd' d='M14.6664 2.51666C14.6695 2.11492 14.4375 1.74844 14.073 1.57933C12.1596 0.738767 10.0895 0.314069 7.9997 0.33333C5.90988 0.314069 3.83979 0.738767 1.92637 1.57933C1.56194 1.74844 1.32996 2.11492 1.33304 2.51666V7.608C1.32753 10.9894 3.40068 14.0266 6.5517 15.2533L7.26304 15.5293C7.73704 15.7127 8.26237 15.7127 8.73637 15.5293L9.4477 15.2533C12.5987 14.0266 14.6719 10.9894 14.6664 7.608V2.51666ZM7.99951 13C8.5518 13 8.99951 12.5523 8.99951 12C8.99951 11.4477 8.5518 11 7.99951 11C7.44723 11 6.99951 11.4477 6.99951 12C6.99951 12.5523 7.44723 13 7.99951 13ZM8.99951 8.83333C8.99951 9.47767 8.5518 10 7.99951 10C7.44723 10 6.99951 9.47767 6.99951 8.83333V4.16667C6.99951 3.52233 7.44723 3 7.99951 3C8.5518 3 8.99951 3.52233 8.99951 4.16667V8.83333Z' fill='%23F29E18'/%3e%3c/svg%3e";

var img$3 = "data:image/svg+xml,%3csvg width='14' height='16' viewBox='0 0 14 16' fill='none' xmlns='http://www.w3.org/2000/svg'%3e%3cpath fill-rule='evenodd' clip-rule='evenodd' d='M13.073 1.57933C13.4375 1.74844 13.6695 2.11492 13.6664 2.51666V7.608C13.6719 10.9894 11.5987 14.0266 8.44771 15.2533L7.73637 15.5293C7.26237 15.7127 6.73704 15.7127 6.26304 15.5293L5.55171 15.2533C2.40068 14.0266 0.327531 10.9894 0.333038 7.608V2.51666C0.329956 2.11492 0.561939 1.74844 0.926372 1.57933C2.83979 0.738767 4.90988 0.314069 6.99971 0.33333C9.08953 0.314069 11.1596 0.738767 13.073 1.57933ZM10.0796 11.0759C10.3398 10.8156 10.3398 10.3936 10.0796 10.1333L8.23623 8.29261C8.17353 8.23007 8.1383 8.14516 8.1383 8.05661C8.1383 7.96806 8.17353 7.88315 8.23623 7.82061L10.0796 5.97728C10.3322 5.71569 10.3286 5.29989 10.0714 5.04273C9.81428 4.78558 9.39848 4.78196 9.13689 5.03461L7.29289 6.87794C7.16273 7.00807 6.95173 7.00807 6.82156 6.87794L4.97823 5.03461C4.81084 4.86131 4.56297 4.7918 4.32989 4.85281C4.0968 4.91382 3.91477 5.09585 3.85376 5.32894C3.79275 5.56203 3.86225 5.80989 4.03556 5.97728L5.87889 7.82061C5.94159 7.88315 5.97682 7.96806 5.97682 8.05661C5.97682 8.14516 5.94159 8.23007 5.87889 8.29261L4.03556 10.1359C3.7753 10.3963 3.7753 10.8183 4.03556 11.0786C4.30029 11.328 4.7135 11.328 4.97823 11.0786L6.82156 9.23528C6.95173 9.10515 7.16273 9.10515 7.29289 9.23528L9.13689 11.0759C9.39857 11.3329 9.81789 11.3329 10.0796 11.0759Z' fill='%23EE4266'/%3e%3c/svg%3e";

//

var script$6 = {
    name: 'ResultDetail',
    mixins: [i18nWrapperMixin],
    components: {
        MDIcon: __vue_component__
    },
    props: {
        verificationMode: {
            type: String,
            required: true
        },
        notFound: {
            type: Boolean,
            default: false
        },
        hasTechnicalProblem: {
            type: Boolean,
            default: false
        },
        hasUnverifiedIssuer: {
            type: Boolean,
            default: false
        },
        hasVerifiedIssuer: {
            type: Boolean,
            default: false
        },
        documentRegistrationInProgress: {
            type: Boolean,
            default: false
        },
        documentRevoked: {
            type: Boolean,
            default: false
        },
        documentRevocationInProgress: {
            type: Boolean,
            default: false
        },
        documentRevocationDate: null,
        signaturesInProgress: {
            type: Number,
            default: 0
        },
        hasUnverifiedSigner: {
            type: Boolean,
            default: false
        },
        hasVerifiedSigner: {
            type: Boolean,
            default: false
        },
        signerCount: {
            type: Number,
            default: 0
        }
    },
    data() {
        return {
            mdiShieldCheck: js.mdiShieldCheck,
            mdiChevronUp: js.mdiChevronUp,
            mdiChevronDown: js.mdiChevronDown,
            mdiCircle: js.mdiCircle,
            headerSuccessShield: img$1,
            headerWarningShield: img$2,
            headerErrorShield: img$3,
            showDetails: false
        }
    },
    computed: {
        showDropdownToggler() {
            return (!this.notFound && !this.hasTechnicalProblem)
        },
        verificationStatus() {
            if (this.documentRevoked) {
                return 'error'
            }

            if (this.notFound || this.hasTechnicalProblem || this.hasUnverifiedIssuer || this.hasUnverifiedSigner) {
                return 'warning'
            }

            return 'success'
        },
        headerIcon() {
            switch (this.verificationStatus) {
                case 'success':
                    return img$1
                case 'warning':
                    return img$2
                case 'error':
                default:
                    return img$3
            }
        },
        headerLabel() {
            if (this.notFound) {
                return this._$t(`verification.result.${this.verificationMode}.notFound.status`)
            }

            if (this.hasTechnicalProblem) {
                return this._$t(`verification.result.${this.verificationMode}.technicalProblem.status`)
            }

            if (this.documentRevoked) {
                return this._$t(`verification.result.${this.verificationMode}.revoked.status`)
            }

            if (this.hasUnverifiedIssuer) {
                return this._$t(`verification.result.${this.verificationMode}.unverifiedIssuer.status`)
            }

            if (this.hasVerifiedIssuer) {
                return this._$t(`verification.result.${this.verificationMode}.verifiedIssuer.status`)
            }

            if (this.hasUnverifiedSigner) {
                return this._$tc(`verification.result.${this.verificationMode}.unverifiedSigner.status`, this.signerCount)
            }

            if (this.hasVerifiedSigner) {
                return this._$tc(`verification.result.${this.verificationMode}.verifiedSigner.status`, this.signerCount)
            }

            return null
        },
        details() {
            const langDetailsKeyPrefix = `verification.result.${this.verificationMode}.resultDetails`;
            const details = [];

            details.push({
                label: this._$t(`${langDetailsKeyPrefix}.tamperProof`),
                class: 'tamper-proof',
                icon: 'check'
            });

            const blockchainStatus = { class: 'blockchain', inProgress: true };
            if (this.documentRegistrationInProgress) {
                blockchainStatus.label = this._$t(`${langDetailsKeyPrefix}.blockchain.inProgress.registration`);
            } else if (this.documentRevocationInProgress) {
                blockchainStatus.label = this._$t(`${langDetailsKeyPrefix}.blockchain.inProgress.revocation`);
            } else if (this.signaturesInProgress > 0) {
                blockchainStatus.label = this._$t(`${langDetailsKeyPrefix}.blockchain.inProgress.signature`);
            } else {
                blockchainStatus.label = this._$t(`${langDetailsKeyPrefix}.blockchain.processed`);
                blockchainStatus.inProgress = false;
                blockchainStatus.icon = 'check';
            }

            const documentStatus = { class: 'document-valid', icon: 'check' };
            if (this.documentRevoked) {
                if (this.documentRevocationInProgress) {
                    documentStatus.label = this._$t(`${langDetailsKeyPrefix}.document.revoked.inProgress`);
                } else {
                    documentStatus.label = this._$t(
                        `${langDetailsKeyPrefix}.document.revoked.processed`,
                        { revocationDate: this.documentRevocationDate }
                    );
                }
                documentStatus.class = 'document-revoked';
                documentStatus.icon = 'close';
            } else {
                documentStatus.label = this._$t(`${langDetailsKeyPrefix}.document.valid`);
            }

            switch (this.verificationMode) {
                case 'certifying':
                    if (this.hasUnverifiedIssuer) {
                        details.push({
                            label: this._$t(`${langDetailsKeyPrefix}.issuer.unverified`),
                            class: 'unverified-issuer',
                            icon: 'alert'
                        });
                    } else if (this.hasVerifiedIssuer) {
                        details.push({
                            label: this._$t(`${langDetailsKeyPrefix}.issuer.verified`),
                            class: 'verified-issuer',
                            icon: 'check'
                        });
                    }

                    details.push(blockchainStatus);
                    details.push(documentStatus);
                    break

                case 'signing':
                    details.push(blockchainStatus);
                    details.push(documentStatus);

                    if (this.hasUnverifiedSigner) {
                        details.push({
                            label: this._$tc(`${langDetailsKeyPrefix}.signer.unverified`, this.signerCount),
                            class: 'unverified-signer',
                            icon: 'alert'
                        });
                    } else if (this.hasVerifiedSigner) {
                        details.push({
                            label: this._$tc(`${langDetailsKeyPrefix}.signer.verified`, this.signerCount),
                            class: 'verified-signer',
                            icon: 'check'
                        });
                    }
                    break
            }

            return details
        }
    },
    methods: {
        toggleDropdown() {
            this.showDetails = this.showDropdownToggler ? !this.showDetails : this.showDetails;
        },
        getDetailIcon(icon) {
            switch (icon) {
                case 'check':
                    return js.mdiCheckCircle
                case 'alert':
                    return js.mdiAlertCircle
                case 'close':
                    return js.mdiCloseCircle
            }
            return null
        }
    }
};

var img$4 = "data:image/svg+xml,%3c%3fxml version='1.0' encoding='utf-8'%3f%3e%3csvg xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' style='margin: auto%3b background: none%3b display: block%3b shape-rendering: auto%3b' width='100px' height='100px' viewBox='0 0 100 100' preserveAspectRatio='xMidYMid'%3e%3cg transform='rotate(0 50 50)'%3e %3crect x='46.5' y='17' rx='0.9' ry='0.9' width='7' height='18' fill='white'%3e %3canimate attributeName='opacity' values='1%3b0' keyTimes='0%3b1' dur='1s' begin='-0.875s' repeatCount='indefinite'%3e%3c/animate%3e %3c/rect%3e%3c/g%3e%3cg transform='rotate(45 50 50)'%3e %3crect x='46.5' y='17' rx='0.9' ry='0.9' width='7' height='18' fill='white'%3e %3canimate attributeName='opacity' values='1%3b0' keyTimes='0%3b1' dur='1s' begin='-0.75s' repeatCount='indefinite'%3e%3c/animate%3e %3c/rect%3e%3c/g%3e%3cg transform='rotate(90 50 50)'%3e %3crect x='46.5' y='17' rx='0.9' ry='0.9' width='7' height='18' fill='white'%3e %3canimate attributeName='opacity' values='1%3b0' keyTimes='0%3b1' dur='1s' begin='-0.625s' repeatCount='indefinite'%3e%3c/animate%3e %3c/rect%3e%3c/g%3e%3cg transform='rotate(135 50 50)'%3e %3crect x='46.5' y='17' rx='0.9' ry='0.9' width='7' height='18' fill='white'%3e %3canimate attributeName='opacity' values='1%3b0' keyTimes='0%3b1' dur='1s' begin='-0.5s' repeatCount='indefinite'%3e%3c/animate%3e %3c/rect%3e%3c/g%3e%3cg transform='rotate(180 50 50)'%3e %3crect x='46.5' y='17' rx='0.9' ry='0.9' width='7' height='18' fill='white'%3e %3canimate attributeName='opacity' values='1%3b0' keyTimes='0%3b1' dur='1s' begin='-0.375s' repeatCount='indefinite'%3e%3c/animate%3e %3c/rect%3e%3c/g%3e%3cg transform='rotate(225 50 50)'%3e %3crect x='46.5' y='17' rx='0.9' ry='0.9' width='7' height='18' fill='white'%3e %3canimate attributeName='opacity' values='1%3b0' keyTimes='0%3b1' dur='1s' begin='-0.25s' repeatCount='indefinite'%3e%3c/animate%3e %3c/rect%3e%3c/g%3e%3cg transform='rotate(270 50 50)'%3e %3crect x='46.5' y='17' rx='0.9' ry='0.9' width='7' height='18' fill='white'%3e %3canimate attributeName='opacity' values='1%3b0' keyTimes='0%3b1' dur='1s' begin='-0.125s' repeatCount='indefinite'%3e%3c/animate%3e %3c/rect%3e%3c/g%3e%3cg transform='rotate(315 50 50)'%3e %3crect x='46.5' y='17' rx='0.9' ry='0.9' width='7' height='18' fill='white'%3e %3canimate attributeName='opacity' values='1%3b0' keyTimes='0%3b1' dur='1s' begin='0s' repeatCount='indefinite'%3e%3c/animate%3e %3c/rect%3e%3c/g%3e%3c!-- %5bldio%5d generated by https://loading.io/ --%3e%3c/svg%3e";

/* script */
const __vue_script__$6 = script$6;
var __vue_render__$6 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"result-detail",class:[_vm.verificationStatus, { expanded: _vm.showDetails && _vm.showDropdownToggler }]},[_c('div',{staticClass:"detail-header",on:{"click":_vm.toggleDropdown}},[_c('div',{staticClass:"header-icon"},[_c('img',{attrs:{"src":_vm.headerIcon,"alt":"Icon"}})]),_vm._v(" "),_c('div',{staticClass:"header-label"},[_c('div',{domProps:{"innerHTML":_vm._s(_vm.headerLabel)}})]),_vm._v(" "),(_vm.showDropdownToggler)?_c('div',{staticClass:"header-action"},[_c('button',{staticClass:"btn-link advanced-toggler",attrs:{"type":"button"}},[(_vm.documentRegistrationInProgress || _vm.documentRevocationInProgress || _vm.signaturesInProgress > 0)?_c('img',{staticClass:"loading-spinner",attrs:{"src":img$4,"alt":"Spinner"}}):_vm._e(),_vm._v(" "),_c('span',[_vm._v(_vm._s(_vm._$t('verification.result.meta.details')))]),_vm._v(" "),_c('MDIcon',{staticClass:"toggler",attrs:{"icon":_vm.showDetails ? _vm.mdiChevronUp : _vm.mdiChevronDown}})],1)]):_vm._e()]),_vm._v(" "),_c('transition',{attrs:{"name":"collapse"}},[(_vm.showDetails)?_c('div',{staticClass:"detail-body"},[_c('ul',_vm._l((_vm.details),function(item,index){return _c('li',{key:index,staticClass:"detail",class:[item.class, { 'in-progress': item.inProgress }]},[(item.inProgress)?[_c('MDIcon',{staticClass:"in-progress",attrs:{"icon":_vm.mdiCircle}}),_vm._v(" "),_c('img',{staticClass:"loading-spinner",attrs:{"src":img$4,"alt":"Spinner"}})]:_c('MDIcon',{attrs:{"icon":_vm.getDetailIcon(item.icon)}}),_vm._v(" "),_c('span',{domProps:{"innerHTML":_vm._s(item.label)}})],2)}),0)]):_vm._e()])],1)};
var __vue_staticRenderFns__$6 = [];

  /* style */
  const __vue_inject_styles__$6 = undefined;
  /* scoped */
  const __vue_scope_id__$6 = undefined;
  /* module identifier */
  const __vue_module_identifier__$6 = undefined;
  /* functional template */
  const __vue_is_functional_template__$6 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$6 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$6, staticRenderFns: __vue_staticRenderFns__$6 },
    __vue_inject_styles__$6,
    __vue_script__$6,
    __vue_scope_id__$6,
    __vue_is_functional_template__$6,
    __vue_module_identifier__$6,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$7 = {
    name: 'NotFoundCard',
    mixins: [i18nWrapperMixin],
    components: {
        BaseCard: __vue_component__$5,
        MDIcon: __vue_component__,
        ResultDetail: __vue_component__$6
    },
    props: {
        verificationItem: {
            type: Object,
            required: true
        }
    },
    data() {
        return {
            mdiFileDocument: js.mdiFileDocument
        }
    },
    methods: {
        toggleHelp(type) {
            this.$emit('toggle-help', type);
        }
    }
};

/* script */
const __vue_script__$7 = script$7;

/* template */
var __vue_render__$7 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('BaseCard',{staticClass:"not-found-card",scopedSlots:_vm._u([{key:"header",fn:function(){return [_c('div',{staticClass:"icon"},[_c('MDIcon',{staticClass:"icon-verified",attrs:{"icon":_vm.mdiFileDocument}})],1),_vm._v(" "),_c('div',{staticClass:"title"},[_c('div',{staticClass:"filename"},[_vm._v(_vm._s(_vm.verificationItem.name))])])]},proxy:true},{key:"body",fn:function(){return [_c('ResultDetail',{attrs:{"verification-mode":"error","not-found":true}}),_vm._v(" "),_c('div',{staticClass:"verification-info"},[_c('div',{staticClass:"verification-entry error"},[_c('p',{domProps:{"innerHTML":_vm._s(_vm._$t("verification.result.error.notFound.details"))}})]),_vm._v(" "),(_vm.verificationItem.hash)?_c('div',{staticClass:"verification-entry fingerprint"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.fingerprint')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('span',{staticClass:"hash"},[_vm._v(_vm._s(_vm.verificationItem.hash))])])]):_vm._e()])]},proxy:true},{key:"footer",fn:function(){return [_c('div',{staticClass:"left"}),_vm._v(" "),_c('div',{staticClass:"right"},[_c('button',{staticClass:"btn primary",on:{"click":function($event){return _vm.toggleHelp('contact')}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.support')))])])])]},proxy:true}])})};
var __vue_staticRenderFns__$7 = [];

  /* style */
  const __vue_inject_styles__$7 = undefined;
  /* scoped */
  const __vue_scope_id__$7 = undefined;
  /* module identifier */
  const __vue_module_identifier__$7 = undefined;
  /* functional template */
  const __vue_is_functional_template__$7 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$7 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$7, staticRenderFns: __vue_staticRenderFns__$7 },
    __vue_inject_styles__$7,
    __vue_script__$7,
    __vue_scope_id__$7,
    __vue_is_functional_template__$7,
    __vue_module_identifier__$7,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$8 = {
    name: 'TechnicalProblemCard',
    mixins: [i18nWrapperMixin],
    components: {
        BaseCard: __vue_component__$5,
        MDIcon: __vue_component__,
        ResultDetail: __vue_component__$6
    },
    props: {
        verificationItem: {
            type: Object,
            required: true
        }
    },
    data() {
        return {
            mdiFileDocument: js.mdiFileDocument
        }
    },
    methods: {
        toggleHelp(type) {
            this.$emit('toggle-help', type);
        }
    }
};

/* script */
const __vue_script__$8 = script$8;

/* template */
var __vue_render__$8 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('BaseCard',{staticClass:"technical-problem-card",scopedSlots:_vm._u([{key:"header",fn:function(){return [_c('div',{staticClass:"icon"},[_c('MDIcon',{staticClass:"icon-verified",attrs:{"icon":_vm.mdiFileDocument}})],1),_vm._v(" "),_c('div',{staticClass:"title"},[_c('div',{staticClass:"filename"},[_vm._v(_vm._s(_vm.verificationItem.name))])])]},proxy:true},{key:"body",fn:function(){return [_c('ResultDetail',{attrs:{"verification-mode":"error","has-technical-problem":true}}),_vm._v(" "),_c('div',{staticClass:"verification-info"},[_c('div',{staticClass:"verification-entry error"},[_c('p',{domProps:{"innerHTML":_vm._s(_vm._$t("verification.result.error.technicalProblem.details"))}})]),_vm._v(" "),(_vm.verificationItem.hash)?_c('div',{staticClass:"verification-entry fingerprint"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.fingerprint')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('span',{staticClass:"hash"},[_vm._v(_vm._s(_vm.verificationItem.hash))])])]):_vm._e()])]},proxy:true},{key:"footer",fn:function(){return [_c('div',{staticClass:"left"}),_vm._v(" "),_c('div',{staticClass:"right"},[_c('button',{staticClass:"btn primary",on:{"click":function($event){return _vm.toggleHelp('contact')}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.support')))])]),_vm._v(" "),_c('button',{staticClass:"btn secondary",on:{"click":function($event){return _vm.toggleHelp('faq')}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.questions')))])])])]},proxy:true}])})};
var __vue_staticRenderFns__$8 = [];

  /* style */
  const __vue_inject_styles__$8 = undefined;
  /* scoped */
  const __vue_scope_id__$8 = undefined;
  /* module identifier */
  const __vue_module_identifier__$8 = undefined;
  /* functional template */
  const __vue_is_functional_template__$8 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$8 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$8, staticRenderFns: __vue_staticRenderFns__$8 },
    __vue_inject_styles__$8,
    __vue_script__$8,
    __vue_scope_id__$8,
    __vue_is_functional_template__$8,
    __vue_module_identifier__$8,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$9 = {
    name: 'FaqCard',
    mixins: [i18nWrapperMixin],
    components: {
        BaseCard: __vue_component__$5,
        MDIcon: __vue_component__
    },
    data() {
        return {
            mdiChevronDown: js.mdiChevronDown,
            openItems: []
        }
    },
    methods: {
        toggleHelp(type) {
            this.$emit('toggle-help', type);
        },
        toggleItem(index) {
            if (!this.isItemOpen(index)) {
                this.openItems.push(index);
            } else {
                this.openItems = this.openItems.filter(item => item !== index);
            }
        },
        isItemOpen(index) {
            return (this.openItems.indexOf(index) >= 0)
        },
        onEnterTransition(el) {
            el.style.height = 'auto';
            const height = window.getComputedStyle(el).height;
            el.style.height = 0;
            window.getComputedStyle(el);
            window.setTimeout(() => {
                el.style.height = height;
            });
        },
        onAfterEnterTransition(el) {
            el.style.height = 'auto';
        },
        onLeaveTransition(el) {
            el.style.height = window.getComputedStyle(el).height;
            window.getComputedStyle(el);
            window.setTimeout(() => {
                el.style.height = 0;
            });
        }
    }
};

/* script */
const __vue_script__$9 = script$9;

/* template */
var __vue_render__$9 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('BaseCard',{staticClass:"help-card",scopedSlots:_vm._u([{key:"header",fn:function(){return [_c('div',{staticClass:"title"},[_c('span',{staticClass:"help-card-title"},[_vm._v(_vm._s(_vm._$t('verification.card.faq.title')))])])]},proxy:true},{key:"body",fn:function(){return [_c('div',{staticClass:"faq-items accordion"},_vm._l((_vm._$t('verification.card.faq.items', { returnObjects: true })),function(item,index){return _c('div',{key:index,staticClass:"item",class:{ open: _vm.isItemOpen(index) }},[_c('div',{staticClass:"item-title",on:{"click":function($event){return _vm.toggleItem(index)}}},[_c('span',[_vm._v(_vm._s(item.title))]),_vm._v(" "),_c('MDIcon',{staticClass:"chevron",attrs:{"icon":_vm.mdiChevronDown}})],1),_vm._v(" "),_c('transition',{attrs:{"name":"collapse"},on:{"enter":_vm.onEnterTransition,"after-enter":_vm.onAfterEnterTransition,"leave":_vm.onLeaveTransition}},[(_vm.isItemOpen(index))?_c('div',{staticClass:"content"},[_c('div',{staticClass:"inside",domProps:{"innerHTML":_vm._s(item.content)}})]):_vm._e()])],1)}),0)]},proxy:true},{key:"footer",fn:function(){return [_c('div',{staticClass:"left"},[_c('button',{staticClass:"btn secondary",on:{"click":function($event){return _vm.toggleHelp('faq')}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.back')))])])]),_vm._v(" "),_c('div',{staticClass:"right"},[_c('button',{staticClass:"btn primary",on:{"click":function($event){return _vm.toggleHelp('contact')}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.support')))])])])]},proxy:true}])})};
var __vue_staticRenderFns__$9 = [];

  /* style */
  const __vue_inject_styles__$9 = undefined;
  /* scoped */
  const __vue_scope_id__$9 = undefined;
  /* module identifier */
  const __vue_module_identifier__$9 = undefined;
  /* functional template */
  const __vue_is_functional_template__$9 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$9 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$9, staticRenderFns: __vue_staticRenderFns__$9 },
    __vue_inject_styles__$9,
    __vue_script__$9,
    __vue_scope_id__$9,
    __vue_is_functional_template__$9,
    __vue_module_identifier__$9,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$a = {
    name: 'ContactCard',
    mixins: [i18nWrapperMixin],
    components: {
        BaseCard: __vue_component__$5
    },
    props: {
        certifactionApiUrl: {
            type: String,
            required: true
        }
    },
    data() {
        return {
            contactFormSubmitting: false,
            contactFormSuccessful: false,
            contactFormFailed: false,
            reactiveValidation: false,
            email: null,
            question: null,
            consentAccepted: false,
            errors: {
                email: false,
                question: false,
                consent: false
            }
        }
    },
    watch: {
        email: function() {
            if (this.reactiveValidation) {
                this.validate();
            }
        },
        question: function() {
            if (this.reactiveValidation) {
                this.validate();
            }
        },
        consentAccepted: function() {
            if (this.reactiveValidation) {
                this.validate();
            }
        }
    },
    methods: {
        toggleHelp(type) {
            this.$emit('toggle-help', type);
        },
        checkForm: function(e) {
            e.preventDefault();
            this.reactiveValidation = true;
            this.contactFormSuccessful = this.contactFormFailed = false;

            if (this.validate()) {
                this.postForm();
            }
        },
        validate() {
            const emailRegex = /^[a-zA-Z0-9.!#$%&’*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/;

            this.errors.email = this.errors.question = this.errors.consent = false;

            if (!this.email || (!!this.email && !emailRegex.test(this.email))) {
                this.errors.email = true;
            }
            if (!this.question) {
                this.errors.question = true;
            }
            if (!this.consentAccepted) {
                this.errors.consent = true;
            }

            return !(this.errors.email || this.errors.question || this.errors.consent)
        },
        async postForm() {
            this.contactFormSubmitting = true;

            try {
                await axios__default['default'].post(`${this.certifactionApiUrl}support/request`, {
                    origin: 'Verification Tool',
                    contact_email: this.email,
                    subject: 'Support request',
                    body: this.question
                });

                this.contactFormSuccessful = true;
                this.email = this.question = null;
                this.consentAccepted = false;
            } catch (error) {
                console.log('postForm() catch()', error, error.response.data);
                this.contactFormFailed = true;
            }

            this.contactFormSubmitting = this.reactiveValidation = false;
        }
    }
};

/* script */
const __vue_script__$a = script$a;
var __vue_render__$a = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('BaseCard',{staticClass:"help-card",scopedSlots:_vm._u([{key:"header",fn:function(){return [_c('div',{staticClass:"title"},[_c('span',{staticClass:"help-card-title"},[_vm._v(_vm._s(_vm._$t('verification.card.contact.title')))])])]},proxy:true},{key:"body",fn:function(){return [_c('form',{attrs:{"id":"contact-form","method":"POST"},on:{"submit":_vm.checkForm}},[_c('div',{staticClass:"email-field",class:{error: _vm.errors.email}},[_c('label',{attrs:{"for":"email"}},[_vm._v(_vm._s(_vm._$t('verification.card.contact.form.email')))]),_vm._v(" "),_c('input',{directives:[{name:"model",rawName:"v-model",value:(_vm.email),expression:"email"}],attrs:{"id":"email","type":"email","name":"email"},domProps:{"value":(_vm.email)},on:{"input":function($event){if($event.target.composing){ return; }_vm.email=$event.target.value;}}})]),_vm._v(" "),_c('div',{staticClass:"question-field",class:{error: _vm.errors.question}},[_c('label',{attrs:{"for":"question"}},[_vm._v(_vm._s(_vm._$t('verification.card.contact.form.question')))]),_vm._v(" "),_c('textarea',{directives:[{name:"model",rawName:"v-model",value:(_vm.question),expression:"question"}],attrs:{"id":"question","name":"question"},domProps:{"value":(_vm.question)},on:{"input":function($event){if($event.target.composing){ return; }_vm.question=$event.target.value;}}})]),_vm._v(" "),_c('div',{staticClass:"consent-field",class:{error: _vm.errors.consent}},[_c('label',{staticClass:"switch"},[_c('input',{directives:[{name:"model",rawName:"v-model",value:(_vm.consentAccepted),expression:"consentAccepted"}],attrs:{"id":"consent","type":"checkbox"},domProps:{"checked":Array.isArray(_vm.consentAccepted)?_vm._i(_vm.consentAccepted,null)>-1:(_vm.consentAccepted)},on:{"change":function($event){var $$a=_vm.consentAccepted,$$el=$event.target,$$c=$$el.checked?(true):(false);if(Array.isArray($$a)){var $$v=null,$$i=_vm._i($$a,$$v);if($$el.checked){$$i<0&&(_vm.consentAccepted=$$a.concat([$$v]));}else {$$i>-1&&(_vm.consentAccepted=$$a.slice(0,$$i).concat($$a.slice($$i+1)));}}else {_vm.consentAccepted=$$c;}}}}),_vm._v(" "),_c('span',{staticClass:"slider round"})]),_vm._v(" "),_c('label',{staticClass:"consent",attrs:{"for":"consent"},domProps:{"innerHTML":_vm._s(_vm._$t('verification.card.contact.form.consent'))}})]),_vm._v(" "),(_vm.contactFormSuccessful)?_c('span',{staticClass:"message-sent success"},[_vm._v(_vm._s(_vm._$t('verification.card.contact.form.submitted')))]):_vm._e(),_vm._v(" "),(_vm.contactFormFailed)?_c('span',{staticClass:"message-sent failed"},[_vm._v(_vm._s(_vm._$t('verification.card.contact.form.failed')))]):_vm._e()])]},proxy:true},{key:"footer",fn:function(){return [_c('div',{staticClass:"left"},[_c('button',{staticClass:"btn secondary",on:{"click":function($event){return _vm.toggleHelp('contact')}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.back')))])])]),_vm._v(" "),_c('div',{staticClass:"right"},[_c('button',{staticClass:"btn primary",attrs:{"type":"submit","form":"contact-form","disabled":_vm.contactFormSubmitting}},[(_vm.contactFormSubmitting)?_c('img',{staticClass:"loading-spinner",attrs:{"src":img$4,"alt":"Spinner"}}):_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.contact.form.submit')))])])])]},proxy:true}])})};
var __vue_staticRenderFns__$a = [];

  /* style */
  const __vue_inject_styles__$a = undefined;
  /* scoped */
  const __vue_scope_id__$a = undefined;
  /* module identifier */
  const __vue_module_identifier__$a = undefined;
  /* functional template */
  const __vue_is_functional_template__$a = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$a = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$a, staticRenderFns: __vue_staticRenderFns__$a },
    __vue_inject_styles__$a,
    __vue_script__$a,
    __vue_scope_id__$a,
    __vue_is_functional_template__$a,
    __vue_module_identifier__$a,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$b = {
    name: 'CertifyingCard',
    mixins: [i18nWrapperMixin],
    components: {
        BaseCard: __vue_component__$5,
        ResultDetail: __vue_component__$6,
        MDIcon: __vue_component__
    },
    data() {
        return {
            mdiShieldCheck: js.mdiShieldCheck,
            mdiFileDocument: js.mdiFileDocument,
            mdiAlertCircle: js.mdiAlertCircle,
            showExpertInfo: false
        }
    },
    props: {
        verificationItem: {
            type: Object,
            required: true
        },
        net: {
            type: String,
            required: true
        }
    },
    computed: {
        registerEvents() {
            return this.verificationItem.events ? this.verificationItem.events.filter(event => ['register', 'certify'].indexOf(event.scope) >= 0) : []
        },
        revokeEvents() {
            return this.verificationItem.events ? this.verificationItem.events.filter(event => event.scope === 'revoke') : []
        },
        registrationInProgress() {
            return this.registerEvents.filter(event => !event.on_blockchain).length > 0
        },
        revocationInProgress() {
            return this.revokeEvents.filter(event => !event.on_blockchain).length > 0
        },
        revocationDate() {
            if (this.revokeEvents.length === 0) {
                return null
            }

            const revocationDate = new Date(this.revokeEvents[0].date);
            if (!isNaN(revocationDate)) {
                return this._$d(revocationDate, 'long')
            }

            return this.revokeEvents[0].date
        },
        hasUnverifiedIssuer() {
            return this.registerEvents.filter(event => !event.issuer.verified_by).length > 0
        },
        hasVerifiedIssuer() {
            return this.registerEvents.filter(event => !!event.issuer.verified_by).length > 0
        }
    },
    methods: {
        toggleHelp(type) {
            this.$emit('toggle-help', type);
        }
    }
};

/* script */
const __vue_script__$b = script$b;

/* template */
var __vue_render__$b = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('BaseCard',{scopedSlots:_vm._u([(_vm.verificationItem.name)?{key:"header",fn:function(){return [_c('div',{staticClass:"icon"},[_c('MDIcon',{staticClass:"icon-verified",attrs:{"icon":_vm.mdiFileDocument}})],1),_vm._v(" "),_c('div',{staticClass:"title"},[_c('div',{staticClass:"filename"},[_vm._v(_vm._s(_vm.verificationItem.name))])])]},proxy:true}:null,(_vm.showExpertInfo)?{key:"body",fn:function(){return [_c('div',{staticClass:"verification-info expert"},[(_vm.verificationItem.hash)?_c('div',{staticClass:"verification-entry fingerprint"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.fingerprint')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('span',[_vm._v(_vm._s(_vm.verificationItem.hash))])])]):_vm._e(),_vm._v(" "),(_vm.registerEvents.length > 0 && _vm.registerEvents[0].issuer.id)?_c('div',{staticClass:"verification-entry issuer-address"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.issuerAddress')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('span',[_vm._v(_vm._s(_vm.registerEvents[0].issuer.id))])])]):_vm._e(),_vm._v(" "),(_vm.registerEvents.length > 0 && _vm.registerEvents[0].on_blockchain)?_c('div',{staticClass:"verification-entry smart-contract-address"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.smartContractAddress')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('a',{attrs:{"href":("https://" + _vm.net + "/address/" + (_vm.registerEvents[0].on_blockchain.contract_address)),"target":"_blank"}},[_vm._v(_vm._s(_vm.registerEvents[0].on_blockchain.contract_address))])])]):_vm._e(),_vm._v(" "),(_vm.registerEvents.length > 0 && _vm.registerEvents[0].on_blockchain)?_c('div',{staticClass:"verification-entry registration-hash"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.registrationTransaction')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('a',{attrs:{"href":("https://" + _vm.net + "/tx/" + (_vm.registerEvents[0].on_blockchain.tx_hash)),"target":"_blank"}},[_vm._v(_vm._s(_vm.registerEvents[0].on_blockchain.tx_hash))])])]):_vm._e(),_vm._v(" "),(_vm.revokeEvents.length > 0 && _vm.revokeEvents[0].on_blockchain)?_c('div',{staticClass:"verification-entry revocation-hash"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.revocationTransaction')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('a',{attrs:{"href":("https://" + _vm.net + "/tx/" + (_vm.revokeEvents[0].on_blockchain.tx_hash)),"target":"_blank"}},[_vm._v(_vm._s(_vm.revokeEvents[0].on_blockchain.tx_hash))])])]):_vm._e()])]},proxy:true}:{key:"body",fn:function(){return [_c('ResultDetail',{attrs:{"verification-mode":"certifying","has-unverified-issuer":_vm.hasUnverifiedIssuer,"has-verified-issuer":_vm.hasVerifiedIssuer,"document-registration-in-progress":_vm.registrationInProgress,"document-revoked":_vm.revokeEvents.length > 0,"document-revocation-in-progress":_vm.revocationInProgress,"document-revocation-date":_vm.revocationDate}}),_vm._v(" "),_c('div',{staticClass:"verification-info"},[(_vm.registerEvents.length > 0)?_c('div',{staticClass:"verification-entry issuer"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.issuer')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('span',[_vm._v(_vm._s(_vm.registerEvents[0].issuer.name))])]),_vm._v(" "),(_vm.registerEvents.length > 0 && !_vm.registerEvents[0].issuer.verified)?_c('div',{staticClass:"footnote warning"},[_c('MDIcon',{attrs:{"icon":_vm.mdiAlertCircle}}),_vm._v(" "),_c('span',[_vm._v(_vm._s(_vm._$t('verification.result.certifying.unverifiedIssuer.issuerFootnote')))])],1):_vm._e()]):_vm._e(),_vm._v(" "),(_vm.registerEvents.length > 0 && _vm.registerEvents[0].issuer.verified_by)?_c('div',{staticClass:"verification-entry verifier"},[_c('div',{staticClass:"verifier-name"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.issuerVerifiedBy')))]),_vm._v(" "),(_vm.registerEvents[0].issuer.verified_by.image)?_c('div',{staticClass:"verifier-image"},[_c('img',{attrs:{"src":(_vm.registerEvents[0].issuer.verified_by.image).split('.png')[0] + '_redesign.png',"alt":""}})]):_c('div',{staticClass:"value"},[_c('span',[_vm._v(_vm._s(_vm.registerEvents[0].issuer.verified_by.name))])])])]):_vm._e(),_vm._v(" "),(_vm.registerEvents.length > 0 && _vm.registerEvents[0].on_blockchain && _vm.registerEvents[0].date)?_c('div',{staticClass:"verification-entry registration-date"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.registrationDate')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_vm._v(_vm._s(_vm._$d(new Date(_vm.registerEvents[0].date), 'long')))])]):_vm._e(),_vm._v(" "),(_vm.revokeEvents.length > 0 && _vm.revokeEvents[0].on_blockchain && _vm.revocationDate)?_c('div',{staticClass:"verification-entry revocation-date"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.revocationDate')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_vm._v(_vm._s(_vm.revocationDate))])]):_vm._e()])]},proxy:true},{key:"footer",fn:function(){return [_c('div',{staticClass:"left"},[(_vm.showExpertInfo)?_c('button',{staticClass:"btn secondary",on:{"click":function($event){_vm.showExpertInfo = !_vm.showExpertInfo;}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.back')))])]):_vm._e()]),_vm._v(" "),_c('div',{staticClass:"right"},[(!_vm.showExpertInfo)?_c('button',{staticClass:"btn secondary",on:{"click":function($event){_vm.showExpertInfo = !_vm.showExpertInfo;}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.expertInfo')))])]):_vm._e(),_vm._v(" "),_c('button',{staticClass:"btn secondary",on:{"click":function($event){return _vm.toggleHelp('faq')}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.questions')))])])])]},proxy:true}],null,true)})};
var __vue_staticRenderFns__$b = [];

  /* style */
  const __vue_inject_styles__$b = undefined;
  /* scoped */
  const __vue_scope_id__$b = undefined;
  /* module identifier */
  const __vue_module_identifier__$b = undefined;
  /* functional template */
  const __vue_is_functional_template__$b = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$b = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$b, staticRenderFns: __vue_staticRenderFns__$b },
    __vue_inject_styles__$b,
    __vue_script__$b,
    __vue_scope_id__$b,
    __vue_is_functional_template__$b,
    __vue_module_identifier__$b,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$c = {
    name: 'SigningCard',
    mixins: [i18nWrapperMixin],
    components: {
        BaseCard: __vue_component__$5,
        ResultDetail: __vue_component__$6,
        MDIcon: __vue_component__
    },
    data() {
        return {
            mdiShieldCheck: js.mdiShieldCheck,
            mdiFileDocument: js.mdiFileDocument,
            mdiAlertCircle: js.mdiAlertCircle,
            mdiCheckCircle: js.mdiCheckCircle,
            showExpertInfo: false
        }
    },
    props: {
        verificationItem: {
            type: Object,
            required: true
        },
        net: {
            type: String,
            required: true
        }
    },
    computed: {
        registerEvents() {
            return this.verificationItem.events ? this.verificationItem.events.filter(event => event.scope === 'register') : []
        },
        revokeEvents() {
            return this.verificationItem.events ? this.verificationItem.events.filter(event => event.scope === 'revoke') : []
        },
        signEvents() {
            return this.verificationItem.events ? this.verificationItem.events.filter(event => event.scope === 'sign') : []
        },
        revocationInProgress() {
            return this.revokeEvents.filter(event => !event.on_blockchain).length > 0
        },
        revocationDate() {
            if (this.revokeEvents.length === 0) {
                return null
            }

            const revocationDate = new Date(this.revokeEvents[0].date);
            if (!isNaN(revocationDate)) {
                return this._$d(revocationDate, 'long')
            }

            return this.revokeEvents[0].date
        },
        signaturesInProgress() {
            return this.signEvents.filter(event => !event.on_blockchain).length
        },
        hasUnverifiedSigner() {
            return this.signEvents.filter(event => !event.issuer.verified).length > 0
        },
        hasVerifiedSigner() {
            return this.signEvents.filter(event => !!event.issuer.verified).length > 0
        },
        singleIdentityVerifier() {
            if (!this.hasVerifiedSigner) {
                return null
            }

            const verifiedSignEvents = this.signEvents.filter(event => !!event.issuer.verified);

            if (verifiedSignEvents.length !== this.signEvents.length) {
                return null
            }

            const identityVerifiers = verifiedSignEvents.map(event => event.issuer.verified_by);
            const uniqueIdentityVerifiers = identityVerifiers.filter(
                (identityVerifier, index) => identityVerifiers.findIndex(checkIdentityVerifier => checkIdentityVerifier.name === identityVerifier.name) === index
            );

            if (uniqueIdentityVerifiers.length > 1) {
                return null
            }

            return uniqueIdentityVerifiers[0]
        }
    },
    methods: {
        signerFootnote(signEvent) {
            let signerState = 'unverifiedSigner';
            if (signEvent.issuer.verified) {
                signerState = 'verifiedSigner';
            }

            return this._$t(`verification.result.signing.${signerState}.signerFootnote`, {
                signingDate: this._$d(new Date(signEvent.date), 'short')
            })
        },
        toggleHelp(type) {
            this.$emit('toggle-help', type);
        }
    }
};

/* script */
const __vue_script__$c = script$c;

/* template */
var __vue_render__$c = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('BaseCard',{scopedSlots:_vm._u([(_vm.verificationItem.name)?{key:"header",fn:function(){return [_c('div',{staticClass:"icon"},[_c('MDIcon',{staticClass:"icon-verified",attrs:{"icon":_vm.mdiFileDocument}})],1),_vm._v(" "),_c('div',{staticClass:"title"},[_c('div',{staticClass:"filename"},[_vm._v(_vm._s(_vm.verificationItem.name))])])]},proxy:true}:null,(_vm.showExpertInfo)?{key:"body",fn:function(){return [_c('div',{staticClass:"verification-info expert"},[(_vm.verificationItem.hash)?_c('div',{staticClass:"verification-entry fingerprint"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.fingerprint')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('span',[_vm._v(_vm._s(_vm.verificationItem.hash))])])]):_vm._e(),_vm._v(" "),(_vm.registerEvents.length > 0 && _vm.registerEvents[0].issuer.id)?_c('div',{staticClass:"verification-entry issuer-address"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.issuerAddress')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('span',[_vm._v(_vm._s(_vm.registerEvents[0].issuer.id))])])]):_vm._e(),_vm._v(" "),(_vm.signEvents.length > 0 && _vm.signEvents[0].on_blockchain)?_c('div',{staticClass:"verification-entry smart-contract-address"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.smartContractAddress')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('a',{attrs:{"href":("https://" + _vm.net + "/address/" + (_vm.signEvents[0].on_blockchain.contract_address)),"target":"_blank"}},[_vm._v(_vm._s(_vm.signEvents[0].on_blockchain.contract_address))])])]):_vm._e(),_vm._v(" "),(_vm.registerEvents.length > 0 && _vm.registerEvents[0].on_blockchain)?_c('div',{staticClass:"verification-entry registration-hash"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.registrationTransaction')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('a',{attrs:{"href":("https://" + _vm.net + "/tx/" + (_vm.registerEvents[0].on_blockchain.tx_hash)),"target":"_blank"}},[_vm._v(_vm._s(_vm.registerEvents[0].on_blockchain.tx_hash))])])]):_vm._e(),_vm._v(" "),(_vm.revokeEvents.length > 0 && _vm.revokeEvents[0].on_blockchain)?_c('div',{staticClass:"verification-entry revocation-hash"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.revocationTransaction')))]),_vm._v(" "),_c('div',{staticClass:"value"},[_c('a',{attrs:{"href":("https://" + _vm.net + "/tx/" + (_vm.revokeEvents[0].on_blockchain.tx_hash)),"target":"_blank"}},[_vm._v(_vm._s(_vm.revokeEvents[0].on_blockchain.tx_hash))])])]):_vm._e(),_vm._v(" "),(_vm.signEvents.length > 0)?_c('div',{staticClass:"verification-entry signature-hashes"},[_c('div',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.result.meta.signatureTransactions')))]),_vm._v(" "),_c('div',{staticClass:"value"},_vm._l((_vm.signEvents),function(signEvent,index){return _c('div',{key:index,staticClass:"signature-hash"},[_c('span',[_vm._v(_vm._s(signEvent.issuer.name))]),_vm._v(" "),(signEvent.on_blockchain)?_c('a',{attrs:{"href":("https://" + _vm.net + "/tx/" + (signEvent.on_blockchain.tx_hash)),"target":"_blank"}},[_vm._v(_vm._s(signEvent.on_blockchain.tx_hash))]):_vm._e()])}),0)]):_vm._e()])]},proxy:true}:{key:"body",fn:function(){return [_c('ResultDetail',{attrs:{"verification-mode":"signing","document-revoked":_vm.revokeEvents.length > 0,"document-revocation-in-progress":_vm.revocationInProgress,"document-revocation-date":_vm.revocationDate,"signatures-in-progress":_vm.signaturesInProgress,"has-unverified-signer":_vm.hasUnverifiedSigner,"has-verified-signer":_vm.hasVerifiedSigner,"signer-count":_vm.signEvents.length}}),_vm._v(" "),_c('div',{staticClass:"verification-info"},[(_vm.signEvents.length > 0)?_c('div',{staticClass:"verification-entry signers"},[_c('span',{staticClass:"label"},[_vm._v(_vm._s(_vm._$tc('verification.result.meta.signer', _vm.signEvents.length)))]),_vm._v(" "),_c('ul',{staticClass:"signers-list"},_vm._l((_vm.signEvents),function(signEvent,index){return _c('li',{key:index,staticClass:"signer"},[_c('div',{staticClass:"left"},[_c('MDIcon',{staticClass:"signed",attrs:{"icon":_vm.mdiCheckCircle}})],1),_vm._v(" "),_c('div',{staticClass:"right"},[_c('div',{staticClass:"value"},[_c('span',[_vm._v(_vm._s(signEvent.issuer.name))])]),_vm._v(" "),(signEvent.on_blockchain && signEvent.date)?_c('div',{staticClass:"footnote"},[_c('span',[_vm._v(_vm._s(_vm.signerFootnote(signEvent)))])]):_vm._e()])])}),0)]):_vm._e(),_vm._v(" "),(_vm.singleIdentityVerifier)?_c('div',{staticClass:"verification-entry verifier"},[_c('div',{staticClass:"verifier-name"},[_c('div',{staticClass:"label"},[_vm._v("\n                        "+_vm._s(_vm._$tc('verification.result.meta.signerVerifiedBy', _vm.signEvents.length))+"\n                    ")]),_vm._v(" "),(_vm.singleIdentityVerifier.image)?_c('div',{staticClass:"verifier-image"},[_c('img',{attrs:{"src":(_vm.singleIdentityVerifier.image).split('.png')[0] + '_redesign.png',"alt":_vm.singleIdentityVerifier.name,"title":_vm.singleIdentityVerifier.name}})]):_c('div',{staticClass:"value"},[_c('span',[_vm._v(_vm._s(_vm.singleIdentityVerifier.name))])])])]):_vm._e()])]},proxy:true},{key:"footer",fn:function(){return [_c('div',{staticClass:"left"},[(_vm.showExpertInfo)?_c('button',{staticClass:"btn secondary",on:{"click":function($event){_vm.showExpertInfo = !_vm.showExpertInfo;}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.back')))])]):_vm._e()]),_vm._v(" "),_c('div',{staticClass:"right"},[(!_vm.showExpertInfo)?_c('button',{staticClass:"btn secondary",on:{"click":function($event){_vm.showExpertInfo = !_vm.showExpertInfo;}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.expertInfo')))])]):_vm._e(),_vm._v(" "),_c('button',{staticClass:"btn secondary",on:{"click":function($event){return _vm.toggleHelp('faq')}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.card.btn.questions')))])])])]},proxy:true}],null,true)})};
var __vue_staticRenderFns__$c = [];

  /* style */
  const __vue_inject_styles__$c = undefined;
  /* scoped */
  const __vue_scope_id__$c = undefined;
  /* module identifier */
  const __vue_module_identifier__$c = undefined;
  /* functional template */
  const __vue_is_functional_template__$c = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$c = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$c, staticRenderFns: __vue_staticRenderFns__$c },
    __vue_inject_styles__$c,
    __vue_script__$c,
    __vue_scope_id__$c,
    __vue_is_functional_template__$c,
    __vue_module_identifier__$c,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$d = {
    name: 'FileConfirmationCard',
    mixins: [i18nWrapperMixin],
    components: {
        MDIcon: __vue_component__,
        BaseCard: __vue_component__$5
    },
    props: {
        fileName: {
            type: String,
            required: true
        }
    },
    data() {
        return {
            mdiCheckCircle: js.mdiCheckCircle,
            mdiCloseCircle: js.mdiCloseCircle
        }
    },
    methods: {
        approveOrDecline(approved) {
            this.$emit('approve-or-decline', approved);
        }
    }
};

/* script */
const __vue_script__$d = script$d;

/* template */
var __vue_render__$d = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('BaseCard',{staticClass:"file-confirmation-card",scopedSlots:_vm._u([{key:"body",fn:function(){return [_c('div',{staticClass:"action-box confirmation mobile"},[_c('div',{staticClass:"text"},[_c('h4',[_vm._v(_vm._s(_vm._$t('verification.digitalTwin.actionBox.confirmation.title.mobile')))]),_vm._v(" "),_c('p',[_vm._v(_vm._s(_vm._$t('verification.digitalTwin.actionBox.confirmation.copy.mobile')))])]),_vm._v(" "),_c('div',{staticClass:"actions"},[_c('div',{staticClass:"confirmation-action approve",on:{"click":function($event){return _vm.approveOrDecline(true)}}},[_c('MDIcon',{attrs:{"icon":_vm.mdiCheckCircle}})],1),_vm._v(" "),_c('div',{staticClass:"confirmation-action decline",on:{"click":function($event){return _vm.approveOrDecline(false)}}},[_c('MDIcon',{attrs:{"icon":_vm.mdiCloseCircle}})],1)])]),_vm._v(" "),_c('div',{staticClass:"action-box confirmation desktop"},[_c('div',{staticClass:"text"},[_c('h4',[_vm._v(_vm._s(_vm._$t('verification.digitalTwin.actionBox.confirmation.title.desktop')))]),_vm._v(" "),_c('p',[_vm._v(_vm._s(_vm._$t('verification.digitalTwin.actionBox.confirmation.copy.desktop')))])]),_vm._v(" "),_c('div',{staticClass:"actions"},[_c('button',{staticClass:"btn light decline",on:{"click":function($event){return _vm.approveOrDecline(false)}}},[_c('MDIcon',{attrs:{"icon":_vm.mdiCloseCircle}}),_vm._v("\n                    "+_vm._s(_vm._$t('verification.digitalTwin.actionBox.confirmation.btn.decline'))+"\n                ")],1),_vm._v(" "),_c('button',{staticClass:"btn light approve",on:{"click":function($event){return _vm.approveOrDecline(true)}}},[_c('MDIcon',{attrs:{"icon":_vm.mdiCheckCircle}}),_vm._v("\n                    "+_vm._s(_vm._$t('verification.digitalTwin.actionBox.confirmation.btn.approve'))+"\n                ")],1)])])]},proxy:true}])})};
var __vue_staticRenderFns__$d = [];

  /* style */
  const __vue_inject_styles__$d = undefined;
  /* scoped */
  const __vue_scope_id__$d = undefined;
  /* module identifier */
  const __vue_module_identifier__$d = undefined;
  /* functional template */
  const __vue_is_functional_template__$d = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$d = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$d, staticRenderFns: __vue_staticRenderFns__$d },
    __vue_inject_styles__$d,
    __vue_script__$d,
    __vue_scope_id__$d,
    __vue_is_functional_template__$d,
    __vue_module_identifier__$d,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$e = {
    name: 'FileDeclinedCard',
    mixins: [i18nWrapperMixin],
    components: {
        BaseCard: __vue_component__$5
    },
    props: {
        fileName: {
            type: String,
            required: true
        }
    },
    methods: {
        toggleHelp(type) {
            this.$emit('toggle-help', type);
        }
    }
};

/* script */
const __vue_script__$e = script$e;

/* template */
var __vue_render__$e = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('BaseCard',{staticClass:"file-declined-card",scopedSlots:_vm._u([{key:"body",fn:function(){return [_c('h3',[_vm._v(_vm._s(_vm._$t('verification.digitalTwin.fileDeclined.title')))]),_vm._v(" "),_c('p',{domProps:{"innerHTML":_vm._s(_vm._$t('verification.digitalTwin.fileDeclined.copy'))}}),_vm._v(" "),_c('button',{staticClass:"btn primary",on:{"click":function($event){return _vm.toggleHelp('contact')}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.digitalTwin.error.btn.contactSupport')))])])]},proxy:true}])})};
var __vue_staticRenderFns__$e = [];

  /* style */
  const __vue_inject_styles__$e = undefined;
  /* scoped */
  const __vue_scope_id__$e = undefined;
  /* module identifier */
  const __vue_module_identifier__$e = undefined;
  /* functional template */
  const __vue_is_functional_template__$e = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$e = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$e, staticRenderFns: __vue_staticRenderFns__$e },
    __vue_inject_styles__$e,
    __vue_script__$e,
    __vue_scope_id__$e,
    __vue_is_functional_template__$e,
    __vue_module_identifier__$e,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$f = {
    name: 'FileErrorCard',
    mixins: [i18nWrapperMixin],
    components: {
        BaseCard: __vue_component__$5
    },
    methods: {
        toggleHelp(type) {
            this.$emit('toggle-help', type);
        }
    }
};

var img$5 = "data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='142' height='168' viewBox='0 0 142 168' fill='none' xmlns:v='https://vecta.io/nano'%3e%3cg filter='url(%23A)'%3e%3cpath transform='translate(12 10)' fill='white' d='M0 0h100v138H0z'/%3e%3cpath fill-rule='evenodd' d='M23.25 22.545c-.69 0-1.25.562-1.25 1.255s.56 1.255 1.25 1.255H52c.69 0 1.25-.562 1.25-1.255s-.56-1.255-1.25-1.255H23.25zm0 7.527c-.69 0-1.25.562-1.25 1.255s.56 1.255 1.25 1.255H52c.69 0 1.25-.562 1.25-1.255s-.56-1.255-1.25-1.255H23.25zM22 51.4c0-.693.56-1.255 1.25-1.255h77.5c.69 0 1.25.562 1.25 1.255s-.56 1.255-1.25 1.255h-77.5c-.69 0-1.25-.562-1.25-1.255zm1.25 6.273c-.69 0-1.25.562-1.25 1.255s.56 1.255 1.25 1.255h77.5c.69 0 1.25-.562 1.25-1.255s-.56-1.255-1.25-1.255h-77.5zM22 66.455c0-.693.56-1.254 1.25-1.254h77.5c.69 0 1.25.562 1.25 1.254s-.56 1.255-1.25 1.255h-77.5c-.69 0-1.25-.562-1.25-1.255zm1.25 6.273c-.69 0-1.25.562-1.25 1.255s.56 1.254 1.25 1.254h77.5c.69 0 1.25-.562 1.25-1.254s-.56-1.255-1.25-1.255h-77.5zM22 81.509c0-.693.56-1.255 1.25-1.255h77.5c.69 0 1.25.562 1.25 1.255s-.56 1.255-1.25 1.255h-77.5c-.69 0-1.25-.562-1.25-1.255zm1.25 6.273c-.69 0-1.25.562-1.25 1.254s.56 1.255 1.25 1.255h35c.69 0 1.25-.562 1.25-1.255s-.56-1.254-1.25-1.254h-35zM22 136.709a1.25 1.25 0 0 1 1.25-1.254H52a1.25 1.25 0 0 1 1.25 1.254c0 .693-.56 1.255-1.25 1.255H23.25c-.69 0-1.25-.562-1.25-1.255zm50.625-1.254a1.25 1.25 0 0 0-1.25 1.254c0 .693.56 1.255 1.25 1.255h28.125c.69 0 1.25-.562 1.25-1.255s-.56-1.254-1.25-1.254H72.625z' fill='%2314213d' fill-opacity='.5'/%3e%3c/g%3e%3cpath fill-rule='evenodd' d='M92 138c0-11.046 8.954-20 20-20 11.04.013 19.987 8.96 20 20 0 11.046-8.954 20-20 20s-20-8.954-20-20zm29.604 8.414c.153-.583-.021-1.202-.454-1.621l-6.5-6.498c-.078-.078-.122-.184-.122-.294s.044-.216.122-.294l6.5-6.5c.45-.414.638-1.042.488-1.635a1.67 1.67 0 0 0-1.206-1.208c-.593-.15-1.221.036-1.635.486l-6.5 6.5a.42.42 0 0 1-.295.122c-.111 0-.217-.044-.295-.122l-6.5-6.5a1.67 1.67 0 0 0-2.358-.003c-.652.651-.653 1.706-.002 2.358l6.5 6.5c.078.078.122.184.122.294s-.044.216-.122.294l-6.5 6.5c-.651.651-.651 1.706 0 2.357.655.64 1.701.64 2.356 0l6.5-6.5a.42.42 0 0 1 .59 0l6.5 6.5c.419.433 1.038.607 1.621.454s1.038-.607 1.19-1.19z' fill='%23ee4266'/%3e%3cdefs%3e%3cfilter id='A' x='0' y='0' width='124' height='162' filterUnits='userSpaceOnUse' color-interpolation-filters='sRGB'%3e%3cfeFlood flood-opacity='0' result='A'/%3e%3cfeColorMatrix in='SourceAlpha' values='0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0'/%3e%3cfeOffset dy='1'/%3e%3cfeGaussianBlur stdDeviation='2'/%3e%3cfeColorMatrix values='0 0 0 0 0.12549 0 0 0 0 0.2 0 0 0 0 0.27451 0 0 0 0.04 0'/%3e%3cfeBlend in2='A' result='B'/%3e%3cfeColorMatrix in='SourceAlpha' values='0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0'/%3e%3cfeOffset dy='2'/%3e%3cfeGaussianBlur stdDeviation='6'/%3e%3cfeColorMatrix values='0 0 0 0 0.12549 0 0 0 0 0.2 0 0 0 0 0.27451 0 0 0 0.09 0'/%3e%3cfeBlend in2='B'/%3e%3cfeBlend in='SourceGraphic'/%3e%3c/filter%3e%3c/defs%3e%3c/svg%3e";

/* script */
const __vue_script__$f = script$f;
var __vue_render__$f = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('BaseCard',{staticClass:"file-error-card",scopedSlots:_vm._u([{key:"body",fn:function(){return [_c('img',{attrs:{"src":img$5,"alt":"DigitalTwin Error"}}),_vm._v(" "),_c('div',{staticClass:"error-message"},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.digitalTwin.error.decryption')))])]),_vm._v(" "),_c('button',{staticClass:"btn primary",on:{"click":function($event){return _vm.toggleHelp('contact')}}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.digitalTwin.error.btn.contactSupport')))])])]},proxy:true}])})};
var __vue_staticRenderFns__$f = [];

  /* style */
  const __vue_inject_styles__$f = undefined;
  /* scoped */
  const __vue_scope_id__$f = undefined;
  /* module identifier */
  const __vue_module_identifier__$f = undefined;
  /* functional template */
  const __vue_is_functional_template__$f = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$f = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$f, staticRenderFns: __vue_staticRenderFns__$f },
    __vue_inject_styles__$f,
    __vue_script__$f,
    __vue_scope_id__$f,
    __vue_is_functional_template__$f,
    __vue_module_identifier__$f,
    false,
    undefined,
    undefined,
    undefined
  );

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _superPropBase(object, property) {
  while (!Object.prototype.hasOwnProperty.call(object, property)) {
    object = _getPrototypeOf(object);
    if (object === null) break;
  }

  return object;
}

function _get(target, property, receiver) {
  if (typeof Reflect !== "undefined" && Reflect.get) {
    _get = Reflect.get;
  } else {
    _get = function _get(target, property, receiver) {
      var base = _superPropBase(target, property);

      if (!base) return;
      var desc = Object.getOwnPropertyDescriptor(base, property);

      if (desc.get) {
        return desc.get.call(receiver);
      }

      return desc.value;
    };
  }

  return _get(target, property, receiver || target);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = o[Symbol.iterator]();
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getAugmentedNamespace(n) {
  if (n.__esModule) return n;
  var a = Object.defineProperty({}, '__esModule', {
    value: true
  });
  Object.keys(n).forEach(function (k) {
    var d = Object.getOwnPropertyDescriptor(n, k);
    Object.defineProperty(a, k, d.get ? d : {
      enumerable: true,
      get: function get() {
        return n[k];
      }
    });
  });
  return a;
}

function createCommonjsModule(fn) {
  var module = {
    exports: {}
  };
  return fn(module, module.exports), module.exports;
}

function commonjsRequire(target) {
  throw new Error('Could not dynamically require "' + target + '". Please configure the dynamicRequireTargets option of @rollup/plugin-commonjs appropriately for this require call to behave properly.');
}

var _nodeResolve_empty = {};

var _nodeResolve_empty$1 = Object.freeze({
  __proto__: null,
  'default': _nodeResolve_empty
});

var require$$5 = getAugmentedNamespace(_nodeResolve_empty$1);
var pdf = createCommonjsModule(function (module, exports) {
  (function webpackUniversalModuleDefinition(root, factory) {
    module.exports = factory();
  })(commonjsGlobal, function () {
    return function (modules) {
      var installedModules = {};

      function __w_pdfjs_require__(moduleId) {
        if (installedModules[moduleId]) {
          return installedModules[moduleId].exports;
        }

        var module = installedModules[moduleId] = {
          i: moduleId,
          l: false,
          exports: {}
        };
        modules[moduleId].call(module.exports, module, module.exports, __w_pdfjs_require__);
        module.l = true;
        return module.exports;
      }

      __w_pdfjs_require__.m = modules;
      __w_pdfjs_require__.c = installedModules;

      __w_pdfjs_require__.d = function (exports, name, getter) {
        if (!__w_pdfjs_require__.o(exports, name)) {
          Object.defineProperty(exports, name, {
            enumerable: true,
            get: getter
          });
        }
      };

      __w_pdfjs_require__.r = function (exports) {
        if (typeof Symbol !== 'undefined' && Symbol.toStringTag) {
          Object.defineProperty(exports, Symbol.toStringTag, {
            value: 'Module'
          });
        }

        Object.defineProperty(exports, '__esModule', {
          value: true
        });
      };

      __w_pdfjs_require__.t = function (value, mode) {
        if (mode & 1) value = __w_pdfjs_require__(value);
        if (mode & 8) return value;
        if (mode & 4 && _typeof(value) === 'object' && value && value.__esModule) return value;
        var ns = Object.create(null);

        __w_pdfjs_require__.r(ns);

        Object.defineProperty(ns, 'default', {
          enumerable: true,
          value: value
        });
        if (mode & 2 && typeof value != 'string') for (var key in value) {
          __w_pdfjs_require__.d(ns, key, function (key) {
            return value[key];
          }.bind(null, key));
        }
        return ns;
      };

      __w_pdfjs_require__.n = function (module) {
        var getter = module && module.__esModule ? function getDefault() {
          return module['default'];
        } : function getModuleExports() {
          return module;
        };

        __w_pdfjs_require__.d(getter, 'a', getter);

        return getter;
      };

      __w_pdfjs_require__.o = function (object, property) {
        return Object.prototype.hasOwnProperty.call(object, property);
      };

      __w_pdfjs_require__.p = "";
      return __w_pdfjs_require__(__w_pdfjs_require__.s = 0);
    }([function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "addLinkAttributes", {
        enumerable: true,
        get: function get() {
          return _display_utils.addLinkAttributes;
        }
      });
      Object.defineProperty(exports, "getFilenameFromUrl", {
        enumerable: true,
        get: function get() {
          return _display_utils.getFilenameFromUrl;
        }
      });
      Object.defineProperty(exports, "LinkTarget", {
        enumerable: true,
        get: function get() {
          return _display_utils.LinkTarget;
        }
      });
      Object.defineProperty(exports, "loadScript", {
        enumerable: true,
        get: function get() {
          return _display_utils.loadScript;
        }
      });
      Object.defineProperty(exports, "PDFDateString", {
        enumerable: true,
        get: function get() {
          return _display_utils.PDFDateString;
        }
      });
      Object.defineProperty(exports, "RenderingCancelledException", {
        enumerable: true,
        get: function get() {
          return _display_utils.RenderingCancelledException;
        }
      });
      Object.defineProperty(exports, "build", {
        enumerable: true,
        get: function get() {
          return _api.build;
        }
      });
      Object.defineProperty(exports, "getDocument", {
        enumerable: true,
        get: function get() {
          return _api.getDocument;
        }
      });
      Object.defineProperty(exports, "LoopbackPort", {
        enumerable: true,
        get: function get() {
          return _api.LoopbackPort;
        }
      });
      Object.defineProperty(exports, "PDFDataRangeTransport", {
        enumerable: true,
        get: function get() {
          return _api.PDFDataRangeTransport;
        }
      });
      Object.defineProperty(exports, "PDFWorker", {
        enumerable: true,
        get: function get() {
          return _api.PDFWorker;
        }
      });
      Object.defineProperty(exports, "version", {
        enumerable: true,
        get: function get() {
          return _api.version;
        }
      });
      Object.defineProperty(exports, "CMapCompressionType", {
        enumerable: true,
        get: function get() {
          return _util.CMapCompressionType;
        }
      });
      Object.defineProperty(exports, "createObjectURL", {
        enumerable: true,
        get: function get() {
          return _util.createObjectURL;
        }
      });
      Object.defineProperty(exports, "createPromiseCapability", {
        enumerable: true,
        get: function get() {
          return _util.createPromiseCapability;
        }
      });
      Object.defineProperty(exports, "createValidAbsoluteUrl", {
        enumerable: true,
        get: function get() {
          return _util.createValidAbsoluteUrl;
        }
      });
      Object.defineProperty(exports, "InvalidPDFException", {
        enumerable: true,
        get: function get() {
          return _util.InvalidPDFException;
        }
      });
      Object.defineProperty(exports, "MissingPDFException", {
        enumerable: true,
        get: function get() {
          return _util.MissingPDFException;
        }
      });
      Object.defineProperty(exports, "OPS", {
        enumerable: true,
        get: function get() {
          return _util.OPS;
        }
      });
      Object.defineProperty(exports, "PasswordResponses", {
        enumerable: true,
        get: function get() {
          return _util.PasswordResponses;
        }
      });
      Object.defineProperty(exports, "PermissionFlag", {
        enumerable: true,
        get: function get() {
          return _util.PermissionFlag;
        }
      });
      Object.defineProperty(exports, "removeNullCharacters", {
        enumerable: true,
        get: function get() {
          return _util.removeNullCharacters;
        }
      });
      Object.defineProperty(exports, "shadow", {
        enumerable: true,
        get: function get() {
          return _util.shadow;
        }
      });
      Object.defineProperty(exports, "UnexpectedResponseException", {
        enumerable: true,
        get: function get() {
          return _util.UnexpectedResponseException;
        }
      });
      Object.defineProperty(exports, "UNSUPPORTED_FEATURES", {
        enumerable: true,
        get: function get() {
          return _util.UNSUPPORTED_FEATURES;
        }
      });
      Object.defineProperty(exports, "Util", {
        enumerable: true,
        get: function get() {
          return _util.Util;
        }
      });
      Object.defineProperty(exports, "VerbosityLevel", {
        enumerable: true,
        get: function get() {
          return _util.VerbosityLevel;
        }
      });
      Object.defineProperty(exports, "AnnotationLayer", {
        enumerable: true,
        get: function get() {
          return _annotation_layer.AnnotationLayer;
        }
      });
      Object.defineProperty(exports, "apiCompatibilityParams", {
        enumerable: true,
        get: function get() {
          return _api_compatibility.apiCompatibilityParams;
        }
      });
      Object.defineProperty(exports, "GlobalWorkerOptions", {
        enumerable: true,
        get: function get() {
          return _worker_options.GlobalWorkerOptions;
        }
      });
      Object.defineProperty(exports, "renderTextLayer", {
        enumerable: true,
        get: function get() {
          return _text_layer.renderTextLayer;
        }
      });
      Object.defineProperty(exports, "SVGGraphics", {
        enumerable: true,
        get: function get() {
          return _svg.SVGGraphics;
        }
      });

      var _display_utils = __w_pdfjs_require__(1);

      var _api = __w_pdfjs_require__(5);

      var _util = __w_pdfjs_require__(2);

      var _annotation_layer = __w_pdfjs_require__(19);

      var _api_compatibility = __w_pdfjs_require__(9);

      var _worker_options = __w_pdfjs_require__(12);

      var _text_layer = __w_pdfjs_require__(20);

      var _svg = __w_pdfjs_require__(21);

      {
        var _w_pdfjs_require__ = __w_pdfjs_require__(4),
            isNodeJS = _w_pdfjs_require__.isNodeJS;

        if (isNodeJS) {
          var PDFNodeStream = __w_pdfjs_require__(22).PDFNodeStream;

          (0, _api.setPDFNetworkStreamFactory)(function (params) {
            return new PDFNodeStream(params);
          });
        } else {
          var PDFNetworkStream = __w_pdfjs_require__(25).PDFNetworkStream;

          var PDFFetchStream;

          if ((0, _display_utils.isFetchSupported)()) {
            PDFFetchStream = __w_pdfjs_require__(26).PDFFetchStream;
          }

          (0, _api.setPDFNetworkStreamFactory)(function (params) {
            if (PDFFetchStream && (0, _display_utils.isValidFetchUrl)(params.url)) {
              return new PDFFetchStream(params);
            }

            return new PDFNetworkStream(params);
          });
        }
      }
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.addLinkAttributes = addLinkAttributes;
      exports.getFilenameFromUrl = getFilenameFromUrl;
      exports.isFetchSupported = isFetchSupported;
      exports.isValidFetchUrl = isValidFetchUrl;
      exports.loadScript = loadScript;
      exports.deprecated = deprecated;
      exports.PDFDateString = exports.StatTimer = exports.DOMSVGFactory = exports.DOMCMapReaderFactory = exports.BaseCMapReaderFactory = exports.DOMCanvasFactory = exports.BaseCanvasFactory = exports.DEFAULT_LINK_REL = exports.LinkTarget = exports.RenderingCancelledException = exports.PageViewport = void 0;

      var _util = __w_pdfjs_require__(2);

      var DEFAULT_LINK_REL = "noopener noreferrer nofollow";
      exports.DEFAULT_LINK_REL = DEFAULT_LINK_REL;
      var SVG_NS = "http://www.w3.org/2000/svg";

      var BaseCanvasFactory = function () {
        function BaseCanvasFactory() {
          _classCallCheck(this, BaseCanvasFactory);

          if (this.constructor === BaseCanvasFactory) {
            (0, _util.unreachable)("Cannot initialize BaseCanvasFactory.");
          }
        }

        _createClass(BaseCanvasFactory, [{
          key: "create",
          value: function create(width, height) {
            (0, _util.unreachable)("Abstract method `create` called.");
          }
        }, {
          key: "reset",
          value: function reset(canvasAndContext, width, height) {
            if (!canvasAndContext.canvas) {
              throw new Error("Canvas is not specified");
            }

            if (width <= 0 || height <= 0) {
              throw new Error("Invalid canvas size");
            }

            canvasAndContext.canvas.width = width;
            canvasAndContext.canvas.height = height;
          }
        }, {
          key: "destroy",
          value: function destroy(canvasAndContext) {
            if (!canvasAndContext.canvas) {
              throw new Error("Canvas is not specified");
            }

            canvasAndContext.canvas.width = 0;
            canvasAndContext.canvas.height = 0;
            canvasAndContext.canvas = null;
            canvasAndContext.context = null;
          }
        }]);

        return BaseCanvasFactory;
      }();

      exports.BaseCanvasFactory = BaseCanvasFactory;

      var DOMCanvasFactory = function (_BaseCanvasFactory) {
        _inherits(DOMCanvasFactory, _BaseCanvasFactory);

        var _super = _createSuper(DOMCanvasFactory);

        function DOMCanvasFactory() {
          var _this;

          var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
              _ref$ownerDocument = _ref.ownerDocument,
              ownerDocument = _ref$ownerDocument === void 0 ? globalThis.document : _ref$ownerDocument;

          _classCallCheck(this, DOMCanvasFactory);

          _this = _super.call(this);
          _this._document = ownerDocument;
          return _this;
        }

        _createClass(DOMCanvasFactory, [{
          key: "create",
          value: function create(width, height) {
            if (width <= 0 || height <= 0) {
              throw new Error("Invalid canvas size");
            }

            var canvas = this._document.createElement("canvas");

            var context = canvas.getContext("2d");
            canvas.width = width;
            canvas.height = height;
            return {
              canvas: canvas,
              context: context
            };
          }
        }]);

        return DOMCanvasFactory;
      }(BaseCanvasFactory);

      exports.DOMCanvasFactory = DOMCanvasFactory;

      var BaseCMapReaderFactory = function () {
        function BaseCMapReaderFactory(_ref2) {
          var _ref2$baseUrl = _ref2.baseUrl,
              baseUrl = _ref2$baseUrl === void 0 ? null : _ref2$baseUrl,
              _ref2$isCompressed = _ref2.isCompressed,
              isCompressed = _ref2$isCompressed === void 0 ? false : _ref2$isCompressed;

          _classCallCheck(this, BaseCMapReaderFactory);

          if (this.constructor === BaseCMapReaderFactory) {
            (0, _util.unreachable)("Cannot initialize BaseCMapReaderFactory.");
          }

          this.baseUrl = baseUrl;
          this.isCompressed = isCompressed;
        }

        _createClass(BaseCMapReaderFactory, [{
          key: "fetch",
          value: function () {
            var _fetch = _asyncToGenerator(regeneratorRuntime.mark(function _callee(_ref3) {
              var _this2 = this;

              var name, url, compressionType;
              return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      name = _ref3.name;

                      if (this.baseUrl) {
                        _context.next = 3;
                        break;
                      }

                      throw new Error('The CMap "baseUrl" parameter must be specified, ensure that ' + 'the "cMapUrl" and "cMapPacked" API parameters are provided.');

                    case 3:
                      if (name) {
                        _context.next = 5;
                        break;
                      }

                      throw new Error("CMap name must be specified.");

                    case 5:
                      url = this.baseUrl + name + (this.isCompressed ? ".bcmap" : "");
                      compressionType = this.isCompressed ? _util.CMapCompressionType.BINARY : _util.CMapCompressionType.NONE;
                      return _context.abrupt("return", this._fetchData(url, compressionType).catch(function (reason) {
                        throw new Error("Unable to load ".concat(_this2.isCompressed ? "binary " : "", "CMap at: ").concat(url));
                      }));

                    case 8:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee, this);
            }));

            function fetch(_x) {
              return _fetch.apply(this, arguments);
            }

            return fetch;
          }()
        }, {
          key: "_fetchData",
          value: function _fetchData(url, compressionType) {
            (0, _util.unreachable)("Abstract method `_fetchData` called.");
          }
        }]);

        return BaseCMapReaderFactory;
      }();

      exports.BaseCMapReaderFactory = BaseCMapReaderFactory;

      var DOMCMapReaderFactory = function (_BaseCMapReaderFactor) {
        _inherits(DOMCMapReaderFactory, _BaseCMapReaderFactor);

        var _super2 = _createSuper(DOMCMapReaderFactory);

        function DOMCMapReaderFactory() {
          _classCallCheck(this, DOMCMapReaderFactory);

          return _super2.apply(this, arguments);
        }

        _createClass(DOMCMapReaderFactory, [{
          key: "_fetchData",
          value: function _fetchData(url, compressionType) {
            var _this3 = this;

            if (isFetchSupported() && isValidFetchUrl(url, document.baseURI)) {
              return fetch(url).then(function () {
                var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(response) {
                  var cMapData;
                  return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          if (response.ok) {
                            _context2.next = 2;
                            break;
                          }

                          throw new Error(response.statusText);

                        case 2:
                          if (!_this3.isCompressed) {
                            _context2.next = 10;
                            break;
                          }

                          _context2.t0 = Uint8Array;
                          _context2.next = 6;
                          return response.arrayBuffer();

                        case 6:
                          _context2.t1 = _context2.sent;
                          cMapData = new _context2.t0(_context2.t1);
                          _context2.next = 15;
                          break;

                        case 10:
                          _context2.t2 = (_util.stringToBytes);
                          _context2.next = 13;
                          return response.text();

                        case 13:
                          _context2.t3 = _context2.sent;
                          cMapData = (0, _context2.t2)(_context2.t3);

                        case 15:
                          return _context2.abrupt("return", {
                            cMapData: cMapData,
                            compressionType: compressionType
                          });

                        case 16:
                        case "end":
                          return _context2.stop();
                      }
                    }
                  }, _callee2);
                }));

                return function (_x2) {
                  return _ref4.apply(this, arguments);
                };
              }());
            }

            return new Promise(function (resolve, reject) {
              var request = new XMLHttpRequest();
              request.open("GET", url, true);

              if (_this3.isCompressed) {
                request.responseType = "arraybuffer";
              }

              request.onreadystatechange = function () {
                if (request.readyState !== XMLHttpRequest.DONE) {
                  return;
                }

                if (request.status === 200 || request.status === 0) {
                  var cMapData;

                  if (_this3.isCompressed && request.response) {
                    cMapData = new Uint8Array(request.response);
                  } else if (!_this3.isCompressed && request.responseText) {
                    cMapData = (0, _util.stringToBytes)(request.responseText);
                  }

                  if (cMapData) {
                    resolve({
                      cMapData: cMapData,
                      compressionType: compressionType
                    });
                    return;
                  }
                }

                reject(new Error(request.statusText));
              };

              request.send(null);
            });
          }
        }]);

        return DOMCMapReaderFactory;
      }(BaseCMapReaderFactory);

      exports.DOMCMapReaderFactory = DOMCMapReaderFactory;

      var DOMSVGFactory = function () {
        function DOMSVGFactory() {
          _classCallCheck(this, DOMSVGFactory);
        }

        _createClass(DOMSVGFactory, [{
          key: "create",
          value: function create(width, height) {
            (0, _util.assert)(width > 0 && height > 0, "Invalid SVG dimensions");
            var svg = document.createElementNS(SVG_NS, "svg:svg");
            svg.setAttribute("version", "1.1");
            svg.setAttribute("width", width + "px");
            svg.setAttribute("height", height + "px");
            svg.setAttribute("preserveAspectRatio", "none");
            svg.setAttribute("viewBox", "0 0 " + width + " " + height);
            return svg;
          }
        }, {
          key: "createElement",
          value: function createElement(type) {
            (0, _util.assert)(typeof type === "string", "Invalid SVG element type");
            return document.createElementNS(SVG_NS, type);
          }
        }]);

        return DOMSVGFactory;
      }();

      exports.DOMSVGFactory = DOMSVGFactory;

      var PageViewport = function () {
        function PageViewport(_ref5) {
          var viewBox = _ref5.viewBox,
              scale = _ref5.scale,
              rotation = _ref5.rotation,
              _ref5$offsetX = _ref5.offsetX,
              offsetX = _ref5$offsetX === void 0 ? 0 : _ref5$offsetX,
              _ref5$offsetY = _ref5.offsetY,
              offsetY = _ref5$offsetY === void 0 ? 0 : _ref5$offsetY,
              _ref5$dontFlip = _ref5.dontFlip,
              dontFlip = _ref5$dontFlip === void 0 ? false : _ref5$dontFlip;

          _classCallCheck(this, PageViewport);

          this.viewBox = viewBox;
          this.scale = scale;
          this.rotation = rotation;
          this.offsetX = offsetX;
          this.offsetY = offsetY;
          var centerX = (viewBox[2] + viewBox[0]) / 2;
          var centerY = (viewBox[3] + viewBox[1]) / 2;
          var rotateA, rotateB, rotateC, rotateD;
          rotation = rotation % 360;
          rotation = rotation < 0 ? rotation + 360 : rotation;

          switch (rotation) {
            case 180:
              rotateA = -1;
              rotateB = 0;
              rotateC = 0;
              rotateD = 1;
              break;

            case 90:
              rotateA = 0;
              rotateB = 1;
              rotateC = 1;
              rotateD = 0;
              break;

            case 270:
              rotateA = 0;
              rotateB = -1;
              rotateC = -1;
              rotateD = 0;
              break;

            case 0:
              rotateA = 1;
              rotateB = 0;
              rotateC = 0;
              rotateD = -1;
              break;

            default:
              throw new Error("PageViewport: Invalid rotation, must be a multiple of 90 degrees.");
          }

          if (dontFlip) {
            rotateC = -rotateC;
            rotateD = -rotateD;
          }

          var offsetCanvasX, offsetCanvasY;
          var width, height;

          if (rotateA === 0) {
            offsetCanvasX = Math.abs(centerY - viewBox[1]) * scale + offsetX;
            offsetCanvasY = Math.abs(centerX - viewBox[0]) * scale + offsetY;
            width = Math.abs(viewBox[3] - viewBox[1]) * scale;
            height = Math.abs(viewBox[2] - viewBox[0]) * scale;
          } else {
            offsetCanvasX = Math.abs(centerX - viewBox[0]) * scale + offsetX;
            offsetCanvasY = Math.abs(centerY - viewBox[1]) * scale + offsetY;
            width = Math.abs(viewBox[2] - viewBox[0]) * scale;
            height = Math.abs(viewBox[3] - viewBox[1]) * scale;
          }

          this.transform = [rotateA * scale, rotateB * scale, rotateC * scale, rotateD * scale, offsetCanvasX - rotateA * scale * centerX - rotateC * scale * centerY, offsetCanvasY - rotateB * scale * centerX - rotateD * scale * centerY];
          this.width = width;
          this.height = height;
        }

        _createClass(PageViewport, [{
          key: "clone",
          value: function clone() {
            var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
                _ref6$scale = _ref6.scale,
                scale = _ref6$scale === void 0 ? this.scale : _ref6$scale,
                _ref6$rotation = _ref6.rotation,
                rotation = _ref6$rotation === void 0 ? this.rotation : _ref6$rotation,
                _ref6$offsetX = _ref6.offsetX,
                offsetX = _ref6$offsetX === void 0 ? this.offsetX : _ref6$offsetX,
                _ref6$offsetY = _ref6.offsetY,
                offsetY = _ref6$offsetY === void 0 ? this.offsetY : _ref6$offsetY,
                _ref6$dontFlip = _ref6.dontFlip,
                dontFlip = _ref6$dontFlip === void 0 ? false : _ref6$dontFlip;

            return new PageViewport({
              viewBox: this.viewBox.slice(),
              scale: scale,
              rotation: rotation,
              offsetX: offsetX,
              offsetY: offsetY,
              dontFlip: dontFlip
            });
          }
        }, {
          key: "convertToViewportPoint",
          value: function convertToViewportPoint(x, y) {
            return _util.Util.applyTransform([x, y], this.transform);
          }
        }, {
          key: "convertToViewportRectangle",
          value: function convertToViewportRectangle(rect) {
            var topLeft = _util.Util.applyTransform([rect[0], rect[1]], this.transform);

            var bottomRight = _util.Util.applyTransform([rect[2], rect[3]], this.transform);

            return [topLeft[0], topLeft[1], bottomRight[0], bottomRight[1]];
          }
        }, {
          key: "convertToPdfPoint",
          value: function convertToPdfPoint(x, y) {
            return _util.Util.applyInverseTransform([x, y], this.transform);
          }
        }]);

        return PageViewport;
      }();

      exports.PageViewport = PageViewport;

      var RenderingCancelledException = function (_util$BaseException) {
        _inherits(RenderingCancelledException, _util$BaseException);

        var _super3 = _createSuper(RenderingCancelledException);

        function RenderingCancelledException(msg, type) {
          var _this4;

          _classCallCheck(this, RenderingCancelledException);

          _this4 = _super3.call(this, msg);
          _this4.type = type;
          return _this4;
        }

        return RenderingCancelledException;
      }(_util.BaseException);

      exports.RenderingCancelledException = RenderingCancelledException;
      var LinkTarget = {
        NONE: 0,
        SELF: 1,
        BLANK: 2,
        PARENT: 3,
        TOP: 4
      };
      exports.LinkTarget = LinkTarget;

      function addLinkAttributes(link) {
        var _ref7 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            url = _ref7.url,
            target = _ref7.target,
            rel = _ref7.rel,
            _ref7$enabled = _ref7.enabled,
            enabled = _ref7$enabled === void 0 ? true : _ref7$enabled;

        (0, _util.assert)(url && typeof url === "string", 'addLinkAttributes: A valid "url" parameter must provided.');
        var urlNullRemoved = (0, _util.removeNullCharacters)(url);

        if (enabled) {
          link.href = link.title = urlNullRemoved;
        } else {
          link.href = "";
          link.title = "Disabled: ".concat(urlNullRemoved);

          link.onclick = function () {
            return false;
          };
        }

        var targetStr = "";

        switch (target) {
          case LinkTarget.NONE:
            break;

          case LinkTarget.SELF:
            targetStr = "_self";
            break;

          case LinkTarget.BLANK:
            targetStr = "_blank";
            break;

          case LinkTarget.PARENT:
            targetStr = "_parent";
            break;

          case LinkTarget.TOP:
            targetStr = "_top";
            break;
        }

        link.target = targetStr;
        link.rel = typeof rel === "string" ? rel : DEFAULT_LINK_REL;
      }

      function getFilenameFromUrl(url) {
        var anchor = url.indexOf("#");
        var query = url.indexOf("?");
        var end = Math.min(anchor > 0 ? anchor : url.length, query > 0 ? query : url.length);
        return url.substring(url.lastIndexOf("/", end) + 1, end);
      }

      var StatTimer = function () {
        function StatTimer() {
          _classCallCheck(this, StatTimer);

          this.started = Object.create(null);
          this.times = [];
        }

        _createClass(StatTimer, [{
          key: "time",
          value: function time(name) {
            if (name in this.started) {
              (0, _util.warn)("Timer is already running for ".concat(name));
            }

            this.started[name] = Date.now();
          }
        }, {
          key: "timeEnd",
          value: function timeEnd(name) {
            if (!(name in this.started)) {
              (0, _util.warn)("Timer has not been started for ".concat(name));
            }

            this.times.push({
              name: name,
              start: this.started[name],
              end: Date.now()
            });
            delete this.started[name];
          }
        }, {
          key: "toString",
          value: function toString() {
            var outBuf = [];
            var longest = 0;

            var _iterator = _createForOfIteratorHelper(this.times),
                _step;

            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                var time = _step.value;
                var name = time.name;

                if (name.length > longest) {
                  longest = name.length;
                }
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }

            var _iterator2 = _createForOfIteratorHelper(this.times),
                _step2;

            try {
              for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                var _time = _step2.value;
                var duration = _time.end - _time.start;
                outBuf.push("".concat(_time.name.padEnd(longest), " ").concat(duration, "ms\n"));
              }
            } catch (err) {
              _iterator2.e(err);
            } finally {
              _iterator2.f();
            }

            return outBuf.join("");
          }
        }]);

        return StatTimer;
      }();

      exports.StatTimer = StatTimer;

      function isFetchSupported() {
        return typeof fetch !== "undefined" && typeof Response !== "undefined" && "body" in Response.prototype && typeof ReadableStream !== "undefined";
      }

      function isValidFetchUrl(url, baseUrl) {
        try {
          var _ref8 = baseUrl ? new URL(url, baseUrl) : new URL(url),
              protocol = _ref8.protocol;

          return protocol === "http:" || protocol === "https:";
        } catch (ex) {
          return false;
        }
      }

      function loadScript(src) {
        return new Promise(function (resolve, reject) {
          var script = document.createElement("script");
          script.src = src;
          script.onload = resolve;

          script.onerror = function () {
            reject(new Error("Cannot load script at: ".concat(script.src)));
          };

          (document.head || document.documentElement).appendChild(script);
        });
      }

      function deprecated(details) {
        console.log("Deprecated API usage: " + details);
      }

      var pdfDateStringRegex;

      var PDFDateString = function () {
        function PDFDateString() {
          _classCallCheck(this, PDFDateString);
        }

        _createClass(PDFDateString, null, [{
          key: "toDateObject",
          value: function toDateObject(input) {
            if (!input || !(0, _util.isString)(input)) {
              return null;
            }

            if (!pdfDateStringRegex) {
              pdfDateStringRegex = new RegExp("^D:" + "(\\d{4})" + "(\\d{2})?" + "(\\d{2})?" + "(\\d{2})?" + "(\\d{2})?" + "(\\d{2})?" + "([Z|+|-])?" + "(\\d{2})?" + "'?" + "(\\d{2})?" + "'?");
            }

            var matches = pdfDateStringRegex.exec(input);

            if (!matches) {
              return null;
            }

            var year = parseInt(matches[1], 10);
            var month = parseInt(matches[2], 10);
            month = month >= 1 && month <= 12 ? month - 1 : 0;
            var day = parseInt(matches[3], 10);
            day = day >= 1 && day <= 31 ? day : 1;
            var hour = parseInt(matches[4], 10);
            hour = hour >= 0 && hour <= 23 ? hour : 0;
            var minute = parseInt(matches[5], 10);
            minute = minute >= 0 && minute <= 59 ? minute : 0;
            var second = parseInt(matches[6], 10);
            second = second >= 0 && second <= 59 ? second : 0;
            var universalTimeRelation = matches[7] || "Z";
            var offsetHour = parseInt(matches[8], 10);
            offsetHour = offsetHour >= 0 && offsetHour <= 23 ? offsetHour : 0;
            var offsetMinute = parseInt(matches[9], 10) || 0;
            offsetMinute = offsetMinute >= 0 && offsetMinute <= 59 ? offsetMinute : 0;

            if (universalTimeRelation === "-") {
              hour += offsetHour;
              minute += offsetMinute;
            } else if (universalTimeRelation === "+") {
              hour -= offsetHour;
              minute -= offsetMinute;
            }

            return new Date(Date.UTC(year, month, day, hour, minute, second));
          }
        }]);

        return PDFDateString;
      }();

      exports.PDFDateString = PDFDateString;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.arrayByteLength = arrayByteLength;
      exports.arraysToBytes = arraysToBytes;
      exports.assert = assert;
      exports.bytesToString = bytesToString;
      exports.createPromiseCapability = createPromiseCapability;
      exports.escapeString = escapeString;
      exports.getModificationDate = getModificationDate;
      exports.getVerbosityLevel = getVerbosityLevel;
      exports.info = info;
      exports.isArrayBuffer = isArrayBuffer;
      exports.isArrayEqual = isArrayEqual;
      exports.isBool = isBool;
      exports.isNum = isNum;
      exports.isString = isString;
      exports.isSameOrigin = isSameOrigin;
      exports.createValidAbsoluteUrl = createValidAbsoluteUrl;
      exports.removeNullCharacters = removeNullCharacters;
      exports.setVerbosityLevel = setVerbosityLevel;
      exports.shadow = shadow;
      exports.string32 = string32;
      exports.stringToBytes = stringToBytes;
      exports.stringToPDFString = stringToPDFString;
      exports.stringToUTF8String = stringToUTF8String;
      exports.utf8StringToString = utf8StringToString;
      exports.warn = warn;
      exports.unreachable = unreachable;
      exports.IsEvalSupportedCached = exports.IsLittleEndianCached = exports.createObjectURL = exports.FormatError = exports.Util = exports.UnknownErrorException = exports.UnexpectedResponseException = exports.TextRenderingMode = exports.StreamType = exports.PermissionFlag = exports.PasswordResponses = exports.PasswordException = exports.MissingPDFException = exports.InvalidPDFException = exports.AbortException = exports.CMapCompressionType = exports.ImageKind = exports.FontType = exports.AnnotationType = exports.AnnotationStateModelType = exports.AnnotationReviewState = exports.AnnotationReplyType = exports.AnnotationMarkedState = exports.AnnotationFlag = exports.AnnotationFieldFlag = exports.AnnotationBorderStyleType = exports.UNSUPPORTED_FEATURES = exports.VerbosityLevel = exports.OPS = exports.IDENTITY_MATRIX = exports.FONT_IDENTITY_MATRIX = exports.BaseException = void 0;

      __w_pdfjs_require__(3);

      var IDENTITY_MATRIX = [1, 0, 0, 1, 0, 0];
      exports.IDENTITY_MATRIX = IDENTITY_MATRIX;
      var FONT_IDENTITY_MATRIX = [0.001, 0, 0, 0.001, 0, 0];
      exports.FONT_IDENTITY_MATRIX = FONT_IDENTITY_MATRIX;
      var PermissionFlag = {
        PRINT: 0x04,
        MODIFY_CONTENTS: 0x08,
        COPY: 0x10,
        MODIFY_ANNOTATIONS: 0x20,
        FILL_INTERACTIVE_FORMS: 0x100,
        COPY_FOR_ACCESSIBILITY: 0x200,
        ASSEMBLE: 0x400,
        PRINT_HIGH_QUALITY: 0x800
      };
      exports.PermissionFlag = PermissionFlag;
      var TextRenderingMode = {
        FILL: 0,
        STROKE: 1,
        FILL_STROKE: 2,
        INVISIBLE: 3,
        FILL_ADD_TO_PATH: 4,
        STROKE_ADD_TO_PATH: 5,
        FILL_STROKE_ADD_TO_PATH: 6,
        ADD_TO_PATH: 7,
        FILL_STROKE_MASK: 3,
        ADD_TO_PATH_FLAG: 4
      };
      exports.TextRenderingMode = TextRenderingMode;
      var ImageKind = {
        GRAYSCALE_1BPP: 1,
        RGB_24BPP: 2,
        RGBA_32BPP: 3
      };
      exports.ImageKind = ImageKind;
      var AnnotationType = {
        TEXT: 1,
        LINK: 2,
        FREETEXT: 3,
        LINE: 4,
        SQUARE: 5,
        CIRCLE: 6,
        POLYGON: 7,
        POLYLINE: 8,
        HIGHLIGHT: 9,
        UNDERLINE: 10,
        SQUIGGLY: 11,
        STRIKEOUT: 12,
        STAMP: 13,
        CARET: 14,
        INK: 15,
        POPUP: 16,
        FILEATTACHMENT: 17,
        SOUND: 18,
        MOVIE: 19,
        WIDGET: 20,
        SCREEN: 21,
        PRINTERMARK: 22,
        TRAPNET: 23,
        WATERMARK: 24,
        THREED: 25,
        REDACT: 26
      };
      exports.AnnotationType = AnnotationType;
      var AnnotationStateModelType = {
        MARKED: "Marked",
        REVIEW: "Review"
      };
      exports.AnnotationStateModelType = AnnotationStateModelType;
      var AnnotationMarkedState = {
        MARKED: "Marked",
        UNMARKED: "Unmarked"
      };
      exports.AnnotationMarkedState = AnnotationMarkedState;
      var AnnotationReviewState = {
        ACCEPTED: "Accepted",
        REJECTED: "Rejected",
        CANCELLED: "Cancelled",
        COMPLETED: "Completed",
        NONE: "None"
      };
      exports.AnnotationReviewState = AnnotationReviewState;
      var AnnotationReplyType = {
        GROUP: "Group",
        REPLY: "R"
      };
      exports.AnnotationReplyType = AnnotationReplyType;
      var AnnotationFlag = {
        INVISIBLE: 0x01,
        HIDDEN: 0x02,
        PRINT: 0x04,
        NOZOOM: 0x08,
        NOROTATE: 0x10,
        NOVIEW: 0x20,
        READONLY: 0x40,
        LOCKED: 0x80,
        TOGGLENOVIEW: 0x100,
        LOCKEDCONTENTS: 0x200
      };
      exports.AnnotationFlag = AnnotationFlag;
      var AnnotationFieldFlag = {
        READONLY: 0x0000001,
        REQUIRED: 0x0000002,
        NOEXPORT: 0x0000004,
        MULTILINE: 0x0001000,
        PASSWORD: 0x0002000,
        NOTOGGLETOOFF: 0x0004000,
        RADIO: 0x0008000,
        PUSHBUTTON: 0x0010000,
        COMBO: 0x0020000,
        EDIT: 0x0040000,
        SORT: 0x0080000,
        FILESELECT: 0x0100000,
        MULTISELECT: 0x0200000,
        DONOTSPELLCHECK: 0x0400000,
        DONOTSCROLL: 0x0800000,
        COMB: 0x1000000,
        RICHTEXT: 0x2000000,
        RADIOSINUNISON: 0x2000000,
        COMMITONSELCHANGE: 0x4000000
      };
      exports.AnnotationFieldFlag = AnnotationFieldFlag;
      var AnnotationBorderStyleType = {
        SOLID: 1,
        DASHED: 2,
        BEVELED: 3,
        INSET: 4,
        UNDERLINE: 5
      };
      exports.AnnotationBorderStyleType = AnnotationBorderStyleType;
      var StreamType = {
        UNKNOWN: "UNKNOWN",
        FLATE: "FLATE",
        LZW: "LZW",
        DCT: "DCT",
        JPX: "JPX",
        JBIG: "JBIG",
        A85: "A85",
        AHX: "AHX",
        CCF: "CCF",
        RLX: "RLX"
      };
      exports.StreamType = StreamType;
      var FontType = {
        UNKNOWN: "UNKNOWN",
        TYPE1: "TYPE1",
        TYPE1C: "TYPE1C",
        CIDFONTTYPE0: "CIDFONTTYPE0",
        CIDFONTTYPE0C: "CIDFONTTYPE0C",
        TRUETYPE: "TRUETYPE",
        CIDFONTTYPE2: "CIDFONTTYPE2",
        TYPE3: "TYPE3",
        OPENTYPE: "OPENTYPE",
        TYPE0: "TYPE0",
        MMTYPE1: "MMTYPE1"
      };
      exports.FontType = FontType;
      var VerbosityLevel = {
        ERRORS: 0,
        WARNINGS: 1,
        INFOS: 5
      };
      exports.VerbosityLevel = VerbosityLevel;
      var CMapCompressionType = {
        NONE: 0,
        BINARY: 1,
        STREAM: 2
      };
      exports.CMapCompressionType = CMapCompressionType;
      var OPS = {
        dependency: 1,
        setLineWidth: 2,
        setLineCap: 3,
        setLineJoin: 4,
        setMiterLimit: 5,
        setDash: 6,
        setRenderingIntent: 7,
        setFlatness: 8,
        setGState: 9,
        save: 10,
        restore: 11,
        transform: 12,
        moveTo: 13,
        lineTo: 14,
        curveTo: 15,
        curveTo2: 16,
        curveTo3: 17,
        closePath: 18,
        rectangle: 19,
        stroke: 20,
        closeStroke: 21,
        fill: 22,
        eoFill: 23,
        fillStroke: 24,
        eoFillStroke: 25,
        closeFillStroke: 26,
        closeEOFillStroke: 27,
        endPath: 28,
        clip: 29,
        eoClip: 30,
        beginText: 31,
        endText: 32,
        setCharSpacing: 33,
        setWordSpacing: 34,
        setHScale: 35,
        setLeading: 36,
        setFont: 37,
        setTextRenderingMode: 38,
        setTextRise: 39,
        moveText: 40,
        setLeadingMoveText: 41,
        setTextMatrix: 42,
        nextLine: 43,
        showText: 44,
        showSpacedText: 45,
        nextLineShowText: 46,
        nextLineSetSpacingShowText: 47,
        setCharWidth: 48,
        setCharWidthAndBounds: 49,
        setStrokeColorSpace: 50,
        setFillColorSpace: 51,
        setStrokeColor: 52,
        setStrokeColorN: 53,
        setFillColor: 54,
        setFillColorN: 55,
        setStrokeGray: 56,
        setFillGray: 57,
        setStrokeRGBColor: 58,
        setFillRGBColor: 59,
        setStrokeCMYKColor: 60,
        setFillCMYKColor: 61,
        shadingFill: 62,
        beginInlineImage: 63,
        beginImageData: 64,
        endInlineImage: 65,
        paintXObject: 66,
        markPoint: 67,
        markPointProps: 68,
        beginMarkedContent: 69,
        beginMarkedContentProps: 70,
        endMarkedContent: 71,
        beginCompat: 72,
        endCompat: 73,
        paintFormXObjectBegin: 74,
        paintFormXObjectEnd: 75,
        beginGroup: 76,
        endGroup: 77,
        beginAnnotations: 78,
        endAnnotations: 79,
        beginAnnotation: 80,
        endAnnotation: 81,
        paintJpegXObject: 82,
        paintImageMaskXObject: 83,
        paintImageMaskXObjectGroup: 84,
        paintImageXObject: 85,
        paintInlineImageXObject: 86,
        paintInlineImageXObjectGroup: 87,
        paintImageXObjectRepeat: 88,
        paintImageMaskXObjectRepeat: 89,
        paintSolidColorImageMask: 90,
        constructPath: 91
      };
      exports.OPS = OPS;
      var UNSUPPORTED_FEATURES = {
        unknown: "unknown",
        forms: "forms",
        javaScript: "javaScript",
        smask: "smask",
        shadingPattern: "shadingPattern",
        font: "font",
        errorTilingPattern: "errorTilingPattern",
        errorExtGState: "errorExtGState",
        errorXObject: "errorXObject",
        errorFontLoadType3: "errorFontLoadType3",
        errorFontState: "errorFontState",
        errorFontMissing: "errorFontMissing",
        errorFontTranslate: "errorFontTranslate",
        errorColorSpace: "errorColorSpace",
        errorOperatorList: "errorOperatorList",
        errorFontToUnicode: "errorFontToUnicode",
        errorFontLoadNative: "errorFontLoadNative",
        errorFontGetPath: "errorFontGetPath",
        errorMarkedContent: "errorMarkedContent"
      };
      exports.UNSUPPORTED_FEATURES = UNSUPPORTED_FEATURES;
      var PasswordResponses = {
        NEED_PASSWORD: 1,
        INCORRECT_PASSWORD: 2
      };
      exports.PasswordResponses = PasswordResponses;
      var verbosity = VerbosityLevel.WARNINGS;

      function setVerbosityLevel(level) {
        if (Number.isInteger(level)) {
          verbosity = level;
        }
      }

      function getVerbosityLevel() {
        return verbosity;
      }

      function info(msg) {
        if (verbosity >= VerbosityLevel.INFOS) {
          console.log("Info: ".concat(msg));
        }
      }

      function warn(msg) {
        if (verbosity >= VerbosityLevel.WARNINGS) {
          console.log("Warning: ".concat(msg));
        }
      }

      function unreachable(msg) {
        throw new Error(msg);
      }

      function assert(cond, msg) {
        if (!cond) {
          unreachable(msg);
        }
      }

      function isSameOrigin(baseUrl, otherUrl) {
        var base;

        try {
          base = new URL(baseUrl);

          if (!base.origin || base.origin === "null") {
            return false;
          }
        } catch (e) {
          return false;
        }

        var other = new URL(otherUrl, base);
        return base.origin === other.origin;
      }

      function _isValidProtocol(url) {
        if (!url) {
          return false;
        }

        switch (url.protocol) {
          case "http:":
          case "https:":
          case "ftp:":
          case "mailto:":
          case "tel:":
            return true;

          default:
            return false;
        }
      }

      function createValidAbsoluteUrl(url, baseUrl) {
        if (!url) {
          return null;
        }

        try {
          var absoluteUrl = baseUrl ? new URL(url, baseUrl) : new URL(url);

          if (_isValidProtocol(absoluteUrl)) {
            return absoluteUrl;
          }
        } catch (ex) {}

        return null;
      }

      function shadow(obj, prop, value) {
        Object.defineProperty(obj, prop, {
          value: value,
          enumerable: true,
          configurable: true,
          writable: false
        });
        return value;
      }

      var BaseException = function BaseExceptionClosure() {
        function BaseException(message) {
          if (this.constructor === BaseException) {
            unreachable("Cannot initialize BaseException.");
          }

          this.message = message;
          this.name = this.constructor.name;
        }

        BaseException.prototype = new Error();
        BaseException.constructor = BaseException;
        return BaseException;
      }();

      exports.BaseException = BaseException;

      var PasswordException = function (_BaseException) {
        _inherits(PasswordException, _BaseException);

        var _super4 = _createSuper(PasswordException);

        function PasswordException(msg, code) {
          var _this5;

          _classCallCheck(this, PasswordException);

          _this5 = _super4.call(this, msg);
          _this5.code = code;
          return _this5;
        }

        return PasswordException;
      }(BaseException);

      exports.PasswordException = PasswordException;

      var UnknownErrorException = function (_BaseException2) {
        _inherits(UnknownErrorException, _BaseException2);

        var _super5 = _createSuper(UnknownErrorException);

        function UnknownErrorException(msg, details) {
          var _this6;

          _classCallCheck(this, UnknownErrorException);

          _this6 = _super5.call(this, msg);
          _this6.details = details;
          return _this6;
        }

        return UnknownErrorException;
      }(BaseException);

      exports.UnknownErrorException = UnknownErrorException;

      var InvalidPDFException = function (_BaseException3) {
        _inherits(InvalidPDFException, _BaseException3);

        var _super6 = _createSuper(InvalidPDFException);

        function InvalidPDFException() {
          _classCallCheck(this, InvalidPDFException);

          return _super6.apply(this, arguments);
        }

        return InvalidPDFException;
      }(BaseException);

      exports.InvalidPDFException = InvalidPDFException;

      var MissingPDFException = function (_BaseException4) {
        _inherits(MissingPDFException, _BaseException4);

        var _super7 = _createSuper(MissingPDFException);

        function MissingPDFException() {
          _classCallCheck(this, MissingPDFException);

          return _super7.apply(this, arguments);
        }

        return MissingPDFException;
      }(BaseException);

      exports.MissingPDFException = MissingPDFException;

      var UnexpectedResponseException = function (_BaseException5) {
        _inherits(UnexpectedResponseException, _BaseException5);

        var _super8 = _createSuper(UnexpectedResponseException);

        function UnexpectedResponseException(msg, status) {
          var _this7;

          _classCallCheck(this, UnexpectedResponseException);

          _this7 = _super8.call(this, msg);
          _this7.status = status;
          return _this7;
        }

        return UnexpectedResponseException;
      }(BaseException);

      exports.UnexpectedResponseException = UnexpectedResponseException;

      var FormatError = function (_BaseException6) {
        _inherits(FormatError, _BaseException6);

        var _super9 = _createSuper(FormatError);

        function FormatError() {
          _classCallCheck(this, FormatError);

          return _super9.apply(this, arguments);
        }

        return FormatError;
      }(BaseException);

      exports.FormatError = FormatError;

      var AbortException = function (_BaseException7) {
        _inherits(AbortException, _BaseException7);

        var _super10 = _createSuper(AbortException);

        function AbortException() {
          _classCallCheck(this, AbortException);

          return _super10.apply(this, arguments);
        }

        return AbortException;
      }(BaseException);

      exports.AbortException = AbortException;
      var NullCharactersRegExp = /\x00/g;

      function removeNullCharacters(str) {
        if (typeof str !== "string") {
          warn("The argument for removeNullCharacters must be a string.");
          return str;
        }

        return str.replace(NullCharactersRegExp, "");
      }

      function bytesToString(bytes) {
        assert(bytes !== null && _typeof(bytes) === "object" && bytes.length !== undefined, "Invalid argument for bytesToString");
        var length = bytes.length;
        var MAX_ARGUMENT_COUNT = 8192;

        if (length < MAX_ARGUMENT_COUNT) {
          return String.fromCharCode.apply(null, bytes);
        }

        var strBuf = [];

        for (var i = 0; i < length; i += MAX_ARGUMENT_COUNT) {
          var chunkEnd = Math.min(i + MAX_ARGUMENT_COUNT, length);
          var chunk = bytes.subarray(i, chunkEnd);
          strBuf.push(String.fromCharCode.apply(null, chunk));
        }

        return strBuf.join("");
      }

      function stringToBytes(str) {
        assert(typeof str === "string", "Invalid argument for stringToBytes");
        var length = str.length;
        var bytes = new Uint8Array(length);

        for (var i = 0; i < length; ++i) {
          bytes[i] = str.charCodeAt(i) & 0xff;
        }

        return bytes;
      }

      function arrayByteLength(arr) {
        if (arr.length !== undefined) {
          return arr.length;
        }

        assert(arr.byteLength !== undefined, "arrayByteLength - invalid argument.");
        return arr.byteLength;
      }

      function arraysToBytes(arr) {
        var length = arr.length;

        if (length === 1 && arr[0] instanceof Uint8Array) {
          return arr[0];
        }

        var resultLength = 0;

        for (var i = 0; i < length; i++) {
          resultLength += arrayByteLength(arr[i]);
        }

        var pos = 0;
        var data = new Uint8Array(resultLength);

        for (var _i = 0; _i < length; _i++) {
          var item = arr[_i];

          if (!(item instanceof Uint8Array)) {
            if (typeof item === "string") {
              item = stringToBytes(item);
            } else {
              item = new Uint8Array(item);
            }
          }

          var itemLength = item.byteLength;
          data.set(item, pos);
          pos += itemLength;
        }

        return data;
      }

      function string32(value) {
        return String.fromCharCode(value >> 24 & 0xff, value >> 16 & 0xff, value >> 8 & 0xff, value & 0xff);
      }

      function isLittleEndian() {
        var buffer8 = new Uint8Array(4);
        buffer8[0] = 1;
        var view32 = new Uint32Array(buffer8.buffer, 0, 1);
        return view32[0] === 1;
      }

      var IsLittleEndianCached = {
        get value() {
          return shadow(this, "value", isLittleEndian());
        }

      };
      exports.IsLittleEndianCached = IsLittleEndianCached;

      function isEvalSupported() {
        try {
          new Function("");
          return true;
        } catch (e) {
          return false;
        }
      }

      var IsEvalSupportedCached = {
        get value() {
          return shadow(this, "value", isEvalSupported());
        }

      };
      exports.IsEvalSupportedCached = IsEvalSupportedCached;
      var rgbBuf = ["rgb(", 0, ",", 0, ",", 0, ")"];

      var Util = function () {
        function Util() {
          _classCallCheck(this, Util);
        }

        _createClass(Util, null, [{
          key: "makeCssRgb",
          value: function makeCssRgb(r, g, b) {
            rgbBuf[1] = r;
            rgbBuf[3] = g;
            rgbBuf[5] = b;
            return rgbBuf.join("");
          }
        }, {
          key: "transform",
          value: function transform(m1, m2) {
            return [m1[0] * m2[0] + m1[2] * m2[1], m1[1] * m2[0] + m1[3] * m2[1], m1[0] * m2[2] + m1[2] * m2[3], m1[1] * m2[2] + m1[3] * m2[3], m1[0] * m2[4] + m1[2] * m2[5] + m1[4], m1[1] * m2[4] + m1[3] * m2[5] + m1[5]];
          }
        }, {
          key: "applyTransform",
          value: function applyTransform(p, m) {
            var xt = p[0] * m[0] + p[1] * m[2] + m[4];
            var yt = p[0] * m[1] + p[1] * m[3] + m[5];
            return [xt, yt];
          }
        }, {
          key: "applyInverseTransform",
          value: function applyInverseTransform(p, m) {
            var d = m[0] * m[3] - m[1] * m[2];
            var xt = (p[0] * m[3] - p[1] * m[2] + m[2] * m[5] - m[4] * m[3]) / d;
            var yt = (-p[0] * m[1] + p[1] * m[0] + m[4] * m[1] - m[5] * m[0]) / d;
            return [xt, yt];
          }
        }, {
          key: "getAxialAlignedBoundingBox",
          value: function getAxialAlignedBoundingBox(r, m) {
            var p1 = Util.applyTransform(r, m);
            var p2 = Util.applyTransform(r.slice(2, 4), m);
            var p3 = Util.applyTransform([r[0], r[3]], m);
            var p4 = Util.applyTransform([r[2], r[1]], m);
            return [Math.min(p1[0], p2[0], p3[0], p4[0]), Math.min(p1[1], p2[1], p3[1], p4[1]), Math.max(p1[0], p2[0], p3[0], p4[0]), Math.max(p1[1], p2[1], p3[1], p4[1])];
          }
        }, {
          key: "inverseTransform",
          value: function inverseTransform(m) {
            var d = m[0] * m[3] - m[1] * m[2];
            return [m[3] / d, -m[1] / d, -m[2] / d, m[0] / d, (m[2] * m[5] - m[4] * m[3]) / d, (m[4] * m[1] - m[5] * m[0]) / d];
          }
        }, {
          key: "apply3dTransform",
          value: function apply3dTransform(m, v) {
            return [m[0] * v[0] + m[1] * v[1] + m[2] * v[2], m[3] * v[0] + m[4] * v[1] + m[5] * v[2], m[6] * v[0] + m[7] * v[1] + m[8] * v[2]];
          }
        }, {
          key: "singularValueDecompose2dScale",
          value: function singularValueDecompose2dScale(m) {
            var transpose = [m[0], m[2], m[1], m[3]];
            var a = m[0] * transpose[0] + m[1] * transpose[2];
            var b = m[0] * transpose[1] + m[1] * transpose[3];
            var c = m[2] * transpose[0] + m[3] * transpose[2];
            var d = m[2] * transpose[1] + m[3] * transpose[3];
            var first = (a + d) / 2;
            var second = Math.sqrt((a + d) * (a + d) - 4 * (a * d - c * b)) / 2;
            var sx = first + second || 1;
            var sy = first - second || 1;
            return [Math.sqrt(sx), Math.sqrt(sy)];
          }
        }, {
          key: "normalizeRect",
          value: function normalizeRect(rect) {
            var r = rect.slice(0);

            if (rect[0] > rect[2]) {
              r[0] = rect[2];
              r[2] = rect[0];
            }

            if (rect[1] > rect[3]) {
              r[1] = rect[3];
              r[3] = rect[1];
            }

            return r;
          }
        }, {
          key: "intersect",
          value: function intersect(rect1, rect2) {
            function compare(a, b) {
              return a - b;
            }

            var orderedX = [rect1[0], rect1[2], rect2[0], rect2[2]].sort(compare);
            var orderedY = [rect1[1], rect1[3], rect2[1], rect2[3]].sort(compare);
            var result = [];
            rect1 = Util.normalizeRect(rect1);
            rect2 = Util.normalizeRect(rect2);

            if (orderedX[0] === rect1[0] && orderedX[1] === rect2[0] || orderedX[0] === rect2[0] && orderedX[1] === rect1[0]) {
              result[0] = orderedX[1];
              result[2] = orderedX[2];
            } else {
              return null;
            }

            if (orderedY[0] === rect1[1] && orderedY[1] === rect2[1] || orderedY[0] === rect2[1] && orderedY[1] === rect1[1]) {
              result[1] = orderedY[1];
              result[3] = orderedY[2];
            } else {
              return null;
            }

            return result;
          }
        }]);

        return Util;
      }();

      exports.Util = Util;
      var PDFStringTranslateTable = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2D8, 0x2C7, 0x2C6, 0x2D9, 0x2DD, 0x2DB, 0x2DA, 0x2DC, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2022, 0x2020, 0x2021, 0x2026, 0x2014, 0x2013, 0x192, 0x2044, 0x2039, 0x203A, 0x2212, 0x2030, 0x201E, 0x201C, 0x201D, 0x2018, 0x2019, 0x201A, 0x2122, 0xFB01, 0xFB02, 0x141, 0x152, 0x160, 0x178, 0x17D, 0x131, 0x142, 0x153, 0x161, 0x17E, 0, 0x20AC];

      function stringToPDFString(str) {
        var length = str.length,
            strBuf = [];

        if (str[0] === "\xFE" && str[1] === "\xFF") {
          for (var i = 2; i < length; i += 2) {
            strBuf.push(String.fromCharCode(str.charCodeAt(i) << 8 | str.charCodeAt(i + 1)));
          }
        } else if (str[0] === "\xFF" && str[1] === "\xFE") {
          for (var _i2 = 2; _i2 < length; _i2 += 2) {
            strBuf.push(String.fromCharCode(str.charCodeAt(_i2 + 1) << 8 | str.charCodeAt(_i2)));
          }
        } else {
          for (var _i3 = 0; _i3 < length; ++_i3) {
            var code = PDFStringTranslateTable[str.charCodeAt(_i3)];
            strBuf.push(code ? String.fromCharCode(code) : str.charAt(_i3));
          }
        }

        return strBuf.join("");
      }

      function escapeString(str) {
        return str.replace(/([\(\)\\])/g, "\\$1");
      }

      function stringToUTF8String(str) {
        return decodeURIComponent(escape(str));
      }

      function utf8StringToString(str) {
        return unescape(encodeURIComponent(str));
      }

      function isBool(v) {
        return typeof v === "boolean";
      }

      function isNum(v) {
        return typeof v === "number";
      }

      function isString(v) {
        return typeof v === "string";
      }

      function isArrayBuffer(v) {
        return _typeof(v) === "object" && v !== null && v.byteLength !== undefined;
      }

      function isArrayEqual(arr1, arr2) {
        if (arr1.length !== arr2.length) {
          return false;
        }

        return arr1.every(function (element, index) {
          return element === arr2[index];
        });
      }

      function getModificationDate() {
        var date = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new Date(Date.now());
        var buffer = [date.getUTCFullYear().toString(), (date.getUTCMonth() + 1).toString().padStart(2, "0"), (date.getUTCDate() + 1).toString().padStart(2, "0"), date.getUTCHours().toString().padStart(2, "0"), date.getUTCMinutes().toString().padStart(2, "0"), date.getUTCSeconds().toString().padStart(2, "0")];
        return buffer.join("");
      }

      function createPromiseCapability() {
        var capability = Object.create(null);
        var isSettled = false;
        Object.defineProperty(capability, "settled", {
          get: function get() {
            return isSettled;
          }
        });
        capability.promise = new Promise(function (resolve, reject) {
          capability.resolve = function (data) {
            isSettled = true;
            resolve(data);
          };

          capability.reject = function (reason) {
            isSettled = true;
            reject(reason);
          };
        });
        return capability;
      }

      var createObjectURL = function createObjectURLClosure() {
        var digits = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
        return function createObjectURL(data, contentType) {
          var forceDataSchema = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

          if (!forceDataSchema && URL.createObjectURL) {
            var blob = new Blob([data], {
              type: contentType
            });
            return URL.createObjectURL(blob);
          }

          var buffer = "data:".concat(contentType, ";base64,");

          for (var i = 0, ii = data.length; i < ii; i += 3) {
            var b1 = data[i] & 0xff;
            var b2 = data[i + 1] & 0xff;
            var b3 = data[i + 2] & 0xff;
            var d1 = b1 >> 2,
                d2 = (b1 & 3) << 4 | b2 >> 4;
            var d3 = i + 1 < ii ? (b2 & 0xf) << 2 | b3 >> 6 : 64;
            var d4 = i + 2 < ii ? b3 & 0x3f : 64;
            buffer += digits[d1] + digits[d2] + digits[d3] + digits[d4];
          }

          return buffer;
        };
      }();

      exports.createObjectURL = createObjectURL;
    }, function (module, exports, __w_pdfjs_require__) {
      __w_pdfjs_require__(4);
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.isNodeJS = void 0;
      var isNodeJS = (typeof process === "undefined" ? "undefined" : _typeof(process)) === "object" && process + "" === "[object process]" && !process.versions.nw && !(process.versions.electron && process.type && process.type !== "browser");
      exports.isNodeJS = isNodeJS;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.getDocument = getDocument;
      exports.setPDFNetworkStreamFactory = setPDFNetworkStreamFactory;
      exports.build = exports.version = exports.PDFPageProxy = exports.PDFDocumentProxy = exports.PDFWorker = exports.PDFDataRangeTransport = exports.LoopbackPort = void 0;

      var _util = __w_pdfjs_require__(2);

      var _display_utils = __w_pdfjs_require__(1);

      var _font_loader = __w_pdfjs_require__(6);

      var _node_utils = __w_pdfjs_require__(7);

      var _annotation_storage = __w_pdfjs_require__(8);

      var _api_compatibility = __w_pdfjs_require__(9);

      var _canvas = __w_pdfjs_require__(10);

      var _worker_options = __w_pdfjs_require__(12);

      var _is_node = __w_pdfjs_require__(4);

      var _message_handler = __w_pdfjs_require__(13);

      var _metadata = __w_pdfjs_require__(14);

      var _optional_content_config = __w_pdfjs_require__(16);

      var _transport_stream = __w_pdfjs_require__(17);

      var _webgl = __w_pdfjs_require__(18);

      var DEFAULT_RANGE_CHUNK_SIZE = 65536;
      var RENDERING_CANCELLED_TIMEOUT = 100;
      var DefaultCanvasFactory = _is_node.isNodeJS ? _node_utils.NodeCanvasFactory : _display_utils.DOMCanvasFactory;
      var DefaultCMapReaderFactory = _is_node.isNodeJS ? _node_utils.NodeCMapReaderFactory : _display_utils.DOMCMapReaderFactory;
      var createPDFNetworkStream;

      function setPDFNetworkStreamFactory(pdfNetworkStreamFactory) {
        createPDFNetworkStream = pdfNetworkStreamFactory;
      }

      function getDocument(src) {
        var task = new PDFDocumentLoadingTask();
        var source;

        if (typeof src === "string") {
          source = {
            url: src
          };
        } else if ((0, _util.isArrayBuffer)(src)) {
          source = {
            data: src
          };
        } else if (src instanceof PDFDataRangeTransport) {
          source = {
            range: src
          };
        } else {
          if (_typeof(src) !== "object") {
            throw new Error("Invalid parameter in getDocument, " + "need either Uint8Array, string or a parameter object");
          }

          if (!src.url && !src.data && !src.range) {
            throw new Error("Invalid parameter object: need either .data, .range or .url");
          }

          source = src;
        }

        var params = Object.create(null);
        var rangeTransport = null,
            worker = null;

        for (var key in source) {
          if (key === "url" && typeof window !== "undefined") {
            params[key] = new URL(source[key], window.location).href;
            continue;
          } else if (key === "range") {
            rangeTransport = source[key];
            continue;
          } else if (key === "worker") {
            worker = source[key];
            continue;
          } else if (key === "data" && !(source[key] instanceof Uint8Array)) {
            var pdfBytes = source[key];

            if (typeof pdfBytes === "string") {
              params[key] = (0, _util.stringToBytes)(pdfBytes);
            } else if (_typeof(pdfBytes) === "object" && pdfBytes !== null && !isNaN(pdfBytes.length)) {
              params[key] = new Uint8Array(pdfBytes);
            } else if ((0, _util.isArrayBuffer)(pdfBytes)) {
              params[key] = new Uint8Array(pdfBytes);
            } else {
              throw new Error("Invalid PDF binary data: either typed array, " + "string or array-like object is expected in the " + "data property.");
            }

            continue;
          }

          params[key] = source[key];
        }

        params.rangeChunkSize = params.rangeChunkSize || DEFAULT_RANGE_CHUNK_SIZE;
        params.CMapReaderFactory = params.CMapReaderFactory || DefaultCMapReaderFactory;
        params.ignoreErrors = params.stopAtErrors !== true;
        params.fontExtraProperties = params.fontExtraProperties === true;
        params.pdfBug = params.pdfBug === true;

        if (!Number.isInteger(params.maxImageSize)) {
          params.maxImageSize = -1;
        }

        if (typeof params.isEvalSupported !== "boolean") {
          params.isEvalSupported = true;
        }

        if (typeof params.disableFontFace !== "boolean") {
          params.disableFontFace = _api_compatibility.apiCompatibilityParams.disableFontFace || false;
        }

        if (typeof params.ownerDocument === "undefined") {
          params.ownerDocument = globalThis.document;
        }

        if (typeof params.disableRange !== "boolean") {
          params.disableRange = false;
        }

        if (typeof params.disableStream !== "boolean") {
          params.disableStream = false;
        }

        if (typeof params.disableAutoFetch !== "boolean") {
          params.disableAutoFetch = false;
        }

        (0, _util.setVerbosityLevel)(params.verbosity);

        if (!worker) {
          var workerParams = {
            verbosity: params.verbosity,
            port: _worker_options.GlobalWorkerOptions.workerPort
          };
          worker = workerParams.port ? PDFWorker.fromPort(workerParams) : new PDFWorker(workerParams);
          task._worker = worker;
        }

        var docId = task.docId;
        worker.promise.then(function () {
          if (task.destroyed) {
            throw new Error("Loading aborted");
          }

          var workerIdPromise = _fetchDocument(worker, params, rangeTransport, docId);

          var networkStreamPromise = new Promise(function (resolve) {
            var networkStream;

            if (rangeTransport) {
              networkStream = new _transport_stream.PDFDataTransportStream({
                length: params.length,
                initialData: params.initialData,
                progressiveDone: params.progressiveDone,
                disableRange: params.disableRange,
                disableStream: params.disableStream
              }, rangeTransport);
            } else if (!params.data) {
              networkStream = createPDFNetworkStream({
                url: params.url,
                length: params.length,
                httpHeaders: params.httpHeaders,
                withCredentials: params.withCredentials,
                rangeChunkSize: params.rangeChunkSize,
                disableRange: params.disableRange,
                disableStream: params.disableStream
              });
            }

            resolve(networkStream);
          });
          return Promise.all([workerIdPromise, networkStreamPromise]).then(function (_ref9) {
            var _ref10 = _slicedToArray(_ref9, 2),
                workerId = _ref10[0],
                networkStream = _ref10[1];

            if (task.destroyed) {
              throw new Error("Loading aborted");
            }

            var messageHandler = new _message_handler.MessageHandler(docId, workerId, worker.port);
            messageHandler.postMessageTransfers = worker.postMessageTransfers;
            var transport = new WorkerTransport(messageHandler, task, networkStream, params);
            task._transport = transport;
            messageHandler.send("Ready", null);
          });
        }).catch(task._capability.reject);
        return task;
      }

      function _fetchDocument(worker, source, pdfDataRangeTransport, docId) {
        if (worker.destroyed) {
          return Promise.reject(new Error("Worker was destroyed"));
        }

        if (pdfDataRangeTransport) {
          source.length = pdfDataRangeTransport.length;
          source.initialData = pdfDataRangeTransport.initialData;
          source.progressiveDone = pdfDataRangeTransport.progressiveDone;
        }

        return worker.messageHandler.sendWithPromise("GetDocRequest", {
          docId: docId,
          apiVersion: '2.6.347',
          source: {
            data: source.data,
            url: source.url,
            password: source.password,
            disableAutoFetch: source.disableAutoFetch,
            rangeChunkSize: source.rangeChunkSize,
            length: source.length
          },
          maxImageSize: source.maxImageSize,
          disableFontFace: source.disableFontFace,
          postMessageTransfers: worker.postMessageTransfers,
          docBaseUrl: source.docBaseUrl,
          ignoreErrors: source.ignoreErrors,
          isEvalSupported: source.isEvalSupported,
          fontExtraProperties: source.fontExtraProperties
        }).then(function (workerId) {
          if (worker.destroyed) {
            throw new Error("Worker was destroyed");
          }

          return workerId;
        });
      }

      var PDFDocumentLoadingTask = function PDFDocumentLoadingTaskClosure() {
        var nextDocumentId = 0;

        var PDFDocumentLoadingTask = function () {
          function PDFDocumentLoadingTask() {
            _classCallCheck(this, PDFDocumentLoadingTask);

            this._capability = (0, _util.createPromiseCapability)();
            this._transport = null;
            this._worker = null;
            this.docId = "d" + nextDocumentId++;
            this.destroyed = false;
            this.onPassword = null;
            this.onProgress = null;
            this.onUnsupportedFeature = null;
          }

          _createClass(PDFDocumentLoadingTask, [{
            key: "promise",
            get: function get() {
              return this._capability.promise;
            }
          }, {
            key: "destroy",
            value: function destroy() {
              var _this8 = this;

              this.destroyed = true;
              var transportDestroyed = !this._transport ? Promise.resolve() : this._transport.destroy();
              return transportDestroyed.then(function () {
                _this8._transport = null;

                if (_this8._worker) {
                  _this8._worker.destroy();

                  _this8._worker = null;
                }
              });
            }
          }]);

          return PDFDocumentLoadingTask;
        }();

        return PDFDocumentLoadingTask;
      }();

      var PDFDataRangeTransport = function () {
        function PDFDataRangeTransport(length, initialData) {
          var progressiveDone = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

          _classCallCheck(this, PDFDataRangeTransport);

          this.length = length;
          this.initialData = initialData;
          this.progressiveDone = progressiveDone;
          this._rangeListeners = [];
          this._progressListeners = [];
          this._progressiveReadListeners = [];
          this._progressiveDoneListeners = [];
          this._readyCapability = (0, _util.createPromiseCapability)();
        }

        _createClass(PDFDataRangeTransport, [{
          key: "addRangeListener",
          value: function addRangeListener(listener) {
            this._rangeListeners.push(listener);
          }
        }, {
          key: "addProgressListener",
          value: function addProgressListener(listener) {
            this._progressListeners.push(listener);
          }
        }, {
          key: "addProgressiveReadListener",
          value: function addProgressiveReadListener(listener) {
            this._progressiveReadListeners.push(listener);
          }
        }, {
          key: "addProgressiveDoneListener",
          value: function addProgressiveDoneListener(listener) {
            this._progressiveDoneListeners.push(listener);
          }
        }, {
          key: "onDataRange",
          value: function onDataRange(begin, chunk) {
            var _iterator3 = _createForOfIteratorHelper(this._rangeListeners),
                _step3;

            try {
              for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                var listener = _step3.value;
                listener(begin, chunk);
              }
            } catch (err) {
              _iterator3.e(err);
            } finally {
              _iterator3.f();
            }
          }
        }, {
          key: "onDataProgress",
          value: function onDataProgress(loaded, total) {
            var _this9 = this;

            this._readyCapability.promise.then(function () {
              var _iterator4 = _createForOfIteratorHelper(_this9._progressListeners),
                  _step4;

              try {
                for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
                  var listener = _step4.value;
                  listener(loaded, total);
                }
              } catch (err) {
                _iterator4.e(err);
              } finally {
                _iterator4.f();
              }
            });
          }
        }, {
          key: "onDataProgressiveRead",
          value: function onDataProgressiveRead(chunk) {
            var _this10 = this;

            this._readyCapability.promise.then(function () {
              var _iterator5 = _createForOfIteratorHelper(_this10._progressiveReadListeners),
                  _step5;

              try {
                for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
                  var listener = _step5.value;
                  listener(chunk);
                }
              } catch (err) {
                _iterator5.e(err);
              } finally {
                _iterator5.f();
              }
            });
          }
        }, {
          key: "onDataProgressiveDone",
          value: function onDataProgressiveDone() {
            var _this11 = this;

            this._readyCapability.promise.then(function () {
              var _iterator6 = _createForOfIteratorHelper(_this11._progressiveDoneListeners),
                  _step6;

              try {
                for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
                  var listener = _step6.value;
                  listener();
                }
              } catch (err) {
                _iterator6.e(err);
              } finally {
                _iterator6.f();
              }
            });
          }
        }, {
          key: "transportReady",
          value: function transportReady() {
            this._readyCapability.resolve();
          }
        }, {
          key: "requestDataRange",
          value: function requestDataRange(begin, end) {
            (0, _util.unreachable)("Abstract method PDFDataRangeTransport.requestDataRange");
          }
        }, {
          key: "abort",
          value: function abort() {}
        }]);

        return PDFDataRangeTransport;
      }();

      exports.PDFDataRangeTransport = PDFDataRangeTransport;

      var PDFDocumentProxy = function () {
        function PDFDocumentProxy(pdfInfo, transport) {
          _classCallCheck(this, PDFDocumentProxy);

          this._pdfInfo = pdfInfo;
          this._transport = transport;
        }

        _createClass(PDFDocumentProxy, [{
          key: "annotationStorage",
          get: function get() {
            return (0, _util.shadow)(this, "annotationStorage", new _annotation_storage.AnnotationStorage());
          }
        }, {
          key: "numPages",
          get: function get() {
            return this._pdfInfo.numPages;
          }
        }, {
          key: "fingerprint",
          get: function get() {
            return this._pdfInfo.fingerprint;
          }
        }, {
          key: "getPage",
          value: function getPage(pageNumber) {
            return this._transport.getPage(pageNumber);
          }
        }, {
          key: "getPageIndex",
          value: function getPageIndex(ref) {
            return this._transport.getPageIndex(ref);
          }
        }, {
          key: "getDestinations",
          value: function getDestinations() {
            return this._transport.getDestinations();
          }
        }, {
          key: "getDestination",
          value: function getDestination(id) {
            return this._transport.getDestination(id);
          }
        }, {
          key: "getPageLabels",
          value: function getPageLabels() {
            return this._transport.getPageLabels();
          }
        }, {
          key: "getPageLayout",
          value: function getPageLayout() {
            return this._transport.getPageLayout();
          }
        }, {
          key: "getPageMode",
          value: function getPageMode() {
            return this._transport.getPageMode();
          }
        }, {
          key: "getViewerPreferences",
          value: function getViewerPreferences() {
            return this._transport.getViewerPreferences();
          }
        }, {
          key: "getOpenAction",
          value: function getOpenAction() {
            return this._transport.getOpenAction();
          }
        }, {
          key: "getAttachments",
          value: function getAttachments() {
            return this._transport.getAttachments();
          }
        }, {
          key: "getJavaScript",
          value: function getJavaScript() {
            return this._transport.getJavaScript();
          }
        }, {
          key: "getOutline",
          value: function getOutline() {
            return this._transport.getOutline();
          }
        }, {
          key: "getOptionalContentConfig",
          value: function getOptionalContentConfig() {
            return this._transport.getOptionalContentConfig();
          }
        }, {
          key: "getPermissions",
          value: function getPermissions() {
            return this._transport.getPermissions();
          }
        }, {
          key: "getMetadata",
          value: function getMetadata() {
            return this._transport.getMetadata();
          }
        }, {
          key: "getData",
          value: function getData() {
            return this._transport.getData();
          }
        }, {
          key: "getDownloadInfo",
          value: function getDownloadInfo() {
            return this._transport.downloadInfoCapability.promise;
          }
        }, {
          key: "getStats",
          value: function getStats() {
            return this._transport.getStats();
          }
        }, {
          key: "cleanup",
          value: function cleanup() {
            return this._transport.startCleanup();
          }
        }, {
          key: "destroy",
          value: function destroy() {
            return this.loadingTask.destroy();
          }
        }, {
          key: "loadingParams",
          get: function get() {
            return this._transport.loadingParams;
          }
        }, {
          key: "loadingTask",
          get: function get() {
            return this._transport.loadingTask;
          }
        }, {
          key: "saveDocument",
          value: function saveDocument(annotationStorage) {
            return this._transport.saveDocument(annotationStorage);
          }
        }]);

        return PDFDocumentProxy;
      }();

      exports.PDFDocumentProxy = PDFDocumentProxy;

      var PDFPageProxy = function () {
        function PDFPageProxy(pageIndex, pageInfo, transport, ownerDocument) {
          var pdfBug = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;

          _classCallCheck(this, PDFPageProxy);

          this._pageIndex = pageIndex;
          this._pageInfo = pageInfo;
          this._ownerDocument = ownerDocument;
          this._transport = transport;
          this._stats = pdfBug ? new _display_utils.StatTimer() : null;
          this._pdfBug = pdfBug;
          this.commonObjs = transport.commonObjs;
          this.objs = new PDFObjects();
          this.cleanupAfterRender = false;
          this.pendingCleanup = false;
          this._intentStates = new Map();
          this.destroyed = false;
        }

        _createClass(PDFPageProxy, [{
          key: "pageNumber",
          get: function get() {
            return this._pageIndex + 1;
          }
        }, {
          key: "rotate",
          get: function get() {
            return this._pageInfo.rotate;
          }
        }, {
          key: "ref",
          get: function get() {
            return this._pageInfo.ref;
          }
        }, {
          key: "userUnit",
          get: function get() {
            return this._pageInfo.userUnit;
          }
        }, {
          key: "view",
          get: function get() {
            return this._pageInfo.view;
          }
        }, {
          key: "getViewport",
          value: function getViewport() {
            var _ref11 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
                scale = _ref11.scale,
                _ref11$rotation = _ref11.rotation,
                rotation = _ref11$rotation === void 0 ? this.rotate : _ref11$rotation,
                _ref11$offsetX = _ref11.offsetX,
                offsetX = _ref11$offsetX === void 0 ? 0 : _ref11$offsetX,
                _ref11$offsetY = _ref11.offsetY,
                offsetY = _ref11$offsetY === void 0 ? 0 : _ref11$offsetY,
                _ref11$dontFlip = _ref11.dontFlip,
                dontFlip = _ref11$dontFlip === void 0 ? false : _ref11$dontFlip;

            return new _display_utils.PageViewport({
              viewBox: this.view,
              scale: scale,
              rotation: rotation,
              offsetX: offsetX,
              offsetY: offsetY,
              dontFlip: dontFlip
            });
          }
        }, {
          key: "getAnnotations",
          value: function getAnnotations() {
            var _ref12 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
                _ref12$intent = _ref12.intent,
                intent = _ref12$intent === void 0 ? null : _ref12$intent;

            if (!this.annotationsPromise || this.annotationsIntent !== intent) {
              this.annotationsPromise = this._transport.getAnnotations(this._pageIndex, intent);
              this.annotationsIntent = intent;
            }

            return this.annotationsPromise;
          }
        }, {
          key: "render",
          value: function render(_ref13) {
            var _this12 = this;

            var canvasContext = _ref13.canvasContext,
                viewport = _ref13.viewport,
                _ref13$intent = _ref13.intent,
                intent = _ref13$intent === void 0 ? "display" : _ref13$intent,
                _ref13$enableWebGL = _ref13.enableWebGL,
                enableWebGL = _ref13$enableWebGL === void 0 ? false : _ref13$enableWebGL,
                _ref13$renderInteract = _ref13.renderInteractiveForms,
                renderInteractiveForms = _ref13$renderInteract === void 0 ? false : _ref13$renderInteract,
                _ref13$transform = _ref13.transform,
                transform = _ref13$transform === void 0 ? null : _ref13$transform,
                _ref13$imageLayer = _ref13.imageLayer,
                imageLayer = _ref13$imageLayer === void 0 ? null : _ref13$imageLayer,
                _ref13$canvasFactory = _ref13.canvasFactory,
                canvasFactory = _ref13$canvasFactory === void 0 ? null : _ref13$canvasFactory,
                _ref13$background = _ref13.background,
                background = _ref13$background === void 0 ? null : _ref13$background,
                _ref13$annotationStor = _ref13.annotationStorage,
                annotationStorage = _ref13$annotationStor === void 0 ? null : _ref13$annotationStor,
                _ref13$optionalConten = _ref13.optionalContentConfigPromise,
                optionalContentConfigPromise = _ref13$optionalConten === void 0 ? null : _ref13$optionalConten;

            if (this._stats) {
              this._stats.time("Overall");
            }

            var renderingIntent = intent === "print" ? "print" : "display";
            this.pendingCleanup = false;

            if (!optionalContentConfigPromise) {
              optionalContentConfigPromise = this._transport.getOptionalContentConfig();
            }

            var intentState = this._intentStates.get(renderingIntent);

            if (!intentState) {
              intentState = Object.create(null);

              this._intentStates.set(renderingIntent, intentState);
            }

            if (intentState.streamReaderCancelTimeout) {
              clearTimeout(intentState.streamReaderCancelTimeout);
              intentState.streamReaderCancelTimeout = null;
            }

            var canvasFactoryInstance = canvasFactory || new DefaultCanvasFactory({
              ownerDocument: this._ownerDocument
            });
            var webGLContext = new _webgl.WebGLContext({
              enable: enableWebGL
            });

            if (!intentState.displayReadyCapability) {
              intentState.displayReadyCapability = (0, _util.createPromiseCapability)();
              intentState.operatorList = {
                fnArray: [],
                argsArray: [],
                lastChunk: false
              };

              if (this._stats) {
                this._stats.time("Page Request");
              }

              this._pumpOperatorList({
                pageIndex: this._pageIndex,
                intent: renderingIntent,
                renderInteractiveForms: renderInteractiveForms === true,
                annotationStorage: annotationStorage && annotationStorage.getAll() || null
              });
            }

            var complete = function complete(error) {
              var i = intentState.renderTasks.indexOf(internalRenderTask);

              if (i >= 0) {
                intentState.renderTasks.splice(i, 1);
              }

              if (_this12.cleanupAfterRender || renderingIntent === "print") {
                _this12.pendingCleanup = true;
              }

              _this12._tryCleanup();

              if (error) {
                internalRenderTask.capability.reject(error);

                _this12._abortOperatorList({
                  intentState: intentState,
                  reason: error
                });
              } else {
                internalRenderTask.capability.resolve();
              }

              if (_this12._stats) {
                _this12._stats.timeEnd("Rendering");

                _this12._stats.timeEnd("Overall");
              }
            };

            var internalRenderTask = new InternalRenderTask({
              callback: complete,
              params: {
                canvasContext: canvasContext,
                viewport: viewport,
                transform: transform,
                imageLayer: imageLayer,
                background: background
              },
              objs: this.objs,
              commonObjs: this.commonObjs,
              operatorList: intentState.operatorList,
              pageIndex: this._pageIndex,
              canvasFactory: canvasFactoryInstance,
              webGLContext: webGLContext,
              useRequestAnimationFrame: renderingIntent !== "print",
              pdfBug: this._pdfBug
            });

            if (!intentState.renderTasks) {
              intentState.renderTasks = [];
            }

            intentState.renderTasks.push(internalRenderTask);
            var renderTask = internalRenderTask.task;
            Promise.all([intentState.displayReadyCapability.promise, optionalContentConfigPromise]).then(function (_ref14) {
              var _ref15 = _slicedToArray(_ref14, 2),
                  transparency = _ref15[0],
                  optionalContentConfig = _ref15[1];

              if (_this12.pendingCleanup) {
                complete();
                return;
              }

              if (_this12._stats) {
                _this12._stats.time("Rendering");
              }

              internalRenderTask.initializeGraphics({
                transparency: transparency,
                optionalContentConfig: optionalContentConfig
              });
              internalRenderTask.operatorListChanged();
            }).catch(complete);
            return renderTask;
          }
        }, {
          key: "getOperatorList",
          value: function getOperatorList() {
            function operatorListChanged() {
              if (intentState.operatorList.lastChunk) {
                intentState.opListReadCapability.resolve(intentState.operatorList);
                var i = intentState.renderTasks.indexOf(opListTask);

                if (i >= 0) {
                  intentState.renderTasks.splice(i, 1);
                }
              }
            }

            var renderingIntent = "oplist";

            var intentState = this._intentStates.get(renderingIntent);

            if (!intentState) {
              intentState = Object.create(null);

              this._intentStates.set(renderingIntent, intentState);
            }

            var opListTask;

            if (!intentState.opListReadCapability) {
              opListTask = Object.create(null);
              opListTask.operatorListChanged = operatorListChanged;
              intentState.opListReadCapability = (0, _util.createPromiseCapability)();
              intentState.renderTasks = [];
              intentState.renderTasks.push(opListTask);
              intentState.operatorList = {
                fnArray: [],
                argsArray: [],
                lastChunk: false
              };

              if (this._stats) {
                this._stats.time("Page Request");
              }

              this._pumpOperatorList({
                pageIndex: this._pageIndex,
                intent: renderingIntent
              });
            }

            return intentState.opListReadCapability.promise;
          }
        }, {
          key: "streamTextContent",
          value: function streamTextContent() {
            var _ref16 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
                _ref16$normalizeWhite = _ref16.normalizeWhitespace,
                normalizeWhitespace = _ref16$normalizeWhite === void 0 ? false : _ref16$normalizeWhite,
                _ref16$disableCombine = _ref16.disableCombineTextItems,
                disableCombineTextItems = _ref16$disableCombine === void 0 ? false : _ref16$disableCombine;

            var TEXT_CONTENT_CHUNK_SIZE = 100;
            return this._transport.messageHandler.sendWithStream("GetTextContent", {
              pageIndex: this._pageIndex,
              normalizeWhitespace: normalizeWhitespace === true,
              combineTextItems: disableCombineTextItems !== true
            }, {
              highWaterMark: TEXT_CONTENT_CHUNK_SIZE,
              size: function size(textContent) {
                return textContent.items.length;
              }
            });
          }
        }, {
          key: "getTextContent",
          value: function getTextContent() {
            var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
            var readableStream = this.streamTextContent(params);
            return new Promise(function (resolve, reject) {
              function pump() {
                reader.read().then(function (_ref17) {
                  var _textContent$items;

                  var value = _ref17.value,
                      done = _ref17.done;

                  if (done) {
                    resolve(textContent);
                    return;
                  }

                  Object.assign(textContent.styles, value.styles);

                  (_textContent$items = textContent.items).push.apply(_textContent$items, _toConsumableArray(value.items));

                  pump();
                }, reject);
              }

              var reader = readableStream.getReader();
              var textContent = {
                items: [],
                styles: Object.create(null)
              };
              pump();
            });
          }
        }, {
          key: "_destroy",
          value: function _destroy() {
            this.destroyed = true;
            this._transport.pageCache[this._pageIndex] = null;
            var waitOn = [];

            var _iterator7 = _createForOfIteratorHelper(this._intentStates),
                _step7;

            try {
              for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
                var _step7$value = _slicedToArray(_step7.value, 2),
                    intent = _step7$value[0],
                    intentState = _step7$value[1];

                this._abortOperatorList({
                  intentState: intentState,
                  reason: new Error("Page was destroyed."),
                  force: true
                });

                if (intent === "oplist") {
                  continue;
                }

                var _iterator8 = _createForOfIteratorHelper(intentState.renderTasks),
                    _step8;

                try {
                  for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
                    var internalRenderTask = _step8.value;
                    waitOn.push(internalRenderTask.completed);
                    internalRenderTask.cancel();
                  }
                } catch (err) {
                  _iterator8.e(err);
                } finally {
                  _iterator8.f();
                }
              }
            } catch (err) {
              _iterator7.e(err);
            } finally {
              _iterator7.f();
            }

            this.objs.clear();
            this.annotationsPromise = null;
            this.pendingCleanup = false;
            return Promise.all(waitOn);
          }
        }, {
          key: "cleanup",
          value: function cleanup() {
            var resetStats = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
            this.pendingCleanup = true;
            return this._tryCleanup(resetStats);
          }
        }, {
          key: "_tryCleanup",
          value: function _tryCleanup() {
            var resetStats = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

            if (!this.pendingCleanup) {
              return false;
            }

            var _iterator9 = _createForOfIteratorHelper(this._intentStates.values()),
                _step9;

            try {
              for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
                var _step9$value = _step9.value,
                    renderTasks = _step9$value.renderTasks,
                    operatorList = _step9$value.operatorList;

                if (renderTasks.length !== 0 || !operatorList.lastChunk) {
                  return false;
                }
              }
            } catch (err) {
              _iterator9.e(err);
            } finally {
              _iterator9.f();
            }

            this._intentStates.clear();

            this.objs.clear();
            this.annotationsPromise = null;

            if (resetStats && this._stats) {
              this._stats = new _display_utils.StatTimer();
            }

            this.pendingCleanup = false;
            return true;
          }
        }, {
          key: "_startRenderPage",
          value: function _startRenderPage(transparency, intent) {
            var intentState = this._intentStates.get(intent);

            if (!intentState) {
              return;
            }

            if (this._stats) {
              this._stats.timeEnd("Page Request");
            }

            if (intentState.displayReadyCapability) {
              intentState.displayReadyCapability.resolve(transparency);
            }
          }
        }, {
          key: "_renderPageChunk",
          value: function _renderPageChunk(operatorListChunk, intentState) {
            for (var i = 0, ii = operatorListChunk.length; i < ii; i++) {
              intentState.operatorList.fnArray.push(operatorListChunk.fnArray[i]);
              intentState.operatorList.argsArray.push(operatorListChunk.argsArray[i]);
            }

            intentState.operatorList.lastChunk = operatorListChunk.lastChunk;

            for (var _i4 = 0; _i4 < intentState.renderTasks.length; _i4++) {
              intentState.renderTasks[_i4].operatorListChanged();
            }

            if (operatorListChunk.lastChunk) {
              this._tryCleanup();
            }
          }
        }, {
          key: "_pumpOperatorList",
          value: function _pumpOperatorList(args) {
            var _this13 = this;

            (0, _util.assert)(args.intent, 'PDFPageProxy._pumpOperatorList: Expected "intent" argument.');

            var readableStream = this._transport.messageHandler.sendWithStream("GetOperatorList", args);

            var reader = readableStream.getReader();

            var intentState = this._intentStates.get(args.intent);

            intentState.streamReader = reader;

            var pump = function pump() {
              reader.read().then(function (_ref18) {
                var value = _ref18.value,
                    done = _ref18.done;

                if (done) {
                  intentState.streamReader = null;
                  return;
                }

                if (_this13._transport.destroyed) {
                  return;
                }

                _this13._renderPageChunk(value, intentState);

                pump();
              }, function (reason) {
                intentState.streamReader = null;

                if (_this13._transport.destroyed) {
                  return;
                }

                if (intentState.operatorList) {
                  intentState.operatorList.lastChunk = true;

                  for (var i = 0; i < intentState.renderTasks.length; i++) {
                    intentState.renderTasks[i].operatorListChanged();
                  }

                  _this13._tryCleanup();
                }

                if (intentState.displayReadyCapability) {
                  intentState.displayReadyCapability.reject(reason);
                } else if (intentState.opListReadCapability) {
                  intentState.opListReadCapability.reject(reason);
                } else {
                  throw reason;
                }
              });
            };

            pump();
          }
        }, {
          key: "_abortOperatorList",
          value: function _abortOperatorList(_ref19) {
            var _this14 = this;

            var intentState = _ref19.intentState,
                reason = _ref19.reason,
                _ref19$force = _ref19.force,
                force = _ref19$force === void 0 ? false : _ref19$force;
            (0, _util.assert)(reason instanceof Error || _typeof(reason) === "object" && reason !== null, 'PDFPageProxy._abortOperatorList: Expected "reason" argument.');

            if (!intentState.streamReader) {
              return;
            }

            if (!force) {
              if (intentState.renderTasks.length !== 0) {
                return;
              }

              if (reason instanceof _display_utils.RenderingCancelledException) {
                intentState.streamReaderCancelTimeout = setTimeout(function () {
                  _this14._abortOperatorList({
                    intentState: intentState,
                    reason: reason,
                    force: true
                  });

                  intentState.streamReaderCancelTimeout = null;
                }, RENDERING_CANCELLED_TIMEOUT);
                return;
              }
            }

            intentState.streamReader.cancel(new _util.AbortException(reason && reason.message));
            intentState.streamReader = null;

            if (this._transport.destroyed) {
              return;
            }

            var _iterator10 = _createForOfIteratorHelper(this._intentStates),
                _step10;

            try {
              for (_iterator10.s(); !(_step10 = _iterator10.n()).done;) {
                var _step10$value = _slicedToArray(_step10.value, 2),
                    intent = _step10$value[0],
                    curIntentState = _step10$value[1];

                if (curIntentState === intentState) {
                  this._intentStates.delete(intent);

                  break;
                }
              }
            } catch (err) {
              _iterator10.e(err);
            } finally {
              _iterator10.f();
            }

            this.cleanup();
          }
        }, {
          key: "stats",
          get: function get() {
            return this._stats;
          }
        }]);

        return PDFPageProxy;
      }();

      exports.PDFPageProxy = PDFPageProxy;

      var LoopbackPort = function () {
        function LoopbackPort() {
          var defer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

          _classCallCheck(this, LoopbackPort);

          this._listeners = [];
          this._defer = defer;
          this._deferred = Promise.resolve(undefined);
        }

        _createClass(LoopbackPort, [{
          key: "postMessage",
          value: function postMessage(obj, transfers) {
            var _this15 = this;

            function cloneValue(value) {
              if (_typeof(value) !== "object" || value === null) {
                return value;
              }

              if (cloned.has(value)) {
                return cloned.get(value);
              }

              var buffer, result;

              if ((buffer = value.buffer) && (0, _util.isArrayBuffer)(buffer)) {
                var transferable = transfers && transfers.includes(buffer);

                if (transferable) {
                  result = new value.constructor(buffer, value.byteOffset, value.byteLength);
                } else {
                  result = new value.constructor(value);
                }

                cloned.set(value, result);
                return result;
              }

              result = Array.isArray(value) ? [] : {};
              cloned.set(value, result);

              for (var i in value) {
                var desc = void 0,
                    p = value;

                while (!(desc = Object.getOwnPropertyDescriptor(p, i))) {
                  p = Object.getPrototypeOf(p);
                }

                if (typeof desc.value === "undefined") {
                  continue;
                }

                if (typeof desc.value === "function") {
                  if (value.hasOwnProperty && value.hasOwnProperty(i)) {
                    throw new Error("LoopbackPort.postMessage - cannot clone: ".concat(value[i]));
                  }

                  continue;
                }

                result[i] = cloneValue(desc.value);
              }

              return result;
            }

            if (!this._defer) {
              this._listeners.forEach(function (listener) {
                listener.call(_this15, {
                  data: obj
                });
              });

              return;
            }

            var cloned = new WeakMap();
            var e = {
              data: cloneValue(obj)
            };

            this._deferred.then(function () {
              _this15._listeners.forEach(function (listener) {
                listener.call(_this15, e);
              });
            });
          }
        }, {
          key: "addEventListener",
          value: function addEventListener(name, listener) {
            this._listeners.push(listener);
          }
        }, {
          key: "removeEventListener",
          value: function removeEventListener(name, listener) {
            var i = this._listeners.indexOf(listener);

            this._listeners.splice(i, 1);
          }
        }, {
          key: "terminate",
          value: function terminate() {
            this._listeners.length = 0;
          }
        }]);

        return LoopbackPort;
      }();

      exports.LoopbackPort = LoopbackPort;

      var PDFWorker = function PDFWorkerClosure() {
        var pdfWorkerPorts = new WeakMap();
        var isWorkerDisabled = false;
        var fallbackWorkerSrc;
        var nextFakeWorkerId = 0;
        var fakeWorkerCapability;

        if (_is_node.isNodeJS && typeof commonjsRequire === "function") {
          isWorkerDisabled = true;
          fallbackWorkerSrc = "./pdf.worker.js";
        } else if ((typeof document === "undefined" ? "undefined" : _typeof(document)) === "object" && "currentScript" in document) {
          var pdfjsFilePath = document.currentScript && document.currentScript.src;

          if (pdfjsFilePath) {
            fallbackWorkerSrc = pdfjsFilePath.replace(/(\.(?:min\.)?js)(\?.*)?$/i, ".worker$1$2");
          }
        }

        function _getWorkerSrc() {
          if (_worker_options.GlobalWorkerOptions.workerSrc) {
            return _worker_options.GlobalWorkerOptions.workerSrc;
          }

          if (typeof fallbackWorkerSrc !== "undefined") {
            if (!_is_node.isNodeJS) {
              (0, _display_utils.deprecated)('No "GlobalWorkerOptions.workerSrc" specified.');
            }

            return fallbackWorkerSrc;
          }

          throw new Error('No "GlobalWorkerOptions.workerSrc" specified.');
        }

        function getMainThreadWorkerMessageHandler() {
          var mainWorkerMessageHandler;

          try {
            mainWorkerMessageHandler = globalThis.pdfjsWorker && globalThis.pdfjsWorker.WorkerMessageHandler;
          } catch (ex) {}

          return mainWorkerMessageHandler || null;
        }

        function setupFakeWorkerGlobal() {
          if (fakeWorkerCapability) {
            return fakeWorkerCapability.promise;
          }

          fakeWorkerCapability = (0, _util.createPromiseCapability)();

          var loader = function () {
            var _ref20 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3() {
              var mainWorkerMessageHandler, worker;
              return regeneratorRuntime.wrap(function _callee3$(_context3) {
                while (1) {
                  switch (_context3.prev = _context3.next) {
                    case 0:
                      mainWorkerMessageHandler = getMainThreadWorkerMessageHandler();

                      if (!mainWorkerMessageHandler) {
                        _context3.next = 3;
                        break;
                      }

                      return _context3.abrupt("return", mainWorkerMessageHandler);

                    case 3:
                      if (!(_is_node.isNodeJS && typeof commonjsRequire === "function")) {
                        _context3.next = 6;
                        break;
                      }

                      worker = eval("require")(_getWorkerSrc());
                      return _context3.abrupt("return", worker.WorkerMessageHandler);

                    case 6:
                      _context3.next = 8;
                      return (0, _display_utils.loadScript)(_getWorkerSrc());

                    case 8:
                      return _context3.abrupt("return", window.pdfjsWorker.WorkerMessageHandler);

                    case 9:
                    case "end":
                      return _context3.stop();
                  }
                }
              }, _callee3);
            }));

            return function loader() {
              return _ref20.apply(this, arguments);
            };
          }();

          loader().then(fakeWorkerCapability.resolve, fakeWorkerCapability.reject);
          return fakeWorkerCapability.promise;
        }

        function createCDNWrapper(url) {
          var wrapper = "importScripts('" + url + "');";
          return URL.createObjectURL(new Blob([wrapper]));
        }

        var PDFWorker = function () {
          function PDFWorker() {
            var _ref21 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
                _ref21$name = _ref21.name,
                name = _ref21$name === void 0 ? null : _ref21$name,
                _ref21$port = _ref21.port,
                port = _ref21$port === void 0 ? null : _ref21$port,
                _ref21$verbosity = _ref21.verbosity,
                verbosity = _ref21$verbosity === void 0 ? (0, _util.getVerbosityLevel)() : _ref21$verbosity;

            _classCallCheck(this, PDFWorker);

            if (port && pdfWorkerPorts.has(port)) {
              throw new Error("Cannot use more than one PDFWorker per port");
            }

            this.name = name;
            this.destroyed = false;
            this.postMessageTransfers = true;
            this.verbosity = verbosity;
            this._readyCapability = (0, _util.createPromiseCapability)();
            this._port = null;
            this._webWorker = null;
            this._messageHandler = null;

            if (port) {
              pdfWorkerPorts.set(port, this);

              this._initializeFromPort(port);

              return;
            }

            this._initialize();
          }

          _createClass(PDFWorker, [{
            key: "promise",
            get: function get() {
              return this._readyCapability.promise;
            }
          }, {
            key: "port",
            get: function get() {
              return this._port;
            }
          }, {
            key: "messageHandler",
            get: function get() {
              return this._messageHandler;
            }
          }, {
            key: "_initializeFromPort",
            value: function _initializeFromPort(port) {
              this._port = port;
              this._messageHandler = new _message_handler.MessageHandler("main", "worker", port);

              this._messageHandler.on("ready", function () {});

              this._readyCapability.resolve();
            }
          }, {
            key: "_initialize",
            value: function _initialize() {
              var _this16 = this;

              if (typeof Worker !== "undefined" && !isWorkerDisabled && !getMainThreadWorkerMessageHandler()) {
                var workerSrc = _getWorkerSrc();

                try {
                  if (!(0, _util.isSameOrigin)(window.location.href, workerSrc)) {
                    workerSrc = createCDNWrapper(new URL(workerSrc, window.location).href);
                  }

                  var worker = new Worker(workerSrc);
                  var messageHandler = new _message_handler.MessageHandler("main", "worker", worker);

                  var terminateEarly = function terminateEarly() {
                    worker.removeEventListener("error", onWorkerError);
                    messageHandler.destroy();
                    worker.terminate();

                    if (_this16.destroyed) {
                      _this16._readyCapability.reject(new Error("Worker was destroyed"));
                    } else {
                      _this16._setupFakeWorker();
                    }
                  };

                  var onWorkerError = function onWorkerError() {
                    if (!_this16._webWorker) {
                      terminateEarly();
                    }
                  };

                  worker.addEventListener("error", onWorkerError);
                  messageHandler.on("test", function (data) {
                    worker.removeEventListener("error", onWorkerError);

                    if (_this16.destroyed) {
                      terminateEarly();
                      return;
                    }

                    if (data) {
                      _this16._messageHandler = messageHandler;
                      _this16._port = worker;
                      _this16._webWorker = worker;

                      if (!data.supportTransfers) {
                        _this16.postMessageTransfers = false;
                      }

                      _this16._readyCapability.resolve();

                      messageHandler.send("configure", {
                        verbosity: _this16.verbosity
                      });
                    } else {
                      _this16._setupFakeWorker();

                      messageHandler.destroy();
                      worker.terminate();
                    }
                  });
                  messageHandler.on("ready", function (data) {
                    worker.removeEventListener("error", onWorkerError);

                    if (_this16.destroyed) {
                      terminateEarly();
                      return;
                    }

                    try {
                      sendTest();
                    } catch (e) {
                      _this16._setupFakeWorker();
                    }
                  });

                  var sendTest = function sendTest() {
                    var testObj = new Uint8Array([_this16.postMessageTransfers ? 255 : 0]);

                    try {
                      messageHandler.send("test", testObj, [testObj.buffer]);
                    } catch (ex) {
                      (0, _util.warn)("Cannot use postMessage transfers.");
                      testObj[0] = 0;
                      messageHandler.send("test", testObj);
                    }
                  };

                  sendTest();
                  return;
                } catch (e) {
                  (0, _util.info)("The worker has been disabled.");
                }
              }

              this._setupFakeWorker();
            }
          }, {
            key: "_setupFakeWorker",
            value: function _setupFakeWorker() {
              var _this17 = this;

              if (!isWorkerDisabled) {
                (0, _util.warn)("Setting up fake worker.");
                isWorkerDisabled = true;
              }

              setupFakeWorkerGlobal().then(function (WorkerMessageHandler) {
                if (_this17.destroyed) {
                  _this17._readyCapability.reject(new Error("Worker was destroyed"));

                  return;
                }

                var port = new LoopbackPort();
                _this17._port = port;
                var id = "fake" + nextFakeWorkerId++;
                var workerHandler = new _message_handler.MessageHandler(id + "_worker", id, port);
                WorkerMessageHandler.setup(workerHandler, port);
                var messageHandler = new _message_handler.MessageHandler(id, id + "_worker", port);
                _this17._messageHandler = messageHandler;

                _this17._readyCapability.resolve();

                messageHandler.send("configure", {
                  verbosity: _this17.verbosity
                });
              }).catch(function (reason) {
                _this17._readyCapability.reject(new Error("Setting up fake worker failed: \"".concat(reason.message, "\".")));
              });
            }
          }, {
            key: "destroy",
            value: function destroy() {
              this.destroyed = true;

              if (this._webWorker) {
                this._webWorker.terminate();

                this._webWorker = null;
              }

              pdfWorkerPorts.delete(this._port);
              this._port = null;

              if (this._messageHandler) {
                this._messageHandler.destroy();

                this._messageHandler = null;
              }
            }
          }], [{
            key: "fromPort",
            value: function fromPort(params) {
              if (!params || !params.port) {
                throw new Error("PDFWorker.fromPort - invalid method signature.");
              }

              if (pdfWorkerPorts.has(params.port)) {
                return pdfWorkerPorts.get(params.port);
              }

              return new PDFWorker(params);
            }
          }, {
            key: "getWorkerSrc",
            value: function getWorkerSrc() {
              return _getWorkerSrc();
            }
          }]);

          return PDFWorker;
        }();

        return PDFWorker;
      }();

      exports.PDFWorker = PDFWorker;

      var WorkerTransport = function () {
        function WorkerTransport(messageHandler, loadingTask, networkStream, params) {
          _classCallCheck(this, WorkerTransport);

          this.messageHandler = messageHandler;
          this.loadingTask = loadingTask;
          this.commonObjs = new PDFObjects();
          this.fontLoader = new _font_loader.FontLoader({
            docId: loadingTask.docId,
            onUnsupportedFeature: this._onUnsupportedFeature.bind(this),
            ownerDocument: params.ownerDocument
          });
          this._params = params;
          this.CMapReaderFactory = new params.CMapReaderFactory({
            baseUrl: params.cMapUrl,
            isCompressed: params.cMapPacked
          });
          this.destroyed = false;
          this.destroyCapability = null;
          this._passwordCapability = null;
          this._networkStream = networkStream;
          this._fullReader = null;
          this._lastProgress = null;
          this.pageCache = [];
          this.pagePromises = [];
          this.downloadInfoCapability = (0, _util.createPromiseCapability)();
          this.setupMessageHandler();
        }

        _createClass(WorkerTransport, [{
          key: "destroy",
          value: function destroy() {
            var _this18 = this;

            if (this.destroyCapability) {
              return this.destroyCapability.promise;
            }

            this.destroyed = true;
            this.destroyCapability = (0, _util.createPromiseCapability)();

            if (this._passwordCapability) {
              this._passwordCapability.reject(new Error("Worker was destroyed during onPassword callback"));
            }

            var waitOn = [];
            this.pageCache.forEach(function (page) {
              if (page) {
                waitOn.push(page._destroy());
              }
            });
            this.pageCache.length = 0;
            this.pagePromises.length = 0;
            var terminated = this.messageHandler.sendWithPromise("Terminate", null);
            waitOn.push(terminated);
            Promise.all(waitOn).then(function () {
              _this18.fontLoader.clear();

              if (_this18._networkStream) {
                _this18._networkStream.cancelAllRequests(new _util.AbortException("Worker was terminated."));
              }

              if (_this18.messageHandler) {
                _this18.messageHandler.destroy();

                _this18.messageHandler = null;
              }

              _this18.destroyCapability.resolve();
            }, this.destroyCapability.reject);
            return this.destroyCapability.promise;
          }
        }, {
          key: "setupMessageHandler",
          value: function setupMessageHandler() {
            var _this19 = this;

            var messageHandler = this.messageHandler,
                loadingTask = this.loadingTask;
            messageHandler.on("GetReader", function (data, sink) {
              (0, _util.assert)(_this19._networkStream, "GetReader - no `IPDFStream` instance available.");
              _this19._fullReader = _this19._networkStream.getFullReader();

              _this19._fullReader.onProgress = function (evt) {
                _this19._lastProgress = {
                  loaded: evt.loaded,
                  total: evt.total
                };
              };

              sink.onPull = function () {
                _this19._fullReader.read().then(function (_ref22) {
                  var value = _ref22.value,
                      done = _ref22.done;

                  if (done) {
                    sink.close();
                    return;
                  }

                  (0, _util.assert)((0, _util.isArrayBuffer)(value), "GetReader - expected an ArrayBuffer.");
                  sink.enqueue(new Uint8Array(value), 1, [value]);
                }).catch(function (reason) {
                  sink.error(reason);
                });
              };

              sink.onCancel = function (reason) {
                _this19._fullReader.cancel(reason);

                sink.ready.catch(function (readyReason) {
                  if (_this19.destroyed) {
                    return;
                  }

                  throw readyReason;
                });
              };
            });
            messageHandler.on("ReaderHeadersReady", function (data) {
              var headersCapability = (0, _util.createPromiseCapability)();
              var fullReader = _this19._fullReader;
              fullReader.headersReady.then(function () {
                if (!fullReader.isStreamingSupported || !fullReader.isRangeSupported) {
                  if (_this19._lastProgress && loadingTask.onProgress) {
                    loadingTask.onProgress(_this19._lastProgress);
                  }

                  fullReader.onProgress = function (evt) {
                    if (loadingTask.onProgress) {
                      loadingTask.onProgress({
                        loaded: evt.loaded,
                        total: evt.total
                      });
                    }
                  };
                }

                headersCapability.resolve({
                  isStreamingSupported: fullReader.isStreamingSupported,
                  isRangeSupported: fullReader.isRangeSupported,
                  contentLength: fullReader.contentLength
                });
              }, headersCapability.reject);
              return headersCapability.promise;
            });
            messageHandler.on("GetRangeReader", function (data, sink) {
              (0, _util.assert)(_this19._networkStream, "GetRangeReader - no `IPDFStream` instance available.");

              var rangeReader = _this19._networkStream.getRangeReader(data.begin, data.end);

              if (!rangeReader) {
                sink.close();
                return;
              }

              sink.onPull = function () {
                rangeReader.read().then(function (_ref23) {
                  var value = _ref23.value,
                      done = _ref23.done;

                  if (done) {
                    sink.close();
                    return;
                  }

                  (0, _util.assert)((0, _util.isArrayBuffer)(value), "GetRangeReader - expected an ArrayBuffer.");
                  sink.enqueue(new Uint8Array(value), 1, [value]);
                }).catch(function (reason) {
                  sink.error(reason);
                });
              };

              sink.onCancel = function (reason) {
                rangeReader.cancel(reason);
                sink.ready.catch(function (readyReason) {
                  if (_this19.destroyed) {
                    return;
                  }

                  throw readyReason;
                });
              };
            });
            messageHandler.on("GetDoc", function (_ref24) {
              var pdfInfo = _ref24.pdfInfo;
              _this19._numPages = pdfInfo.numPages;

              loadingTask._capability.resolve(new PDFDocumentProxy(pdfInfo, _this19));
            });
            messageHandler.on("DocException", function (ex) {
              var reason;

              switch (ex.name) {
                case "PasswordException":
                  reason = new _util.PasswordException(ex.message, ex.code);
                  break;

                case "InvalidPDFException":
                  reason = new _util.InvalidPDFException(ex.message);
                  break;

                case "MissingPDFException":
                  reason = new _util.MissingPDFException(ex.message);
                  break;

                case "UnexpectedResponseException":
                  reason = new _util.UnexpectedResponseException(ex.message, ex.status);
                  break;

                case "UnknownErrorException":
                  reason = new _util.UnknownErrorException(ex.message, ex.details);
                  break;
              }

              if (!(reason instanceof Error)) {
                var msg = "DocException - expected a valid Error.";
                (0, _util.warn)(msg);
              }

              loadingTask._capability.reject(reason);
            });
            messageHandler.on("PasswordRequest", function (exception) {
              _this19._passwordCapability = (0, _util.createPromiseCapability)();

              if (loadingTask.onPassword) {
                var updatePassword = function updatePassword(password) {
                  _this19._passwordCapability.resolve({
                    password: password
                  });
                };

                try {
                  loadingTask.onPassword(updatePassword, exception.code);
                } catch (ex) {
                  _this19._passwordCapability.reject(ex);
                }
              } else {
                _this19._passwordCapability.reject(new _util.PasswordException(exception.message, exception.code));
              }

              return _this19._passwordCapability.promise;
            });
            messageHandler.on("DataLoaded", function (data) {
              if (loadingTask.onProgress) {
                loadingTask.onProgress({
                  loaded: data.length,
                  total: data.length
                });
              }

              _this19.downloadInfoCapability.resolve(data);
            });
            messageHandler.on("StartRenderPage", function (data) {
              if (_this19.destroyed) {
                return;
              }

              var page = _this19.pageCache[data.pageIndex];

              page._startRenderPage(data.transparency, data.intent);
            });
            messageHandler.on("commonobj", function (data) {
              if (_this19.destroyed) {
                return;
              }

              var _data = _slicedToArray(data, 3),
                  id = _data[0],
                  type = _data[1],
                  exportedData = _data[2];

              if (_this19.commonObjs.has(id)) {
                return;
              }

              switch (type) {
                case "Font":
                  var params = _this19._params;

                  if ("error" in exportedData) {
                    var exportedError = exportedData.error;
                    (0, _util.warn)("Error during font loading: ".concat(exportedError));

                    _this19.commonObjs.resolve(id, exportedError);

                    break;
                  }

                  var fontRegistry = null;

                  if (params.pdfBug && globalThis.FontInspector && globalThis.FontInspector.enabled) {
                    fontRegistry = {
                      registerFont: function registerFont(font, url) {
                        globalThis.FontInspector.fontAdded(font, url);
                      }
                    };
                  }

                  var font = new _font_loader.FontFaceObject(exportedData, {
                    isEvalSupported: params.isEvalSupported,
                    disableFontFace: params.disableFontFace,
                    ignoreErrors: params.ignoreErrors,
                    onUnsupportedFeature: _this19._onUnsupportedFeature.bind(_this19),
                    fontRegistry: fontRegistry
                  });

                  _this19.fontLoader.bind(font).catch(function (reason) {
                    return messageHandler.sendWithPromise("FontFallback", {
                      id: id
                    });
                  }).finally(function () {
                    if (!params.fontExtraProperties && font.data) {
                      font.data = null;
                    }

                    _this19.commonObjs.resolve(id, font);
                  });

                  break;

                case "FontPath":
                case "Image":
                  _this19.commonObjs.resolve(id, exportedData);

                  break;

                default:
                  throw new Error("Got unknown common object type ".concat(type));
              }
            });
            messageHandler.on("obj", function (data) {
              if (_this19.destroyed) {
                return undefined;
              }

              var _data2 = _slicedToArray(data, 4),
                  id = _data2[0],
                  pageIndex = _data2[1],
                  type = _data2[2],
                  imageData = _data2[3];

              var pageProxy = _this19.pageCache[pageIndex];

              if (pageProxy.objs.has(id)) {
                return undefined;
              }

              switch (type) {
                case "Image":
                  pageProxy.objs.resolve(id, imageData);
                  var MAX_IMAGE_SIZE_TO_STORE = 8000000;

                  if (imageData && "data" in imageData && imageData.data.length > MAX_IMAGE_SIZE_TO_STORE) {
                    pageProxy.cleanupAfterRender = true;
                  }

                  break;

                default:
                  throw new Error("Got unknown object type ".concat(type));
              }

              return undefined;
            });
            messageHandler.on("DocProgress", function (data) {
              if (_this19.destroyed) {
                return;
              }

              if (loadingTask.onProgress) {
                loadingTask.onProgress({
                  loaded: data.loaded,
                  total: data.total
                });
              }
            });
            messageHandler.on("UnsupportedFeature", this._onUnsupportedFeature.bind(this));
            messageHandler.on("FetchBuiltInCMap", function (data, sink) {
              if (_this19.destroyed) {
                sink.error(new Error("Worker was destroyed"));
                return;
              }

              var fetched = false;

              sink.onPull = function () {
                if (fetched) {
                  sink.close();
                  return;
                }

                fetched = true;

                _this19.CMapReaderFactory.fetch(data).then(function (builtInCMap) {
                  sink.enqueue(builtInCMap, 1, [builtInCMap.cMapData.buffer]);
                }).catch(function (reason) {
                  sink.error(reason);
                });
              };
            });
          }
        }, {
          key: "_onUnsupportedFeature",
          value: function _onUnsupportedFeature(_ref25) {
            var featureId = _ref25.featureId;

            if (this.destroyed) {
              return;
            }

            if (this.loadingTask.onUnsupportedFeature) {
              this.loadingTask.onUnsupportedFeature(featureId);
            }
          }
        }, {
          key: "getData",
          value: function getData() {
            return this.messageHandler.sendWithPromise("GetData", null);
          }
        }, {
          key: "getPage",
          value: function getPage(pageNumber) {
            var _this20 = this;

            if (!Number.isInteger(pageNumber) || pageNumber <= 0 || pageNumber > this._numPages) {
              return Promise.reject(new Error("Invalid page request"));
            }

            var pageIndex = pageNumber - 1;

            if (pageIndex in this.pagePromises) {
              return this.pagePromises[pageIndex];
            }

            var promise = this.messageHandler.sendWithPromise("GetPage", {
              pageIndex: pageIndex
            }).then(function (pageInfo) {
              if (_this20.destroyed) {
                throw new Error("Transport destroyed");
              }

              var page = new PDFPageProxy(pageIndex, pageInfo, _this20, _this20._params.ownerDocument, _this20._params.pdfBug);
              _this20.pageCache[pageIndex] = page;
              return page;
            });
            this.pagePromises[pageIndex] = promise;
            return promise;
          }
        }, {
          key: "getPageIndex",
          value: function getPageIndex(ref) {
            return this.messageHandler.sendWithPromise("GetPageIndex", {
              ref: ref
            }).catch(function (reason) {
              return Promise.reject(new Error(reason));
            });
          }
        }, {
          key: "getAnnotations",
          value: function getAnnotations(pageIndex, intent) {
            return this.messageHandler.sendWithPromise("GetAnnotations", {
              pageIndex: pageIndex,
              intent: intent
            });
          }
        }, {
          key: "saveDocument",
          value: function saveDocument(annotationStorage) {
            return this.messageHandler.sendWithPromise("SaveDocument", {
              numPages: this._numPages,
              annotationStorage: annotationStorage && annotationStorage.getAll() || null,
              filename: this._fullReader ? this._fullReader.filename : null
            }).finally(function () {
              if (annotationStorage) {
                annotationStorage.resetModified();
              }
            });
          }
        }, {
          key: "getDestinations",
          value: function getDestinations() {
            return this.messageHandler.sendWithPromise("GetDestinations", null);
          }
        }, {
          key: "getDestination",
          value: function getDestination(id) {
            if (typeof id !== "string") {
              return Promise.reject(new Error("Invalid destination request."));
            }

            return this.messageHandler.sendWithPromise("GetDestination", {
              id: id
            });
          }
        }, {
          key: "getPageLabels",
          value: function getPageLabels() {
            return this.messageHandler.sendWithPromise("GetPageLabels", null);
          }
        }, {
          key: "getPageLayout",
          value: function getPageLayout() {
            return this.messageHandler.sendWithPromise("GetPageLayout", null);
          }
        }, {
          key: "getPageMode",
          value: function getPageMode() {
            return this.messageHandler.sendWithPromise("GetPageMode", null);
          }
        }, {
          key: "getViewerPreferences",
          value: function getViewerPreferences() {
            return this.messageHandler.sendWithPromise("GetViewerPreferences", null);
          }
        }, {
          key: "getOpenAction",
          value: function getOpenAction() {
            return this.messageHandler.sendWithPromise("GetOpenAction", null);
          }
        }, {
          key: "getAttachments",
          value: function getAttachments() {
            return this.messageHandler.sendWithPromise("GetAttachments", null);
          }
        }, {
          key: "getJavaScript",
          value: function getJavaScript() {
            return this.messageHandler.sendWithPromise("GetJavaScript", null);
          }
        }, {
          key: "getOutline",
          value: function getOutline() {
            return this.messageHandler.sendWithPromise("GetOutline", null);
          }
        }, {
          key: "getOptionalContentConfig",
          value: function getOptionalContentConfig() {
            return this.messageHandler.sendWithPromise("GetOptionalContentConfig", null).then(function (results) {
              return new _optional_content_config.OptionalContentConfig(results);
            });
          }
        }, {
          key: "getPermissions",
          value: function getPermissions() {
            return this.messageHandler.sendWithPromise("GetPermissions", null);
          }
        }, {
          key: "getMetadata",
          value: function getMetadata() {
            var _this21 = this;

            return this.messageHandler.sendWithPromise("GetMetadata", null).then(function (results) {
              return {
                info: results[0],
                metadata: results[1] ? new _metadata.Metadata(results[1]) : null,
                contentDispositionFilename: _this21._fullReader ? _this21._fullReader.filename : null
              };
            });
          }
        }, {
          key: "getStats",
          value: function getStats() {
            return this.messageHandler.sendWithPromise("GetStats", null);
          }
        }, {
          key: "startCleanup",
          value: function startCleanup() {
            var _this22 = this;

            return this.messageHandler.sendWithPromise("Cleanup", null).then(function () {
              for (var i = 0, ii = _this22.pageCache.length; i < ii; i++) {
                var page = _this22.pageCache[i];

                if (page) {
                  var cleanupSuccessful = page.cleanup();

                  if (!cleanupSuccessful) {
                    throw new Error("startCleanup: Page ".concat(i + 1, " is currently rendering."));
                  }
                }
              }

              _this22.commonObjs.clear();

              _this22.fontLoader.clear();
            });
          }
        }, {
          key: "loadingParams",
          get: function get() {
            var params = this._params;
            return (0, _util.shadow)(this, "loadingParams", {
              disableAutoFetch: params.disableAutoFetch,
              disableFontFace: params.disableFontFace
            });
          }
        }]);

        return WorkerTransport;
      }();

      var PDFObjects = function () {
        function PDFObjects() {
          _classCallCheck(this, PDFObjects);

          this._objs = Object.create(null);
        }

        _createClass(PDFObjects, [{
          key: "_ensureObj",
          value: function _ensureObj(objId) {
            if (this._objs[objId]) {
              return this._objs[objId];
            }

            return this._objs[objId] = {
              capability: (0, _util.createPromiseCapability)(),
              data: null,
              resolved: false
            };
          }
        }, {
          key: "get",
          value: function get(objId) {
            var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

            if (callback) {
              this._ensureObj(objId).capability.promise.then(callback);

              return null;
            }

            var obj = this._objs[objId];

            if (!obj || !obj.resolved) {
              throw new Error("Requesting object that isn't resolved yet ".concat(objId, "."));
            }

            return obj.data;
          }
        }, {
          key: "has",
          value: function has(objId) {
            var obj = this._objs[objId];
            return obj ? obj.resolved : false;
          }
        }, {
          key: "resolve",
          value: function resolve(objId, data) {
            var obj = this._ensureObj(objId);

            obj.resolved = true;
            obj.data = data;
            obj.capability.resolve(data);
          }
        }, {
          key: "clear",
          value: function clear() {
            this._objs = Object.create(null);
          }
        }]);

        return PDFObjects;
      }();

      var RenderTask = function () {
        function RenderTask(internalRenderTask) {
          _classCallCheck(this, RenderTask);

          this._internalRenderTask = internalRenderTask;
          this.onContinue = null;
        }

        _createClass(RenderTask, [{
          key: "promise",
          get: function get() {
            return this._internalRenderTask.capability.promise;
          }
        }, {
          key: "cancel",
          value: function cancel() {
            this._internalRenderTask.cancel();
          }
        }]);

        return RenderTask;
      }();

      var InternalRenderTask = function InternalRenderTaskClosure() {
        var canvasInRendering = new WeakSet();

        var InternalRenderTask = function () {
          function InternalRenderTask(_ref26) {
            var callback = _ref26.callback,
                params = _ref26.params,
                objs = _ref26.objs,
                commonObjs = _ref26.commonObjs,
                operatorList = _ref26.operatorList,
                pageIndex = _ref26.pageIndex,
                canvasFactory = _ref26.canvasFactory,
                webGLContext = _ref26.webGLContext,
                _ref26$useRequestAnim = _ref26.useRequestAnimationFrame,
                useRequestAnimationFrame = _ref26$useRequestAnim === void 0 ? false : _ref26$useRequestAnim,
                _ref26$pdfBug = _ref26.pdfBug,
                pdfBug = _ref26$pdfBug === void 0 ? false : _ref26$pdfBug;

            _classCallCheck(this, InternalRenderTask);

            this.callback = callback;
            this.params = params;
            this.objs = objs;
            this.commonObjs = commonObjs;
            this.operatorListIdx = null;
            this.operatorList = operatorList;
            this._pageIndex = pageIndex;
            this.canvasFactory = canvasFactory;
            this.webGLContext = webGLContext;
            this._pdfBug = pdfBug;
            this.running = false;
            this.graphicsReadyCallback = null;
            this.graphicsReady = false;
            this._useRequestAnimationFrame = useRequestAnimationFrame === true && typeof window !== "undefined";
            this.cancelled = false;
            this.capability = (0, _util.createPromiseCapability)();
            this.task = new RenderTask(this);
            this._continueBound = this._continue.bind(this);
            this._scheduleNextBound = this._scheduleNext.bind(this);
            this._nextBound = this._next.bind(this);
            this._canvas = params.canvasContext.canvas;
          }

          _createClass(InternalRenderTask, [{
            key: "completed",
            get: function get() {
              return this.capability.promise.catch(function () {});
            }
          }, {
            key: "initializeGraphics",
            value: function initializeGraphics(_ref27) {
              var _ref27$transparency = _ref27.transparency,
                  transparency = _ref27$transparency === void 0 ? false : _ref27$transparency,
                  optionalContentConfig = _ref27.optionalContentConfig;

              if (this.cancelled) {
                return;
              }

              if (this._canvas) {
                if (canvasInRendering.has(this._canvas)) {
                  throw new Error("Cannot use the same canvas during multiple render() operations. " + "Use different canvas or ensure previous operations were " + "cancelled or completed.");
                }

                canvasInRendering.add(this._canvas);
              }

              if (this._pdfBug && globalThis.StepperManager && globalThis.StepperManager.enabled) {
                this.stepper = globalThis.StepperManager.create(this._pageIndex);
                this.stepper.init(this.operatorList);
                this.stepper.nextBreakPoint = this.stepper.getNextBreakPoint();
              }

              var _this$params = this.params,
                  canvasContext = _this$params.canvasContext,
                  viewport = _this$params.viewport,
                  transform = _this$params.transform,
                  imageLayer = _this$params.imageLayer,
                  background = _this$params.background;
              this.gfx = new _canvas.CanvasGraphics(canvasContext, this.commonObjs, this.objs, this.canvasFactory, this.webGLContext, imageLayer, optionalContentConfig);
              this.gfx.beginDrawing({
                transform: transform,
                viewport: viewport,
                transparency: transparency,
                background: background
              });
              this.operatorListIdx = 0;
              this.graphicsReady = true;

              if (this.graphicsReadyCallback) {
                this.graphicsReadyCallback();
              }
            }
          }, {
            key: "cancel",
            value: function cancel() {
              var error = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
              this.running = false;
              this.cancelled = true;

              if (this.gfx) {
                this.gfx.endDrawing();
              }

              if (this._canvas) {
                canvasInRendering.delete(this._canvas);
              }

              this.callback(error || new _display_utils.RenderingCancelledException("Rendering cancelled, page ".concat(this._pageIndex + 1), "canvas"));
            }
          }, {
            key: "operatorListChanged",
            value: function operatorListChanged() {
              if (!this.graphicsReady) {
                if (!this.graphicsReadyCallback) {
                  this.graphicsReadyCallback = this._continueBound;
                }

                return;
              }

              if (this.stepper) {
                this.stepper.updateOperatorList(this.operatorList);
              }

              if (this.running) {
                return;
              }

              this._continue();
            }
          }, {
            key: "_continue",
            value: function _continue() {
              this.running = true;

              if (this.cancelled) {
                return;
              }

              if (this.task.onContinue) {
                this.task.onContinue(this._scheduleNextBound);
              } else {
                this._scheduleNext();
              }
            }
          }, {
            key: "_scheduleNext",
            value: function _scheduleNext() {
              var _this23 = this;

              if (this._useRequestAnimationFrame) {
                window.requestAnimationFrame(function () {
                  _this23._nextBound().catch(_this23.cancel.bind(_this23));
                });
              } else {
                Promise.resolve().then(this._nextBound).catch(this.cancel.bind(this));
              }
            }
          }, {
            key: "_next",
            value: function () {
              var _next2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4() {
                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        if (!this.cancelled) {
                          _context4.next = 2;
                          break;
                        }

                        return _context4.abrupt("return");

                      case 2:
                        this.operatorListIdx = this.gfx.executeOperatorList(this.operatorList, this.operatorListIdx, this._continueBound, this.stepper);

                        if (this.operatorListIdx === this.operatorList.argsArray.length) {
                          this.running = false;

                          if (this.operatorList.lastChunk) {
                            this.gfx.endDrawing();

                            if (this._canvas) {
                              canvasInRendering.delete(this._canvas);
                            }

                            this.callback();
                          }
                        }

                      case 4:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4, this);
              }));

              function _next() {
                return _next2.apply(this, arguments);
              }

              return _next;
            }()
          }]);

          return InternalRenderTask;
        }();

        return InternalRenderTask;
      }();

      var version = '2.6.347';
      exports.version = version;
      var build = '3be9c65f';
      exports.build = build;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.FontLoader = exports.FontFaceObject = void 0;

      var _util = __w_pdfjs_require__(2);

      var BaseFontLoader = function () {
        function BaseFontLoader(_ref28) {
          var docId = _ref28.docId,
              onUnsupportedFeature = _ref28.onUnsupportedFeature,
              _ref28$ownerDocument = _ref28.ownerDocument,
              ownerDocument = _ref28$ownerDocument === void 0 ? globalThis.document : _ref28$ownerDocument;

          _classCallCheck(this, BaseFontLoader);

          if (this.constructor === BaseFontLoader) {
            (0, _util.unreachable)("Cannot initialize BaseFontLoader.");
          }

          this.docId = docId;
          this._onUnsupportedFeature = onUnsupportedFeature;
          this._document = ownerDocument;
          this.nativeFontFaces = [];
          this.styleElement = null;
        }

        _createClass(BaseFontLoader, [{
          key: "addNativeFontFace",
          value: function addNativeFontFace(nativeFontFace) {
            this.nativeFontFaces.push(nativeFontFace);

            this._document.fonts.add(nativeFontFace);
          }
        }, {
          key: "insertRule",
          value: function insertRule(rule) {
            var styleElement = this.styleElement;

            if (!styleElement) {
              styleElement = this.styleElement = this._document.createElement("style");
              styleElement.id = "PDFJS_FONT_STYLE_TAG_".concat(this.docId);

              this._document.documentElement.getElementsByTagName("head")[0].appendChild(styleElement);
            }

            var styleSheet = styleElement.sheet;
            styleSheet.insertRule(rule, styleSheet.cssRules.length);
          }
        }, {
          key: "clear",
          value: function clear() {
            var _this24 = this;

            this.nativeFontFaces.forEach(function (nativeFontFace) {
              _this24._document.fonts.delete(nativeFontFace);
            });
            this.nativeFontFaces.length = 0;

            if (this.styleElement) {
              this.styleElement.remove();
              this.styleElement = null;
            }
          }
        }, {
          key: "bind",
          value: function () {
            var _bind = _asyncToGenerator(regeneratorRuntime.mark(function _callee5(font) {
              var _this25 = this;

              var nativeFontFace, rule;
              return regeneratorRuntime.wrap(function _callee5$(_context5) {
                while (1) {
                  switch (_context5.prev = _context5.next) {
                    case 0:
                      if (!(font.attached || font.missingFile)) {
                        _context5.next = 2;
                        break;
                      }

                      return _context5.abrupt("return");

                    case 2:
                      font.attached = true;

                      if (!this.isFontLoadingAPISupported) {
                        _context5.next = 19;
                        break;
                      }

                      nativeFontFace = font.createNativeFontFace();

                      if (!nativeFontFace) {
                        _context5.next = 18;
                        break;
                      }

                      this.addNativeFontFace(nativeFontFace);
                      _context5.prev = 7;
                      _context5.next = 10;
                      return nativeFontFace.loaded;

                    case 10:
                      _context5.next = 18;
                      break;

                    case 12:
                      _context5.prev = 12;
                      _context5.t0 = _context5["catch"](7);

                      this._onUnsupportedFeature({
                        featureId: _util.UNSUPPORTED_FEATURES.errorFontLoadNative
                      });

                      (0, _util.warn)("Failed to load font '".concat(nativeFontFace.family, "': '").concat(_context5.t0, "'."));
                      font.disableFontFace = true;
                      throw _context5.t0;

                    case 18:
                      return _context5.abrupt("return");

                    case 19:
                      rule = font.createFontFaceRule();

                      if (!rule) {
                        _context5.next = 26;
                        break;
                      }

                      this.insertRule(rule);

                      if (!this.isSyncFontLoadingSupported) {
                        _context5.next = 24;
                        break;
                      }

                      return _context5.abrupt("return");

                    case 24:
                      _context5.next = 26;
                      return new Promise(function (resolve) {
                        var request = _this25._queueLoadingCallback(resolve);

                        _this25._prepareFontLoadEvent([rule], [font], request);
                      });

                    case 26:
                    case "end":
                      return _context5.stop();
                  }
                }
              }, _callee5, this, [[7, 12]]);
            }));

            function bind(_x3) {
              return _bind.apply(this, arguments);
            }

            return bind;
          }()
        }, {
          key: "_queueLoadingCallback",
          value: function _queueLoadingCallback(callback) {
            (0, _util.unreachable)("Abstract method `_queueLoadingCallback`.");
          }
        }, {
          key: "isFontLoadingAPISupported",
          get: function get() {
            var supported = typeof this._document !== "undefined" && !!this._document.fonts;
            return (0, _util.shadow)(this, "isFontLoadingAPISupported", supported);
          }
        }, {
          key: "isSyncFontLoadingSupported",
          get: function get() {
            (0, _util.unreachable)("Abstract method `isSyncFontLoadingSupported`.");
          }
        }, {
          key: "_loadTestFont",
          get: function get() {
            (0, _util.unreachable)("Abstract method `_loadTestFont`.");
          }
        }, {
          key: "_prepareFontLoadEvent",
          value: function _prepareFontLoadEvent(rules, fontsToLoad, request) {
            (0, _util.unreachable)("Abstract method `_prepareFontLoadEvent`.");
          }
        }]);

        return BaseFontLoader;
      }();

      var FontLoader;
      exports.FontLoader = FontLoader;
      {
        exports.FontLoader = FontLoader = function (_BaseFontLoader) {
          _inherits(GenericFontLoader, _BaseFontLoader);

          var _super11 = _createSuper(GenericFontLoader);

          function GenericFontLoader(params) {
            var _this26;

            _classCallCheck(this, GenericFontLoader);

            _this26 = _super11.call(this, params);
            _this26.loadingContext = {
              requests: [],
              nextRequestId: 0
            };
            _this26.loadTestFontId = 0;
            return _this26;
          }

          _createClass(GenericFontLoader, [{
            key: "isSyncFontLoadingSupported",
            get: function get() {
              var supported = false;

              if (typeof navigator === "undefined") {
                supported = true;
              } else {
                var m = /Mozilla\/5.0.*?rv:(\d+).*? Gecko/.exec(navigator.userAgent);

                if (m && m[1] >= 14) {
                  supported = true;
                }
              }

              return (0, _util.shadow)(this, "isSyncFontLoadingSupported", supported);
            }
          }, {
            key: "_queueLoadingCallback",
            value: function _queueLoadingCallback(callback) {
              function completeRequest() {
                (0, _util.assert)(!request.done, "completeRequest() cannot be called twice.");
                request.done = true;

                while (context.requests.length > 0 && context.requests[0].done) {
                  var otherRequest = context.requests.shift();
                  setTimeout(otherRequest.callback, 0);
                }
              }

              var context = this.loadingContext;
              var request = {
                id: "pdfjs-font-loading-".concat(context.nextRequestId++),
                done: false,
                complete: completeRequest,
                callback: callback
              };
              context.requests.push(request);
              return request;
            }
          }, {
            key: "_loadTestFont",
            get: function get() {
              var getLoadTestFont = function getLoadTestFont() {
                return atob("T1RUTwALAIAAAwAwQ0ZGIDHtZg4AAAOYAAAAgUZGVE1lkzZwAAAEHAAAABxHREVGABQA" + "FQAABDgAAAAeT1MvMlYNYwkAAAEgAAAAYGNtYXABDQLUAAACNAAAAUJoZWFk/xVFDQAA" + "ALwAAAA2aGhlYQdkA+oAAAD0AAAAJGhtdHgD6AAAAAAEWAAAAAZtYXhwAAJQAAAAARgA" + "AAAGbmFtZVjmdH4AAAGAAAAAsXBvc3T/hgAzAAADeAAAACAAAQAAAAEAALZRFsRfDzz1" + "AAsD6AAAAADOBOTLAAAAAM4KHDwAAAAAA+gDIQAAAAgAAgAAAAAAAAABAAADIQAAAFoD" + "6AAAAAAD6AABAAAAAAAAAAAAAAAAAAAAAQAAUAAAAgAAAAQD6AH0AAUAAAKKArwAAACM" + "AooCvAAAAeAAMQECAAACAAYJAAAAAAAAAAAAAQAAAAAAAAAAAAAAAFBmRWQAwAAuAC4D" + "IP84AFoDIQAAAAAAAQAAAAAAAAAAACAAIAABAAAADgCuAAEAAAAAAAAAAQAAAAEAAAAA" + "AAEAAQAAAAEAAAAAAAIAAQAAAAEAAAAAAAMAAQAAAAEAAAAAAAQAAQAAAAEAAAAAAAUA" + "AQAAAAEAAAAAAAYAAQAAAAMAAQQJAAAAAgABAAMAAQQJAAEAAgABAAMAAQQJAAIAAgAB" + "AAMAAQQJAAMAAgABAAMAAQQJAAQAAgABAAMAAQQJAAUAAgABAAMAAQQJAAYAAgABWABY" + "AAAAAAAAAwAAAAMAAAAcAAEAAAAAADwAAwABAAAAHAAEACAAAAAEAAQAAQAAAC7//wAA" + "AC7////TAAEAAAAAAAABBgAAAQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAMAAAAAAAD/gwAyAAAAAQAAAAAAAAAAAAAAAAAA" + "AAABAAQEAAEBAQJYAAEBASH4DwD4GwHEAvgcA/gXBIwMAYuL+nz5tQXkD5j3CBLnEQAC" + "AQEBIVhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYAAABAQAADwACAQEEE/t3" + "Dov6fAH6fAT+fPp8+nwHDosMCvm1Cvm1DAz6fBQAAAAAAAABAAAAAMmJbzEAAAAAzgTj" + "FQAAAADOBOQpAAEAAAAAAAAADAAUAAQAAAABAAAAAgABAAAAAAAAAAAD6AAAAAAAAA==");
              };

              return (0, _util.shadow)(this, "_loadTestFont", getLoadTestFont());
            }
          }, {
            key: "_prepareFontLoadEvent",
            value: function _prepareFontLoadEvent(rules, fonts, request) {
              var _this27 = this;

              function int32(data, offset) {
                return data.charCodeAt(offset) << 24 | data.charCodeAt(offset + 1) << 16 | data.charCodeAt(offset + 2) << 8 | data.charCodeAt(offset + 3) & 0xff;
              }

              function spliceString(s, offset, remove, insert) {
                var chunk1 = s.substring(0, offset);
                var chunk2 = s.substring(offset + remove);
                return chunk1 + insert + chunk2;
              }

              var i, ii;

              var canvas = this._document.createElement("canvas");

              canvas.width = 1;
              canvas.height = 1;
              var ctx = canvas.getContext("2d");
              var called = 0;

              function isFontReady(name, callback) {
                called++;

                if (called > 30) {
                  (0, _util.warn)("Load test font never loaded.");
                  callback();
                  return;
                }

                ctx.font = "30px " + name;
                ctx.fillText(".", 0, 20);
                var imageData = ctx.getImageData(0, 0, 1, 1);

                if (imageData.data[3] > 0) {
                  callback();
                  return;
                }

                setTimeout(isFontReady.bind(null, name, callback));
              }

              var loadTestFontId = "lt".concat(Date.now()).concat(this.loadTestFontId++);
              var data = this._loadTestFont;
              var COMMENT_OFFSET = 976;
              data = spliceString(data, COMMENT_OFFSET, loadTestFontId.length, loadTestFontId);
              var CFF_CHECKSUM_OFFSET = 16;
              var XXXX_VALUE = 0x58585858;
              var checksum = int32(data, CFF_CHECKSUM_OFFSET);

              for (i = 0, ii = loadTestFontId.length - 3; i < ii; i += 4) {
                checksum = checksum - XXXX_VALUE + int32(loadTestFontId, i) | 0;
              }

              if (i < loadTestFontId.length) {
                checksum = checksum - XXXX_VALUE + int32(loadTestFontId + "XXX", i) | 0;
              }

              data = spliceString(data, CFF_CHECKSUM_OFFSET, 4, (0, _util.string32)(checksum));
              var url = "url(data:font/opentype;base64,".concat(btoa(data), ");");
              var rule = "@font-face {font-family:\"".concat(loadTestFontId, "\";src:").concat(url, "}");
              this.insertRule(rule);
              var names = [];

              for (i = 0, ii = fonts.length; i < ii; i++) {
                names.push(fonts[i].loadedName);
              }

              names.push(loadTestFontId);

              var div = this._document.createElement("div");

              div.style.visibility = "hidden";
              div.style.width = div.style.height = "10px";
              div.style.position = "absolute";
              div.style.top = div.style.left = "0px";

              for (i = 0, ii = names.length; i < ii; ++i) {
                var span = this._document.createElement("span");

                span.textContent = "Hi";
                span.style.fontFamily = names[i];
                div.appendChild(span);
              }

              this._document.body.appendChild(div);

              isFontReady(loadTestFontId, function () {
                _this27._document.body.removeChild(div);

                request.complete();
              });
            }
          }]);

          return GenericFontLoader;
        }(BaseFontLoader);
      }

      var FontFaceObject = function () {
        function FontFaceObject(translatedData, _ref29) {
          var _ref29$isEvalSupporte = _ref29.isEvalSupported,
              isEvalSupported = _ref29$isEvalSupporte === void 0 ? true : _ref29$isEvalSupporte,
              _ref29$disableFontFac = _ref29.disableFontFace,
              disableFontFace = _ref29$disableFontFac === void 0 ? false : _ref29$disableFontFac,
              _ref29$ignoreErrors = _ref29.ignoreErrors,
              ignoreErrors = _ref29$ignoreErrors === void 0 ? false : _ref29$ignoreErrors,
              _ref29$onUnsupportedF = _ref29.onUnsupportedFeature,
              onUnsupportedFeature = _ref29$onUnsupportedF === void 0 ? null : _ref29$onUnsupportedF,
              _ref29$fontRegistry = _ref29.fontRegistry,
              fontRegistry = _ref29$fontRegistry === void 0 ? null : _ref29$fontRegistry;

          _classCallCheck(this, FontFaceObject);

          this.compiledGlyphs = Object.create(null);

          for (var i in translatedData) {
            this[i] = translatedData[i];
          }

          this.isEvalSupported = isEvalSupported !== false;
          this.disableFontFace = disableFontFace === true;
          this.ignoreErrors = ignoreErrors === true;
          this._onUnsupportedFeature = onUnsupportedFeature;
          this.fontRegistry = fontRegistry;
        }

        _createClass(FontFaceObject, [{
          key: "createNativeFontFace",
          value: function createNativeFontFace() {
            if (!this.data || this.disableFontFace) {
              return null;
            }

            var nativeFontFace = new FontFace(this.loadedName, this.data, {});

            if (this.fontRegistry) {
              this.fontRegistry.registerFont(this);
            }

            return nativeFontFace;
          }
        }, {
          key: "createFontFaceRule",
          value: function createFontFaceRule() {
            if (!this.data || this.disableFontFace) {
              return null;
            }

            var data = (0, _util.bytesToString)(new Uint8Array(this.data));
            var url = "url(data:".concat(this.mimetype, ";base64,").concat(btoa(data), ");");
            var rule = "@font-face {font-family:\"".concat(this.loadedName, "\";src:").concat(url, "}");

            if (this.fontRegistry) {
              this.fontRegistry.registerFont(this, url);
            }

            return rule;
          }
        }, {
          key: "getPathGenerator",
          value: function getPathGenerator(objs, character) {
            if (this.compiledGlyphs[character] !== undefined) {
              return this.compiledGlyphs[character];
            }

            var cmds, current;

            try {
              cmds = objs.get(this.loadedName + "_path_" + character);
            } catch (ex) {
              if (!this.ignoreErrors) {
                throw ex;
              }

              if (this._onUnsupportedFeature) {
                this._onUnsupportedFeature({
                  featureId: _util.UNSUPPORTED_FEATURES.errorFontGetPath
                });
              }

              (0, _util.warn)("getPathGenerator - ignoring character: \"".concat(ex, "\"."));
              return this.compiledGlyphs[character] = function (c, size) {};
            }

            if (this.isEvalSupported && _util.IsEvalSupportedCached.value) {
              var args,
                  js = "";

              for (var i = 0, ii = cmds.length; i < ii; i++) {
                current = cmds[i];

                if (current.args !== undefined) {
                  args = current.args.join(",");
                } else {
                  args = "";
                }

                js += "c." + current.cmd + "(" + args + ");\n";
              }

              return this.compiledGlyphs[character] = new Function("c", "size", js);
            }

            return this.compiledGlyphs[character] = function (c, size) {
              for (var _i5 = 0, _ii = cmds.length; _i5 < _ii; _i5++) {
                current = cmds[_i5];

                if (current.cmd === "scale") {
                  current.args = [size, -size];
                }

                c[current.cmd].apply(c, current.args);
              }
            };
          }
        }]);

        return FontFaceObject;
      }();

      exports.FontFaceObject = FontFaceObject;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.NodeCMapReaderFactory = exports.NodeCanvasFactory = void 0;

      var _display_utils = __w_pdfjs_require__(1);

      var _is_node = __w_pdfjs_require__(4);

      var _util = __w_pdfjs_require__(2);

      var NodeCanvasFactory = function NodeCanvasFactory() {
        _classCallCheck(this, NodeCanvasFactory);

        (0, _util.unreachable)("Not implemented: NodeCanvasFactory");
      };

      exports.NodeCanvasFactory = NodeCanvasFactory;

      var NodeCMapReaderFactory = function NodeCMapReaderFactory() {
        _classCallCheck(this, NodeCMapReaderFactory);

        (0, _util.unreachable)("Not implemented: NodeCMapReaderFactory");
      };

      exports.NodeCMapReaderFactory = NodeCMapReaderFactory;

      if (_is_node.isNodeJS) {
        exports.NodeCanvasFactory = NodeCanvasFactory = function (_display_utils$BaseCa) {
          _inherits(NodeCanvasFactory, _display_utils$BaseCa);

          var _super12 = _createSuper(NodeCanvasFactory);

          function NodeCanvasFactory() {
            _classCallCheck(this, NodeCanvasFactory);

            return _super12.apply(this, arguments);
          }

          _createClass(NodeCanvasFactory, [{
            key: "create",
            value: function create(width, height) {
              if (width <= 0 || height <= 0) {
                throw new Error("Invalid canvas size");
              }

              var Canvas = require$$5;
              var canvas = Canvas.createCanvas(width, height);
              return {
                canvas: canvas,
                context: canvas.getContext("2d")
              };
            }
          }]);

          return NodeCanvasFactory;
        }(_display_utils.BaseCanvasFactory);

        exports.NodeCMapReaderFactory = NodeCMapReaderFactory = function (_display_utils$BaseCM) {
          _inherits(NodeCMapReaderFactory, _display_utils$BaseCM);

          var _super13 = _createSuper(NodeCMapReaderFactory);

          function NodeCMapReaderFactory() {
            _classCallCheck(this, NodeCMapReaderFactory);

            return _super13.apply(this, arguments);
          }

          _createClass(NodeCMapReaderFactory, [{
            key: "_fetchData",
            value: function _fetchData(url, compressionType) {
              return new Promise(function (resolve, reject) {
                var fs = require$$5;
                fs.readFile(url, function (error, data) {
                  if (error || !data) {
                    reject(new Error(error));
                    return;
                  }

                  resolve({
                    cMapData: new Uint8Array(data),
                    compressionType: compressionType
                  });
                });
              });
            }
          }]);

          return NodeCMapReaderFactory;
        }(_display_utils.BaseCMapReaderFactory);
      }
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.AnnotationStorage = void 0;

      var AnnotationStorage = function () {
        function AnnotationStorage() {
          _classCallCheck(this, AnnotationStorage);

          this._storage = new Map();
          this._modified = false;
          this.onSetModified = null;
          this.onResetModified = null;
        }

        _createClass(AnnotationStorage, [{
          key: "getOrCreateValue",
          value: function getOrCreateValue(key, defaultValue) {
            if (this._storage.has(key)) {
              return this._storage.get(key);
            }

            this._storage.set(key, defaultValue);

            return defaultValue;
          }
        }, {
          key: "setValue",
          value: function setValue(key, value) {
            if (this._storage.get(key) !== value) {
              this._setModified();
            }

            this._storage.set(key, value);
          }
        }, {
          key: "getAll",
          value: function getAll() {
            if (this._storage.size === 0) {
              return null;
            }

            return Object.fromEntries(this._storage);
          }
        }, {
          key: "size",
          get: function get() {
            return this._storage.size;
          }
        }, {
          key: "_setModified",
          value: function _setModified() {
            if (!this._modified) {
              this._modified = true;

              if (typeof this.onSetModified === "function") {
                this.onSetModified();
              }
            }
          }
        }, {
          key: "resetModified",
          value: function resetModified() {
            if (this._modified) {
              this._modified = false;

              if (typeof this.onResetModified === "function") {
                this.onResetModified();
              }
            }
          }
        }]);

        return AnnotationStorage;
      }();

      exports.AnnotationStorage = AnnotationStorage;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.apiCompatibilityParams = void 0;

      var _is_node = __w_pdfjs_require__(4);

      var compatibilityParams = Object.create(null);
      {
        (function checkFontFace() {
          if (_is_node.isNodeJS) {
            compatibilityParams.disableFontFace = true;
          }
        })();
      }
      var apiCompatibilityParams = Object.freeze(compatibilityParams);
      exports.apiCompatibilityParams = apiCompatibilityParams;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.CanvasGraphics = void 0;

      var _util = __w_pdfjs_require__(2);

      var _pattern_helper = __w_pdfjs_require__(11);

      var MIN_FONT_SIZE = 16;
      var MAX_FONT_SIZE = 100;
      var MAX_GROUP_SIZE = 4096;
      var MIN_WIDTH_FACTOR = 0.65;
      var MAX_SIZE_TO_COMPILE = 1000;
      var FULL_CHUNK_HEIGHT = 16;

      function addContextCurrentTransform(ctx) {
        if (!ctx.mozCurrentTransform) {
          ctx._originalSave = ctx.save;
          ctx._originalRestore = ctx.restore;
          ctx._originalRotate = ctx.rotate;
          ctx._originalScale = ctx.scale;
          ctx._originalTranslate = ctx.translate;
          ctx._originalTransform = ctx.transform;
          ctx._originalSetTransform = ctx.setTransform;
          ctx._transformMatrix = ctx._transformMatrix || [1, 0, 0, 1, 0, 0];
          ctx._transformStack = [];
          Object.defineProperty(ctx, "mozCurrentTransform", {
            get: function getCurrentTransform() {
              return this._transformMatrix;
            }
          });
          Object.defineProperty(ctx, "mozCurrentTransformInverse", {
            get: function getCurrentTransformInverse() {
              var m = this._transformMatrix;
              var a = m[0],
                  b = m[1],
                  c = m[2],
                  d = m[3],
                  e = m[4],
                  f = m[5];
              var ad_bc = a * d - b * c;
              var bc_ad = b * c - a * d;
              return [d / ad_bc, b / bc_ad, c / bc_ad, a / ad_bc, (d * e - c * f) / bc_ad, (b * e - a * f) / ad_bc];
            }
          });

          ctx.save = function ctxSave() {
            var old = this._transformMatrix;

            this._transformStack.push(old);

            this._transformMatrix = old.slice(0, 6);

            this._originalSave();
          };

          ctx.restore = function ctxRestore() {
            var prev = this._transformStack.pop();

            if (prev) {
              this._transformMatrix = prev;

              this._originalRestore();
            }
          };

          ctx.translate = function ctxTranslate(x, y) {
            var m = this._transformMatrix;
            m[4] = m[0] * x + m[2] * y + m[4];
            m[5] = m[1] * x + m[3] * y + m[5];

            this._originalTranslate(x, y);
          };

          ctx.scale = function ctxScale(x, y) {
            var m = this._transformMatrix;
            m[0] = m[0] * x;
            m[1] = m[1] * x;
            m[2] = m[2] * y;
            m[3] = m[3] * y;

            this._originalScale(x, y);
          };

          ctx.transform = function ctxTransform(a, b, c, d, e, f) {
            var m = this._transformMatrix;
            this._transformMatrix = [m[0] * a + m[2] * b, m[1] * a + m[3] * b, m[0] * c + m[2] * d, m[1] * c + m[3] * d, m[0] * e + m[2] * f + m[4], m[1] * e + m[3] * f + m[5]];

            ctx._originalTransform(a, b, c, d, e, f);
          };

          ctx.setTransform = function ctxSetTransform(a, b, c, d, e, f) {
            this._transformMatrix = [a, b, c, d, e, f];

            ctx._originalSetTransform(a, b, c, d, e, f);
          };

          ctx.rotate = function ctxRotate(angle) {
            var cosValue = Math.cos(angle);
            var sinValue = Math.sin(angle);
            var m = this._transformMatrix;
            this._transformMatrix = [m[0] * cosValue + m[2] * sinValue, m[1] * cosValue + m[3] * sinValue, m[0] * -sinValue + m[2] * cosValue, m[1] * -sinValue + m[3] * cosValue, m[4], m[5]];

            this._originalRotate(angle);
          };
        }
      }

      var CachedCanvases = function CachedCanvasesClosure() {
        function CachedCanvases(canvasFactory) {
          this.canvasFactory = canvasFactory;
          this.cache = Object.create(null);
        }

        CachedCanvases.prototype = {
          getCanvas: function CachedCanvases_getCanvas(id, width, height, trackTransform) {
            var canvasEntry;

            if (this.cache[id] !== undefined) {
              canvasEntry = this.cache[id];
              this.canvasFactory.reset(canvasEntry, width, height);
              canvasEntry.context.setTransform(1, 0, 0, 1, 0, 0);
            } else {
              canvasEntry = this.canvasFactory.create(width, height);
              this.cache[id] = canvasEntry;
            }

            if (trackTransform) {
              addContextCurrentTransform(canvasEntry.context);
            }

            return canvasEntry;
          },
          clear: function clear() {
            for (var id in this.cache) {
              var canvasEntry = this.cache[id];
              this.canvasFactory.destroy(canvasEntry);
              delete this.cache[id];
            }
          }
        };
        return CachedCanvases;
      }();

      function compileType3Glyph(imgData) {
        var POINT_TO_PROCESS_LIMIT = 1000;
        var width = imgData.width,
            height = imgData.height;
        var i,
            j,
            j0,
            width1 = width + 1;
        var points = new Uint8Array(width1 * (height + 1));
        var POINT_TYPES = new Uint8Array([0, 2, 4, 0, 1, 0, 5, 4, 8, 10, 0, 8, 0, 2, 1, 0]);
        var lineSize = width + 7 & ~7,
            data0 = imgData.data;
        var data = new Uint8Array(lineSize * height),
            pos = 0,
            ii;

        for (i = 0, ii = data0.length; i < ii; i++) {
          var mask = 128,
              elem = data0[i];

          while (mask > 0) {
            data[pos++] = elem & mask ? 0 : 255;
            mask >>= 1;
          }
        }

        var count = 0;
        pos = 0;

        if (data[pos] !== 0) {
          points[0] = 1;
          ++count;
        }

        for (j = 1; j < width; j++) {
          if (data[pos] !== data[pos + 1]) {
            points[j] = data[pos] ? 2 : 1;
            ++count;
          }

          pos++;
        }

        if (data[pos] !== 0) {
          points[j] = 2;
          ++count;
        }

        for (i = 1; i < height; i++) {
          pos = i * lineSize;
          j0 = i * width1;

          if (data[pos - lineSize] !== data[pos]) {
            points[j0] = data[pos] ? 1 : 8;
            ++count;
          }

          var sum = (data[pos] ? 4 : 0) + (data[pos - lineSize] ? 8 : 0);

          for (j = 1; j < width; j++) {
            sum = (sum >> 2) + (data[pos + 1] ? 4 : 0) + (data[pos - lineSize + 1] ? 8 : 0);

            if (POINT_TYPES[sum]) {
              points[j0 + j] = POINT_TYPES[sum];
              ++count;
            }

            pos++;
          }

          if (data[pos - lineSize] !== data[pos]) {
            points[j0 + j] = data[pos] ? 2 : 4;
            ++count;
          }

          if (count > POINT_TO_PROCESS_LIMIT) {
            return null;
          }
        }

        pos = lineSize * (height - 1);
        j0 = i * width1;

        if (data[pos] !== 0) {
          points[j0] = 8;
          ++count;
        }

        for (j = 1; j < width; j++) {
          if (data[pos] !== data[pos + 1]) {
            points[j0 + j] = data[pos] ? 4 : 8;
            ++count;
          }

          pos++;
        }

        if (data[pos] !== 0) {
          points[j0 + j] = 4;
          ++count;
        }

        if (count > POINT_TO_PROCESS_LIMIT) {
          return null;
        }

        var steps = new Int32Array([0, width1, -1, 0, -width1, 0, 0, 0, 1]);
        var outlines = [];

        for (i = 0; count && i <= height; i++) {
          var p = i * width1;
          var end = p + width;

          while (p < end && !points[p]) {
            p++;
          }

          if (p === end) {
            continue;
          }

          var coords = [p % width1, i];
          var type = points[p],
              p0 = p,
              pp;

          do {
            var step = steps[type];

            do {
              p += step;
            } while (!points[p]);

            pp = points[p];

            if (pp !== 5 && pp !== 10) {
              type = pp;
              points[p] = 0;
            } else {
              type = pp & 0x33 * type >> 4;
              points[p] &= type >> 2 | type << 2;
            }

            coords.push(p % width1);
            coords.push(p / width1 | 0);

            if (!points[p]) {
              --count;
            }
          } while (p0 !== p);

          outlines.push(coords);
          --i;
        }

        var drawOutline = function drawOutline(c) {
          c.save();
          c.scale(1 / width, -1 / height);
          c.translate(0, -height);
          c.beginPath();

          for (var k = 0, kk = outlines.length; k < kk; k++) {
            var o = outlines[k];
            c.moveTo(o[0], o[1]);

            for (var l = 2, ll = o.length; l < ll; l += 2) {
              c.lineTo(o[l], o[l + 1]);
            }
          }

          c.fill();
          c.beginPath();
          c.restore();
        };

        return drawOutline;
      }

      var CanvasExtraState = function CanvasExtraStateClosure() {
        function CanvasExtraState() {
          this.alphaIsShape = false;
          this.fontSize = 0;
          this.fontSizeScale = 1;
          this.textMatrix = _util.IDENTITY_MATRIX;
          this.textMatrixScale = 1;
          this.fontMatrix = _util.FONT_IDENTITY_MATRIX;
          this.leading = 0;
          this.x = 0;
          this.y = 0;
          this.lineX = 0;
          this.lineY = 0;
          this.charSpacing = 0;
          this.wordSpacing = 0;
          this.textHScale = 1;
          this.textRenderingMode = _util.TextRenderingMode.FILL;
          this.textRise = 0;
          this.fillColor = "#000000";
          this.strokeColor = "#000000";
          this.patternFill = false;
          this.fillAlpha = 1;
          this.strokeAlpha = 1;
          this.lineWidth = 1;
          this.activeSMask = null;
          this.resumeSMaskCtx = null;
          this.transferMaps = null;
        }

        CanvasExtraState.prototype = {
          clone: function CanvasExtraState_clone() {
            return Object.create(this);
          },
          setCurrentPoint: function CanvasExtraState_setCurrentPoint(x, y) {
            this.x = x;
            this.y = y;
          }
        };
        return CanvasExtraState;
      }();

      var CanvasGraphics = function CanvasGraphicsClosure() {
        var EXECUTION_TIME = 15;
        var EXECUTION_STEPS = 10;

        function CanvasGraphics(canvasCtx, commonObjs, objs, canvasFactory, webGLContext, imageLayer, optionalContentConfig) {
          this.ctx = canvasCtx;
          this.current = new CanvasExtraState();
          this.stateStack = [];
          this.pendingClip = null;
          this.pendingEOFill = false;
          this.res = null;
          this.xobjs = null;
          this.commonObjs = commonObjs;
          this.objs = objs;
          this.canvasFactory = canvasFactory;
          this.webGLContext = webGLContext;
          this.imageLayer = imageLayer;
          this.groupStack = [];
          this.processingType3 = null;
          this.baseTransform = null;
          this.baseTransformStack = [];
          this.groupLevel = 0;
          this.smaskStack = [];
          this.smaskCounter = 0;
          this.tempSMask = null;
          this.contentVisible = true;
          this.markedContentStack = [];
          this.optionalContentConfig = optionalContentConfig;
          this.cachedCanvases = new CachedCanvases(this.canvasFactory);

          if (canvasCtx) {
            addContextCurrentTransform(canvasCtx);
          }

          this._cachedGetSinglePixelWidth = null;
        }

        function putBinaryImageData(ctx, imgData) {
          var transferMaps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

          if (typeof ImageData !== "undefined" && imgData instanceof ImageData) {
            ctx.putImageData(imgData, 0, 0);
            return;
          }

          var height = imgData.height,
              width = imgData.width;
          var partialChunkHeight = height % FULL_CHUNK_HEIGHT;
          var fullChunks = (height - partialChunkHeight) / FULL_CHUNK_HEIGHT;
          var totalChunks = partialChunkHeight === 0 ? fullChunks : fullChunks + 1;
          var chunkImgData = ctx.createImageData(width, FULL_CHUNK_HEIGHT);
          var srcPos = 0,
              destPos;
          var src = imgData.data;
          var dest = chunkImgData.data;
          var i, j, thisChunkHeight, elemsInThisChunk;
          var transferMapRed, transferMapGreen, transferMapBlue, transferMapGray;

          if (transferMaps) {
            switch (transferMaps.length) {
              case 1:
                transferMapRed = transferMaps[0];
                transferMapGreen = transferMaps[0];
                transferMapBlue = transferMaps[0];
                transferMapGray = transferMaps[0];
                break;

              case 4:
                transferMapRed = transferMaps[0];
                transferMapGreen = transferMaps[1];
                transferMapBlue = transferMaps[2];
                transferMapGray = transferMaps[3];
                break;
            }
          }

          if (imgData.kind === _util.ImageKind.GRAYSCALE_1BPP) {
            var srcLength = src.byteLength;
            var dest32 = new Uint32Array(dest.buffer, 0, dest.byteLength >> 2);
            var dest32DataLength = dest32.length;
            var fullSrcDiff = width + 7 >> 3;
            var white = 0xffffffff;
            var black = _util.IsLittleEndianCached.value ? 0xff000000 : 0x000000ff;

            if (transferMapGray) {
              if (transferMapGray[0] === 0xff && transferMapGray[0xff] === 0) {
                var _ref30 = [black, white];
                white = _ref30[0];
                black = _ref30[1];
              }
            }

            for (i = 0; i < totalChunks; i++) {
              thisChunkHeight = i < fullChunks ? FULL_CHUNK_HEIGHT : partialChunkHeight;
              destPos = 0;

              for (j = 0; j < thisChunkHeight; j++) {
                var srcDiff = srcLength - srcPos;
                var k = 0;
                var kEnd = srcDiff > fullSrcDiff ? width : srcDiff * 8 - 7;
                var kEndUnrolled = kEnd & ~7;
                var mask = 0;
                var srcByte = 0;

                for (; k < kEndUnrolled; k += 8) {
                  srcByte = src[srcPos++];
                  dest32[destPos++] = srcByte & 128 ? white : black;
                  dest32[destPos++] = srcByte & 64 ? white : black;
                  dest32[destPos++] = srcByte & 32 ? white : black;
                  dest32[destPos++] = srcByte & 16 ? white : black;
                  dest32[destPos++] = srcByte & 8 ? white : black;
                  dest32[destPos++] = srcByte & 4 ? white : black;
                  dest32[destPos++] = srcByte & 2 ? white : black;
                  dest32[destPos++] = srcByte & 1 ? white : black;
                }

                for (; k < kEnd; k++) {
                  if (mask === 0) {
                    srcByte = src[srcPos++];
                    mask = 128;
                  }

                  dest32[destPos++] = srcByte & mask ? white : black;
                  mask >>= 1;
                }
              }

              while (destPos < dest32DataLength) {
                dest32[destPos++] = 0;
              }

              ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
            }
          } else if (imgData.kind === _util.ImageKind.RGBA_32BPP) {
            var hasTransferMaps = !!(transferMapRed || transferMapGreen || transferMapBlue);
            j = 0;
            elemsInThisChunk = width * FULL_CHUNK_HEIGHT * 4;

            for (i = 0; i < fullChunks; i++) {
              dest.set(src.subarray(srcPos, srcPos + elemsInThisChunk));
              srcPos += elemsInThisChunk;

              if (hasTransferMaps) {
                for (var _k = 0; _k < elemsInThisChunk; _k += 4) {
                  if (transferMapRed) {
                    dest[_k + 0] = transferMapRed[dest[_k + 0]];
                  }

                  if (transferMapGreen) {
                    dest[_k + 1] = transferMapGreen[dest[_k + 1]];
                  }

                  if (transferMapBlue) {
                    dest[_k + 2] = transferMapBlue[dest[_k + 2]];
                  }
                }
              }

              ctx.putImageData(chunkImgData, 0, j);
              j += FULL_CHUNK_HEIGHT;
            }

            if (i < totalChunks) {
              elemsInThisChunk = width * partialChunkHeight * 4;
              dest.set(src.subarray(srcPos, srcPos + elemsInThisChunk));

              if (hasTransferMaps) {
                for (var _k2 = 0; _k2 < elemsInThisChunk; _k2 += 4) {
                  if (transferMapRed) {
                    dest[_k2 + 0] = transferMapRed[dest[_k2 + 0]];
                  }

                  if (transferMapGreen) {
                    dest[_k2 + 1] = transferMapGreen[dest[_k2 + 1]];
                  }

                  if (transferMapBlue) {
                    dest[_k2 + 2] = transferMapBlue[dest[_k2 + 2]];
                  }
                }
              }

              ctx.putImageData(chunkImgData, 0, j);
            }
          } else if (imgData.kind === _util.ImageKind.RGB_24BPP) {
            var _hasTransferMaps = !!(transferMapRed || transferMapGreen || transferMapBlue);

            thisChunkHeight = FULL_CHUNK_HEIGHT;
            elemsInThisChunk = width * thisChunkHeight;

            for (i = 0; i < totalChunks; i++) {
              if (i >= fullChunks) {
                thisChunkHeight = partialChunkHeight;
                elemsInThisChunk = width * thisChunkHeight;
              }

              destPos = 0;

              for (j = elemsInThisChunk; j--;) {
                dest[destPos++] = src[srcPos++];
                dest[destPos++] = src[srcPos++];
                dest[destPos++] = src[srcPos++];
                dest[destPos++] = 255;
              }

              if (_hasTransferMaps) {
                for (var _k3 = 0; _k3 < destPos; _k3 += 4) {
                  if (transferMapRed) {
                    dest[_k3 + 0] = transferMapRed[dest[_k3 + 0]];
                  }

                  if (transferMapGreen) {
                    dest[_k3 + 1] = transferMapGreen[dest[_k3 + 1]];
                  }

                  if (transferMapBlue) {
                    dest[_k3 + 2] = transferMapBlue[dest[_k3 + 2]];
                  }
                }
              }

              ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
            }
          } else {
            throw new Error("bad image kind: ".concat(imgData.kind));
          }
        }

        function putBinaryImageMask(ctx, imgData) {
          var height = imgData.height,
              width = imgData.width;
          var partialChunkHeight = height % FULL_CHUNK_HEIGHT;
          var fullChunks = (height - partialChunkHeight) / FULL_CHUNK_HEIGHT;
          var totalChunks = partialChunkHeight === 0 ? fullChunks : fullChunks + 1;
          var chunkImgData = ctx.createImageData(width, FULL_CHUNK_HEIGHT);
          var srcPos = 0;
          var src = imgData.data;
          var dest = chunkImgData.data;

          for (var i = 0; i < totalChunks; i++) {
            var thisChunkHeight = i < fullChunks ? FULL_CHUNK_HEIGHT : partialChunkHeight;
            var destPos = 3;

            for (var j = 0; j < thisChunkHeight; j++) {
              var mask = 0;

              for (var k = 0; k < width; k++) {
                if (!mask) {
                  var elem = src[srcPos++];
                  mask = 128;
                }

                dest[destPos] = elem & mask ? 0 : 255;
                destPos += 4;
                mask >>= 1;
              }
            }

            ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
          }
        }

        function copyCtxState(sourceCtx, destCtx) {
          var properties = ["strokeStyle", "fillStyle", "fillRule", "globalAlpha", "lineWidth", "lineCap", "lineJoin", "miterLimit", "globalCompositeOperation", "font"];

          for (var i = 0, ii = properties.length; i < ii; i++) {
            var property = properties[i];

            if (sourceCtx[property] !== undefined) {
              destCtx[property] = sourceCtx[property];
            }
          }

          if (sourceCtx.setLineDash !== undefined) {
            destCtx.setLineDash(sourceCtx.getLineDash());
            destCtx.lineDashOffset = sourceCtx.lineDashOffset;
          }
        }

        function resetCtxToDefault(ctx) {
          ctx.strokeStyle = "#000000";
          ctx.fillStyle = "#000000";
          ctx.fillRule = "nonzero";
          ctx.globalAlpha = 1;
          ctx.lineWidth = 1;
          ctx.lineCap = "butt";
          ctx.lineJoin = "miter";
          ctx.miterLimit = 10;
          ctx.globalCompositeOperation = "source-over";
          ctx.font = "10px sans-serif";

          if (ctx.setLineDash !== undefined) {
            ctx.setLineDash([]);
            ctx.lineDashOffset = 0;
          }
        }

        function composeSMaskBackdrop(bytes, r0, g0, b0) {
          var length = bytes.length;

          for (var i = 3; i < length; i += 4) {
            var alpha = bytes[i];

            if (alpha === 0) {
              bytes[i - 3] = r0;
              bytes[i - 2] = g0;
              bytes[i - 1] = b0;
            } else if (alpha < 255) {
              var alpha_ = 255 - alpha;
              bytes[i - 3] = bytes[i - 3] * alpha + r0 * alpha_ >> 8;
              bytes[i - 2] = bytes[i - 2] * alpha + g0 * alpha_ >> 8;
              bytes[i - 1] = bytes[i - 1] * alpha + b0 * alpha_ >> 8;
            }
          }
        }

        function composeSMaskAlpha(maskData, layerData, transferMap) {
          var length = maskData.length;
          var scale = 1 / 255;

          for (var i = 3; i < length; i += 4) {
            var alpha = transferMap ? transferMap[maskData[i]] : maskData[i];
            layerData[i] = layerData[i] * alpha * scale | 0;
          }
        }

        function composeSMaskLuminosity(maskData, layerData, transferMap) {
          var length = maskData.length;

          for (var i = 3; i < length; i += 4) {
            var y = maskData[i - 3] * 77 + maskData[i - 2] * 152 + maskData[i - 1] * 28;
            layerData[i] = transferMap ? layerData[i] * transferMap[y >> 8] >> 8 : layerData[i] * y >> 16;
          }
        }

        function genericComposeSMask(maskCtx, layerCtx, width, height, subtype, backdrop, transferMap) {
          var hasBackdrop = !!backdrop;
          var r0 = hasBackdrop ? backdrop[0] : 0;
          var g0 = hasBackdrop ? backdrop[1] : 0;
          var b0 = hasBackdrop ? backdrop[2] : 0;
          var composeFn;

          if (subtype === "Luminosity") {
            composeFn = composeSMaskLuminosity;
          } else {
            composeFn = composeSMaskAlpha;
          }

          var PIXELS_TO_PROCESS = 1048576;
          var chunkSize = Math.min(height, Math.ceil(PIXELS_TO_PROCESS / width));

          for (var row = 0; row < height; row += chunkSize) {
            var chunkHeight = Math.min(chunkSize, height - row);
            var maskData = maskCtx.getImageData(0, row, width, chunkHeight);
            var layerData = layerCtx.getImageData(0, row, width, chunkHeight);

            if (hasBackdrop) {
              composeSMaskBackdrop(maskData.data, r0, g0, b0);
            }

            composeFn(maskData.data, layerData.data, transferMap);
            maskCtx.putImageData(layerData, 0, row);
          }
        }

        function composeSMask(ctx, smask, layerCtx, webGLContext) {
          var mask = smask.canvas;
          var maskCtx = smask.context;
          ctx.setTransform(smask.scaleX, 0, 0, smask.scaleY, smask.offsetX, smask.offsetY);
          var backdrop = smask.backdrop || null;

          if (!smask.transferMap && webGLContext.isEnabled) {
            var composed = webGLContext.composeSMask({
              layer: layerCtx.canvas,
              mask: mask,
              properties: {
                subtype: smask.subtype,
                backdrop: backdrop
              }
            });
            ctx.setTransform(1, 0, 0, 1, 0, 0);
            ctx.drawImage(composed, smask.offsetX, smask.offsetY);
            return;
          }

          genericComposeSMask(maskCtx, layerCtx, mask.width, mask.height, smask.subtype, backdrop, smask.transferMap);
          ctx.drawImage(mask, 0, 0);
        }

        var LINE_CAP_STYLES = ["butt", "round", "square"];
        var LINE_JOIN_STYLES = ["miter", "round", "bevel"];
        var NORMAL_CLIP = {};
        var EO_CLIP = {};
        CanvasGraphics.prototype = {
          beginDrawing: function beginDrawing(_ref31) {
            var transform = _ref31.transform,
                viewport = _ref31.viewport,
                _ref31$transparency = _ref31.transparency,
                transparency = _ref31$transparency === void 0 ? false : _ref31$transparency,
                _ref31$background = _ref31.background,
                background = _ref31$background === void 0 ? null : _ref31$background;
            var width = this.ctx.canvas.width;
            var height = this.ctx.canvas.height;
            this.ctx.save();
            this.ctx.fillStyle = background || "rgb(255, 255, 255)";
            this.ctx.fillRect(0, 0, width, height);
            this.ctx.restore();

            if (transparency) {
              var transparentCanvas = this.cachedCanvases.getCanvas("transparent", width, height, true);
              this.compositeCtx = this.ctx;
              this.transparentCanvas = transparentCanvas.canvas;
              this.ctx = transparentCanvas.context;
              this.ctx.save();
              this.ctx.transform.apply(this.ctx, this.compositeCtx.mozCurrentTransform);
            }

            this.ctx.save();
            resetCtxToDefault(this.ctx);

            if (transform) {
              this.ctx.transform.apply(this.ctx, transform);
            }

            this.ctx.transform.apply(this.ctx, viewport.transform);
            this.baseTransform = this.ctx.mozCurrentTransform.slice();

            if (this.imageLayer) {
              this.imageLayer.beginLayout();
            }
          },
          executeOperatorList: function CanvasGraphics_executeOperatorList(operatorList, executionStartIdx, continueCallback, stepper) {
            var argsArray = operatorList.argsArray;
            var fnArray = operatorList.fnArray;
            var i = executionStartIdx || 0;
            var argsArrayLen = argsArray.length;

            if (argsArrayLen === i) {
              return i;
            }

            var chunkOperations = argsArrayLen - i > EXECUTION_STEPS && typeof continueCallback === "function";
            var endTime = chunkOperations ? Date.now() + EXECUTION_TIME : 0;
            var steps = 0;
            var commonObjs = this.commonObjs;
            var objs = this.objs;
            var fnId;

            while (true) {
              if (stepper !== undefined && i === stepper.nextBreakPoint) {
                stepper.breakIt(i, continueCallback);
                return i;
              }

              fnId = fnArray[i];

              if (fnId !== _util.OPS.dependency) {
                this[fnId].apply(this, argsArray[i]);
              } else {
                var _iterator11 = _createForOfIteratorHelper(argsArray[i]),
                    _step11;

                try {
                  for (_iterator11.s(); !(_step11 = _iterator11.n()).done;) {
                    var depObjId = _step11.value;
                    var objsPool = depObjId.startsWith("g_") ? commonObjs : objs;

                    if (!objsPool.has(depObjId)) {
                      objsPool.get(depObjId, continueCallback);
                      return i;
                    }
                  }
                } catch (err) {
                  _iterator11.e(err);
                } finally {
                  _iterator11.f();
                }
              }

              i++;

              if (i === argsArrayLen) {
                return i;
              }

              if (chunkOperations && ++steps > EXECUTION_STEPS) {
                if (Date.now() > endTime) {
                  continueCallback();
                  return i;
                }

                steps = 0;
              }
            }
          },
          endDrawing: function CanvasGraphics_endDrawing() {
            if (this.current.activeSMask !== null) {
              this.endSMaskGroup();
            }

            this.ctx.restore();

            if (this.transparentCanvas) {
              this.ctx = this.compositeCtx;
              this.ctx.save();
              this.ctx.setTransform(1, 0, 0, 1, 0, 0);
              this.ctx.drawImage(this.transparentCanvas, 0, 0);
              this.ctx.restore();
              this.transparentCanvas = null;
            }

            this.cachedCanvases.clear();
            this.webGLContext.clear();

            if (this.imageLayer) {
              this.imageLayer.endLayout();
            }
          },
          setLineWidth: function CanvasGraphics_setLineWidth(width) {
            this.current.lineWidth = width;
            this.ctx.lineWidth = width;
          },
          setLineCap: function CanvasGraphics_setLineCap(style) {
            this.ctx.lineCap = LINE_CAP_STYLES[style];
          },
          setLineJoin: function CanvasGraphics_setLineJoin(style) {
            this.ctx.lineJoin = LINE_JOIN_STYLES[style];
          },
          setMiterLimit: function CanvasGraphics_setMiterLimit(limit) {
            this.ctx.miterLimit = limit;
          },
          setDash: function CanvasGraphics_setDash(dashArray, dashPhase) {
            var ctx = this.ctx;

            if (ctx.setLineDash !== undefined) {
              ctx.setLineDash(dashArray);
              ctx.lineDashOffset = dashPhase;
            }
          },
          setRenderingIntent: function setRenderingIntent(intent) {},
          setFlatness: function setFlatness(flatness) {},
          setGState: function CanvasGraphics_setGState(states) {
            for (var i = 0, ii = states.length; i < ii; i++) {
              var state = states[i];
              var key = state[0];
              var value = state[1];

              switch (key) {
                case "LW":
                  this.setLineWidth(value);
                  break;

                case "LC":
                  this.setLineCap(value);
                  break;

                case "LJ":
                  this.setLineJoin(value);
                  break;

                case "ML":
                  this.setMiterLimit(value);
                  break;

                case "D":
                  this.setDash(value[0], value[1]);
                  break;

                case "RI":
                  this.setRenderingIntent(value);
                  break;

                case "FL":
                  this.setFlatness(value);
                  break;

                case "Font":
                  this.setFont(value[0], value[1]);
                  break;

                case "CA":
                  this.current.strokeAlpha = state[1];
                  break;

                case "ca":
                  this.current.fillAlpha = state[1];
                  this.ctx.globalAlpha = state[1];
                  break;

                case "BM":
                  this.ctx.globalCompositeOperation = value;
                  break;

                case "SMask":
                  if (this.current.activeSMask) {
                    if (this.stateStack.length > 0 && this.stateStack[this.stateStack.length - 1].activeSMask === this.current.activeSMask) {
                      this.suspendSMaskGroup();
                    } else {
                      this.endSMaskGroup();
                    }
                  }

                  this.current.activeSMask = value ? this.tempSMask : null;

                  if (this.current.activeSMask) {
                    this.beginSMaskGroup();
                  }

                  this.tempSMask = null;
                  break;

                case "TR":
                  this.current.transferMaps = value;
              }
            }
          },
          beginSMaskGroup: function CanvasGraphics_beginSMaskGroup() {
            var activeSMask = this.current.activeSMask;
            var drawnWidth = activeSMask.canvas.width;
            var drawnHeight = activeSMask.canvas.height;
            var cacheId = "smaskGroupAt" + this.groupLevel;
            var scratchCanvas = this.cachedCanvases.getCanvas(cacheId, drawnWidth, drawnHeight, true);
            var currentCtx = this.ctx;
            var currentTransform = currentCtx.mozCurrentTransform;
            this.ctx.save();
            var groupCtx = scratchCanvas.context;
            groupCtx.scale(1 / activeSMask.scaleX, 1 / activeSMask.scaleY);
            groupCtx.translate(-activeSMask.offsetX, -activeSMask.offsetY);
            groupCtx.transform.apply(groupCtx, currentTransform);
            activeSMask.startTransformInverse = groupCtx.mozCurrentTransformInverse;
            copyCtxState(currentCtx, groupCtx);
            this.ctx = groupCtx;
            this.setGState([["BM", "source-over"], ["ca", 1], ["CA", 1]]);
            this.groupStack.push(currentCtx);
            this.groupLevel++;
          },
          suspendSMaskGroup: function CanvasGraphics_endSMaskGroup() {
            var groupCtx = this.ctx;
            this.groupLevel--;
            this.ctx = this.groupStack.pop();
            composeSMask(this.ctx, this.current.activeSMask, groupCtx, this.webGLContext);
            this.ctx.restore();
            this.ctx.save();
            copyCtxState(groupCtx, this.ctx);
            this.current.resumeSMaskCtx = groupCtx;

            var deltaTransform = _util.Util.transform(this.current.activeSMask.startTransformInverse, groupCtx.mozCurrentTransform);

            this.ctx.transform.apply(this.ctx, deltaTransform);
            groupCtx.save();
            groupCtx.setTransform(1, 0, 0, 1, 0, 0);
            groupCtx.clearRect(0, 0, groupCtx.canvas.width, groupCtx.canvas.height);
            groupCtx.restore();
          },
          resumeSMaskGroup: function CanvasGraphics_endSMaskGroup() {
            var groupCtx = this.current.resumeSMaskCtx;
            var currentCtx = this.ctx;
            this.ctx = groupCtx;
            this.groupStack.push(currentCtx);
            this.groupLevel++;
          },
          endSMaskGroup: function CanvasGraphics_endSMaskGroup() {
            var groupCtx = this.ctx;
            this.groupLevel--;
            this.ctx = this.groupStack.pop();
            composeSMask(this.ctx, this.current.activeSMask, groupCtx, this.webGLContext);
            this.ctx.restore();
            copyCtxState(groupCtx, this.ctx);

            var deltaTransform = _util.Util.transform(this.current.activeSMask.startTransformInverse, groupCtx.mozCurrentTransform);

            this.ctx.transform.apply(this.ctx, deltaTransform);
          },
          save: function CanvasGraphics_save() {
            this.ctx.save();
            var old = this.current;
            this.stateStack.push(old);
            this.current = old.clone();
            this.current.resumeSMaskCtx = null;
          },
          restore: function CanvasGraphics_restore() {
            if (this.current.resumeSMaskCtx) {
              this.resumeSMaskGroup();
            }

            if (this.current.activeSMask !== null && (this.stateStack.length === 0 || this.stateStack[this.stateStack.length - 1].activeSMask !== this.current.activeSMask)) {
              this.endSMaskGroup();
            }

            if (this.stateStack.length !== 0) {
              this.current = this.stateStack.pop();
              this.ctx.restore();
              this.pendingClip = null;
              this._cachedGetSinglePixelWidth = null;
            }
          },
          transform: function CanvasGraphics_transform(a, b, c, d, e, f) {
            this.ctx.transform(a, b, c, d, e, f);
            this._cachedGetSinglePixelWidth = null;
          },
          constructPath: function CanvasGraphics_constructPath(ops, args) {
            var ctx = this.ctx;
            var current = this.current;
            var x = current.x,
                y = current.y;

            for (var i = 0, j = 0, ii = ops.length; i < ii; i++) {
              switch (ops[i] | 0) {
                case _util.OPS.rectangle:
                  x = args[j++];
                  y = args[j++];
                  var width = args[j++];
                  var height = args[j++];

                  if (width === 0 && ctx.lineWidth < this.getSinglePixelWidth()) {
                    width = this.getSinglePixelWidth();
                  }

                  if (height === 0 && ctx.lineWidth < this.getSinglePixelWidth()) {
                    height = this.getSinglePixelWidth();
                  }

                  var xw = x + width;
                  var yh = y + height;
                  ctx.moveTo(x, y);
                  ctx.lineTo(xw, y);
                  ctx.lineTo(xw, yh);
                  ctx.lineTo(x, yh);
                  ctx.lineTo(x, y);
                  ctx.closePath();
                  break;

                case _util.OPS.moveTo:
                  x = args[j++];
                  y = args[j++];
                  ctx.moveTo(x, y);
                  break;

                case _util.OPS.lineTo:
                  x = args[j++];
                  y = args[j++];
                  ctx.lineTo(x, y);
                  break;

                case _util.OPS.curveTo:
                  x = args[j + 4];
                  y = args[j + 5];
                  ctx.bezierCurveTo(args[j], args[j + 1], args[j + 2], args[j + 3], x, y);
                  j += 6;
                  break;

                case _util.OPS.curveTo2:
                  ctx.bezierCurveTo(x, y, args[j], args[j + 1], args[j + 2], args[j + 3]);
                  x = args[j + 2];
                  y = args[j + 3];
                  j += 4;
                  break;

                case _util.OPS.curveTo3:
                  x = args[j + 2];
                  y = args[j + 3];
                  ctx.bezierCurveTo(args[j], args[j + 1], x, y, x, y);
                  j += 4;
                  break;

                case _util.OPS.closePath:
                  ctx.closePath();
                  break;
              }
            }

            current.setCurrentPoint(x, y);
          },
          closePath: function CanvasGraphics_closePath() {
            this.ctx.closePath();
          },
          stroke: function CanvasGraphics_stroke(consumePath) {
            consumePath = typeof consumePath !== "undefined" ? consumePath : true;
            var ctx = this.ctx;
            var strokeColor = this.current.strokeColor;
            ctx.globalAlpha = this.current.strokeAlpha;

            if (this.contentVisible) {
              if (strokeColor && strokeColor.hasOwnProperty("type") && strokeColor.type === "Pattern") {
                ctx.save();
                var transform = ctx.mozCurrentTransform;

                var scale = _util.Util.singularValueDecompose2dScale(transform)[0];

                ctx.strokeStyle = strokeColor.getPattern(ctx, this);
                ctx.lineWidth = Math.max(this.getSinglePixelWidth() * MIN_WIDTH_FACTOR, this.current.lineWidth * scale);
                ctx.stroke();
                ctx.restore();
              } else {
                ctx.lineWidth = Math.max(this.getSinglePixelWidth() * MIN_WIDTH_FACTOR, this.current.lineWidth);
                ctx.stroke();
              }
            }

            if (consumePath) {
              this.consumePath();
            }

            ctx.globalAlpha = this.current.fillAlpha;
          },
          closeStroke: function CanvasGraphics_closeStroke() {
            this.closePath();
            this.stroke();
          },
          fill: function CanvasGraphics_fill(consumePath) {
            consumePath = typeof consumePath !== "undefined" ? consumePath : true;
            var ctx = this.ctx;
            var fillColor = this.current.fillColor;
            var isPatternFill = this.current.patternFill;
            var needRestore = false;

            if (isPatternFill) {
              ctx.save();

              if (this.baseTransform) {
                ctx.setTransform.apply(ctx, this.baseTransform);
              }

              ctx.fillStyle = fillColor.getPattern(ctx, this);
              needRestore = true;
            }

            if (this.contentVisible) {
              if (this.pendingEOFill) {
                ctx.fill("evenodd");
                this.pendingEOFill = false;
              } else {
                ctx.fill();
              }
            }

            if (needRestore) {
              ctx.restore();
            }

            if (consumePath) {
              this.consumePath();
            }
          },
          eoFill: function CanvasGraphics_eoFill() {
            this.pendingEOFill = true;
            this.fill();
          },
          fillStroke: function CanvasGraphics_fillStroke() {
            this.fill(false);
            this.stroke(false);
            this.consumePath();
          },
          eoFillStroke: function CanvasGraphics_eoFillStroke() {
            this.pendingEOFill = true;
            this.fillStroke();
          },
          closeFillStroke: function CanvasGraphics_closeFillStroke() {
            this.closePath();
            this.fillStroke();
          },
          closeEOFillStroke: function CanvasGraphics_closeEOFillStroke() {
            this.pendingEOFill = true;
            this.closePath();
            this.fillStroke();
          },
          endPath: function CanvasGraphics_endPath() {
            this.consumePath();
          },
          clip: function CanvasGraphics_clip() {
            this.pendingClip = NORMAL_CLIP;
          },
          eoClip: function CanvasGraphics_eoClip() {
            this.pendingClip = EO_CLIP;
          },
          beginText: function CanvasGraphics_beginText() {
            this.current.textMatrix = _util.IDENTITY_MATRIX;
            this.current.textMatrixScale = 1;
            this.current.x = this.current.lineX = 0;
            this.current.y = this.current.lineY = 0;
          },
          endText: function CanvasGraphics_endText() {
            var paths = this.pendingTextPaths;
            var ctx = this.ctx;

            if (paths === undefined) {
              ctx.beginPath();
              return;
            }

            ctx.save();
            ctx.beginPath();

            for (var i = 0; i < paths.length; i++) {
              var path = paths[i];
              ctx.setTransform.apply(ctx, path.transform);
              ctx.translate(path.x, path.y);
              path.addToPath(ctx, path.fontSize);
            }

            ctx.restore();
            ctx.clip();
            ctx.beginPath();
            delete this.pendingTextPaths;
          },
          setCharSpacing: function CanvasGraphics_setCharSpacing(spacing) {
            this.current.charSpacing = spacing;
          },
          setWordSpacing: function CanvasGraphics_setWordSpacing(spacing) {
            this.current.wordSpacing = spacing;
          },
          setHScale: function CanvasGraphics_setHScale(scale) {
            this.current.textHScale = scale / 100;
          },
          setLeading: function CanvasGraphics_setLeading(leading) {
            this.current.leading = -leading;
          },
          setFont: function CanvasGraphics_setFont(fontRefName, size) {
            var fontObj = this.commonObjs.get(fontRefName);
            var current = this.current;

            if (!fontObj) {
              throw new Error("Can't find font for ".concat(fontRefName));
            }

            current.fontMatrix = fontObj.fontMatrix ? fontObj.fontMatrix : _util.FONT_IDENTITY_MATRIX;

            if (current.fontMatrix[0] === 0 || current.fontMatrix[3] === 0) {
              (0, _util.warn)("Invalid font matrix for font " + fontRefName);
            }

            if (size < 0) {
              size = -size;
              current.fontDirection = -1;
            } else {
              current.fontDirection = 1;
            }

            this.current.font = fontObj;
            this.current.fontSize = size;

            if (fontObj.isType3Font) {
              return;
            }

            var name = fontObj.loadedName || "sans-serif";
            var bold = "normal";

            if (fontObj.black) {
              bold = "900";
            } else if (fontObj.bold) {
              bold = "bold";
            }

            var italic = fontObj.italic ? "italic" : "normal";
            var typeface = "\"".concat(name, "\", ").concat(fontObj.fallbackName);
            var browserFontSize = size;

            if (size < MIN_FONT_SIZE) {
              browserFontSize = MIN_FONT_SIZE;
            } else if (size > MAX_FONT_SIZE) {
              browserFontSize = MAX_FONT_SIZE;
            }

            this.current.fontSizeScale = size / browserFontSize;
            this.ctx.font = "".concat(italic, " ").concat(bold, " ").concat(browserFontSize, "px ").concat(typeface);
          },
          setTextRenderingMode: function CanvasGraphics_setTextRenderingMode(mode) {
            this.current.textRenderingMode = mode;
          },
          setTextRise: function CanvasGraphics_setTextRise(rise) {
            this.current.textRise = rise;
          },
          moveText: function CanvasGraphics_moveText(x, y) {
            this.current.x = this.current.lineX += x;
            this.current.y = this.current.lineY += y;
          },
          setLeadingMoveText: function CanvasGraphics_setLeadingMoveText(x, y) {
            this.setLeading(-y);
            this.moveText(x, y);
          },
          setTextMatrix: function CanvasGraphics_setTextMatrix(a, b, c, d, e, f) {
            this.current.textMatrix = [a, b, c, d, e, f];
            this.current.textMatrixScale = Math.sqrt(a * a + b * b);
            this.current.x = this.current.lineX = 0;
            this.current.y = this.current.lineY = 0;
          },
          nextLine: function CanvasGraphics_nextLine() {
            this.moveText(0, this.current.leading);
          },
          paintChar: function paintChar(character, x, y, patternTransform) {
            var ctx = this.ctx;
            var current = this.current;
            var font = current.font;
            var textRenderingMode = current.textRenderingMode;
            var fontSize = current.fontSize / current.fontSizeScale;
            var fillStrokeMode = textRenderingMode & _util.TextRenderingMode.FILL_STROKE_MASK;
            var isAddToPathSet = !!(textRenderingMode & _util.TextRenderingMode.ADD_TO_PATH_FLAG);
            var patternFill = current.patternFill && !font.missingFile;
            var addToPath;

            if (font.disableFontFace || isAddToPathSet || patternFill) {
              addToPath = font.getPathGenerator(this.commonObjs, character);
            }

            if (font.disableFontFace || patternFill) {
              ctx.save();
              ctx.translate(x, y);
              ctx.beginPath();
              addToPath(ctx, fontSize);

              if (patternTransform) {
                ctx.setTransform.apply(ctx, patternTransform);
              }

              if (fillStrokeMode === _util.TextRenderingMode.FILL || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
                ctx.fill();
              }

              if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
                ctx.stroke();
              }

              ctx.restore();
            } else {
              if (fillStrokeMode === _util.TextRenderingMode.FILL || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
                ctx.fillText(character, x, y);
              }

              if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
                ctx.strokeText(character, x, y);
              }
            }

            if (isAddToPathSet) {
              var paths = this.pendingTextPaths || (this.pendingTextPaths = []);
              paths.push({
                transform: ctx.mozCurrentTransform,
                x: x,
                y: y,
                fontSize: fontSize,
                addToPath: addToPath
              });
            }
          },

          get isFontSubpixelAAEnabled() {
            var _this$cachedCanvases$ = this.cachedCanvases.getCanvas("isFontSubpixelAAEnabled", 10, 10),
                ctx = _this$cachedCanvases$.context;

            ctx.scale(1.5, 1);
            ctx.fillText("I", 0, 10);
            var data = ctx.getImageData(0, 0, 10, 10).data;
            var enabled = false;

            for (var i = 3; i < data.length; i += 4) {
              if (data[i] > 0 && data[i] < 255) {
                enabled = true;
                break;
              }
            }

            return (0, _util.shadow)(this, "isFontSubpixelAAEnabled", enabled);
          },

          showText: function CanvasGraphics_showText(glyphs) {
            var current = this.current;
            var font = current.font;

            if (font.isType3Font) {
              return this.showType3Text(glyphs);
            }

            var fontSize = current.fontSize;

            if (fontSize === 0) {
              return undefined;
            }

            var ctx = this.ctx;
            var fontSizeScale = current.fontSizeScale;
            var charSpacing = current.charSpacing;
            var wordSpacing = current.wordSpacing;
            var fontDirection = current.fontDirection;
            var textHScale = current.textHScale * fontDirection;
            var glyphsLength = glyphs.length;
            var vertical = font.vertical;
            var spacingDir = vertical ? 1 : -1;
            var defaultVMetrics = font.defaultVMetrics;
            var widthAdvanceScale = fontSize * current.fontMatrix[0];
            var simpleFillText = current.textRenderingMode === _util.TextRenderingMode.FILL && !font.disableFontFace && !current.patternFill;
            ctx.save();
            var patternTransform;

            if (current.patternFill) {
              ctx.save();
              var pattern = current.fillColor.getPattern(ctx, this);
              patternTransform = ctx.mozCurrentTransform;
              ctx.restore();
              ctx.fillStyle = pattern;
            }

            ctx.transform.apply(ctx, current.textMatrix);
            ctx.translate(current.x, current.y + current.textRise);

            if (fontDirection > 0) {
              ctx.scale(textHScale, -1);
            } else {
              ctx.scale(textHScale, 1);
            }

            var lineWidth = current.lineWidth;
            var scale = current.textMatrixScale;

            if (scale === 0 || lineWidth === 0) {
              var fillStrokeMode = current.textRenderingMode & _util.TextRenderingMode.FILL_STROKE_MASK;

              if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
                this._cachedGetSinglePixelWidth = null;
                lineWidth = this.getSinglePixelWidth() * MIN_WIDTH_FACTOR;
              }
            } else {
              lineWidth /= scale;
            }

            if (fontSizeScale !== 1.0) {
              ctx.scale(fontSizeScale, fontSizeScale);
              lineWidth /= fontSizeScale;
            }

            ctx.lineWidth = lineWidth;
            var x = 0,
                i;

            for (i = 0; i < glyphsLength; ++i) {
              var glyph = glyphs[i];

              if ((0, _util.isNum)(glyph)) {
                x += spacingDir * glyph * fontSize / 1000;
                continue;
              }

              var restoreNeeded = false;
              var spacing = (glyph.isSpace ? wordSpacing : 0) + charSpacing;
              var character = glyph.fontChar;
              var accent = glyph.accent;
              var scaledX, scaledY, scaledAccentX, scaledAccentY;
              var width = glyph.width;

              if (vertical) {
                var vmetric, vx, vy;
                vmetric = glyph.vmetric || defaultVMetrics;
                vx = glyph.vmetric ? vmetric[1] : width * 0.5;
                vx = -vx * widthAdvanceScale;
                vy = vmetric[2] * widthAdvanceScale;
                width = vmetric ? -vmetric[0] : width;
                scaledX = vx / fontSizeScale;
                scaledY = (x + vy) / fontSizeScale;
              } else {
                scaledX = x / fontSizeScale;
                scaledY = 0;
              }

              if (font.remeasure && width > 0) {
                var measuredWidth = ctx.measureText(character).width * 1000 / fontSize * fontSizeScale;

                if (width < measuredWidth && this.isFontSubpixelAAEnabled) {
                  var characterScaleX = width / measuredWidth;
                  restoreNeeded = true;
                  ctx.save();
                  ctx.scale(characterScaleX, 1);
                  scaledX /= characterScaleX;
                } else if (width !== measuredWidth) {
                  scaledX += (width - measuredWidth) / 2000 * fontSize / fontSizeScale;
                }
              }

              if (this.contentVisible && (glyph.isInFont || font.missingFile)) {
                if (simpleFillText && !accent) {
                  ctx.fillText(character, scaledX, scaledY);
                } else {
                  this.paintChar(character, scaledX, scaledY, patternTransform);

                  if (accent) {
                    scaledAccentX = scaledX + fontSize * accent.offset.x / fontSizeScale;
                    scaledAccentY = scaledY - fontSize * accent.offset.y / fontSizeScale;
                    this.paintChar(accent.fontChar, scaledAccentX, scaledAccentY, patternTransform);
                  }
                }
              }

              var charWidth;

              if (vertical) {
                charWidth = width * widthAdvanceScale - spacing * fontDirection;
              } else {
                charWidth = width * widthAdvanceScale + spacing * fontDirection;
              }

              x += charWidth;

              if (restoreNeeded) {
                ctx.restore();
              }
            }

            if (vertical) {
              current.y -= x;
            } else {
              current.x += x * textHScale;
            }

            ctx.restore();
          },
          showType3Text: function CanvasGraphics_showType3Text(glyphs) {
            var ctx = this.ctx;
            var current = this.current;
            var font = current.font;
            var fontSize = current.fontSize;
            var fontDirection = current.fontDirection;
            var spacingDir = font.vertical ? 1 : -1;
            var charSpacing = current.charSpacing;
            var wordSpacing = current.wordSpacing;
            var textHScale = current.textHScale * fontDirection;
            var fontMatrix = current.fontMatrix || _util.FONT_IDENTITY_MATRIX;
            var glyphsLength = glyphs.length;
            var isTextInvisible = current.textRenderingMode === _util.TextRenderingMode.INVISIBLE;
            var i, glyph, width, spacingLength;

            if (isTextInvisible || fontSize === 0) {
              return;
            }

            this._cachedGetSinglePixelWidth = null;
            ctx.save();
            ctx.transform.apply(ctx, current.textMatrix);
            ctx.translate(current.x, current.y);
            ctx.scale(textHScale, fontDirection);

            for (i = 0; i < glyphsLength; ++i) {
              glyph = glyphs[i];

              if ((0, _util.isNum)(glyph)) {
                spacingLength = spacingDir * glyph * fontSize / 1000;
                this.ctx.translate(spacingLength, 0);
                current.x += spacingLength * textHScale;
                continue;
              }

              var spacing = (glyph.isSpace ? wordSpacing : 0) + charSpacing;
              var operatorList = font.charProcOperatorList[glyph.operatorListId];

              if (!operatorList) {
                (0, _util.warn)("Type3 character \"".concat(glyph.operatorListId, "\" is not available."));
                continue;
              }

              if (this.contentVisible) {
                this.processingType3 = glyph;
                this.save();
                ctx.scale(fontSize, fontSize);
                ctx.transform.apply(ctx, fontMatrix);
                this.executeOperatorList(operatorList);
                this.restore();
              }

              var transformed = _util.Util.applyTransform([glyph.width, 0], fontMatrix);

              width = transformed[0] * fontSize + spacing;
              ctx.translate(width, 0);
              current.x += width * textHScale;
            }

            ctx.restore();
            this.processingType3 = null;
          },
          setCharWidth: function CanvasGraphics_setCharWidth(xWidth, yWidth) {},
          setCharWidthAndBounds: function CanvasGraphics_setCharWidthAndBounds(xWidth, yWidth, llx, lly, urx, ury) {
            this.ctx.rect(llx, lly, urx - llx, ury - lly);
            this.clip();
            this.endPath();
          },
          getColorN_Pattern: function CanvasGraphics_getColorN_Pattern(IR) {
            var _this28 = this;

            var pattern;

            if (IR[0] === "TilingPattern") {
              var color = IR[1];
              var baseTransform = this.baseTransform || this.ctx.mozCurrentTransform.slice();
              var canvasGraphicsFactory = {
                createCanvasGraphics: function createCanvasGraphics(ctx) {
                  return new CanvasGraphics(ctx, _this28.commonObjs, _this28.objs, _this28.canvasFactory, _this28.webGLContext);
                }
              };
              pattern = new _pattern_helper.TilingPattern(IR, color, this.ctx, canvasGraphicsFactory, baseTransform);
            } else {
              pattern = (0, _pattern_helper.getShadingPatternFromIR)(IR);
            }

            return pattern;
          },
          setStrokeColorN: function CanvasGraphics_setStrokeColorN() {
            this.current.strokeColor = this.getColorN_Pattern(arguments);
          },
          setFillColorN: function CanvasGraphics_setFillColorN() {
            this.current.fillColor = this.getColorN_Pattern(arguments);
            this.current.patternFill = true;
          },
          setStrokeRGBColor: function CanvasGraphics_setStrokeRGBColor(r, g, b) {
            var color = _util.Util.makeCssRgb(r, g, b);

            this.ctx.strokeStyle = color;
            this.current.strokeColor = color;
          },
          setFillRGBColor: function CanvasGraphics_setFillRGBColor(r, g, b) {
            var color = _util.Util.makeCssRgb(r, g, b);

            this.ctx.fillStyle = color;
            this.current.fillColor = color;
            this.current.patternFill = false;
          },
          shadingFill: function CanvasGraphics_shadingFill(patternIR) {
            if (!this.contentVisible) {
              return;
            }

            var ctx = this.ctx;
            this.save();
            var pattern = (0, _pattern_helper.getShadingPatternFromIR)(patternIR);
            ctx.fillStyle = pattern.getPattern(ctx, this, true);
            var inv = ctx.mozCurrentTransformInverse;

            if (inv) {
              var canvas = ctx.canvas;
              var width = canvas.width;
              var height = canvas.height;

              var bl = _util.Util.applyTransform([0, 0], inv);

              var br = _util.Util.applyTransform([0, height], inv);

              var ul = _util.Util.applyTransform([width, 0], inv);

              var ur = _util.Util.applyTransform([width, height], inv);

              var x0 = Math.min(bl[0], br[0], ul[0], ur[0]);
              var y0 = Math.min(bl[1], br[1], ul[1], ur[1]);
              var x1 = Math.max(bl[0], br[0], ul[0], ur[0]);
              var y1 = Math.max(bl[1], br[1], ul[1], ur[1]);
              this.ctx.fillRect(x0, y0, x1 - x0, y1 - y0);
            } else {
              this.ctx.fillRect(-1e10, -1e10, 2e10, 2e10);
            }

            this.restore();
          },
          beginInlineImage: function CanvasGraphics_beginInlineImage() {
            (0, _util.unreachable)("Should not call beginInlineImage");
          },
          beginImageData: function CanvasGraphics_beginImageData() {
            (0, _util.unreachable)("Should not call beginImageData");
          },
          paintFormXObjectBegin: function CanvasGraphics_paintFormXObjectBegin(matrix, bbox) {
            if (!this.contentVisible) {
              return;
            }

            this.save();
            this.baseTransformStack.push(this.baseTransform);

            if (Array.isArray(matrix) && matrix.length === 6) {
              this.transform.apply(this, matrix);
            }

            this.baseTransform = this.ctx.mozCurrentTransform;

            if (bbox) {
              var width = bbox[2] - bbox[0];
              var height = bbox[3] - bbox[1];
              this.ctx.rect(bbox[0], bbox[1], width, height);
              this.clip();
              this.endPath();
            }
          },
          paintFormXObjectEnd: function CanvasGraphics_paintFormXObjectEnd() {
            if (!this.contentVisible) {
              return;
            }

            this.restore();
            this.baseTransform = this.baseTransformStack.pop();
          },
          beginGroup: function CanvasGraphics_beginGroup(group) {
            if (!this.contentVisible) {
              return;
            }

            this.save();
            var currentCtx = this.ctx;

            if (!group.isolated) {
              (0, _util.info)("TODO: Support non-isolated groups.");
            }

            if (group.knockout) {
              (0, _util.warn)("Knockout groups not supported.");
            }

            var currentTransform = currentCtx.mozCurrentTransform;

            if (group.matrix) {
              currentCtx.transform.apply(currentCtx, group.matrix);
            }

            if (!group.bbox) {
              throw new Error("Bounding box is required.");
            }

            var bounds = _util.Util.getAxialAlignedBoundingBox(group.bbox, currentCtx.mozCurrentTransform);

            var canvasBounds = [0, 0, currentCtx.canvas.width, currentCtx.canvas.height];
            bounds = _util.Util.intersect(bounds, canvasBounds) || [0, 0, 0, 0];
            var offsetX = Math.floor(bounds[0]);
            var offsetY = Math.floor(bounds[1]);
            var drawnWidth = Math.max(Math.ceil(bounds[2]) - offsetX, 1);
            var drawnHeight = Math.max(Math.ceil(bounds[3]) - offsetY, 1);
            var scaleX = 1,
                scaleY = 1;

            if (drawnWidth > MAX_GROUP_SIZE) {
              scaleX = drawnWidth / MAX_GROUP_SIZE;
              drawnWidth = MAX_GROUP_SIZE;
            }

            if (drawnHeight > MAX_GROUP_SIZE) {
              scaleY = drawnHeight / MAX_GROUP_SIZE;
              drawnHeight = MAX_GROUP_SIZE;
            }

            var cacheId = "groupAt" + this.groupLevel;

            if (group.smask) {
              cacheId += "_smask_" + this.smaskCounter++ % 2;
            }

            var scratchCanvas = this.cachedCanvases.getCanvas(cacheId, drawnWidth, drawnHeight, true);
            var groupCtx = scratchCanvas.context;
            groupCtx.scale(1 / scaleX, 1 / scaleY);
            groupCtx.translate(-offsetX, -offsetY);
            groupCtx.transform.apply(groupCtx, currentTransform);

            if (group.smask) {
              this.smaskStack.push({
                canvas: scratchCanvas.canvas,
                context: groupCtx,
                offsetX: offsetX,
                offsetY: offsetY,
                scaleX: scaleX,
                scaleY: scaleY,
                subtype: group.smask.subtype,
                backdrop: group.smask.backdrop,
                transferMap: group.smask.transferMap || null,
                startTransformInverse: null
              });
            } else {
              currentCtx.setTransform(1, 0, 0, 1, 0, 0);
              currentCtx.translate(offsetX, offsetY);
              currentCtx.scale(scaleX, scaleY);
            }

            copyCtxState(currentCtx, groupCtx);
            this.ctx = groupCtx;
            this.setGState([["BM", "source-over"], ["ca", 1], ["CA", 1]]);
            this.groupStack.push(currentCtx);
            this.groupLevel++;
            this.current.activeSMask = null;
          },
          endGroup: function CanvasGraphics_endGroup(group) {
            if (!this.contentVisible) {
              return;
            }

            this.groupLevel--;
            var groupCtx = this.ctx;
            this.ctx = this.groupStack.pop();

            if (this.ctx.imageSmoothingEnabled !== undefined) {
              this.ctx.imageSmoothingEnabled = false;
            } else {
              this.ctx.mozImageSmoothingEnabled = false;
            }

            if (group.smask) {
              this.tempSMask = this.smaskStack.pop();
            } else {
              this.ctx.drawImage(groupCtx.canvas, 0, 0);
            }

            this.restore();
          },
          beginAnnotations: function CanvasGraphics_beginAnnotations() {
            this.save();

            if (this.baseTransform) {
              this.ctx.setTransform.apply(this.ctx, this.baseTransform);
            }
          },
          endAnnotations: function CanvasGraphics_endAnnotations() {
            this.restore();
          },
          beginAnnotation: function CanvasGraphics_beginAnnotation(rect, transform, matrix) {
            this.save();
            resetCtxToDefault(this.ctx);
            this.current = new CanvasExtraState();

            if (Array.isArray(rect) && rect.length === 4) {
              var width = rect[2] - rect[0];
              var height = rect[3] - rect[1];
              this.ctx.rect(rect[0], rect[1], width, height);
              this.clip();
              this.endPath();
            }

            this.transform.apply(this, transform);
            this.transform.apply(this, matrix);
          },
          endAnnotation: function CanvasGraphics_endAnnotation() {
            this.restore();
          },
          paintImageMaskXObject: function CanvasGraphics_paintImageMaskXObject(img) {
            if (!this.contentVisible) {
              return;
            }

            var ctx = this.ctx;
            var width = img.width,
                height = img.height;
            var fillColor = this.current.fillColor;
            var isPatternFill = this.current.patternFill;
            var glyph = this.processingType3;

            if (glyph && glyph.compiled === undefined) {
              if (width <= MAX_SIZE_TO_COMPILE && height <= MAX_SIZE_TO_COMPILE) {
                glyph.compiled = compileType3Glyph({
                  data: img.data,
                  width: width,
                  height: height
                });
              } else {
                glyph.compiled = null;
              }
            }

            if (glyph && glyph.compiled) {
              glyph.compiled(ctx);
              return;
            }

            var maskCanvas = this.cachedCanvases.getCanvas("maskCanvas", width, height);
            var maskCtx = maskCanvas.context;
            maskCtx.save();
            putBinaryImageMask(maskCtx, img);
            maskCtx.globalCompositeOperation = "source-in";
            maskCtx.fillStyle = isPatternFill ? fillColor.getPattern(maskCtx, this) : fillColor;
            maskCtx.fillRect(0, 0, width, height);
            maskCtx.restore();
            this.paintInlineImageXObject(maskCanvas.canvas);
          },
          paintImageMaskXObjectRepeat: function paintImageMaskXObjectRepeat(imgData, scaleX) {
            var skewX = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
            var skewY = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
            var scaleY = arguments.length > 4 ? arguments[4] : undefined;
            var positions = arguments.length > 5 ? arguments[5] : undefined;

            if (!this.contentVisible) {
              return;
            }

            var width = imgData.width;
            var height = imgData.height;
            var fillColor = this.current.fillColor;
            var isPatternFill = this.current.patternFill;
            var maskCanvas = this.cachedCanvases.getCanvas("maskCanvas", width, height);
            var maskCtx = maskCanvas.context;
            maskCtx.save();
            putBinaryImageMask(maskCtx, imgData);
            maskCtx.globalCompositeOperation = "source-in";
            maskCtx.fillStyle = isPatternFill ? fillColor.getPattern(maskCtx, this) : fillColor;
            maskCtx.fillRect(0, 0, width, height);
            maskCtx.restore();
            var ctx = this.ctx;

            for (var i = 0, ii = positions.length; i < ii; i += 2) {
              ctx.save();
              ctx.transform(scaleX, skewX, skewY, scaleY, positions[i], positions[i + 1]);
              ctx.scale(1, -1);
              ctx.drawImage(maskCanvas.canvas, 0, 0, width, height, 0, -1, 1, 1);
              ctx.restore();
            }
          },
          paintImageMaskXObjectGroup: function CanvasGraphics_paintImageMaskXObjectGroup(images) {
            if (!this.contentVisible) {
              return;
            }

            var ctx = this.ctx;
            var fillColor = this.current.fillColor;
            var isPatternFill = this.current.patternFill;

            for (var i = 0, ii = images.length; i < ii; i++) {
              var image = images[i];
              var width = image.width,
                  height = image.height;
              var maskCanvas = this.cachedCanvases.getCanvas("maskCanvas", width, height);
              var maskCtx = maskCanvas.context;
              maskCtx.save();
              putBinaryImageMask(maskCtx, image);
              maskCtx.globalCompositeOperation = "source-in";
              maskCtx.fillStyle = isPatternFill ? fillColor.getPattern(maskCtx, this) : fillColor;
              maskCtx.fillRect(0, 0, width, height);
              maskCtx.restore();
              ctx.save();
              ctx.transform.apply(ctx, image.transform);
              ctx.scale(1, -1);
              ctx.drawImage(maskCanvas.canvas, 0, 0, width, height, 0, -1, 1, 1);
              ctx.restore();
            }
          },
          paintImageXObject: function CanvasGraphics_paintImageXObject(objId) {
            if (!this.contentVisible) {
              return;
            }

            var imgData = objId.startsWith("g_") ? this.commonObjs.get(objId) : this.objs.get(objId);

            if (!imgData) {
              (0, _util.warn)("Dependent image isn't ready yet");
              return;
            }

            this.paintInlineImageXObject(imgData);
          },
          paintImageXObjectRepeat: function CanvasGraphics_paintImageXObjectRepeat(objId, scaleX, scaleY, positions) {
            if (!this.contentVisible) {
              return;
            }

            var imgData = objId.startsWith("g_") ? this.commonObjs.get(objId) : this.objs.get(objId);

            if (!imgData) {
              (0, _util.warn)("Dependent image isn't ready yet");
              return;
            }

            var width = imgData.width;
            var height = imgData.height;
            var map = [];

            for (var i = 0, ii = positions.length; i < ii; i += 2) {
              map.push({
                transform: [scaleX, 0, 0, scaleY, positions[i], positions[i + 1]],
                x: 0,
                y: 0,
                w: width,
                h: height
              });
            }

            this.paintInlineImageXObjectGroup(imgData, map);
          },
          paintInlineImageXObject: function CanvasGraphics_paintInlineImageXObject(imgData) {
            if (!this.contentVisible) {
              return;
            }

            var width = imgData.width;
            var height = imgData.height;
            var ctx = this.ctx;
            this.save();
            ctx.scale(1 / width, -1 / height);
            var currentTransform = ctx.mozCurrentTransformInverse;
            var a = currentTransform[0],
                b = currentTransform[1];
            var widthScale = Math.max(Math.sqrt(a * a + b * b), 1);
            var c = currentTransform[2],
                d = currentTransform[3];
            var heightScale = Math.max(Math.sqrt(c * c + d * d), 1);
            var imgToPaint, tmpCanvas;

            if (typeof HTMLElement === "function" && imgData instanceof HTMLElement || !imgData.data) {
              imgToPaint = imgData;
            } else {
              tmpCanvas = this.cachedCanvases.getCanvas("inlineImage", width, height);
              var tmpCtx = tmpCanvas.context;
              putBinaryImageData(tmpCtx, imgData, this.current.transferMaps);
              imgToPaint = tmpCanvas.canvas;
            }

            var paintWidth = width,
                paintHeight = height;
            var tmpCanvasId = "prescale1";

            while (widthScale > 2 && paintWidth > 1 || heightScale > 2 && paintHeight > 1) {
              var newWidth = paintWidth,
                  newHeight = paintHeight;

              if (widthScale > 2 && paintWidth > 1) {
                newWidth = Math.ceil(paintWidth / 2);
                widthScale /= paintWidth / newWidth;
              }

              if (heightScale > 2 && paintHeight > 1) {
                newHeight = Math.ceil(paintHeight / 2);
                heightScale /= paintHeight / newHeight;
              }

              tmpCanvas = this.cachedCanvases.getCanvas(tmpCanvasId, newWidth, newHeight);
              tmpCtx = tmpCanvas.context;
              tmpCtx.clearRect(0, 0, newWidth, newHeight);
              tmpCtx.drawImage(imgToPaint, 0, 0, paintWidth, paintHeight, 0, 0, newWidth, newHeight);
              imgToPaint = tmpCanvas.canvas;
              paintWidth = newWidth;
              paintHeight = newHeight;
              tmpCanvasId = tmpCanvasId === "prescale1" ? "prescale2" : "prescale1";
            }

            ctx.drawImage(imgToPaint, 0, 0, paintWidth, paintHeight, 0, -height, width, height);

            if (this.imageLayer) {
              var position = this.getCanvasPosition(0, -height);
              this.imageLayer.appendImage({
                imgData: imgData,
                left: position[0],
                top: position[1],
                width: width / currentTransform[0],
                height: height / currentTransform[3]
              });
            }

            this.restore();
          },
          paintInlineImageXObjectGroup: function CanvasGraphics_paintInlineImageXObjectGroup(imgData, map) {
            if (!this.contentVisible) {
              return;
            }

            var ctx = this.ctx;
            var w = imgData.width;
            var h = imgData.height;
            var tmpCanvas = this.cachedCanvases.getCanvas("inlineImage", w, h);
            var tmpCtx = tmpCanvas.context;
            putBinaryImageData(tmpCtx, imgData, this.current.transferMaps);

            for (var i = 0, ii = map.length; i < ii; i++) {
              var entry = map[i];
              ctx.save();
              ctx.transform.apply(ctx, entry.transform);
              ctx.scale(1, -1);
              ctx.drawImage(tmpCanvas.canvas, entry.x, entry.y, entry.w, entry.h, 0, -1, 1, 1);

              if (this.imageLayer) {
                var position = this.getCanvasPosition(entry.x, entry.y);
                this.imageLayer.appendImage({
                  imgData: imgData,
                  left: position[0],
                  top: position[1],
                  width: w,
                  height: h
                });
              }

              ctx.restore();
            }
          },
          paintSolidColorImageMask: function CanvasGraphics_paintSolidColorImageMask() {
            if (!this.contentVisible) {
              return;
            }

            this.ctx.fillRect(0, 0, 1, 1);
          },
          markPoint: function CanvasGraphics_markPoint(tag) {},
          markPointProps: function CanvasGraphics_markPointProps(tag, properties) {},
          beginMarkedContent: function CanvasGraphics_beginMarkedContent(tag) {
            this.markedContentStack.push({
              visible: true
            });
          },
          beginMarkedContentProps: function CanvasGraphics_beginMarkedContentProps(tag, properties) {
            if (tag === "OC") {
              this.markedContentStack.push({
                visible: this.optionalContentConfig.isVisible(properties)
              });
            } else {
              this.markedContentStack.push({
                visible: true
              });
            }

            this.contentVisible = this.isContentVisible();
          },
          endMarkedContent: function CanvasGraphics_endMarkedContent() {
            this.markedContentStack.pop();
            this.contentVisible = this.isContentVisible();
          },
          beginCompat: function CanvasGraphics_beginCompat() {},
          endCompat: function CanvasGraphics_endCompat() {},
          consumePath: function CanvasGraphics_consumePath() {
            var ctx = this.ctx;

            if (this.pendingClip) {
              if (this.pendingClip === EO_CLIP) {
                ctx.clip("evenodd");
              } else {
                ctx.clip();
              }

              this.pendingClip = null;
            }

            ctx.beginPath();
          },
          getSinglePixelWidth: function getSinglePixelWidth(scale) {
            if (this._cachedGetSinglePixelWidth === null) {
              var inverse = this.ctx.mozCurrentTransformInverse;
              this._cachedGetSinglePixelWidth = Math.sqrt(Math.max(inverse[0] * inverse[0] + inverse[1] * inverse[1], inverse[2] * inverse[2] + inverse[3] * inverse[3]));
            }

            return this._cachedGetSinglePixelWidth;
          },
          getCanvasPosition: function CanvasGraphics_getCanvasPosition(x, y) {
            var transform = this.ctx.mozCurrentTransform;
            return [transform[0] * x + transform[2] * y + transform[4], transform[1] * x + transform[3] * y + transform[5]];
          },
          isContentVisible: function CanvasGraphics_isContentVisible() {
            for (var i = this.markedContentStack.length - 1; i >= 0; i--) {
              if (!this.markedContentStack[i].visible) {
                return false;
              }
            }

            return true;
          }
        };

        for (var op in _util.OPS) {
          CanvasGraphics.prototype[_util.OPS[op]] = CanvasGraphics.prototype[op];
        }

        return CanvasGraphics;
      }();

      exports.CanvasGraphics = CanvasGraphics;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.getShadingPatternFromIR = getShadingPatternFromIR;
      exports.TilingPattern = void 0;

      var _util = __w_pdfjs_require__(2);

      var ShadingIRs = {};

      function applyBoundingBox(ctx, bbox) {
        if (!bbox || typeof Path2D === "undefined") {
          return;
        }

        var width = bbox[2] - bbox[0];
        var height = bbox[3] - bbox[1];
        var region = new Path2D();
        region.rect(bbox[0], bbox[1], width, height);
        ctx.clip(region);
      }

      ShadingIRs.RadialAxial = {
        fromIR: function RadialAxial_fromIR(raw) {
          var type = raw[1];
          var bbox = raw[2];
          var colorStops = raw[3];
          var p0 = raw[4];
          var p1 = raw[5];
          var r0 = raw[6];
          var r1 = raw[7];
          return {
            type: "Pattern",
            getPattern: function RadialAxial_getPattern(ctx) {
              applyBoundingBox(ctx, bbox);
              var grad;

              if (type === "axial") {
                grad = ctx.createLinearGradient(p0[0], p0[1], p1[0], p1[1]);
              } else if (type === "radial") {
                grad = ctx.createRadialGradient(p0[0], p0[1], r0, p1[0], p1[1], r1);
              }

              for (var i = 0, ii = colorStops.length; i < ii; ++i) {
                var c = colorStops[i];
                grad.addColorStop(c[0], c[1]);
              }

              return grad;
            }
          };
        }
      };

      var createMeshCanvas = function createMeshCanvasClosure() {
        function drawTriangle(data, context, p1, p2, p3, c1, c2, c3) {
          var coords = context.coords,
              colors = context.colors;
          var bytes = data.data,
              rowSize = data.width * 4;
          var tmp;

          if (coords[p1 + 1] > coords[p2 + 1]) {
            tmp = p1;
            p1 = p2;
            p2 = tmp;
            tmp = c1;
            c1 = c2;
            c2 = tmp;
          }

          if (coords[p2 + 1] > coords[p3 + 1]) {
            tmp = p2;
            p2 = p3;
            p3 = tmp;
            tmp = c2;
            c2 = c3;
            c3 = tmp;
          }

          if (coords[p1 + 1] > coords[p2 + 1]) {
            tmp = p1;
            p1 = p2;
            p2 = tmp;
            tmp = c1;
            c1 = c2;
            c2 = tmp;
          }

          var x1 = (coords[p1] + context.offsetX) * context.scaleX;
          var y1 = (coords[p1 + 1] + context.offsetY) * context.scaleY;
          var x2 = (coords[p2] + context.offsetX) * context.scaleX;
          var y2 = (coords[p2 + 1] + context.offsetY) * context.scaleY;
          var x3 = (coords[p3] + context.offsetX) * context.scaleX;
          var y3 = (coords[p3 + 1] + context.offsetY) * context.scaleY;

          if (y1 >= y3) {
            return;
          }

          var c1r = colors[c1],
              c1g = colors[c1 + 1],
              c1b = colors[c1 + 2];
          var c2r = colors[c2],
              c2g = colors[c2 + 1],
              c2b = colors[c2 + 2];
          var c3r = colors[c3],
              c3g = colors[c3 + 1],
              c3b = colors[c3 + 2];
          var minY = Math.round(y1),
              maxY = Math.round(y3);
          var xa, car, cag, cab;
          var xb, cbr, cbg, cbb;

          for (var y = minY; y <= maxY; y++) {
            if (y < y2) {
              var _k4 = void 0;

              if (y < y1) {
                _k4 = 0;
              } else if (y1 === y2) {
                _k4 = 1;
              } else {
                _k4 = (y1 - y) / (y1 - y2);
              }

              xa = x1 - (x1 - x2) * _k4;
              car = c1r - (c1r - c2r) * _k4;
              cag = c1g - (c1g - c2g) * _k4;
              cab = c1b - (c1b - c2b) * _k4;
            } else {
              var _k5 = void 0;

              if (y > y3) {
                _k5 = 1;
              } else if (y2 === y3) {
                _k5 = 0;
              } else {
                _k5 = (y2 - y) / (y2 - y3);
              }

              xa = x2 - (x2 - x3) * _k5;
              car = c2r - (c2r - c3r) * _k5;
              cag = c2g - (c2g - c3g) * _k5;
              cab = c2b - (c2b - c3b) * _k5;
            }

            var k = void 0;

            if (y < y1) {
              k = 0;
            } else if (y > y3) {
              k = 1;
            } else {
              k = (y1 - y) / (y1 - y3);
            }

            xb = x1 - (x1 - x3) * k;
            cbr = c1r - (c1r - c3r) * k;
            cbg = c1g - (c1g - c3g) * k;
            cbb = c1b - (c1b - c3b) * k;
            var x1_ = Math.round(Math.min(xa, xb));
            var x2_ = Math.round(Math.max(xa, xb));
            var j = rowSize * y + x1_ * 4;

            for (var x = x1_; x <= x2_; x++) {
              k = (xa - x) / (xa - xb);

              if (k < 0) {
                k = 0;
              } else if (k > 1) {
                k = 1;
              }

              bytes[j++] = car - (car - cbr) * k | 0;
              bytes[j++] = cag - (cag - cbg) * k | 0;
              bytes[j++] = cab - (cab - cbb) * k | 0;
              bytes[j++] = 255;
            }
          }
        }

        function drawFigure(data, figure, context) {
          var ps = figure.coords;
          var cs = figure.colors;
          var i, ii;

          switch (figure.type) {
            case "lattice":
              var verticesPerRow = figure.verticesPerRow;
              var rows = Math.floor(ps.length / verticesPerRow) - 1;
              var cols = verticesPerRow - 1;

              for (i = 0; i < rows; i++) {
                var q = i * verticesPerRow;

                for (var j = 0; j < cols; j++, q++) {
                  drawTriangle(data, context, ps[q], ps[q + 1], ps[q + verticesPerRow], cs[q], cs[q + 1], cs[q + verticesPerRow]);
                  drawTriangle(data, context, ps[q + verticesPerRow + 1], ps[q + 1], ps[q + verticesPerRow], cs[q + verticesPerRow + 1], cs[q + 1], cs[q + verticesPerRow]);
                }
              }

              break;

            case "triangles":
              for (i = 0, ii = ps.length; i < ii; i += 3) {
                drawTriangle(data, context, ps[i], ps[i + 1], ps[i + 2], cs[i], cs[i + 1], cs[i + 2]);
              }

              break;

            default:
              throw new Error("illegal figure");
          }
        }

        function createMeshCanvas(bounds, combinesScale, coords, colors, figures, backgroundColor, cachedCanvases, webGLContext) {
          var EXPECTED_SCALE = 1.1;
          var MAX_PATTERN_SIZE = 3000;
          var BORDER_SIZE = 2;
          var offsetX = Math.floor(bounds[0]);
          var offsetY = Math.floor(bounds[1]);
          var boundsWidth = Math.ceil(bounds[2]) - offsetX;
          var boundsHeight = Math.ceil(bounds[3]) - offsetY;
          var width = Math.min(Math.ceil(Math.abs(boundsWidth * combinesScale[0] * EXPECTED_SCALE)), MAX_PATTERN_SIZE);
          var height = Math.min(Math.ceil(Math.abs(boundsHeight * combinesScale[1] * EXPECTED_SCALE)), MAX_PATTERN_SIZE);
          var scaleX = boundsWidth / width;
          var scaleY = boundsHeight / height;
          var context = {
            coords: coords,
            colors: colors,
            offsetX: -offsetX,
            offsetY: -offsetY,
            scaleX: 1 / scaleX,
            scaleY: 1 / scaleY
          };
          var paddedWidth = width + BORDER_SIZE * 2;
          var paddedHeight = height + BORDER_SIZE * 2;
          var canvas, tmpCanvas, i, ii;

          if (webGLContext.isEnabled) {
            canvas = webGLContext.drawFigures({
              width: width,
              height: height,
              backgroundColor: backgroundColor,
              figures: figures,
              context: context
            });
            tmpCanvas = cachedCanvases.getCanvas("mesh", paddedWidth, paddedHeight, false);
            tmpCanvas.context.drawImage(canvas, BORDER_SIZE, BORDER_SIZE);
            canvas = tmpCanvas.canvas;
          } else {
            tmpCanvas = cachedCanvases.getCanvas("mesh", paddedWidth, paddedHeight, false);
            var tmpCtx = tmpCanvas.context;
            var data = tmpCtx.createImageData(width, height);

            if (backgroundColor) {
              var bytes = data.data;

              for (i = 0, ii = bytes.length; i < ii; i += 4) {
                bytes[i] = backgroundColor[0];
                bytes[i + 1] = backgroundColor[1];
                bytes[i + 2] = backgroundColor[2];
                bytes[i + 3] = 255;
              }
            }

            for (i = 0; i < figures.length; i++) {
              drawFigure(data, figures[i], context);
            }

            tmpCtx.putImageData(data, BORDER_SIZE, BORDER_SIZE);
            canvas = tmpCanvas.canvas;
          }

          return {
            canvas: canvas,
            offsetX: offsetX - BORDER_SIZE * scaleX,
            offsetY: offsetY - BORDER_SIZE * scaleY,
            scaleX: scaleX,
            scaleY: scaleY
          };
        }

        return createMeshCanvas;
      }();

      ShadingIRs.Mesh = {
        fromIR: function Mesh_fromIR(raw) {
          var coords = raw[2];
          var colors = raw[3];
          var figures = raw[4];
          var bounds = raw[5];
          var matrix = raw[6];
          var bbox = raw[7];
          var background = raw[8];
          return {
            type: "Pattern",
            getPattern: function Mesh_getPattern(ctx, owner, shadingFill) {
              applyBoundingBox(ctx, bbox);
              var scale;

              if (shadingFill) {
                scale = _util.Util.singularValueDecompose2dScale(ctx.mozCurrentTransform);
              } else {
                scale = _util.Util.singularValueDecompose2dScale(owner.baseTransform);

                if (matrix) {
                  var matrixScale = _util.Util.singularValueDecompose2dScale(matrix);

                  scale = [scale[0] * matrixScale[0], scale[1] * matrixScale[1]];
                }
              }

              var temporaryPatternCanvas = createMeshCanvas(bounds, scale, coords, colors, figures, shadingFill ? null : background, owner.cachedCanvases, owner.webGLContext);

              if (!shadingFill) {
                ctx.setTransform.apply(ctx, owner.baseTransform);

                if (matrix) {
                  ctx.transform.apply(ctx, matrix);
                }
              }

              ctx.translate(temporaryPatternCanvas.offsetX, temporaryPatternCanvas.offsetY);
              ctx.scale(temporaryPatternCanvas.scaleX, temporaryPatternCanvas.scaleY);
              return ctx.createPattern(temporaryPatternCanvas.canvas, "no-repeat");
            }
          };
        }
      };
      ShadingIRs.Dummy = {
        fromIR: function Dummy_fromIR() {
          return {
            type: "Pattern",
            getPattern: function Dummy_fromIR_getPattern() {
              return "hotpink";
            }
          };
        }
      };

      function getShadingPatternFromIR(raw) {
        var shadingIR = ShadingIRs[raw[0]];

        if (!shadingIR) {
          throw new Error("Unknown IR type: ".concat(raw[0]));
        }

        return shadingIR.fromIR(raw);
      }

      var TilingPattern = function TilingPatternClosure() {
        var PaintType = {
          COLORED: 1,
          UNCOLORED: 2
        };
        var MAX_PATTERN_SIZE = 3000;

        function TilingPattern(IR, color, ctx, canvasGraphicsFactory, baseTransform) {
          this.operatorList = IR[2];
          this.matrix = IR[3] || [1, 0, 0, 1, 0, 0];
          this.bbox = IR[4];
          this.xstep = IR[5];
          this.ystep = IR[6];
          this.paintType = IR[7];
          this.tilingType = IR[8];
          this.color = color;
          this.canvasGraphicsFactory = canvasGraphicsFactory;
          this.baseTransform = baseTransform;
          this.type = "Pattern";
          this.ctx = ctx;
        }

        TilingPattern.prototype = {
          createPatternCanvas: function TilinPattern_createPatternCanvas(owner) {
            var operatorList = this.operatorList;
            var bbox = this.bbox;
            var xstep = this.xstep;
            var ystep = this.ystep;
            var paintType = this.paintType;
            var tilingType = this.tilingType;
            var color = this.color;
            var canvasGraphicsFactory = this.canvasGraphicsFactory;
            (0, _util.info)("TilingType: " + tilingType);
            var x0 = bbox[0],
                y0 = bbox[1],
                x1 = bbox[2],
                y1 = bbox[3];

            var matrixScale = _util.Util.singularValueDecompose2dScale(this.matrix);

            var curMatrixScale = _util.Util.singularValueDecompose2dScale(this.baseTransform);

            var combinedScale = [matrixScale[0] * curMatrixScale[0], matrixScale[1] * curMatrixScale[1]];
            var dimx = this.getSizeAndScale(xstep, this.ctx.canvas.width, combinedScale[0]);
            var dimy = this.getSizeAndScale(ystep, this.ctx.canvas.height, combinedScale[1]);
            var tmpCanvas = owner.cachedCanvases.getCanvas("pattern", dimx.size, dimy.size, true);
            var tmpCtx = tmpCanvas.context;
            var graphics = canvasGraphicsFactory.createCanvasGraphics(tmpCtx);
            graphics.groupLevel = owner.groupLevel;
            this.setFillAndStrokeStyleToContext(graphics, paintType, color);
            graphics.transform(dimx.scale, 0, 0, dimy.scale, 0, 0);
            graphics.transform(1, 0, 0, 1, -x0, -y0);
            this.clipBbox(graphics, bbox, x0, y0, x1, y1);
            graphics.executeOperatorList(operatorList);
            this.ctx.transform(1, 0, 0, 1, x0, y0);
            this.ctx.scale(1 / dimx.scale, 1 / dimy.scale);
            return tmpCanvas.canvas;
          },
          getSizeAndScale: function TilingPattern_getSizeAndScale(step, realOutputSize, scale) {
            step = Math.abs(step);
            var maxSize = Math.max(MAX_PATTERN_SIZE, realOutputSize);
            var size = Math.ceil(step * scale);

            if (size >= maxSize) {
              size = maxSize;
            } else {
              scale = size / step;
            }

            return {
              scale: scale,
              size: size
            };
          },
          clipBbox: function clipBbox(graphics, bbox, x0, y0, x1, y1) {
            if (Array.isArray(bbox) && bbox.length === 4) {
              var bboxWidth = x1 - x0;
              var bboxHeight = y1 - y0;
              graphics.ctx.rect(x0, y0, bboxWidth, bboxHeight);
              graphics.clip();
              graphics.endPath();
            }
          },
          setFillAndStrokeStyleToContext: function setFillAndStrokeStyleToContext(graphics, paintType, color) {
            var context = graphics.ctx,
                current = graphics.current;

            switch (paintType) {
              case PaintType.COLORED:
                var ctx = this.ctx;
                context.fillStyle = ctx.fillStyle;
                context.strokeStyle = ctx.strokeStyle;
                current.fillColor = ctx.fillStyle;
                current.strokeColor = ctx.strokeStyle;
                break;

              case PaintType.UNCOLORED:
                var cssColor = _util.Util.makeCssRgb(color[0], color[1], color[2]);

                context.fillStyle = cssColor;
                context.strokeStyle = cssColor;
                current.fillColor = cssColor;
                current.strokeColor = cssColor;
                break;

              default:
                throw new _util.FormatError("Unsupported paint type: ".concat(paintType));
            }
          },
          getPattern: function TilingPattern_getPattern(ctx, owner) {
            ctx = this.ctx;
            ctx.setTransform.apply(ctx, this.baseTransform);
            ctx.transform.apply(ctx, this.matrix);
            var temporaryPatternCanvas = this.createPatternCanvas(owner);
            return ctx.createPattern(temporaryPatternCanvas, "repeat");
          }
        };
        return TilingPattern;
      }();

      exports.TilingPattern = TilingPattern;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.GlobalWorkerOptions = void 0;
      var GlobalWorkerOptions = Object.create(null);
      exports.GlobalWorkerOptions = GlobalWorkerOptions;
      GlobalWorkerOptions.workerPort = GlobalWorkerOptions.workerPort === undefined ? null : GlobalWorkerOptions.workerPort;
      GlobalWorkerOptions.workerSrc = GlobalWorkerOptions.workerSrc === undefined ? "" : GlobalWorkerOptions.workerSrc;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.MessageHandler = void 0;

      var _util = __w_pdfjs_require__(2);

      var CallbackKind = {
        UNKNOWN: 0,
        DATA: 1,
        ERROR: 2
      };
      var StreamKind = {
        UNKNOWN: 0,
        CANCEL: 1,
        CANCEL_COMPLETE: 2,
        CLOSE: 3,
        ENQUEUE: 4,
        ERROR: 5,
        PULL: 6,
        PULL_COMPLETE: 7,
        START_COMPLETE: 8
      };

      function wrapReason(reason) {
        if (_typeof(reason) !== "object" || reason === null) {
          return reason;
        }

        switch (reason.name) {
          case "AbortException":
            return new _util.AbortException(reason.message);

          case "MissingPDFException":
            return new _util.MissingPDFException(reason.message);

          case "UnexpectedResponseException":
            return new _util.UnexpectedResponseException(reason.message, reason.status);

          case "UnknownErrorException":
            return new _util.UnknownErrorException(reason.message, reason.details);

          default:
            return new _util.UnknownErrorException(reason.message, reason.toString());
        }
      }

      var MessageHandler = function () {
        function MessageHandler(sourceName, targetName, comObj) {
          var _this29 = this;

          _classCallCheck(this, MessageHandler);

          this.sourceName = sourceName;
          this.targetName = targetName;
          this.comObj = comObj;
          this.callbackId = 1;
          this.streamId = 1;
          this.postMessageTransfers = true;
          this.streamSinks = Object.create(null);
          this.streamControllers = Object.create(null);
          this.callbackCapabilities = Object.create(null);
          this.actionHandler = Object.create(null);

          this._onComObjOnMessage = function (event) {
            var data = event.data;

            if (data.targetName !== _this29.sourceName) {
              return;
            }

            if (data.stream) {
              _this29._processStreamMessage(data);

              return;
            }

            if (data.callback) {
              var callbackId = data.callbackId;
              var capability = _this29.callbackCapabilities[callbackId];

              if (!capability) {
                throw new Error("Cannot resolve callback ".concat(callbackId));
              }

              delete _this29.callbackCapabilities[callbackId];

              if (data.callback === CallbackKind.DATA) {
                capability.resolve(data.data);
              } else if (data.callback === CallbackKind.ERROR) {
                capability.reject(wrapReason(data.reason));
              } else {
                throw new Error("Unexpected callback case");
              }

              return;
            }

            var action = _this29.actionHandler[data.action];

            if (!action) {
              throw new Error("Unknown action from worker: ".concat(data.action));
            }

            if (data.callbackId) {
              var cbSourceName = _this29.sourceName;
              var cbTargetName = data.sourceName;
              new Promise(function (resolve) {
                resolve(action(data.data));
              }).then(function (result) {
                comObj.postMessage({
                  sourceName: cbSourceName,
                  targetName: cbTargetName,
                  callback: CallbackKind.DATA,
                  callbackId: data.callbackId,
                  data: result
                });
              }, function (reason) {
                comObj.postMessage({
                  sourceName: cbSourceName,
                  targetName: cbTargetName,
                  callback: CallbackKind.ERROR,
                  callbackId: data.callbackId,
                  reason: wrapReason(reason)
                });
              });
              return;
            }

            if (data.streamId) {
              _this29._createStreamSink(data);

              return;
            }

            action(data.data);
          };

          comObj.addEventListener("message", this._onComObjOnMessage);
        }

        _createClass(MessageHandler, [{
          key: "on",
          value: function on(actionName, handler) {
            var ah = this.actionHandler;

            if (ah[actionName]) {
              throw new Error("There is already an actionName called \"".concat(actionName, "\""));
            }

            ah[actionName] = handler;
          }
        }, {
          key: "send",
          value: function send(actionName, data, transfers) {
            this._postMessage({
              sourceName: this.sourceName,
              targetName: this.targetName,
              action: actionName,
              data: data
            }, transfers);
          }
        }, {
          key: "sendWithPromise",
          value: function sendWithPromise(actionName, data, transfers) {
            var callbackId = this.callbackId++;
            var capability = (0, _util.createPromiseCapability)();
            this.callbackCapabilities[callbackId] = capability;

            try {
              this._postMessage({
                sourceName: this.sourceName,
                targetName: this.targetName,
                action: actionName,
                callbackId: callbackId,
                data: data
              }, transfers);
            } catch (ex) {
              capability.reject(ex);
            }

            return capability.promise;
          }
        }, {
          key: "sendWithStream",
          value: function sendWithStream(actionName, data, queueingStrategy, transfers) {
            var _this30 = this;

            var streamId = this.streamId++;
            var sourceName = this.sourceName;
            var targetName = this.targetName;
            var comObj = this.comObj;
            return new ReadableStream({
              start: function start(controller) {
                var startCapability = (0, _util.createPromiseCapability)();
                _this30.streamControllers[streamId] = {
                  controller: controller,
                  startCall: startCapability,
                  pullCall: null,
                  cancelCall: null,
                  isClosed: false
                };

                _this30._postMessage({
                  sourceName: sourceName,
                  targetName: targetName,
                  action: actionName,
                  streamId: streamId,
                  data: data,
                  desiredSize: controller.desiredSize
                }, transfers);

                return startCapability.promise;
              },
              pull: function pull(controller) {
                var pullCapability = (0, _util.createPromiseCapability)();
                _this30.streamControllers[streamId].pullCall = pullCapability;
                comObj.postMessage({
                  sourceName: sourceName,
                  targetName: targetName,
                  stream: StreamKind.PULL,
                  streamId: streamId,
                  desiredSize: controller.desiredSize
                });
                return pullCapability.promise;
              },
              cancel: function cancel(reason) {
                (0, _util.assert)(reason instanceof Error, "cancel must have a valid reason");
                var cancelCapability = (0, _util.createPromiseCapability)();
                _this30.streamControllers[streamId].cancelCall = cancelCapability;
                _this30.streamControllers[streamId].isClosed = true;
                comObj.postMessage({
                  sourceName: sourceName,
                  targetName: targetName,
                  stream: StreamKind.CANCEL,
                  streamId: streamId,
                  reason: wrapReason(reason)
                });
                return cancelCapability.promise;
              }
            }, queueingStrategy);
          }
        }, {
          key: "_createStreamSink",
          value: function _createStreamSink(data) {
            var self = this;
            var action = this.actionHandler[data.action];
            var streamId = data.streamId;
            var sourceName = this.sourceName;
            var targetName = data.sourceName;
            var comObj = this.comObj;
            var streamSink = {
              enqueue: function enqueue(chunk) {
                var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
                var transfers = arguments.length > 2 ? arguments[2] : undefined;

                if (this.isCancelled) {
                  return;
                }

                var lastDesiredSize = this.desiredSize;
                this.desiredSize -= size;

                if (lastDesiredSize > 0 && this.desiredSize <= 0) {
                  this.sinkCapability = (0, _util.createPromiseCapability)();
                  this.ready = this.sinkCapability.promise;
                }

                self._postMessage({
                  sourceName: sourceName,
                  targetName: targetName,
                  stream: StreamKind.ENQUEUE,
                  streamId: streamId,
                  chunk: chunk
                }, transfers);
              },
              close: function close() {
                if (this.isCancelled) {
                  return;
                }

                this.isCancelled = true;
                comObj.postMessage({
                  sourceName: sourceName,
                  targetName: targetName,
                  stream: StreamKind.CLOSE,
                  streamId: streamId
                });
                delete self.streamSinks[streamId];
              },
              error: function error(reason) {
                (0, _util.assert)(reason instanceof Error, "error must have a valid reason");

                if (this.isCancelled) {
                  return;
                }

                this.isCancelled = true;
                comObj.postMessage({
                  sourceName: sourceName,
                  targetName: targetName,
                  stream: StreamKind.ERROR,
                  streamId: streamId,
                  reason: wrapReason(reason)
                });
              },
              sinkCapability: (0, _util.createPromiseCapability)(),
              onPull: null,
              onCancel: null,
              isCancelled: false,
              desiredSize: data.desiredSize,
              ready: null
            };
            streamSink.sinkCapability.resolve();
            streamSink.ready = streamSink.sinkCapability.promise;
            this.streamSinks[streamId] = streamSink;
            new Promise(function (resolve) {
              resolve(action(data.data, streamSink));
            }).then(function () {
              comObj.postMessage({
                sourceName: sourceName,
                targetName: targetName,
                stream: StreamKind.START_COMPLETE,
                streamId: streamId,
                success: true
              });
            }, function (reason) {
              comObj.postMessage({
                sourceName: sourceName,
                targetName: targetName,
                stream: StreamKind.START_COMPLETE,
                streamId: streamId,
                reason: wrapReason(reason)
              });
            });
          }
        }, {
          key: "_processStreamMessage",
          value: function _processStreamMessage(data) {
            var streamId = data.streamId;
            var sourceName = this.sourceName;
            var targetName = data.sourceName;
            var comObj = this.comObj;

            switch (data.stream) {
              case StreamKind.START_COMPLETE:
                if (data.success) {
                  this.streamControllers[streamId].startCall.resolve();
                } else {
                  this.streamControllers[streamId].startCall.reject(wrapReason(data.reason));
                }

                break;

              case StreamKind.PULL_COMPLETE:
                if (data.success) {
                  this.streamControllers[streamId].pullCall.resolve();
                } else {
                  this.streamControllers[streamId].pullCall.reject(wrapReason(data.reason));
                }

                break;

              case StreamKind.PULL:
                if (!this.streamSinks[streamId]) {
                  comObj.postMessage({
                    sourceName: sourceName,
                    targetName: targetName,
                    stream: StreamKind.PULL_COMPLETE,
                    streamId: streamId,
                    success: true
                  });
                  break;
                }

                if (this.streamSinks[streamId].desiredSize <= 0 && data.desiredSize > 0) {
                  this.streamSinks[streamId].sinkCapability.resolve();
                }

                this.streamSinks[streamId].desiredSize = data.desiredSize;
                var onPull = this.streamSinks[data.streamId].onPull;
                new Promise(function (resolve) {
                  resolve(onPull && onPull());
                }).then(function () {
                  comObj.postMessage({
                    sourceName: sourceName,
                    targetName: targetName,
                    stream: StreamKind.PULL_COMPLETE,
                    streamId: streamId,
                    success: true
                  });
                }, function (reason) {
                  comObj.postMessage({
                    sourceName: sourceName,
                    targetName: targetName,
                    stream: StreamKind.PULL_COMPLETE,
                    streamId: streamId,
                    reason: wrapReason(reason)
                  });
                });
                break;

              case StreamKind.ENQUEUE:
                (0, _util.assert)(this.streamControllers[streamId], "enqueue should have stream controller");

                if (this.streamControllers[streamId].isClosed) {
                  break;
                }

                this.streamControllers[streamId].controller.enqueue(data.chunk);
                break;

              case StreamKind.CLOSE:
                (0, _util.assert)(this.streamControllers[streamId], "close should have stream controller");

                if (this.streamControllers[streamId].isClosed) {
                  break;
                }

                this.streamControllers[streamId].isClosed = true;
                this.streamControllers[streamId].controller.close();

                this._deleteStreamController(streamId);

                break;

              case StreamKind.ERROR:
                (0, _util.assert)(this.streamControllers[streamId], "error should have stream controller");
                this.streamControllers[streamId].controller.error(wrapReason(data.reason));

                this._deleteStreamController(streamId);

                break;

              case StreamKind.CANCEL_COMPLETE:
                if (data.success) {
                  this.streamControllers[streamId].cancelCall.resolve();
                } else {
                  this.streamControllers[streamId].cancelCall.reject(wrapReason(data.reason));
                }

                this._deleteStreamController(streamId);

                break;

              case StreamKind.CANCEL:
                if (!this.streamSinks[streamId]) {
                  break;
                }

                var onCancel = this.streamSinks[data.streamId].onCancel;
                new Promise(function (resolve) {
                  resolve(onCancel && onCancel(wrapReason(data.reason)));
                }).then(function () {
                  comObj.postMessage({
                    sourceName: sourceName,
                    targetName: targetName,
                    stream: StreamKind.CANCEL_COMPLETE,
                    streamId: streamId,
                    success: true
                  });
                }, function (reason) {
                  comObj.postMessage({
                    sourceName: sourceName,
                    targetName: targetName,
                    stream: StreamKind.CANCEL_COMPLETE,
                    streamId: streamId,
                    reason: wrapReason(reason)
                  });
                });
                this.streamSinks[streamId].sinkCapability.reject(wrapReason(data.reason));
                this.streamSinks[streamId].isCancelled = true;
                delete this.streamSinks[streamId];
                break;

              default:
                throw new Error("Unexpected stream case");
            }
          }
        }, {
          key: "_deleteStreamController",
          value: function () {
            var _deleteStreamController2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee6(streamId) {
              return regeneratorRuntime.wrap(function _callee6$(_context6) {
                while (1) {
                  switch (_context6.prev = _context6.next) {
                    case 0:
                      _context6.next = 2;
                      return Promise.allSettled([this.streamControllers[streamId].startCall, this.streamControllers[streamId].pullCall, this.streamControllers[streamId].cancelCall].map(function (capability) {
                        return capability && capability.promise;
                      }));

                    case 2:
                      delete this.streamControllers[streamId];

                    case 3:
                    case "end":
                      return _context6.stop();
                  }
                }
              }, _callee6, this);
            }));

            function _deleteStreamController(_x4) {
              return _deleteStreamController2.apply(this, arguments);
            }

            return _deleteStreamController;
          }()
        }, {
          key: "_postMessage",
          value: function _postMessage(message, transfers) {
            if (transfers && this.postMessageTransfers) {
              this.comObj.postMessage(message, transfers);
            } else {
              this.comObj.postMessage(message);
            }
          }
        }, {
          key: "destroy",
          value: function destroy() {
            this.comObj.removeEventListener("message", this._onComObjOnMessage);
          }
        }]);

        return MessageHandler;
      }();

      exports.MessageHandler = MessageHandler;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.Metadata = void 0;

      var _util = __w_pdfjs_require__(2);

      var _xml_parser = __w_pdfjs_require__(15);

      var Metadata = function () {
        function Metadata(data) {
          _classCallCheck(this, Metadata);

          (0, _util.assert)(typeof data === "string", "Metadata: input is not a string");
          data = this._repair(data);
          var parser = new _xml_parser.SimpleXMLParser();
          var xmlDocument = parser.parseFromString(data);
          this._metadataMap = new Map();

          if (xmlDocument) {
            this._parse(xmlDocument);
          }
        }

        _createClass(Metadata, [{
          key: "_repair",
          value: function _repair(data) {
            return data.replace(/^[^<]+/, "").replace(/>\\376\\377([^<]+)/g, function (all, codes) {
              var bytes = codes.replace(/\\([0-3])([0-7])([0-7])/g, function (code, d1, d2, d3) {
                return String.fromCharCode(d1 * 64 + d2 * 8 + d3 * 1);
              }).replace(/&(amp|apos|gt|lt|quot);/g, function (str, name) {
                switch (name) {
                  case "amp":
                    return "&";

                  case "apos":
                    return "'";

                  case "gt":
                    return ">";

                  case "lt":
                    return "<";

                  case "quot":
                    return '"';
                }

                throw new Error("_repair: ".concat(name, " isn't defined."));
              });
              var chars = "";

              for (var i = 0, ii = bytes.length; i < ii; i += 2) {
                var code = bytes.charCodeAt(i) * 256 + bytes.charCodeAt(i + 1);

                if (code >= 32 && code < 127 && code !== 60 && code !== 62 && code !== 38) {
                  chars += String.fromCharCode(code);
                } else {
                  chars += "&#x" + (0x10000 + code).toString(16).substring(1) + ";";
                }
              }

              return ">" + chars;
            });
          }
        }, {
          key: "_parse",
          value: function _parse(xmlDocument) {
            var rdf = xmlDocument.documentElement;

            if (rdf.nodeName.toLowerCase() !== "rdf:rdf") {
              rdf = rdf.firstChild;

              while (rdf && rdf.nodeName.toLowerCase() !== "rdf:rdf") {
                rdf = rdf.nextSibling;
              }
            }

            var nodeName = rdf ? rdf.nodeName.toLowerCase() : null;

            if (!rdf || nodeName !== "rdf:rdf" || !rdf.hasChildNodes()) {
              return;
            }

            var children = rdf.childNodes;

            for (var i = 0, ii = children.length; i < ii; i++) {
              var desc = children[i];

              if (desc.nodeName.toLowerCase() !== "rdf:description") {
                continue;
              }

              for (var j = 0, jj = desc.childNodes.length; j < jj; j++) {
                if (desc.childNodes[j].nodeName.toLowerCase() !== "#text") {
                  var entry = desc.childNodes[j];
                  var name = entry.nodeName.toLowerCase();

                  this._metadataMap.set(name, entry.textContent.trim());
                }
              }
            }
          }
        }, {
          key: "get",
          value: function get(name) {
            return this._metadataMap.has(name) ? this._metadataMap.get(name) : null;
          }
        }, {
          key: "getAll",
          value: function getAll() {
            return Object.fromEntries(this._metadataMap);
          }
        }, {
          key: "has",
          value: function has(name) {
            return this._metadataMap.has(name);
          }
        }]);

        return Metadata;
      }();

      exports.Metadata = Metadata;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.SimpleXMLParser = void 0;
      var XMLParserErrorCode = {
        NoError: 0,
        EndOfDocument: -1,
        UnterminatedCdat: -2,
        UnterminatedXmlDeclaration: -3,
        UnterminatedDoctypeDeclaration: -4,
        UnterminatedComment: -5,
        MalformedElement: -6,
        OutOfMemory: -7,
        UnterminatedAttributeValue: -8,
        UnterminatedElement: -9,
        ElementNeverBegun: -10
      };

      function isWhitespace(s, index) {
        var ch = s[index];
        return ch === " " || ch === "\n" || ch === "\r" || ch === "\t";
      }

      function isWhitespaceString(s) {
        for (var i = 0, ii = s.length; i < ii; i++) {
          if (!isWhitespace(s, i)) {
            return false;
          }
        }

        return true;
      }

      var XMLParserBase = function () {
        function XMLParserBase() {
          _classCallCheck(this, XMLParserBase);
        }

        _createClass(XMLParserBase, [{
          key: "_resolveEntities",
          value: function _resolveEntities(s) {
            var _this31 = this;

            return s.replace(/&([^;]+);/g, function (all, entity) {
              if (entity.substring(0, 2) === "#x") {
                return String.fromCharCode(parseInt(entity.substring(2), 16));
              } else if (entity.substring(0, 1) === "#") {
                return String.fromCharCode(parseInt(entity.substring(1), 10));
              }

              switch (entity) {
                case "lt":
                  return "<";

                case "gt":
                  return ">";

                case "amp":
                  return "&";

                case "quot":
                  return '"';
              }

              return _this31.onResolveEntity(entity);
            });
          }
        }, {
          key: "_parseContent",
          value: function _parseContent(s, start) {
            var attributes = [];
            var pos = start;

            function skipWs() {
              while (pos < s.length && isWhitespace(s, pos)) {
                ++pos;
              }
            }

            while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== ">" && s[pos] !== "/") {
              ++pos;
            }

            var name = s.substring(start, pos);
            skipWs();

            while (pos < s.length && s[pos] !== ">" && s[pos] !== "/" && s[pos] !== "?") {
              skipWs();
              var attrName = "",
                  attrValue = "";

              while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== "=") {
                attrName += s[pos];
                ++pos;
              }

              skipWs();

              if (s[pos] !== "=") {
                return null;
              }

              ++pos;
              skipWs();
              var attrEndChar = s[pos];

              if (attrEndChar !== '"' && attrEndChar !== "'") {
                return null;
              }

              var attrEndIndex = s.indexOf(attrEndChar, ++pos);

              if (attrEndIndex < 0) {
                return null;
              }

              attrValue = s.substring(pos, attrEndIndex);
              attributes.push({
                name: attrName,
                value: this._resolveEntities(attrValue)
              });
              pos = attrEndIndex + 1;
              skipWs();
            }

            return {
              name: name,
              attributes: attributes,
              parsed: pos - start
            };
          }
        }, {
          key: "_parseProcessingInstruction",
          value: function _parseProcessingInstruction(s, start) {
            var pos = start;

            function skipWs() {
              while (pos < s.length && isWhitespace(s, pos)) {
                ++pos;
              }
            }

            while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== ">" && s[pos] !== "/") {
              ++pos;
            }

            var name = s.substring(start, pos);
            skipWs();
            var attrStart = pos;

            while (pos < s.length && (s[pos] !== "?" || s[pos + 1] !== ">")) {
              ++pos;
            }

            var value = s.substring(attrStart, pos);
            return {
              name: name,
              value: value,
              parsed: pos - start
            };
          }
        }, {
          key: "parseXml",
          value: function parseXml(s) {
            var i = 0;

            while (i < s.length) {
              var ch = s[i];
              var j = i;

              if (ch === "<") {
                ++j;
                var ch2 = s[j];
                var q = void 0;

                switch (ch2) {
                  case "/":
                    ++j;
                    q = s.indexOf(">", j);

                    if (q < 0) {
                      this.onError(XMLParserErrorCode.UnterminatedElement);
                      return;
                    }

                    this.onEndElement(s.substring(j, q));
                    j = q + 1;
                    break;

                  case "?":
                    ++j;

                    var pi = this._parseProcessingInstruction(s, j);

                    if (s.substring(j + pi.parsed, j + pi.parsed + 2) !== "?>") {
                      this.onError(XMLParserErrorCode.UnterminatedXmlDeclaration);
                      return;
                    }

                    this.onPi(pi.name, pi.value);
                    j += pi.parsed + 2;
                    break;

                  case "!":
                    if (s.substring(j + 1, j + 3) === "--") {
                      q = s.indexOf("-->", j + 3);

                      if (q < 0) {
                        this.onError(XMLParserErrorCode.UnterminatedComment);
                        return;
                      }

                      this.onComment(s.substring(j + 3, q));
                      j = q + 3;
                    } else if (s.substring(j + 1, j + 8) === "[CDATA[") {
                      q = s.indexOf("]]>", j + 8);

                      if (q < 0) {
                        this.onError(XMLParserErrorCode.UnterminatedCdat);
                        return;
                      }

                      this.onCdata(s.substring(j + 8, q));
                      j = q + 3;
                    } else if (s.substring(j + 1, j + 8) === "DOCTYPE") {
                      var q2 = s.indexOf("[", j + 8);
                      var complexDoctype = false;
                      q = s.indexOf(">", j + 8);

                      if (q < 0) {
                        this.onError(XMLParserErrorCode.UnterminatedDoctypeDeclaration);
                        return;
                      }

                      if (q2 > 0 && q > q2) {
                        q = s.indexOf("]>", j + 8);

                        if (q < 0) {
                          this.onError(XMLParserErrorCode.UnterminatedDoctypeDeclaration);
                          return;
                        }

                        complexDoctype = true;
                      }

                      var doctypeContent = s.substring(j + 8, q + (complexDoctype ? 1 : 0));
                      this.onDoctype(doctypeContent);
                      j = q + (complexDoctype ? 2 : 1);
                    } else {
                      this.onError(XMLParserErrorCode.MalformedElement);
                      return;
                    }

                    break;

                  default:
                    var content = this._parseContent(s, j);

                    if (content === null) {
                      this.onError(XMLParserErrorCode.MalformedElement);
                      return;
                    }

                    var isClosed = false;

                    if (s.substring(j + content.parsed, j + content.parsed + 2) === "/>") {
                      isClosed = true;
                    } else if (s.substring(j + content.parsed, j + content.parsed + 1) !== ">") {
                      this.onError(XMLParserErrorCode.UnterminatedElement);
                      return;
                    }

                    this.onBeginElement(content.name, content.attributes, isClosed);
                    j += content.parsed + (isClosed ? 2 : 1);
                    break;
                }
              } else {
                while (j < s.length && s[j] !== "<") {
                  j++;
                }

                var text = s.substring(i, j);
                this.onText(this._resolveEntities(text));
              }

              i = j;
            }
          }
        }, {
          key: "onResolveEntity",
          value: function onResolveEntity(name) {
            return "&".concat(name, ";");
          }
        }, {
          key: "onPi",
          value: function onPi(name, value) {}
        }, {
          key: "onComment",
          value: function onComment(text) {}
        }, {
          key: "onCdata",
          value: function onCdata(text) {}
        }, {
          key: "onDoctype",
          value: function onDoctype(doctypeContent) {}
        }, {
          key: "onText",
          value: function onText(text) {}
        }, {
          key: "onBeginElement",
          value: function onBeginElement(name, attributes, isEmpty) {}
        }, {
          key: "onEndElement",
          value: function onEndElement(name) {}
        }, {
          key: "onError",
          value: function onError(code) {}
        }]);

        return XMLParserBase;
      }();

      var SimpleDOMNode = function () {
        function SimpleDOMNode(nodeName, nodeValue) {
          _classCallCheck(this, SimpleDOMNode);

          this.nodeName = nodeName;
          this.nodeValue = nodeValue;
          Object.defineProperty(this, "parentNode", {
            value: null,
            writable: true
          });
        }

        _createClass(SimpleDOMNode, [{
          key: "firstChild",
          get: function get() {
            return this.childNodes && this.childNodes[0];
          }
        }, {
          key: "nextSibling",
          get: function get() {
            var childNodes = this.parentNode.childNodes;

            if (!childNodes) {
              return undefined;
            }

            var index = childNodes.indexOf(this);

            if (index === -1) {
              return undefined;
            }

            return childNodes[index + 1];
          }
        }, {
          key: "textContent",
          get: function get() {
            if (!this.childNodes) {
              return this.nodeValue || "";
            }

            return this.childNodes.map(function (child) {
              return child.textContent;
            }).join("");
          }
        }, {
          key: "hasChildNodes",
          value: function hasChildNodes() {
            return this.childNodes && this.childNodes.length > 0;
          }
        }]);

        return SimpleDOMNode;
      }();

      var SimpleXMLParser = function (_XMLParserBase) {
        _inherits(SimpleXMLParser, _XMLParserBase);

        var _super14 = _createSuper(SimpleXMLParser);

        function SimpleXMLParser() {
          var _this32;

          _classCallCheck(this, SimpleXMLParser);

          _this32 = _super14.call(this);
          _this32._currentFragment = null;
          _this32._stack = null;
          _this32._errorCode = XMLParserErrorCode.NoError;
          return _this32;
        }

        _createClass(SimpleXMLParser, [{
          key: "parseFromString",
          value: function parseFromString(data) {
            this._currentFragment = [];
            this._stack = [];
            this._errorCode = XMLParserErrorCode.NoError;
            this.parseXml(data);

            if (this._errorCode !== XMLParserErrorCode.NoError) {
              return undefined;
            }

            var _this$_currentFragmen = _slicedToArray(this._currentFragment, 1),
                documentElement = _this$_currentFragmen[0];

            if (!documentElement) {
              return undefined;
            }

            return {
              documentElement: documentElement
            };
          }
        }, {
          key: "onResolveEntity",
          value: function onResolveEntity(name) {
            switch (name) {
              case "apos":
                return "'";
            }

            return _get(_getPrototypeOf(SimpleXMLParser.prototype), "onResolveEntity", this).call(this, name);
          }
        }, {
          key: "onText",
          value: function onText(text) {
            if (isWhitespaceString(text)) {
              return;
            }

            var node = new SimpleDOMNode("#text", text);

            this._currentFragment.push(node);
          }
        }, {
          key: "onCdata",
          value: function onCdata(text) {
            var node = new SimpleDOMNode("#text", text);

            this._currentFragment.push(node);
          }
        }, {
          key: "onBeginElement",
          value: function onBeginElement(name, attributes, isEmpty) {
            var node = new SimpleDOMNode(name);
            node.childNodes = [];

            this._currentFragment.push(node);

            if (isEmpty) {
              return;
            }

            this._stack.push(this._currentFragment);

            this._currentFragment = node.childNodes;
          }
        }, {
          key: "onEndElement",
          value: function onEndElement(name) {
            this._currentFragment = this._stack.pop() || [];
            var lastElement = this._currentFragment[this._currentFragment.length - 1];

            if (!lastElement) {
              return;
            }

            for (var i = 0, ii = lastElement.childNodes.length; i < ii; i++) {
              lastElement.childNodes[i].parentNode = lastElement;
            }
          }
        }, {
          key: "onError",
          value: function onError(code) {
            this._errorCode = code;
          }
        }]);

        return SimpleXMLParser;
      }(XMLParserBase);

      exports.SimpleXMLParser = SimpleXMLParser;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.OptionalContentConfig = void 0;

      var _util = __w_pdfjs_require__(2);

      var OptionalContentGroup = function OptionalContentGroup(name, intent) {
        _classCallCheck(this, OptionalContentGroup);

        this.visible = true;
        this.name = name;
        this.intent = intent;
      };

      var OptionalContentConfig = function () {
        function OptionalContentConfig(data) {
          _classCallCheck(this, OptionalContentConfig);

          this.name = null;
          this.creator = null;
          this._order = null;
          this._groups = new Map();

          if (data === null) {
            return;
          }

          this.name = data.name;
          this.creator = data.creator;
          this._order = data.order;

          var _iterator12 = _createForOfIteratorHelper(data.groups),
              _step12;

          try {
            for (_iterator12.s(); !(_step12 = _iterator12.n()).done;) {
              var _group = _step12.value;

              this._groups.set(_group.id, new OptionalContentGroup(_group.name, _group.intent));
            }
          } catch (err) {
            _iterator12.e(err);
          } finally {
            _iterator12.f();
          }

          if (data.baseState === "OFF") {
            var _iterator13 = _createForOfIteratorHelper(this._groups),
                _step13;

            try {
              for (_iterator13.s(); !(_step13 = _iterator13.n()).done;) {
                var group = _step13.value;
                group.visible = false;
              }
            } catch (err) {
              _iterator13.e(err);
            } finally {
              _iterator13.f();
            }
          }

          var _iterator14 = _createForOfIteratorHelper(data.on),
              _step14;

          try {
            for (_iterator14.s(); !(_step14 = _iterator14.n()).done;) {
              var on = _step14.value;
              this._groups.get(on).visible = true;
            }
          } catch (err) {
            _iterator14.e(err);
          } finally {
            _iterator14.f();
          }

          var _iterator15 = _createForOfIteratorHelper(data.off),
              _step15;

          try {
            for (_iterator15.s(); !(_step15 = _iterator15.n()).done;) {
              var off = _step15.value;
              this._groups.get(off).visible = false;
            }
          } catch (err) {
            _iterator15.e(err);
          } finally {
            _iterator15.f();
          }
        }

        _createClass(OptionalContentConfig, [{
          key: "isVisible",
          value: function isVisible(group) {
            if (group.type === "OCG") {
              if (!this._groups.has(group.id)) {
                (0, _util.warn)("Optional content group not found: ".concat(group.id));
                return true;
              }

              return this._groups.get(group.id).visible;
            } else if (group.type === "OCMD") {
              if (group.expression) {
                (0, _util.warn)("Visibility expression not supported yet.");
              }

              if (!group.policy || group.policy === "AnyOn") {
                var _iterator16 = _createForOfIteratorHelper(group.ids),
                    _step16;

                try {
                  for (_iterator16.s(); !(_step16 = _iterator16.n()).done;) {
                    var id = _step16.value;

                    if (!this._groups.has(id)) {
                      (0, _util.warn)("Optional content group not found: ".concat(id));
                      return true;
                    }

                    if (this._groups.get(id).visible) {
                      return true;
                    }
                  }
                } catch (err) {
                  _iterator16.e(err);
                } finally {
                  _iterator16.f();
                }

                return false;
              } else if (group.policy === "AllOn") {
                var _iterator17 = _createForOfIteratorHelper(group.ids),
                    _step17;

                try {
                  for (_iterator17.s(); !(_step17 = _iterator17.n()).done;) {
                    var _id = _step17.value;

                    if (!this._groups.has(_id)) {
                      (0, _util.warn)("Optional content group not found: ".concat(_id));
                      return true;
                    }

                    if (!this._groups.get(_id).visible) {
                      return false;
                    }
                  }
                } catch (err) {
                  _iterator17.e(err);
                } finally {
                  _iterator17.f();
                }

                return true;
              } else if (group.policy === "AnyOff") {
                var _iterator18 = _createForOfIteratorHelper(group.ids),
                    _step18;

                try {
                  for (_iterator18.s(); !(_step18 = _iterator18.n()).done;) {
                    var _id2 = _step18.value;

                    if (!this._groups.has(_id2)) {
                      (0, _util.warn)("Optional content group not found: ".concat(_id2));
                      return true;
                    }

                    if (!this._groups.get(_id2).visible) {
                      return true;
                    }
                  }
                } catch (err) {
                  _iterator18.e(err);
                } finally {
                  _iterator18.f();
                }

                return false;
              } else if (group.policy === "AllOff") {
                var _iterator19 = _createForOfIteratorHelper(group.ids),
                    _step19;

                try {
                  for (_iterator19.s(); !(_step19 = _iterator19.n()).done;) {
                    var _id3 = _step19.value;

                    if (!this._groups.has(_id3)) {
                      (0, _util.warn)("Optional content group not found: ".concat(_id3));
                      return true;
                    }

                    if (this._groups.get(_id3).visible) {
                      return false;
                    }
                  }
                } catch (err) {
                  _iterator19.e(err);
                } finally {
                  _iterator19.f();
                }

                return true;
              }

              (0, _util.warn)("Unknown optional content policy ".concat(group.policy, "."));
              return true;
            }

            (0, _util.warn)("Unknown group type ".concat(group.type, "."));
            return true;
          }
        }, {
          key: "setVisibility",
          value: function setVisibility(id) {
            var visible = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

            if (!this._groups.has(id)) {
              (0, _util.warn)("Optional content group not found: ".concat(id));
              return;
            }

            this._groups.get(id).visible = !!visible;
          }
        }, {
          key: "getOrder",
          value: function getOrder() {
            if (!this._groups.size) {
              return null;
            }

            if (this._order) {
              return this._order.slice();
            }

            return Array.from(this._groups.keys());
          }
        }, {
          key: "getGroups",
          value: function getGroups() {
            if (!this._groups.size) {
              return null;
            }

            return Object.fromEntries(this._groups);
          }
        }, {
          key: "getGroup",
          value: function getGroup(id) {
            return this._groups.get(id) || null;
          }
        }]);

        return OptionalContentConfig;
      }();

      exports.OptionalContentConfig = OptionalContentConfig;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.PDFDataTransportStream = void 0;

      var _util = __w_pdfjs_require__(2);

      var PDFDataTransportStream = function () {
        function PDFDataTransportStream(params, pdfDataRangeTransport) {
          var _this33 = this;

          _classCallCheck(this, PDFDataTransportStream);

          (0, _util.assert)(pdfDataRangeTransport, 'PDFDataTransportStream - missing required "pdfDataRangeTransport" argument.');
          this._queuedChunks = [];
          this._progressiveDone = params.progressiveDone || false;
          var initialData = params.initialData;

          if (initialData && initialData.length > 0) {
            var buffer = new Uint8Array(initialData).buffer;

            this._queuedChunks.push(buffer);
          }

          this._pdfDataRangeTransport = pdfDataRangeTransport;
          this._isStreamingSupported = !params.disableStream;
          this._isRangeSupported = !params.disableRange;
          this._contentLength = params.length;
          this._fullRequestReader = null;
          this._rangeReaders = [];

          this._pdfDataRangeTransport.addRangeListener(function (begin, chunk) {
            _this33._onReceiveData({
              begin: begin,
              chunk: chunk
            });
          });

          this._pdfDataRangeTransport.addProgressListener(function (loaded, total) {
            _this33._onProgress({
              loaded: loaded,
              total: total
            });
          });

          this._pdfDataRangeTransport.addProgressiveReadListener(function (chunk) {
            _this33._onReceiveData({
              chunk: chunk
            });
          });

          this._pdfDataRangeTransport.addProgressiveDoneListener(function () {
            _this33._onProgressiveDone();
          });

          this._pdfDataRangeTransport.transportReady();
        }

        _createClass(PDFDataTransportStream, [{
          key: "_onReceiveData",
          value: function _onReceiveData(args) {
            var buffer = new Uint8Array(args.chunk).buffer;

            if (args.begin === undefined) {
              if (this._fullRequestReader) {
                this._fullRequestReader._enqueue(buffer);
              } else {
                this._queuedChunks.push(buffer);
              }
            } else {
              var found = this._rangeReaders.some(function (rangeReader) {
                if (rangeReader._begin !== args.begin) {
                  return false;
                }

                rangeReader._enqueue(buffer);

                return true;
              });

              (0, _util.assert)(found, "_onReceiveData - no `PDFDataTransportStreamRangeReader` instance found.");
            }
          }
        }, {
          key: "_progressiveDataLength",
          get: function get() {
            return this._fullRequestReader ? this._fullRequestReader._loaded : 0;
          }
        }, {
          key: "_onProgress",
          value: function _onProgress(evt) {
            if (evt.total === undefined) {
              var firstReader = this._rangeReaders[0];

              if (firstReader && firstReader.onProgress) {
                firstReader.onProgress({
                  loaded: evt.loaded
                });
              }
            } else {
              var fullReader = this._fullRequestReader;

              if (fullReader && fullReader.onProgress) {
                fullReader.onProgress({
                  loaded: evt.loaded,
                  total: evt.total
                });
              }
            }
          }
        }, {
          key: "_onProgressiveDone",
          value: function _onProgressiveDone() {
            if (this._fullRequestReader) {
              this._fullRequestReader.progressiveDone();
            }

            this._progressiveDone = true;
          }
        }, {
          key: "_removeRangeReader",
          value: function _removeRangeReader(reader) {
            var i = this._rangeReaders.indexOf(reader);

            if (i >= 0) {
              this._rangeReaders.splice(i, 1);
            }
          }
        }, {
          key: "getFullReader",
          value: function getFullReader() {
            (0, _util.assert)(!this._fullRequestReader, "PDFDataTransportStream.getFullReader can only be called once.");
            var queuedChunks = this._queuedChunks;
            this._queuedChunks = null;
            return new PDFDataTransportStreamReader(this, queuedChunks, this._progressiveDone);
          }
        }, {
          key: "getRangeReader",
          value: function getRangeReader(begin, end) {
            if (end <= this._progressiveDataLength) {
              return null;
            }

            var reader = new PDFDataTransportStreamRangeReader(this, begin, end);

            this._pdfDataRangeTransport.requestDataRange(begin, end);

            this._rangeReaders.push(reader);

            return reader;
          }
        }, {
          key: "cancelAllRequests",
          value: function cancelAllRequests(reason) {
            if (this._fullRequestReader) {
              this._fullRequestReader.cancel(reason);
            }

            var readers = this._rangeReaders.slice(0);

            readers.forEach(function (rangeReader) {
              rangeReader.cancel(reason);
            });

            this._pdfDataRangeTransport.abort();
          }
        }]);

        return PDFDataTransportStream;
      }();

      exports.PDFDataTransportStream = PDFDataTransportStream;

      var PDFDataTransportStreamReader = function () {
        function PDFDataTransportStreamReader(stream, queuedChunks) {
          var progressiveDone = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

          _classCallCheck(this, PDFDataTransportStreamReader);

          this._stream = stream;
          this._done = progressiveDone || false;
          this._filename = null;
          this._queuedChunks = queuedChunks || [];
          this._loaded = 0;

          var _iterator20 = _createForOfIteratorHelper(this._queuedChunks),
              _step20;

          try {
            for (_iterator20.s(); !(_step20 = _iterator20.n()).done;) {
              var chunk = _step20.value;
              this._loaded += chunk.byteLength;
            }
          } catch (err) {
            _iterator20.e(err);
          } finally {
            _iterator20.f();
          }

          this._requests = [];
          this._headersReady = Promise.resolve();
          stream._fullRequestReader = this;
          this.onProgress = null;
        }

        _createClass(PDFDataTransportStreamReader, [{
          key: "_enqueue",
          value: function _enqueue(chunk) {
            if (this._done) {
              return;
            }

            if (this._requests.length > 0) {
              var requestCapability = this._requests.shift();

              requestCapability.resolve({
                value: chunk,
                done: false
              });
            } else {
              this._queuedChunks.push(chunk);
            }

            this._loaded += chunk.byteLength;
          }
        }, {
          key: "headersReady",
          get: function get() {
            return this._headersReady;
          }
        }, {
          key: "filename",
          get: function get() {
            return this._filename;
          }
        }, {
          key: "isRangeSupported",
          get: function get() {
            return this._stream._isRangeSupported;
          }
        }, {
          key: "isStreamingSupported",
          get: function get() {
            return this._stream._isStreamingSupported;
          }
        }, {
          key: "contentLength",
          get: function get() {
            return this._stream._contentLength;
          }
        }, {
          key: "read",
          value: function () {
            var _read = _asyncToGenerator(regeneratorRuntime.mark(function _callee7() {
              var chunk, requestCapability;
              return regeneratorRuntime.wrap(function _callee7$(_context7) {
                while (1) {
                  switch (_context7.prev = _context7.next) {
                    case 0:
                      if (!(this._queuedChunks.length > 0)) {
                        _context7.next = 3;
                        break;
                      }

                      chunk = this._queuedChunks.shift();
                      return _context7.abrupt("return", {
                        value: chunk,
                        done: false
                      });

                    case 3:
                      if (!this._done) {
                        _context7.next = 5;
                        break;
                      }

                      return _context7.abrupt("return", {
                        value: undefined,
                        done: true
                      });

                    case 5:
                      requestCapability = (0, _util.createPromiseCapability)();

                      this._requests.push(requestCapability);

                      return _context7.abrupt("return", requestCapability.promise);

                    case 8:
                    case "end":
                      return _context7.stop();
                  }
                }
              }, _callee7, this);
            }));

            function read() {
              return _read.apply(this, arguments);
            }

            return read;
          }()
        }, {
          key: "cancel",
          value: function cancel(reason) {
            this._done = true;

            this._requests.forEach(function (requestCapability) {
              requestCapability.resolve({
                value: undefined,
                done: true
              });
            });

            this._requests = [];
          }
        }, {
          key: "progressiveDone",
          value: function progressiveDone() {
            if (this._done) {
              return;
            }

            this._done = true;
          }
        }]);

        return PDFDataTransportStreamReader;
      }();

      var PDFDataTransportStreamRangeReader = function () {
        function PDFDataTransportStreamRangeReader(stream, begin, end) {
          _classCallCheck(this, PDFDataTransportStreamRangeReader);

          this._stream = stream;
          this._begin = begin;
          this._end = end;
          this._queuedChunk = null;
          this._requests = [];
          this._done = false;
          this.onProgress = null;
        }

        _createClass(PDFDataTransportStreamRangeReader, [{
          key: "_enqueue",
          value: function _enqueue(chunk) {
            if (this._done) {
              return;
            }

            if (this._requests.length === 0) {
              this._queuedChunk = chunk;
            } else {
              var requestsCapability = this._requests.shift();

              requestsCapability.resolve({
                value: chunk,
                done: false
              });

              this._requests.forEach(function (requestCapability) {
                requestCapability.resolve({
                  value: undefined,
                  done: true
                });
              });

              this._requests = [];
            }

            this._done = true;

            this._stream._removeRangeReader(this);
          }
        }, {
          key: "isStreamingSupported",
          get: function get() {
            return false;
          }
        }, {
          key: "read",
          value: function () {
            var _read2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee8() {
              var chunk, requestCapability;
              return regeneratorRuntime.wrap(function _callee8$(_context8) {
                while (1) {
                  switch (_context8.prev = _context8.next) {
                    case 0:
                      if (!this._queuedChunk) {
                        _context8.next = 4;
                        break;
                      }

                      chunk = this._queuedChunk;
                      this._queuedChunk = null;
                      return _context8.abrupt("return", {
                        value: chunk,
                        done: false
                      });

                    case 4:
                      if (!this._done) {
                        _context8.next = 6;
                        break;
                      }

                      return _context8.abrupt("return", {
                        value: undefined,
                        done: true
                      });

                    case 6:
                      requestCapability = (0, _util.createPromiseCapability)();

                      this._requests.push(requestCapability);

                      return _context8.abrupt("return", requestCapability.promise);

                    case 9:
                    case "end":
                      return _context8.stop();
                  }
                }
              }, _callee8, this);
            }));

            function read() {
              return _read2.apply(this, arguments);
            }

            return read;
          }()
        }, {
          key: "cancel",
          value: function cancel(reason) {
            this._done = true;

            this._requests.forEach(function (requestCapability) {
              requestCapability.resolve({
                value: undefined,
                done: true
              });
            });

            this._requests = [];

            this._stream._removeRangeReader(this);
          }
        }]);

        return PDFDataTransportStreamRangeReader;
      }();
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.WebGLContext = void 0;

      var _util = __w_pdfjs_require__(2);

      var WebGLContext = function () {
        function WebGLContext(_ref32) {
          var _ref32$enable = _ref32.enable,
              enable = _ref32$enable === void 0 ? false : _ref32$enable;

          _classCallCheck(this, WebGLContext);

          this._enabled = enable === true;
        }

        _createClass(WebGLContext, [{
          key: "isEnabled",
          get: function get() {
            var enabled = this._enabled;

            if (enabled) {
              enabled = WebGLUtils.tryInitGL();
            }

            return (0, _util.shadow)(this, "isEnabled", enabled);
          }
        }, {
          key: "composeSMask",
          value: function composeSMask(_ref33) {
            var layer = _ref33.layer,
                mask = _ref33.mask,
                properties = _ref33.properties;
            return WebGLUtils.composeSMask(layer, mask, properties);
          }
        }, {
          key: "drawFigures",
          value: function drawFigures(_ref34) {
            var width = _ref34.width,
                height = _ref34.height,
                backgroundColor = _ref34.backgroundColor,
                figures = _ref34.figures,
                context = _ref34.context;
            return WebGLUtils.drawFigures(width, height, backgroundColor, figures, context);
          }
        }, {
          key: "clear",
          value: function clear() {
            WebGLUtils.cleanup();
          }
        }]);

        return WebGLContext;
      }();

      exports.WebGLContext = WebGLContext;

      var WebGLUtils = function WebGLUtilsClosure() {
        function loadShader(gl, code, shaderType) {
          var shader = gl.createShader(shaderType);
          gl.shaderSource(shader, code);
          gl.compileShader(shader);
          var compiled = gl.getShaderParameter(shader, gl.COMPILE_STATUS);

          if (!compiled) {
            var errorMsg = gl.getShaderInfoLog(shader);
            throw new Error("Error during shader compilation: " + errorMsg);
          }

          return shader;
        }

        function createVertexShader(gl, code) {
          return loadShader(gl, code, gl.VERTEX_SHADER);
        }

        function createFragmentShader(gl, code) {
          return loadShader(gl, code, gl.FRAGMENT_SHADER);
        }

        function createProgram(gl, shaders) {
          var program = gl.createProgram();

          for (var i = 0, ii = shaders.length; i < ii; ++i) {
            gl.attachShader(program, shaders[i]);
          }

          gl.linkProgram(program);
          var linked = gl.getProgramParameter(program, gl.LINK_STATUS);

          if (!linked) {
            var errorMsg = gl.getProgramInfoLog(program);
            throw new Error("Error during program linking: " + errorMsg);
          }

          return program;
        }

        function createTexture(gl, image, textureId) {
          gl.activeTexture(textureId);
          var texture = gl.createTexture();
          gl.bindTexture(gl.TEXTURE_2D, texture);
          gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
          gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
          gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
          gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
          gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, image);
          return texture;
        }

        var currentGL, currentCanvas;

        function generateGL() {
          if (currentGL) {
            return;
          }

          currentCanvas = document.createElement("canvas");
          currentGL = currentCanvas.getContext("webgl", {
            premultipliedalpha: false
          });
        }

        var smaskVertexShaderCode = "\
  attribute vec2 a_position;                                    \
  attribute vec2 a_texCoord;                                    \
                                                                \
  uniform vec2 u_resolution;                                    \
                                                                \
  varying vec2 v_texCoord;                                      \
                                                                \
  void main() {                                                 \
    vec2 clipSpace = (a_position / u_resolution) * 2.0 - 1.0;   \
    gl_Position = vec4(clipSpace * vec2(1, -1), 0, 1);          \
                                                                \
    v_texCoord = a_texCoord;                                    \
  }                                                             ";
        var smaskFragmentShaderCode = "\
  precision mediump float;                                      \
                                                                \
  uniform vec4 u_backdrop;                                      \
  uniform int u_subtype;                                        \
  uniform sampler2D u_image;                                    \
  uniform sampler2D u_mask;                                     \
                                                                \
  varying vec2 v_texCoord;                                      \
                                                                \
  void main() {                                                 \
    vec4 imageColor = texture2D(u_image, v_texCoord);           \
    vec4 maskColor = texture2D(u_mask, v_texCoord);             \
    if (u_backdrop.a > 0.0) {                                   \
      maskColor.rgb = maskColor.rgb * maskColor.a +             \
                      u_backdrop.rgb * (1.0 - maskColor.a);     \
    }                                                           \
    float lum;                                                  \
    if (u_subtype == 0) {                                       \
      lum = maskColor.a;                                        \
    } else {                                                    \
      lum = maskColor.r * 0.3 + maskColor.g * 0.59 +            \
            maskColor.b * 0.11;                                 \
    }                                                           \
    imageColor.a *= lum;                                        \
    imageColor.rgb *= imageColor.a;                             \
    gl_FragColor = imageColor;                                  \
  }                                                             ";
        var smaskCache = null;

        function initSmaskGL() {
          var canvas, gl;
          generateGL();
          canvas = currentCanvas;
          currentCanvas = null;
          gl = currentGL;
          currentGL = null;
          var vertexShader = createVertexShader(gl, smaskVertexShaderCode);
          var fragmentShader = createFragmentShader(gl, smaskFragmentShaderCode);
          var program = createProgram(gl, [vertexShader, fragmentShader]);
          gl.useProgram(program);
          var cache = {};
          cache.gl = gl;
          cache.canvas = canvas;
          cache.resolutionLocation = gl.getUniformLocation(program, "u_resolution");
          cache.positionLocation = gl.getAttribLocation(program, "a_position");
          cache.backdropLocation = gl.getUniformLocation(program, "u_backdrop");
          cache.subtypeLocation = gl.getUniformLocation(program, "u_subtype");
          var texCoordLocation = gl.getAttribLocation(program, "a_texCoord");
          var texLayerLocation = gl.getUniformLocation(program, "u_image");
          var texMaskLocation = gl.getUniformLocation(program, "u_mask");
          var texCoordBuffer = gl.createBuffer();
          gl.bindBuffer(gl.ARRAY_BUFFER, texCoordBuffer);
          gl.bufferData(gl.ARRAY_BUFFER, new Float32Array([0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.0, 1.0, 1.0]), gl.STATIC_DRAW);
          gl.enableVertexAttribArray(texCoordLocation);
          gl.vertexAttribPointer(texCoordLocation, 2, gl.FLOAT, false, 0, 0);
          gl.uniform1i(texLayerLocation, 0);
          gl.uniform1i(texMaskLocation, 1);
          smaskCache = cache;
        }

        function composeSMask(layer, mask, properties) {
          var width = layer.width,
              height = layer.height;

          if (!smaskCache) {
            initSmaskGL();
          }

          var cache = smaskCache,
              canvas = cache.canvas,
              gl = cache.gl;
          canvas.width = width;
          canvas.height = height;
          gl.viewport(0, 0, gl.drawingBufferWidth, gl.drawingBufferHeight);
          gl.uniform2f(cache.resolutionLocation, width, height);

          if (properties.backdrop) {
            gl.uniform4f(cache.resolutionLocation, properties.backdrop[0], properties.backdrop[1], properties.backdrop[2], 1);
          } else {
            gl.uniform4f(cache.resolutionLocation, 0, 0, 0, 0);
          }

          gl.uniform1i(cache.subtypeLocation, properties.subtype === "Luminosity" ? 1 : 0);
          var texture = createTexture(gl, layer, gl.TEXTURE0);
          var maskTexture = createTexture(gl, mask, gl.TEXTURE1);
          var buffer = gl.createBuffer();
          gl.bindBuffer(gl.ARRAY_BUFFER, buffer);
          gl.bufferData(gl.ARRAY_BUFFER, new Float32Array([0, 0, width, 0, 0, height, 0, height, width, 0, width, height]), gl.STATIC_DRAW);
          gl.enableVertexAttribArray(cache.positionLocation);
          gl.vertexAttribPointer(cache.positionLocation, 2, gl.FLOAT, false, 0, 0);
          gl.clearColor(0, 0, 0, 0);
          gl.enable(gl.BLEND);
          gl.blendFunc(gl.ONE, gl.ONE_MINUS_SRC_ALPHA);
          gl.clear(gl.COLOR_BUFFER_BIT);
          gl.drawArrays(gl.TRIANGLES, 0, 6);
          gl.flush();
          gl.deleteTexture(texture);
          gl.deleteTexture(maskTexture);
          gl.deleteBuffer(buffer);
          return canvas;
        }

        var figuresVertexShaderCode = "\
  attribute vec2 a_position;                                    \
  attribute vec3 a_color;                                       \
                                                                \
  uniform vec2 u_resolution;                                    \
  uniform vec2 u_scale;                                         \
  uniform vec2 u_offset;                                        \
                                                                \
  varying vec4 v_color;                                         \
                                                                \
  void main() {                                                 \
    vec2 position = (a_position + u_offset) * u_scale;          \
    vec2 clipSpace = (position / u_resolution) * 2.0 - 1.0;     \
    gl_Position = vec4(clipSpace * vec2(1, -1), 0, 1);          \
                                                                \
    v_color = vec4(a_color / 255.0, 1.0);                       \
  }                                                             ";
        var figuresFragmentShaderCode = "\
  precision mediump float;                                      \
                                                                \
  varying vec4 v_color;                                         \
                                                                \
  void main() {                                                 \
    gl_FragColor = v_color;                                     \
  }                                                             ";
        var figuresCache = null;

        function initFiguresGL() {
          var canvas, gl;
          generateGL();
          canvas = currentCanvas;
          currentCanvas = null;
          gl = currentGL;
          currentGL = null;
          var vertexShader = createVertexShader(gl, figuresVertexShaderCode);
          var fragmentShader = createFragmentShader(gl, figuresFragmentShaderCode);
          var program = createProgram(gl, [vertexShader, fragmentShader]);
          gl.useProgram(program);
          var cache = {};
          cache.gl = gl;
          cache.canvas = canvas;
          cache.resolutionLocation = gl.getUniformLocation(program, "u_resolution");
          cache.scaleLocation = gl.getUniformLocation(program, "u_scale");
          cache.offsetLocation = gl.getUniformLocation(program, "u_offset");
          cache.positionLocation = gl.getAttribLocation(program, "a_position");
          cache.colorLocation = gl.getAttribLocation(program, "a_color");
          figuresCache = cache;
        }

        function drawFigures(width, height, backgroundColor, figures, context) {
          if (!figuresCache) {
            initFiguresGL();
          }

          var cache = figuresCache,
              canvas = cache.canvas,
              gl = cache.gl;
          canvas.width = width;
          canvas.height = height;
          gl.viewport(0, 0, gl.drawingBufferWidth, gl.drawingBufferHeight);
          gl.uniform2f(cache.resolutionLocation, width, height);
          var count = 0;
          var i, ii, rows;

          for (i = 0, ii = figures.length; i < ii; i++) {
            switch (figures[i].type) {
              case "lattice":
                rows = figures[i].coords.length / figures[i].verticesPerRow | 0;
                count += (rows - 1) * (figures[i].verticesPerRow - 1) * 6;
                break;

              case "triangles":
                count += figures[i].coords.length;
                break;
            }
          }

          var coords = new Float32Array(count * 2);
          var colors = new Uint8Array(count * 3);
          var coordsMap = context.coords,
              colorsMap = context.colors;
          var pIndex = 0,
              cIndex = 0;

          for (i = 0, ii = figures.length; i < ii; i++) {
            var figure = figures[i],
                ps = figure.coords,
                cs = figure.colors;

            switch (figure.type) {
              case "lattice":
                var cols = figure.verticesPerRow;
                rows = ps.length / cols | 0;

                for (var row = 1; row < rows; row++) {
                  var offset = row * cols + 1;

                  for (var col = 1; col < cols; col++, offset++) {
                    coords[pIndex] = coordsMap[ps[offset - cols - 1]];
                    coords[pIndex + 1] = coordsMap[ps[offset - cols - 1] + 1];
                    coords[pIndex + 2] = coordsMap[ps[offset - cols]];
                    coords[pIndex + 3] = coordsMap[ps[offset - cols] + 1];
                    coords[pIndex + 4] = coordsMap[ps[offset - 1]];
                    coords[pIndex + 5] = coordsMap[ps[offset - 1] + 1];
                    colors[cIndex] = colorsMap[cs[offset - cols - 1]];
                    colors[cIndex + 1] = colorsMap[cs[offset - cols - 1] + 1];
                    colors[cIndex + 2] = colorsMap[cs[offset - cols - 1] + 2];
                    colors[cIndex + 3] = colorsMap[cs[offset - cols]];
                    colors[cIndex + 4] = colorsMap[cs[offset - cols] + 1];
                    colors[cIndex + 5] = colorsMap[cs[offset - cols] + 2];
                    colors[cIndex + 6] = colorsMap[cs[offset - 1]];
                    colors[cIndex + 7] = colorsMap[cs[offset - 1] + 1];
                    colors[cIndex + 8] = colorsMap[cs[offset - 1] + 2];
                    coords[pIndex + 6] = coords[pIndex + 2];
                    coords[pIndex + 7] = coords[pIndex + 3];
                    coords[pIndex + 8] = coords[pIndex + 4];
                    coords[pIndex + 9] = coords[pIndex + 5];
                    coords[pIndex + 10] = coordsMap[ps[offset]];
                    coords[pIndex + 11] = coordsMap[ps[offset] + 1];
                    colors[cIndex + 9] = colors[cIndex + 3];
                    colors[cIndex + 10] = colors[cIndex + 4];
                    colors[cIndex + 11] = colors[cIndex + 5];
                    colors[cIndex + 12] = colors[cIndex + 6];
                    colors[cIndex + 13] = colors[cIndex + 7];
                    colors[cIndex + 14] = colors[cIndex + 8];
                    colors[cIndex + 15] = colorsMap[cs[offset]];
                    colors[cIndex + 16] = colorsMap[cs[offset] + 1];
                    colors[cIndex + 17] = colorsMap[cs[offset] + 2];
                    pIndex += 12;
                    cIndex += 18;
                  }
                }

                break;

              case "triangles":
                for (var j = 0, jj = ps.length; j < jj; j++) {
                  coords[pIndex] = coordsMap[ps[j]];
                  coords[pIndex + 1] = coordsMap[ps[j] + 1];
                  colors[cIndex] = colorsMap[cs[j]];
                  colors[cIndex + 1] = colorsMap[cs[j] + 1];
                  colors[cIndex + 2] = colorsMap[cs[j] + 2];
                  pIndex += 2;
                  cIndex += 3;
                }

                break;
            }
          }

          if (backgroundColor) {
            gl.clearColor(backgroundColor[0] / 255, backgroundColor[1] / 255, backgroundColor[2] / 255, 1.0);
          } else {
            gl.clearColor(0, 0, 0, 0);
          }

          gl.clear(gl.COLOR_BUFFER_BIT);
          var coordsBuffer = gl.createBuffer();
          gl.bindBuffer(gl.ARRAY_BUFFER, coordsBuffer);
          gl.bufferData(gl.ARRAY_BUFFER, coords, gl.STATIC_DRAW);
          gl.enableVertexAttribArray(cache.positionLocation);
          gl.vertexAttribPointer(cache.positionLocation, 2, gl.FLOAT, false, 0, 0);
          var colorsBuffer = gl.createBuffer();
          gl.bindBuffer(gl.ARRAY_BUFFER, colorsBuffer);
          gl.bufferData(gl.ARRAY_BUFFER, colors, gl.STATIC_DRAW);
          gl.enableVertexAttribArray(cache.colorLocation);
          gl.vertexAttribPointer(cache.colorLocation, 3, gl.UNSIGNED_BYTE, false, 0, 0);
          gl.uniform2f(cache.scaleLocation, context.scaleX, context.scaleY);
          gl.uniform2f(cache.offsetLocation, context.offsetX, context.offsetY);
          gl.drawArrays(gl.TRIANGLES, 0, count);
          gl.flush();
          gl.deleteBuffer(coordsBuffer);
          gl.deleteBuffer(colorsBuffer);
          return canvas;
        }

        return {
          tryInitGL: function tryInitGL() {
            try {
              generateGL();
              return !!currentGL;
            } catch (ex) {}

            return false;
          },
          composeSMask: composeSMask,
          drawFigures: drawFigures,
          cleanup: function cleanup() {
            if (smaskCache && smaskCache.canvas) {
              smaskCache.canvas.width = 0;
              smaskCache.canvas.height = 0;
            }

            if (figuresCache && figuresCache.canvas) {
              figuresCache.canvas.width = 0;
              figuresCache.canvas.height = 0;
            }

            smaskCache = null;
            figuresCache = null;
          }
        };
      }();
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.AnnotationLayer = void 0;

      var _display_utils = __w_pdfjs_require__(1);

      var _util = __w_pdfjs_require__(2);

      var _annotation_storage = __w_pdfjs_require__(8);

      var AnnotationElementFactory = function () {
        function AnnotationElementFactory() {
          _classCallCheck(this, AnnotationElementFactory);
        }

        _createClass(AnnotationElementFactory, null, [{
          key: "create",
          value: function create(parameters) {
            var subtype = parameters.data.annotationType;

            switch (subtype) {
              case _util.AnnotationType.LINK:
                return new LinkAnnotationElement(parameters);

              case _util.AnnotationType.TEXT:
                return new TextAnnotationElement(parameters);

              case _util.AnnotationType.WIDGET:
                var fieldType = parameters.data.fieldType;

                switch (fieldType) {
                  case "Tx":
                    return new TextWidgetAnnotationElement(parameters);

                  case "Btn":
                    if (parameters.data.radioButton) {
                      return new RadioButtonWidgetAnnotationElement(parameters);
                    } else if (parameters.data.checkBox) {
                      return new CheckboxWidgetAnnotationElement(parameters);
                    }

                    return new PushButtonWidgetAnnotationElement(parameters);

                  case "Ch":
                    return new ChoiceWidgetAnnotationElement(parameters);
                }

                return new WidgetAnnotationElement(parameters);

              case _util.AnnotationType.POPUP:
                return new PopupAnnotationElement(parameters);

              case _util.AnnotationType.FREETEXT:
                return new FreeTextAnnotationElement(parameters);

              case _util.AnnotationType.LINE:
                return new LineAnnotationElement(parameters);

              case _util.AnnotationType.SQUARE:
                return new SquareAnnotationElement(parameters);

              case _util.AnnotationType.CIRCLE:
                return new CircleAnnotationElement(parameters);

              case _util.AnnotationType.POLYLINE:
                return new PolylineAnnotationElement(parameters);

              case _util.AnnotationType.CARET:
                return new CaretAnnotationElement(parameters);

              case _util.AnnotationType.INK:
                return new InkAnnotationElement(parameters);

              case _util.AnnotationType.POLYGON:
                return new PolygonAnnotationElement(parameters);

              case _util.AnnotationType.HIGHLIGHT:
                return new HighlightAnnotationElement(parameters);

              case _util.AnnotationType.UNDERLINE:
                return new UnderlineAnnotationElement(parameters);

              case _util.AnnotationType.SQUIGGLY:
                return new SquigglyAnnotationElement(parameters);

              case _util.AnnotationType.STRIKEOUT:
                return new StrikeOutAnnotationElement(parameters);

              case _util.AnnotationType.STAMP:
                return new StampAnnotationElement(parameters);

              case _util.AnnotationType.FILEATTACHMENT:
                return new FileAttachmentAnnotationElement(parameters);

              default:
                return new AnnotationElement(parameters);
            }
          }
        }]);

        return AnnotationElementFactory;
      }();

      var AnnotationElement = function () {
        function AnnotationElement(parameters) {
          var isRenderable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
          var ignoreBorder = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

          _classCallCheck(this, AnnotationElement);

          this.isRenderable = isRenderable;
          this.data = parameters.data;
          this.layer = parameters.layer;
          this.page = parameters.page;
          this.viewport = parameters.viewport;
          this.linkService = parameters.linkService;
          this.downloadManager = parameters.downloadManager;
          this.imageResourcesPath = parameters.imageResourcesPath;
          this.renderInteractiveForms = parameters.renderInteractiveForms;
          this.svgFactory = parameters.svgFactory;
          this.annotationStorage = parameters.annotationStorage;

          if (isRenderable) {
            this.container = this._createContainer(ignoreBorder);
          }
        }

        _createClass(AnnotationElement, [{
          key: "_createContainer",
          value: function _createContainer() {
            var ignoreBorder = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
            var data = this.data,
                page = this.page,
                viewport = this.viewport;
            var container = document.createElement("section");
            var width = data.rect[2] - data.rect[0];
            var height = data.rect[3] - data.rect[1];
            container.setAttribute("data-annotation-id", data.id);

            var rect = _util.Util.normalizeRect([data.rect[0], page.view[3] - data.rect[1] + page.view[1], data.rect[2], page.view[3] - data.rect[3] + page.view[1]]);

            container.style.transform = "matrix(".concat(viewport.transform.join(","), ")");
            container.style.transformOrigin = "-".concat(rect[0], "px -").concat(rect[1], "px");

            if (!ignoreBorder && data.borderStyle.width > 0) {
              container.style.borderWidth = "".concat(data.borderStyle.width, "px");

              if (data.borderStyle.style !== _util.AnnotationBorderStyleType.UNDERLINE) {
                width = width - 2 * data.borderStyle.width;
                height = height - 2 * data.borderStyle.width;
              }

              var horizontalRadius = data.borderStyle.horizontalCornerRadius;
              var verticalRadius = data.borderStyle.verticalCornerRadius;

              if (horizontalRadius > 0 || verticalRadius > 0) {
                var radius = "".concat(horizontalRadius, "px / ").concat(verticalRadius, "px");
                container.style.borderRadius = radius;
              }

              switch (data.borderStyle.style) {
                case _util.AnnotationBorderStyleType.SOLID:
                  container.style.borderStyle = "solid";
                  break;

                case _util.AnnotationBorderStyleType.DASHED:
                  container.style.borderStyle = "dashed";
                  break;

                case _util.AnnotationBorderStyleType.BEVELED:
                  (0, _util.warn)("Unimplemented border style: beveled");
                  break;

                case _util.AnnotationBorderStyleType.INSET:
                  (0, _util.warn)("Unimplemented border style: inset");
                  break;

                case _util.AnnotationBorderStyleType.UNDERLINE:
                  container.style.borderBottomStyle = "solid";
                  break;
              }

              if (data.color) {
                container.style.borderColor = _util.Util.makeCssRgb(data.color[0] | 0, data.color[1] | 0, data.color[2] | 0);
              } else {
                container.style.borderWidth = 0;
              }
            }

            container.style.left = "".concat(rect[0], "px");
            container.style.top = "".concat(rect[1], "px");
            container.style.width = "".concat(width, "px");
            container.style.height = "".concat(height, "px");
            return container;
          }
        }, {
          key: "_createPopup",
          value: function _createPopup(container, trigger, data) {
            if (!trigger) {
              trigger = document.createElement("div");
              trigger.style.height = container.style.height;
              trigger.style.width = container.style.width;
              container.appendChild(trigger);
            }

            var popupElement = new PopupElement({
              container: container,
              trigger: trigger,
              color: data.color,
              title: data.title,
              modificationDate: data.modificationDate,
              contents: data.contents,
              hideWrapper: true
            });
            var popup = popupElement.render();
            popup.style.left = container.style.width;
            container.appendChild(popup);
          }
        }, {
          key: "render",
          value: function render() {
            (0, _util.unreachable)("Abstract method `AnnotationElement.render` called");
          }
        }]);

        return AnnotationElement;
      }();

      var LinkAnnotationElement = function (_AnnotationElement) {
        _inherits(LinkAnnotationElement, _AnnotationElement);

        var _super15 = _createSuper(LinkAnnotationElement);

        function LinkAnnotationElement(parameters) {
          _classCallCheck(this, LinkAnnotationElement);

          var isRenderable = !!(parameters.data.url || parameters.data.dest || parameters.data.action);
          return _super15.call(this, parameters, isRenderable);
        }

        _createClass(LinkAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "linkAnnotation";
            var data = this.data,
                linkService = this.linkService;
            var link = document.createElement("a");

            if (data.url) {
              (0, _display_utils.addLinkAttributes)(link, {
                url: data.url,
                target: data.newWindow ? _display_utils.LinkTarget.BLANK : linkService.externalLinkTarget,
                rel: linkService.externalLinkRel,
                enabled: linkService.externalLinkEnabled
              });
            } else if (data.action) {
              this._bindNamedAction(link, data.action);
            } else {
              this._bindLink(link, data.dest);
            }

            this.container.appendChild(link);
            return this.container;
          }
        }, {
          key: "_bindLink",
          value: function _bindLink(link, destination) {
            var _this34 = this;

            link.href = this.linkService.getDestinationHash(destination);

            link.onclick = function () {
              if (destination) {
                _this34.linkService.navigateTo(destination);
              }

              return false;
            };

            if (destination) {
              link.className = "internalLink";
            }
          }
        }, {
          key: "_bindNamedAction",
          value: function _bindNamedAction(link, action) {
            var _this35 = this;

            link.href = this.linkService.getAnchorUrl("");

            link.onclick = function () {
              _this35.linkService.executeNamedAction(action);

              return false;
            };

            link.className = "internalLink";
          }
        }]);

        return LinkAnnotationElement;
      }(AnnotationElement);

      var TextAnnotationElement = function (_AnnotationElement2) {
        _inherits(TextAnnotationElement, _AnnotationElement2);

        var _super16 = _createSuper(TextAnnotationElement);

        function TextAnnotationElement(parameters) {
          _classCallCheck(this, TextAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          return _super16.call(this, parameters, isRenderable);
        }

        _createClass(TextAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "textAnnotation";
            var image = document.createElement("img");
            image.style.height = this.container.style.height;
            image.style.width = this.container.style.width;
            image.src = this.imageResourcesPath + "annotation-" + this.data.name.toLowerCase() + ".svg";
            image.alt = "[{{type}} Annotation]";
            image.dataset.l10nId = "text_annotation_type";
            image.dataset.l10nArgs = JSON.stringify({
              type: this.data.name
            });

            if (!this.data.hasPopup) {
              this._createPopup(this.container, image, this.data);
            }

            this.container.appendChild(image);
            return this.container;
          }
        }]);

        return TextAnnotationElement;
      }(AnnotationElement);

      var WidgetAnnotationElement = function (_AnnotationElement3) {
        _inherits(WidgetAnnotationElement, _AnnotationElement3);

        var _super17 = _createSuper(WidgetAnnotationElement);

        function WidgetAnnotationElement() {
          _classCallCheck(this, WidgetAnnotationElement);

          return _super17.apply(this, arguments);
        }

        _createClass(WidgetAnnotationElement, [{
          key: "render",
          value: function render() {
            return this.container;
          }
        }]);

        return WidgetAnnotationElement;
      }(AnnotationElement);

      var TextWidgetAnnotationElement = function (_WidgetAnnotationElem) {
        _inherits(TextWidgetAnnotationElement, _WidgetAnnotationElem);

        var _super18 = _createSuper(TextWidgetAnnotationElement);

        function TextWidgetAnnotationElement(parameters) {
          _classCallCheck(this, TextWidgetAnnotationElement);

          var isRenderable = parameters.renderInteractiveForms || !parameters.data.hasAppearance && !!parameters.data.fieldValue;
          return _super18.call(this, parameters, isRenderable);
        }

        _createClass(TextWidgetAnnotationElement, [{
          key: "render",
          value: function render() {
            var TEXT_ALIGNMENT = ["left", "center", "right"];
            var storage = this.annotationStorage;
            var id = this.data.id;
            this.container.className = "textWidgetAnnotation";
            var element = null;

            if (this.renderInteractiveForms) {
              var textContent = storage.getOrCreateValue(id, this.data.fieldValue);

              if (this.data.multiLine) {
                element = document.createElement("textarea");
                element.textContent = textContent;
              } else {
                element = document.createElement("input");
                element.type = "text";
                element.setAttribute("value", textContent);
              }

              element.addEventListener("input", function (event) {
                storage.setValue(id, event.target.value);
              });
              element.disabled = this.data.readOnly;
              element.name = this.data.fieldName;

              if (this.data.maxLen !== null) {
                element.maxLength = this.data.maxLen;
              }

              if (this.data.comb) {
                var fieldWidth = this.data.rect[2] - this.data.rect[0];
                var combWidth = fieldWidth / this.data.maxLen;
                element.classList.add("comb");
                element.style.letterSpacing = "calc(".concat(combWidth, "px - 1ch)");
              }
            } else {
              element = document.createElement("div");
              element.textContent = this.data.fieldValue;
              element.style.verticalAlign = "middle";
              element.style.display = "table-cell";
              var font = null;

              if (this.data.fontRefName && this.page.commonObjs.has(this.data.fontRefName)) {
                font = this.page.commonObjs.get(this.data.fontRefName);
              }

              this._setTextStyle(element, font);
            }

            if (this.data.textAlignment !== null) {
              element.style.textAlign = TEXT_ALIGNMENT[this.data.textAlignment];
            }

            this.container.appendChild(element);
            return this.container;
          }
        }, {
          key: "_setTextStyle",
          value: function _setTextStyle(element, font) {
            var style = element.style;
            style.fontSize = "".concat(this.data.fontSize, "px");
            style.direction = this.data.fontDirection < 0 ? "rtl" : "ltr";

            if (!font) {
              return;
            }

            var bold = "normal";

            if (font.black) {
              bold = "900";
            } else if (font.bold) {
              bold = "bold";
            }

            style.fontWeight = bold;
            style.fontStyle = font.italic ? "italic" : "normal";
            var fontFamily = font.loadedName ? "\"".concat(font.loadedName, "\", ") : "";
            var fallbackName = font.fallbackName || "Helvetica, sans-serif";
            style.fontFamily = fontFamily + fallbackName;
          }
        }]);

        return TextWidgetAnnotationElement;
      }(WidgetAnnotationElement);

      var CheckboxWidgetAnnotationElement = function (_WidgetAnnotationElem2) {
        _inherits(CheckboxWidgetAnnotationElement, _WidgetAnnotationElem2);

        var _super19 = _createSuper(CheckboxWidgetAnnotationElement);

        function CheckboxWidgetAnnotationElement(parameters) {
          _classCallCheck(this, CheckboxWidgetAnnotationElement);

          return _super19.call(this, parameters, parameters.renderInteractiveForms);
        }

        _createClass(CheckboxWidgetAnnotationElement, [{
          key: "render",
          value: function render() {
            var storage = this.annotationStorage;
            var data = this.data;
            var id = data.id;
            var value = storage.getOrCreateValue(id, data.fieldValue && data.fieldValue !== "Off");
            this.container.className = "buttonWidgetAnnotation checkBox";
            var element = document.createElement("input");
            element.disabled = data.readOnly;
            element.type = "checkbox";
            element.name = this.data.fieldName;

            if (value) {
              element.setAttribute("checked", true);
            }

            element.addEventListener("change", function (event) {
              storage.setValue(id, event.target.checked);
            });
            this.container.appendChild(element);
            return this.container;
          }
        }]);

        return CheckboxWidgetAnnotationElement;
      }(WidgetAnnotationElement);

      var RadioButtonWidgetAnnotationElement = function (_WidgetAnnotationElem3) {
        _inherits(RadioButtonWidgetAnnotationElement, _WidgetAnnotationElem3);

        var _super20 = _createSuper(RadioButtonWidgetAnnotationElement);

        function RadioButtonWidgetAnnotationElement(parameters) {
          _classCallCheck(this, RadioButtonWidgetAnnotationElement);

          return _super20.call(this, parameters, parameters.renderInteractiveForms);
        }

        _createClass(RadioButtonWidgetAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "buttonWidgetAnnotation radioButton";
            var storage = this.annotationStorage;
            var data = this.data;
            var id = data.id;
            var value = storage.getOrCreateValue(id, data.fieldValue === data.buttonValue);
            var element = document.createElement("input");
            element.disabled = data.readOnly;
            element.type = "radio";
            element.name = data.fieldName;

            if (value) {
              element.setAttribute("checked", true);
            }

            element.addEventListener("change", function (event) {
              var name = event.target.name;

              var _iterator21 = _createForOfIteratorHelper(document.getElementsByName(name)),
                  _step21;

              try {
                for (_iterator21.s(); !(_step21 = _iterator21.n()).done;) {
                  var radio = _step21.value;

                  if (radio !== event.target) {
                    storage.setValue(radio.parentNode.getAttribute("data-annotation-id"), false);
                  }
                }
              } catch (err) {
                _iterator21.e(err);
              } finally {
                _iterator21.f();
              }

              storage.setValue(id, event.target.checked);
            });
            this.container.appendChild(element);
            return this.container;
          }
        }]);

        return RadioButtonWidgetAnnotationElement;
      }(WidgetAnnotationElement);

      var PushButtonWidgetAnnotationElement = function (_LinkAnnotationElemen) {
        _inherits(PushButtonWidgetAnnotationElement, _LinkAnnotationElemen);

        var _super21 = _createSuper(PushButtonWidgetAnnotationElement);

        function PushButtonWidgetAnnotationElement() {
          _classCallCheck(this, PushButtonWidgetAnnotationElement);

          return _super21.apply(this, arguments);
        }

        _createClass(PushButtonWidgetAnnotationElement, [{
          key: "render",
          value: function render() {
            var container = _get(_getPrototypeOf(PushButtonWidgetAnnotationElement.prototype), "render", this).call(this);

            container.className = "buttonWidgetAnnotation pushButton";
            return container;
          }
        }]);

        return PushButtonWidgetAnnotationElement;
      }(LinkAnnotationElement);

      var ChoiceWidgetAnnotationElement = function (_WidgetAnnotationElem4) {
        _inherits(ChoiceWidgetAnnotationElement, _WidgetAnnotationElem4);

        var _super22 = _createSuper(ChoiceWidgetAnnotationElement);

        function ChoiceWidgetAnnotationElement(parameters) {
          _classCallCheck(this, ChoiceWidgetAnnotationElement);

          return _super22.call(this, parameters, parameters.renderInteractiveForms);
        }

        _createClass(ChoiceWidgetAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "choiceWidgetAnnotation";
            var storage = this.annotationStorage;
            var id = this.data.id;
            storage.getOrCreateValue(id, this.data.fieldValue.length > 0 ? this.data.fieldValue[0] : null);
            var selectElement = document.createElement("select");
            selectElement.disabled = this.data.readOnly;
            selectElement.name = this.data.fieldName;

            if (!this.data.combo) {
              selectElement.size = this.data.options.length;

              if (this.data.multiSelect) {
                selectElement.multiple = true;
              }
            }

            var _iterator22 = _createForOfIteratorHelper(this.data.options),
                _step22;

            try {
              for (_iterator22.s(); !(_step22 = _iterator22.n()).done;) {
                var option = _step22.value;
                var optionElement = document.createElement("option");
                optionElement.textContent = option.displayValue;
                optionElement.value = option.exportValue;

                if (this.data.fieldValue.includes(option.exportValue)) {
                  optionElement.setAttribute("selected", true);
                }

                selectElement.appendChild(optionElement);
              }
            } catch (err) {
              _iterator22.e(err);
            } finally {
              _iterator22.f();
            }

            selectElement.addEventListener("input", function (event) {
              var options = event.target.options;
              var value = options[options.selectedIndex].value;
              storage.setValue(id, value);
            });
            this.container.appendChild(selectElement);
            return this.container;
          }
        }]);

        return ChoiceWidgetAnnotationElement;
      }(WidgetAnnotationElement);

      var PopupAnnotationElement = function (_AnnotationElement4) {
        _inherits(PopupAnnotationElement, _AnnotationElement4);

        var _super23 = _createSuper(PopupAnnotationElement);

        function PopupAnnotationElement(parameters) {
          _classCallCheck(this, PopupAnnotationElement);

          var isRenderable = !!(parameters.data.title || parameters.data.contents);
          return _super23.call(this, parameters, isRenderable);
        }

        _createClass(PopupAnnotationElement, [{
          key: "render",
          value: function render() {
            var IGNORE_TYPES = ["Line", "Square", "Circle", "PolyLine", "Polygon", "Ink"];
            this.container.className = "popupAnnotation";

            if (IGNORE_TYPES.includes(this.data.parentType)) {
              return this.container;
            }

            var selector = "[data-annotation-id=\"".concat(this.data.parentId, "\"]");
            var parentElement = this.layer.querySelector(selector);

            if (!parentElement) {
              return this.container;
            }

            var popup = new PopupElement({
              container: this.container,
              trigger: parentElement,
              color: this.data.color,
              title: this.data.title,
              modificationDate: this.data.modificationDate,
              contents: this.data.contents
            });
            var parentLeft = parseFloat(parentElement.style.left);
            var parentWidth = parseFloat(parentElement.style.width);
            this.container.style.transformOrigin = "-".concat(parentLeft + parentWidth, "px -").concat(parentElement.style.top);
            this.container.style.left = "".concat(parentLeft + parentWidth, "px");
            this.container.appendChild(popup.render());
            return this.container;
          }
        }]);

        return PopupAnnotationElement;
      }(AnnotationElement);

      var PopupElement = function () {
        function PopupElement(parameters) {
          _classCallCheck(this, PopupElement);

          this.container = parameters.container;
          this.trigger = parameters.trigger;
          this.color = parameters.color;
          this.title = parameters.title;
          this.modificationDate = parameters.modificationDate;
          this.contents = parameters.contents;
          this.hideWrapper = parameters.hideWrapper || false;
          this.pinned = false;
        }

        _createClass(PopupElement, [{
          key: "render",
          value: function render() {
            var BACKGROUND_ENLIGHT = 0.7;
            var wrapper = document.createElement("div");
            wrapper.className = "popupWrapper";
            this.hideElement = this.hideWrapper ? wrapper : this.container;
            this.hideElement.setAttribute("hidden", true);
            var popup = document.createElement("div");
            popup.className = "popup";
            var color = this.color;

            if (color) {
              var r = BACKGROUND_ENLIGHT * (255 - color[0]) + color[0];
              var g = BACKGROUND_ENLIGHT * (255 - color[1]) + color[1];
              var b = BACKGROUND_ENLIGHT * (255 - color[2]) + color[2];
              popup.style.backgroundColor = _util.Util.makeCssRgb(r | 0, g | 0, b | 0);
            }

            var title = document.createElement("h1");
            title.textContent = this.title;
            popup.appendChild(title);

            var dateObject = _display_utils.PDFDateString.toDateObject(this.modificationDate);

            if (dateObject) {
              var modificationDate = document.createElement("span");
              modificationDate.textContent = "{{date}}, {{time}}";
              modificationDate.dataset.l10nId = "annotation_date_string";
              modificationDate.dataset.l10nArgs = JSON.stringify({
                date: dateObject.toLocaleDateString(),
                time: dateObject.toLocaleTimeString()
              });
              popup.appendChild(modificationDate);
            }

            var contents = this._formatContents(this.contents);

            popup.appendChild(contents);
            this.trigger.addEventListener("click", this._toggle.bind(this));
            this.trigger.addEventListener("mouseover", this._show.bind(this, false));
            this.trigger.addEventListener("mouseout", this._hide.bind(this, false));
            popup.addEventListener("click", this._hide.bind(this, true));
            wrapper.appendChild(popup);
            return wrapper;
          }
        }, {
          key: "_formatContents",
          value: function _formatContents(contents) {
            var p = document.createElement("p");
            var lines = contents.split(/(?:\r\n?|\n)/);

            for (var i = 0, ii = lines.length; i < ii; ++i) {
              var line = lines[i];
              p.appendChild(document.createTextNode(line));

              if (i < ii - 1) {
                p.appendChild(document.createElement("br"));
              }
            }

            return p;
          }
        }, {
          key: "_toggle",
          value: function _toggle() {
            if (this.pinned) {
              this._hide(true);
            } else {
              this._show(true);
            }
          }
        }, {
          key: "_show",
          value: function _show() {
            var pin = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

            if (pin) {
              this.pinned = true;
            }

            if (this.hideElement.hasAttribute("hidden")) {
              this.hideElement.removeAttribute("hidden");
              this.container.style.zIndex += 1;
            }
          }
        }, {
          key: "_hide",
          value: function _hide() {
            var unpin = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

            if (unpin) {
              this.pinned = false;
            }

            if (!this.hideElement.hasAttribute("hidden") && !this.pinned) {
              this.hideElement.setAttribute("hidden", true);
              this.container.style.zIndex -= 1;
            }
          }
        }]);

        return PopupElement;
      }();

      var FreeTextAnnotationElement = function (_AnnotationElement5) {
        _inherits(FreeTextAnnotationElement, _AnnotationElement5);

        var _super24 = _createSuper(FreeTextAnnotationElement);

        function FreeTextAnnotationElement(parameters) {
          _classCallCheck(this, FreeTextAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          return _super24.call(this, parameters, isRenderable, true);
        }

        _createClass(FreeTextAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "freeTextAnnotation";

            if (!this.data.hasPopup) {
              this._createPopup(this.container, null, this.data);
            }

            return this.container;
          }
        }]);

        return FreeTextAnnotationElement;
      }(AnnotationElement);

      var LineAnnotationElement = function (_AnnotationElement6) {
        _inherits(LineAnnotationElement, _AnnotationElement6);

        var _super25 = _createSuper(LineAnnotationElement);

        function LineAnnotationElement(parameters) {
          _classCallCheck(this, LineAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          return _super25.call(this, parameters, isRenderable, true);
        }

        _createClass(LineAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "lineAnnotation";
            var data = this.data;
            var width = data.rect[2] - data.rect[0];
            var height = data.rect[3] - data.rect[1];
            var svg = this.svgFactory.create(width, height);
            var line = this.svgFactory.createElement("svg:line");
            line.setAttribute("x1", data.rect[2] - data.lineCoordinates[0]);
            line.setAttribute("y1", data.rect[3] - data.lineCoordinates[1]);
            line.setAttribute("x2", data.rect[2] - data.lineCoordinates[2]);
            line.setAttribute("y2", data.rect[3] - data.lineCoordinates[3]);
            line.setAttribute("stroke-width", data.borderStyle.width || 1);
            line.setAttribute("stroke", "transparent");
            svg.appendChild(line);
            this.container.append(svg);

            this._createPopup(this.container, line, data);

            return this.container;
          }
        }]);

        return LineAnnotationElement;
      }(AnnotationElement);

      var SquareAnnotationElement = function (_AnnotationElement7) {
        _inherits(SquareAnnotationElement, _AnnotationElement7);

        var _super26 = _createSuper(SquareAnnotationElement);

        function SquareAnnotationElement(parameters) {
          _classCallCheck(this, SquareAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          return _super26.call(this, parameters, isRenderable, true);
        }

        _createClass(SquareAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "squareAnnotation";
            var data = this.data;
            var width = data.rect[2] - data.rect[0];
            var height = data.rect[3] - data.rect[1];
            var svg = this.svgFactory.create(width, height);
            var borderWidth = data.borderStyle.width;
            var square = this.svgFactory.createElement("svg:rect");
            square.setAttribute("x", borderWidth / 2);
            square.setAttribute("y", borderWidth / 2);
            square.setAttribute("width", width - borderWidth);
            square.setAttribute("height", height - borderWidth);
            square.setAttribute("stroke-width", borderWidth || 1);
            square.setAttribute("stroke", "transparent");
            square.setAttribute("fill", "none");
            svg.appendChild(square);
            this.container.append(svg);

            this._createPopup(this.container, square, data);

            return this.container;
          }
        }]);

        return SquareAnnotationElement;
      }(AnnotationElement);

      var CircleAnnotationElement = function (_AnnotationElement8) {
        _inherits(CircleAnnotationElement, _AnnotationElement8);

        var _super27 = _createSuper(CircleAnnotationElement);

        function CircleAnnotationElement(parameters) {
          _classCallCheck(this, CircleAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          return _super27.call(this, parameters, isRenderable, true);
        }

        _createClass(CircleAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "circleAnnotation";
            var data = this.data;
            var width = data.rect[2] - data.rect[0];
            var height = data.rect[3] - data.rect[1];
            var svg = this.svgFactory.create(width, height);
            var borderWidth = data.borderStyle.width;
            var circle = this.svgFactory.createElement("svg:ellipse");
            circle.setAttribute("cx", width / 2);
            circle.setAttribute("cy", height / 2);
            circle.setAttribute("rx", width / 2 - borderWidth / 2);
            circle.setAttribute("ry", height / 2 - borderWidth / 2);
            circle.setAttribute("stroke-width", borderWidth || 1);
            circle.setAttribute("stroke", "transparent");
            circle.setAttribute("fill", "none");
            svg.appendChild(circle);
            this.container.append(svg);

            this._createPopup(this.container, circle, data);

            return this.container;
          }
        }]);

        return CircleAnnotationElement;
      }(AnnotationElement);

      var PolylineAnnotationElement = function (_AnnotationElement9) {
        _inherits(PolylineAnnotationElement, _AnnotationElement9);

        var _super28 = _createSuper(PolylineAnnotationElement);

        function PolylineAnnotationElement(parameters) {
          var _this36;

          _classCallCheck(this, PolylineAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          _this36 = _super28.call(this, parameters, isRenderable, true);
          _this36.containerClassName = "polylineAnnotation";
          _this36.svgElementName = "svg:polyline";
          return _this36;
        }

        _createClass(PolylineAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = this.containerClassName;
            var data = this.data;
            var width = data.rect[2] - data.rect[0];
            var height = data.rect[3] - data.rect[1];
            var svg = this.svgFactory.create(width, height);
            var points = [];

            var _iterator23 = _createForOfIteratorHelper(data.vertices),
                _step23;

            try {
              for (_iterator23.s(); !(_step23 = _iterator23.n()).done;) {
                var coordinate = _step23.value;
                var x = coordinate.x - data.rect[0];
                var y = data.rect[3] - coordinate.y;
                points.push(x + "," + y);
              }
            } catch (err) {
              _iterator23.e(err);
            } finally {
              _iterator23.f();
            }

            points = points.join(" ");
            var polyline = this.svgFactory.createElement(this.svgElementName);
            polyline.setAttribute("points", points);
            polyline.setAttribute("stroke-width", data.borderStyle.width || 1);
            polyline.setAttribute("stroke", "transparent");
            polyline.setAttribute("fill", "none");
            svg.appendChild(polyline);
            this.container.append(svg);

            this._createPopup(this.container, polyline, data);

            return this.container;
          }
        }]);

        return PolylineAnnotationElement;
      }(AnnotationElement);

      var PolygonAnnotationElement = function (_PolylineAnnotationEl) {
        _inherits(PolygonAnnotationElement, _PolylineAnnotationEl);

        var _super29 = _createSuper(PolygonAnnotationElement);

        function PolygonAnnotationElement(parameters) {
          var _this37;

          _classCallCheck(this, PolygonAnnotationElement);

          _this37 = _super29.call(this, parameters);
          _this37.containerClassName = "polygonAnnotation";
          _this37.svgElementName = "svg:polygon";
          return _this37;
        }

        return PolygonAnnotationElement;
      }(PolylineAnnotationElement);

      var CaretAnnotationElement = function (_AnnotationElement10) {
        _inherits(CaretAnnotationElement, _AnnotationElement10);

        var _super30 = _createSuper(CaretAnnotationElement);

        function CaretAnnotationElement(parameters) {
          _classCallCheck(this, CaretAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          return _super30.call(this, parameters, isRenderable, true);
        }

        _createClass(CaretAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "caretAnnotation";

            if (!this.data.hasPopup) {
              this._createPopup(this.container, null, this.data);
            }

            return this.container;
          }
        }]);

        return CaretAnnotationElement;
      }(AnnotationElement);

      var InkAnnotationElement = function (_AnnotationElement11) {
        _inherits(InkAnnotationElement, _AnnotationElement11);

        var _super31 = _createSuper(InkAnnotationElement);

        function InkAnnotationElement(parameters) {
          var _this38;

          _classCallCheck(this, InkAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          _this38 = _super31.call(this, parameters, isRenderable, true);
          _this38.containerClassName = "inkAnnotation";
          _this38.svgElementName = "svg:polyline";
          return _this38;
        }

        _createClass(InkAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = this.containerClassName;
            var data = this.data;
            var width = data.rect[2] - data.rect[0];
            var height = data.rect[3] - data.rect[1];
            var svg = this.svgFactory.create(width, height);

            var _iterator24 = _createForOfIteratorHelper(data.inkLists),
                _step24;

            try {
              for (_iterator24.s(); !(_step24 = _iterator24.n()).done;) {
                var inkList = _step24.value;
                var points = [];

                var _iterator25 = _createForOfIteratorHelper(inkList),
                    _step25;

                try {
                  for (_iterator25.s(); !(_step25 = _iterator25.n()).done;) {
                    var coordinate = _step25.value;
                    var x = coordinate.x - data.rect[0];
                    var y = data.rect[3] - coordinate.y;
                    points.push("".concat(x, ",").concat(y));
                  }
                } catch (err) {
                  _iterator25.e(err);
                } finally {
                  _iterator25.f();
                }

                points = points.join(" ");
                var polyline = this.svgFactory.createElement(this.svgElementName);
                polyline.setAttribute("points", points);
                polyline.setAttribute("stroke-width", data.borderStyle.width || 1);
                polyline.setAttribute("stroke", "transparent");
                polyline.setAttribute("fill", "none");

                this._createPopup(this.container, polyline, data);

                svg.appendChild(polyline);
              }
            } catch (err) {
              _iterator24.e(err);
            } finally {
              _iterator24.f();
            }

            this.container.append(svg);
            return this.container;
          }
        }]);

        return InkAnnotationElement;
      }(AnnotationElement);

      var HighlightAnnotationElement = function (_AnnotationElement12) {
        _inherits(HighlightAnnotationElement, _AnnotationElement12);

        var _super32 = _createSuper(HighlightAnnotationElement);

        function HighlightAnnotationElement(parameters) {
          _classCallCheck(this, HighlightAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          return _super32.call(this, parameters, isRenderable, true);
        }

        _createClass(HighlightAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "highlightAnnotation";

            if (!this.data.hasPopup) {
              this._createPopup(this.container, null, this.data);
            }

            return this.container;
          }
        }]);

        return HighlightAnnotationElement;
      }(AnnotationElement);

      var UnderlineAnnotationElement = function (_AnnotationElement13) {
        _inherits(UnderlineAnnotationElement, _AnnotationElement13);

        var _super33 = _createSuper(UnderlineAnnotationElement);

        function UnderlineAnnotationElement(parameters) {
          _classCallCheck(this, UnderlineAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          return _super33.call(this, parameters, isRenderable, true);
        }

        _createClass(UnderlineAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "underlineAnnotation";

            if (!this.data.hasPopup) {
              this._createPopup(this.container, null, this.data);
            }

            return this.container;
          }
        }]);

        return UnderlineAnnotationElement;
      }(AnnotationElement);

      var SquigglyAnnotationElement = function (_AnnotationElement14) {
        _inherits(SquigglyAnnotationElement, _AnnotationElement14);

        var _super34 = _createSuper(SquigglyAnnotationElement);

        function SquigglyAnnotationElement(parameters) {
          _classCallCheck(this, SquigglyAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          return _super34.call(this, parameters, isRenderable, true);
        }

        _createClass(SquigglyAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "squigglyAnnotation";

            if (!this.data.hasPopup) {
              this._createPopup(this.container, null, this.data);
            }

            return this.container;
          }
        }]);

        return SquigglyAnnotationElement;
      }(AnnotationElement);

      var StrikeOutAnnotationElement = function (_AnnotationElement15) {
        _inherits(StrikeOutAnnotationElement, _AnnotationElement15);

        var _super35 = _createSuper(StrikeOutAnnotationElement);

        function StrikeOutAnnotationElement(parameters) {
          _classCallCheck(this, StrikeOutAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          return _super35.call(this, parameters, isRenderable, true);
        }

        _createClass(StrikeOutAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "strikeoutAnnotation";

            if (!this.data.hasPopup) {
              this._createPopup(this.container, null, this.data);
            }

            return this.container;
          }
        }]);

        return StrikeOutAnnotationElement;
      }(AnnotationElement);

      var StampAnnotationElement = function (_AnnotationElement16) {
        _inherits(StampAnnotationElement, _AnnotationElement16);

        var _super36 = _createSuper(StampAnnotationElement);

        function StampAnnotationElement(parameters) {
          _classCallCheck(this, StampAnnotationElement);

          var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
          return _super36.call(this, parameters, isRenderable, true);
        }

        _createClass(StampAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "stampAnnotation";

            if (!this.data.hasPopup) {
              this._createPopup(this.container, null, this.data);
            }

            return this.container;
          }
        }]);

        return StampAnnotationElement;
      }(AnnotationElement);

      var FileAttachmentAnnotationElement = function (_AnnotationElement17) {
        _inherits(FileAttachmentAnnotationElement, _AnnotationElement17);

        var _super37 = _createSuper(FileAttachmentAnnotationElement);

        function FileAttachmentAnnotationElement(parameters) {
          var _this39;

          _classCallCheck(this, FileAttachmentAnnotationElement);

          _this39 = _super37.call(this, parameters, true);
          var _this39$data$file = _this39.data.file,
              filename = _this39$data$file.filename,
              content = _this39$data$file.content;
          _this39.filename = (0, _display_utils.getFilenameFromUrl)(filename);
          _this39.content = content;

          if (_this39.linkService.eventBus) {
            _this39.linkService.eventBus.dispatch("fileattachmentannotation", {
              source: _assertThisInitialized(_this39),
              id: (0, _util.stringToPDFString)(filename),
              filename: filename,
              content: content
            });
          }

          return _this39;
        }

        _createClass(FileAttachmentAnnotationElement, [{
          key: "render",
          value: function render() {
            this.container.className = "fileAttachmentAnnotation";
            var trigger = document.createElement("div");
            trigger.style.height = this.container.style.height;
            trigger.style.width = this.container.style.width;
            trigger.addEventListener("dblclick", this._download.bind(this));

            if (!this.data.hasPopup && (this.data.title || this.data.contents)) {
              this._createPopup(this.container, trigger, this.data);
            }

            this.container.appendChild(trigger);
            return this.container;
          }
        }, {
          key: "_download",
          value: function _download() {
            if (!this.downloadManager) {
              (0, _util.warn)("Download cannot be started due to unavailable download manager");
              return;
            }

            this.downloadManager.downloadData(this.content, this.filename, "");
          }
        }]);

        return FileAttachmentAnnotationElement;
      }(AnnotationElement);

      var AnnotationLayer = function () {
        function AnnotationLayer() {
          _classCallCheck(this, AnnotationLayer);
        }

        _createClass(AnnotationLayer, null, [{
          key: "render",
          value: function render(parameters) {
            var sortedAnnotations = [],
                popupAnnotations = [];

            var _iterator26 = _createForOfIteratorHelper(parameters.annotations),
                _step26;

            try {
              for (_iterator26.s(); !(_step26 = _iterator26.n()).done;) {
                var _data3 = _step26.value;

                if (!_data3) {
                  continue;
                }

                if (_data3.annotationType === _util.AnnotationType.POPUP) {
                  popupAnnotations.push(_data3);
                  continue;
                }

                sortedAnnotations.push(_data3);
              }
            } catch (err) {
              _iterator26.e(err);
            } finally {
              _iterator26.f();
            }

            if (popupAnnotations.length) {
              sortedAnnotations.push.apply(sortedAnnotations, popupAnnotations);
            }

            for (var _i6 = 0, _sortedAnnotations = sortedAnnotations; _i6 < _sortedAnnotations.length; _i6++) {
              var data = _sortedAnnotations[_i6];
              var element = AnnotationElementFactory.create({
                data: data,
                layer: parameters.div,
                page: parameters.page,
                viewport: parameters.viewport,
                linkService: parameters.linkService,
                downloadManager: parameters.downloadManager,
                imageResourcesPath: parameters.imageResourcesPath || "",
                renderInteractiveForms: typeof parameters.renderInteractiveForms === "boolean" ? parameters.renderInteractiveForms : true,
                svgFactory: new _display_utils.DOMSVGFactory(),
                annotationStorage: parameters.annotationStorage || new _annotation_storage.AnnotationStorage()
              });

              if (element.isRenderable) {
                parameters.div.appendChild(element.render());
              }
            }
          }
        }, {
          key: "update",
          value: function update(parameters) {
            var _iterator27 = _createForOfIteratorHelper(parameters.annotations),
                _step27;

            try {
              for (_iterator27.s(); !(_step27 = _iterator27.n()).done;) {
                var data = _step27.value;
                var element = parameters.div.querySelector("[data-annotation-id=\"".concat(data.id, "\"]"));

                if (element) {
                  element.style.transform = "matrix(".concat(parameters.viewport.transform.join(","), ")");
                }
              }
            } catch (err) {
              _iterator27.e(err);
            } finally {
              _iterator27.f();
            }

            parameters.div.removeAttribute("hidden");
          }
        }]);

        return AnnotationLayer;
      }();

      exports.AnnotationLayer = AnnotationLayer;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.renderTextLayer = void 0;

      var _util = __w_pdfjs_require__(2);

      var renderTextLayer = function renderTextLayerClosure() {
        var MAX_TEXT_DIVS_TO_RENDER = 100000;
        var NonWhitespaceRegexp = /\S/;

        function isAllWhitespace(str) {
          return !NonWhitespaceRegexp.test(str);
        }

        function appendText(task, geom, styles) {
          var textDiv = document.createElement("span");
          var textDivProperties = {
            angle: 0,
            canvasWidth: 0,
            isWhitespace: false,
            originalTransform: null,
            paddingBottom: 0,
            paddingLeft: 0,
            paddingRight: 0,
            paddingTop: 0,
            scale: 1
          };

          task._textDivs.push(textDiv);

          if (isAllWhitespace(geom.str)) {
            textDivProperties.isWhitespace = true;

            task._textDivProperties.set(textDiv, textDivProperties);

            return;
          }

          var tx = _util.Util.transform(task._viewport.transform, geom.transform);

          var angle = Math.atan2(tx[1], tx[0]);
          var style = styles[geom.fontName];

          if (style.vertical) {
            angle += Math.PI / 2;
          }

          var fontHeight = Math.sqrt(tx[2] * tx[2] + tx[3] * tx[3]);
          var fontAscent = fontHeight;

          if (style.ascent) {
            fontAscent = style.ascent * fontAscent;
          } else if (style.descent) {
            fontAscent = (1 + style.descent) * fontAscent;
          }

          var left, top;

          if (angle === 0) {
            left = tx[4];
            top = tx[5] - fontAscent;
          } else {
            left = tx[4] + fontAscent * Math.sin(angle);
            top = tx[5] - fontAscent * Math.cos(angle);
          }

          textDiv.style.left = "".concat(left, "px");
          textDiv.style.top = "".concat(top, "px");
          textDiv.style.fontSize = "".concat(fontHeight, "px");
          textDiv.style.fontFamily = style.fontFamily;
          textDiv.textContent = geom.str;

          if (task._fontInspectorEnabled) {
            textDiv.dataset.fontName = geom.fontName;
          }

          if (angle !== 0) {
            textDivProperties.angle = angle * (180 / Math.PI);
          }

          var shouldScaleText = false;

          if (geom.str.length > 1) {
            shouldScaleText = true;
          } else if (geom.transform[0] !== geom.transform[3]) {
            var absScaleX = Math.abs(geom.transform[0]),
                absScaleY = Math.abs(geom.transform[3]);

            if (absScaleX !== absScaleY && Math.max(absScaleX, absScaleY) / Math.min(absScaleX, absScaleY) > 1.5) {
              shouldScaleText = true;
            }
          }

          if (shouldScaleText) {
            if (style.vertical) {
              textDivProperties.canvasWidth = geom.height * task._viewport.scale;
            } else {
              textDivProperties.canvasWidth = geom.width * task._viewport.scale;
            }
          }

          task._textDivProperties.set(textDiv, textDivProperties);

          if (task._textContentStream) {
            task._layoutText(textDiv);
          }

          if (task._enhanceTextSelection) {
            var angleCos = 1,
                angleSin = 0;

            if (angle !== 0) {
              angleCos = Math.cos(angle);
              angleSin = Math.sin(angle);
            }

            var divWidth = (style.vertical ? geom.height : geom.width) * task._viewport.scale;
            var divHeight = fontHeight;
            var m, b;

            if (angle !== 0) {
              m = [angleCos, angleSin, -angleSin, angleCos, left, top];
              b = _util.Util.getAxialAlignedBoundingBox([0, 0, divWidth, divHeight], m);
            } else {
              b = [left, top, left + divWidth, top + divHeight];
            }

            task._bounds.push({
              left: b[0],
              top: b[1],
              right: b[2],
              bottom: b[3],
              div: textDiv,
              size: [divWidth, divHeight],
              m: m
            });
          }
        }

        function render(task) {
          if (task._canceled) {
            return;
          }

          var textDivs = task._textDivs;
          var capability = task._capability;
          var textDivsLength = textDivs.length;

          if (textDivsLength > MAX_TEXT_DIVS_TO_RENDER) {
            task._renderingDone = true;
            capability.resolve();
            return;
          }

          if (!task._textContentStream) {
            for (var i = 0; i < textDivsLength; i++) {
              task._layoutText(textDivs[i]);
            }
          }

          task._renderingDone = true;
          capability.resolve();
        }

        function findPositiveMin(ts, offset, count) {
          var result = 0;

          for (var i = 0; i < count; i++) {
            var t = ts[offset++];

            if (t > 0) {
              result = result ? Math.min(t, result) : t;
            }
          }

          return result;
        }

        function expand(task) {
          var bounds = task._bounds;
          var viewport = task._viewport;
          var expanded = expandBounds(viewport.width, viewport.height, bounds);

          for (var i = 0; i < expanded.length; i++) {
            var div = bounds[i].div;

            var divProperties = task._textDivProperties.get(div);

            if (divProperties.angle === 0) {
              divProperties.paddingLeft = bounds[i].left - expanded[i].left;
              divProperties.paddingTop = bounds[i].top - expanded[i].top;
              divProperties.paddingRight = expanded[i].right - bounds[i].right;
              divProperties.paddingBottom = expanded[i].bottom - bounds[i].bottom;

              task._textDivProperties.set(div, divProperties);

              continue;
            }

            var e = expanded[i],
                b = bounds[i];
            var m = b.m,
                c = m[0],
                s = m[1];
            var points = [[0, 0], [0, b.size[1]], [b.size[0], 0], b.size];
            var ts = new Float64Array(64);
            points.forEach(function (p, j) {
              var t = _util.Util.applyTransform(p, m);

              ts[j + 0] = c && (e.left - t[0]) / c;
              ts[j + 4] = s && (e.top - t[1]) / s;
              ts[j + 8] = c && (e.right - t[0]) / c;
              ts[j + 12] = s && (e.bottom - t[1]) / s;
              ts[j + 16] = s && (e.left - t[0]) / -s;
              ts[j + 20] = c && (e.top - t[1]) / c;
              ts[j + 24] = s && (e.right - t[0]) / -s;
              ts[j + 28] = c && (e.bottom - t[1]) / c;
              ts[j + 32] = c && (e.left - t[0]) / -c;
              ts[j + 36] = s && (e.top - t[1]) / -s;
              ts[j + 40] = c && (e.right - t[0]) / -c;
              ts[j + 44] = s && (e.bottom - t[1]) / -s;
              ts[j + 48] = s && (e.left - t[0]) / s;
              ts[j + 52] = c && (e.top - t[1]) / -c;
              ts[j + 56] = s && (e.right - t[0]) / s;
              ts[j + 60] = c && (e.bottom - t[1]) / -c;
            });
            var boxScale = 1 + Math.min(Math.abs(c), Math.abs(s));
            divProperties.paddingLeft = findPositiveMin(ts, 32, 16) / boxScale;
            divProperties.paddingTop = findPositiveMin(ts, 48, 16) / boxScale;
            divProperties.paddingRight = findPositiveMin(ts, 0, 16) / boxScale;
            divProperties.paddingBottom = findPositiveMin(ts, 16, 16) / boxScale;

            task._textDivProperties.set(div, divProperties);
          }
        }

        function expandBounds(width, height, boxes) {
          var bounds = boxes.map(function (box, i) {
            return {
              x1: box.left,
              y1: box.top,
              x2: box.right,
              y2: box.bottom,
              index: i,
              x1New: undefined,
              x2New: undefined
            };
          });
          expandBoundsLTR(width, bounds);
          var expanded = new Array(boxes.length);
          bounds.forEach(function (b) {
            var i = b.index;
            expanded[i] = {
              left: b.x1New,
              top: 0,
              right: b.x2New,
              bottom: 0
            };
          });
          boxes.map(function (box, i) {
            var e = expanded[i],
                b = bounds[i];
            b.x1 = box.top;
            b.y1 = width - e.right;
            b.x2 = box.bottom;
            b.y2 = width - e.left;
            b.index = i;
            b.x1New = undefined;
            b.x2New = undefined;
          });
          expandBoundsLTR(height, bounds);
          bounds.forEach(function (b) {
            var i = b.index;
            expanded[i].top = b.x1New;
            expanded[i].bottom = b.x2New;
          });
          return expanded;
        }

        function expandBoundsLTR(width, bounds) {
          bounds.sort(function (a, b) {
            return a.x1 - b.x1 || a.index - b.index;
          });
          var fakeBoundary = {
            x1: -Infinity,
            y1: -Infinity,
            x2: 0,
            y2: Infinity,
            index: -1,
            x1New: 0,
            x2New: 0
          };
          var horizon = [{
            start: -Infinity,
            end: Infinity,
            boundary: fakeBoundary
          }];
          bounds.forEach(function (boundary) {
            var i = 0;

            while (i < horizon.length && horizon[i].end <= boundary.y1) {
              i++;
            }

            var j = horizon.length - 1;

            while (j >= 0 && horizon[j].start >= boundary.y2) {
              j--;
            }

            var horizonPart, affectedBoundary;
            var q,
                k,
                maxXNew = -Infinity;

            for (q = i; q <= j; q++) {
              horizonPart = horizon[q];
              affectedBoundary = horizonPart.boundary;
              var xNew;

              if (affectedBoundary.x2 > boundary.x1) {
                xNew = affectedBoundary.index > boundary.index ? affectedBoundary.x1New : boundary.x1;
              } else if (affectedBoundary.x2New === undefined) {
                xNew = (affectedBoundary.x2 + boundary.x1) / 2;
              } else {
                xNew = affectedBoundary.x2New;
              }

              if (xNew > maxXNew) {
                maxXNew = xNew;
              }
            }

            boundary.x1New = maxXNew;

            for (q = i; q <= j; q++) {
              horizonPart = horizon[q];
              affectedBoundary = horizonPart.boundary;

              if (affectedBoundary.x2New === undefined) {
                if (affectedBoundary.x2 > boundary.x1) {
                  if (affectedBoundary.index > boundary.index) {
                    affectedBoundary.x2New = affectedBoundary.x2;
                  }
                } else {
                  affectedBoundary.x2New = maxXNew;
                }
              } else if (affectedBoundary.x2New > maxXNew) {
                affectedBoundary.x2New = Math.max(maxXNew, affectedBoundary.x2);
              }
            }

            var changedHorizon = [],
                lastBoundary = null;

            for (q = i; q <= j; q++) {
              horizonPart = horizon[q];
              affectedBoundary = horizonPart.boundary;
              var useBoundary = affectedBoundary.x2 > boundary.x2 ? affectedBoundary : boundary;

              if (lastBoundary === useBoundary) {
                changedHorizon[changedHorizon.length - 1].end = horizonPart.end;
              } else {
                changedHorizon.push({
                  start: horizonPart.start,
                  end: horizonPart.end,
                  boundary: useBoundary
                });
                lastBoundary = useBoundary;
              }
            }

            if (horizon[i].start < boundary.y1) {
              changedHorizon[0].start = boundary.y1;
              changedHorizon.unshift({
                start: horizon[i].start,
                end: boundary.y1,
                boundary: horizon[i].boundary
              });
            }

            if (boundary.y2 < horizon[j].end) {
              changedHorizon[changedHorizon.length - 1].end = boundary.y2;
              changedHorizon.push({
                start: boundary.y2,
                end: horizon[j].end,
                boundary: horizon[j].boundary
              });
            }

            for (q = i; q <= j; q++) {
              horizonPart = horizon[q];
              affectedBoundary = horizonPart.boundary;

              if (affectedBoundary.x2New !== undefined) {
                continue;
              }

              var used = false;

              for (k = i - 1; !used && k >= 0 && horizon[k].start >= affectedBoundary.y1; k--) {
                used = horizon[k].boundary === affectedBoundary;
              }

              for (k = j + 1; !used && k < horizon.length && horizon[k].end <= affectedBoundary.y2; k++) {
                used = horizon[k].boundary === affectedBoundary;
              }

              for (k = 0; !used && k < changedHorizon.length; k++) {
                used = changedHorizon[k].boundary === affectedBoundary;
              }

              if (!used) {
                affectedBoundary.x2New = maxXNew;
              }
            }

            Array.prototype.splice.apply(horizon, [i, j - i + 1].concat(changedHorizon));
          });
          horizon.forEach(function (horizonPart) {
            var affectedBoundary = horizonPart.boundary;

            if (affectedBoundary.x2New === undefined) {
              affectedBoundary.x2New = Math.max(width, affectedBoundary.x2);
            }
          });
        }

        function TextLayerRenderTask(_ref35) {
          var _this40 = this;

          var textContent = _ref35.textContent,
              textContentStream = _ref35.textContentStream,
              container = _ref35.container,
              viewport = _ref35.viewport,
              textDivs = _ref35.textDivs,
              textContentItemsStr = _ref35.textContentItemsStr,
              enhanceTextSelection = _ref35.enhanceTextSelection;
          this._textContent = textContent;
          this._textContentStream = textContentStream;
          this._container = container;
          this._document = container.ownerDocument;
          this._viewport = viewport;
          this._textDivs = textDivs || [];
          this._textContentItemsStr = textContentItemsStr || [];
          this._enhanceTextSelection = !!enhanceTextSelection;
          this._fontInspectorEnabled = !!(globalThis.FontInspector && globalThis.FontInspector.enabled);
          this._reader = null;
          this._layoutTextLastFontSize = null;
          this._layoutTextLastFontFamily = null;
          this._layoutTextCtx = null;
          this._textDivProperties = new WeakMap();
          this._renderingDone = false;
          this._canceled = false;
          this._capability = (0, _util.createPromiseCapability)();
          this._renderTimer = null;
          this._bounds = [];

          this._capability.promise.finally(function () {
            if (_this40._layoutTextCtx) {
              _this40._layoutTextCtx.canvas.width = 0;
              _this40._layoutTextCtx.canvas.height = 0;
              _this40._layoutTextCtx = null;
            }
          }).catch(function () {});
        }

        TextLayerRenderTask.prototype = {
          get promise() {
            return this._capability.promise;
          },

          cancel: function TextLayer_cancel() {
            this._canceled = true;

            if (this._reader) {
              this._reader.cancel(new _util.AbortException("TextLayer task cancelled."));

              this._reader = null;
            }

            if (this._renderTimer !== null) {
              clearTimeout(this._renderTimer);
              this._renderTimer = null;
            }

            this._capability.reject(new Error("TextLayer task cancelled."));
          },
          _processItems: function _processItems(items, styleCache) {
            for (var i = 0, len = items.length; i < len; i++) {
              this._textContentItemsStr.push(items[i].str);

              appendText(this, items[i], styleCache);
            }
          },
          _layoutText: function _layoutText(textDiv) {
            var textDivProperties = this._textDivProperties.get(textDiv);

            if (textDivProperties.isWhitespace) {
              return;
            }

            var transform = "";

            if (textDivProperties.canvasWidth !== 0) {
              var _textDiv$style = textDiv.style,
                  fontSize = _textDiv$style.fontSize,
                  fontFamily = _textDiv$style.fontFamily;

              if (fontSize !== this._layoutTextLastFontSize || fontFamily !== this._layoutTextLastFontFamily) {
                this._layoutTextCtx.font = "".concat(fontSize, " ").concat(fontFamily);
                this._layoutTextLastFontSize = fontSize;
                this._layoutTextLastFontFamily = fontFamily;
              }

              var _this$_layoutTextCtx$ = this._layoutTextCtx.measureText(textDiv.textContent),
                  width = _this$_layoutTextCtx$.width;

              if (width > 0) {
                textDivProperties.scale = textDivProperties.canvasWidth / width;
                transform = "scaleX(".concat(textDivProperties.scale, ")");
              }
            }

            if (textDivProperties.angle !== 0) {
              transform = "rotate(".concat(textDivProperties.angle, "deg) ").concat(transform);
            }

            if (transform.length > 0) {
              if (this._enhanceTextSelection) {
                textDivProperties.originalTransform = transform;
              }

              textDiv.style.transform = transform;
            }

            this._textDivProperties.set(textDiv, textDivProperties);

            this._container.appendChild(textDiv);
          },
          _render: function TextLayer_render(timeout) {
            var _this41 = this;

            var capability = (0, _util.createPromiseCapability)();
            var styleCache = Object.create(null);

            var canvas = this._document.createElement("canvas");

            canvas.mozOpaque = true;
            this._layoutTextCtx = canvas.getContext("2d", {
              alpha: false
            });

            if (this._textContent) {
              var textItems = this._textContent.items;
              var textStyles = this._textContent.styles;

              this._processItems(textItems, textStyles);

              capability.resolve();
            } else if (this._textContentStream) {
              var pump = function pump() {
                _this41._reader.read().then(function (_ref36) {
                  var value = _ref36.value,
                      done = _ref36.done;

                  if (done) {
                    capability.resolve();
                    return;
                  }

                  Object.assign(styleCache, value.styles);

                  _this41._processItems(value.items, styleCache);

                  pump();
                }, capability.reject);
              };

              this._reader = this._textContentStream.getReader();
              pump();
            } else {
              throw new Error('Neither "textContent" nor "textContentStream"' + " parameters specified.");
            }

            capability.promise.then(function () {
              styleCache = null;

              if (!timeout) {
                render(_this41);
              } else {
                _this41._renderTimer = setTimeout(function () {
                  render(_this41);
                  _this41._renderTimer = null;
                }, timeout);
              }
            }, this._capability.reject);
          },
          expandTextDivs: function TextLayer_expandTextDivs(expandDivs) {
            if (!this._enhanceTextSelection || !this._renderingDone) {
              return;
            }

            if (this._bounds !== null) {
              expand(this);
              this._bounds = null;
            }

            var transformBuf = [],
                paddingBuf = [];

            for (var i = 0, ii = this._textDivs.length; i < ii; i++) {
              var div = this._textDivs[i];

              var divProps = this._textDivProperties.get(div);

              if (divProps.isWhitespace) {
                continue;
              }

              if (expandDivs) {
                transformBuf.length = 0;
                paddingBuf.length = 0;

                if (divProps.originalTransform) {
                  transformBuf.push(divProps.originalTransform);
                }

                if (divProps.paddingTop > 0) {
                  paddingBuf.push("".concat(divProps.paddingTop, "px"));
                  transformBuf.push("translateY(".concat(-divProps.paddingTop, "px)"));
                } else {
                  paddingBuf.push(0);
                }

                if (divProps.paddingRight > 0) {
                  paddingBuf.push("".concat(divProps.paddingRight / divProps.scale, "px"));
                } else {
                  paddingBuf.push(0);
                }

                if (divProps.paddingBottom > 0) {
                  paddingBuf.push("".concat(divProps.paddingBottom, "px"));
                } else {
                  paddingBuf.push(0);
                }

                if (divProps.paddingLeft > 0) {
                  paddingBuf.push("".concat(divProps.paddingLeft / divProps.scale, "px"));
                  transformBuf.push("translateX(".concat(-divProps.paddingLeft / divProps.scale, "px)"));
                } else {
                  paddingBuf.push(0);
                }

                div.style.padding = paddingBuf.join(" ");

                if (transformBuf.length) {
                  div.style.transform = transformBuf.join(" ");
                }
              } else {
                div.style.padding = null;
                div.style.transform = divProps.originalTransform;
              }
            }
          }
        };

        function renderTextLayer(renderParameters) {
          var task = new TextLayerRenderTask({
            textContent: renderParameters.textContent,
            textContentStream: renderParameters.textContentStream,
            container: renderParameters.container,
            viewport: renderParameters.viewport,
            textDivs: renderParameters.textDivs,
            textContentItemsStr: renderParameters.textContentItemsStr,
            enhanceTextSelection: renderParameters.enhanceTextSelection
          });

          task._render(renderParameters.timeout);

          return task;
        }

        return renderTextLayer;
      }();

      exports.renderTextLayer = renderTextLayer;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.SVGGraphics = void 0;

      var _util = __w_pdfjs_require__(2);

      var _display_utils = __w_pdfjs_require__(1);

      var _is_node = __w_pdfjs_require__(4);

      var SVGGraphics = function SVGGraphics() {
        throw new Error("Not implemented: SVGGraphics");
      };

      exports.SVGGraphics = SVGGraphics;
      {
        var SVG_DEFAULTS = {
          fontStyle: "normal",
          fontWeight: "normal",
          fillColor: "#000000"
        };
        var XML_NS = "http://www.w3.org/XML/1998/namespace";
        var XLINK_NS = "http://www.w3.org/1999/xlink";
        var LINE_CAP_STYLES = ["butt", "round", "square"];
        var LINE_JOIN_STYLES = ["miter", "round", "bevel"];

        var convertImgDataToPng = function () {
          var PNG_HEADER = new Uint8Array([0x89, 0x50, 0x4e, 0x47, 0x0d, 0x0a, 0x1a, 0x0a]);
          var CHUNK_WRAPPER_SIZE = 12;
          var crcTable = new Int32Array(256);

          for (var i = 0; i < 256; i++) {
            var c = i;

            for (var h = 0; h < 8; h++) {
              if (c & 1) {
                c = 0xedb88320 ^ c >> 1 & 0x7fffffff;
              } else {
                c = c >> 1 & 0x7fffffff;
              }
            }

            crcTable[i] = c;
          }

          function crc32(data, start, end) {
            var crc = -1;

            for (var _i7 = start; _i7 < end; _i7++) {
              var a = (crc ^ data[_i7]) & 0xff;
              var b = crcTable[a];
              crc = crc >>> 8 ^ b;
            }

            return crc ^ -1;
          }

          function writePngChunk(type, body, data, offset) {
            var p = offset;
            var len = body.length;
            data[p] = len >> 24 & 0xff;
            data[p + 1] = len >> 16 & 0xff;
            data[p + 2] = len >> 8 & 0xff;
            data[p + 3] = len & 0xff;
            p += 4;
            data[p] = type.charCodeAt(0) & 0xff;
            data[p + 1] = type.charCodeAt(1) & 0xff;
            data[p + 2] = type.charCodeAt(2) & 0xff;
            data[p + 3] = type.charCodeAt(3) & 0xff;
            p += 4;
            data.set(body, p);
            p += body.length;
            var crc = crc32(data, offset + 4, p);
            data[p] = crc >> 24 & 0xff;
            data[p + 1] = crc >> 16 & 0xff;
            data[p + 2] = crc >> 8 & 0xff;
            data[p + 3] = crc & 0xff;
          }

          function adler32(data, start, end) {
            var a = 1;
            var b = 0;

            for (var _i8 = start; _i8 < end; ++_i8) {
              a = (a + (data[_i8] & 0xff)) % 65521;
              b = (b + a) % 65521;
            }

            return b << 16 | a;
          }

          function deflateSync(literals) {
            if (!_is_node.isNodeJS) {
              return deflateSyncUncompressed(literals);
            }

            try {
              var input;

              if (parseInt(process.versions.node) >= 8) {
                input = literals;
              } else {
                input = Buffer.from(literals);
              }

              var output = require$$5.deflateSync(input, {
                level: 9
              });
              return output instanceof Uint8Array ? output : new Uint8Array(output);
            } catch (e) {
              (0, _util.warn)("Not compressing PNG because zlib.deflateSync is unavailable: " + e);
            }

            return deflateSyncUncompressed(literals);
          }

          function deflateSyncUncompressed(literals) {
            var len = literals.length;
            var maxBlockLength = 0xffff;
            var deflateBlocks = Math.ceil(len / maxBlockLength);
            var idat = new Uint8Array(2 + len + deflateBlocks * 5 + 4);
            var pi = 0;
            idat[pi++] = 0x78;
            idat[pi++] = 0x9c;
            var pos = 0;

            while (len > maxBlockLength) {
              idat[pi++] = 0x00;
              idat[pi++] = 0xff;
              idat[pi++] = 0xff;
              idat[pi++] = 0x00;
              idat[pi++] = 0x00;
              idat.set(literals.subarray(pos, pos + maxBlockLength), pi);
              pi += maxBlockLength;
              pos += maxBlockLength;
              len -= maxBlockLength;
            }

            idat[pi++] = 0x01;
            idat[pi++] = len & 0xff;
            idat[pi++] = len >> 8 & 0xff;
            idat[pi++] = ~len & 0xffff & 0xff;
            idat[pi++] = (~len & 0xffff) >> 8 & 0xff;
            idat.set(literals.subarray(pos), pi);
            pi += literals.length - pos;
            var adler = adler32(literals, 0, literals.length);
            idat[pi++] = adler >> 24 & 0xff;
            idat[pi++] = adler >> 16 & 0xff;
            idat[pi++] = adler >> 8 & 0xff;
            idat[pi++] = adler & 0xff;
            return idat;
          }

          function encode(imgData, kind, forceDataSchema, isMask) {
            var width = imgData.width;
            var height = imgData.height;
            var bitDepth, colorType, lineSize;
            var bytes = imgData.data;

            switch (kind) {
              case _util.ImageKind.GRAYSCALE_1BPP:
                colorType = 0;
                bitDepth = 1;
                lineSize = width + 7 >> 3;
                break;

              case _util.ImageKind.RGB_24BPP:
                colorType = 2;
                bitDepth = 8;
                lineSize = width * 3;
                break;

              case _util.ImageKind.RGBA_32BPP:
                colorType = 6;
                bitDepth = 8;
                lineSize = width * 4;
                break;

              default:
                throw new Error("invalid format");
            }

            var literals = new Uint8Array((1 + lineSize) * height);
            var offsetLiterals = 0,
                offsetBytes = 0;

            for (var y = 0; y < height; ++y) {
              literals[offsetLiterals++] = 0;
              literals.set(bytes.subarray(offsetBytes, offsetBytes + lineSize), offsetLiterals);
              offsetBytes += lineSize;
              offsetLiterals += lineSize;
            }

            if (kind === _util.ImageKind.GRAYSCALE_1BPP && isMask) {
              offsetLiterals = 0;

              for (var _y = 0; _y < height; _y++) {
                offsetLiterals++;

                for (var _i9 = 0; _i9 < lineSize; _i9++) {
                  literals[offsetLiterals++] ^= 0xff;
                }
              }
            }

            var ihdr = new Uint8Array([width >> 24 & 0xff, width >> 16 & 0xff, width >> 8 & 0xff, width & 0xff, height >> 24 & 0xff, height >> 16 & 0xff, height >> 8 & 0xff, height & 0xff, bitDepth, colorType, 0x00, 0x00, 0x00]);
            var idat = deflateSync(literals);
            var pngLength = PNG_HEADER.length + CHUNK_WRAPPER_SIZE * 3 + ihdr.length + idat.length;
            var data = new Uint8Array(pngLength);
            var offset = 0;
            data.set(PNG_HEADER, offset);
            offset += PNG_HEADER.length;
            writePngChunk("IHDR", ihdr, data, offset);
            offset += CHUNK_WRAPPER_SIZE + ihdr.length;
            writePngChunk("IDATA", idat, data, offset);
            offset += CHUNK_WRAPPER_SIZE + idat.length;
            writePngChunk("IEND", new Uint8Array(0), data, offset);
            return (0, _util.createObjectURL)(data, "image/png", forceDataSchema);
          }

          return function convertImgDataToPng(imgData, forceDataSchema, isMask) {
            var kind = imgData.kind === undefined ? _util.ImageKind.GRAYSCALE_1BPP : imgData.kind;
            return encode(imgData, kind, forceDataSchema, isMask);
          };
        }();

        var SVGExtraState = function () {
          function SVGExtraState() {
            _classCallCheck(this, SVGExtraState);

            this.fontSizeScale = 1;
            this.fontWeight = SVG_DEFAULTS.fontWeight;
            this.fontSize = 0;
            this.textMatrix = _util.IDENTITY_MATRIX;
            this.fontMatrix = _util.FONT_IDENTITY_MATRIX;
            this.leading = 0;
            this.textRenderingMode = _util.TextRenderingMode.FILL;
            this.textMatrixScale = 1;
            this.x = 0;
            this.y = 0;
            this.lineX = 0;
            this.lineY = 0;
            this.charSpacing = 0;
            this.wordSpacing = 0;
            this.textHScale = 1;
            this.textRise = 0;
            this.fillColor = SVG_DEFAULTS.fillColor;
            this.strokeColor = "#000000";
            this.fillAlpha = 1;
            this.strokeAlpha = 1;
            this.lineWidth = 1;
            this.lineJoin = "";
            this.lineCap = "";
            this.miterLimit = 0;
            this.dashArray = [];
            this.dashPhase = 0;
            this.dependencies = [];
            this.activeClipUrl = null;
            this.clipGroup = null;
            this.maskId = "";
          }

          _createClass(SVGExtraState, [{
            key: "clone",
            value: function clone() {
              return Object.create(this);
            }
          }, {
            key: "setCurrentPoint",
            value: function setCurrentPoint(x, y) {
              this.x = x;
              this.y = y;
            }
          }]);

          return SVGExtraState;
        }();

        function opListToTree(opList) {
          var opTree = [];
          var tmp = [];

          var _iterator28 = _createForOfIteratorHelper(opList),
              _step28;

          try {
            for (_iterator28.s(); !(_step28 = _iterator28.n()).done;) {
              var opListElement = _step28.value;

              if (opListElement.fn === "save") {
                opTree.push({
                  fnId: 92,
                  fn: "group",
                  items: []
                });
                tmp.push(opTree);
                opTree = opTree[opTree.length - 1].items;
                continue;
              }

              if (opListElement.fn === "restore") {
                opTree = tmp.pop();
              } else {
                opTree.push(opListElement);
              }
            }
          } catch (err) {
            _iterator28.e(err);
          } finally {
            _iterator28.f();
          }

          return opTree;
        }

        function pf(value) {
          if (Number.isInteger(value)) {
            return value.toString();
          }

          var s = value.toFixed(10);
          var i = s.length - 1;

          if (s[i] !== "0") {
            return s;
          }

          do {
            i--;
          } while (s[i] === "0");

          return s.substring(0, s[i] === "." ? i : i + 1);
        }

        function pm(m) {
          if (m[4] === 0 && m[5] === 0) {
            if (m[1] === 0 && m[2] === 0) {
              if (m[0] === 1 && m[3] === 1) {
                return "";
              }

              return "scale(".concat(pf(m[0]), " ").concat(pf(m[3]), ")");
            }

            if (m[0] === m[3] && m[1] === -m[2]) {
              var a = Math.acos(m[0]) * 180 / Math.PI;
              return "rotate(".concat(pf(a), ")");
            }
          } else {
            if (m[0] === 1 && m[1] === 0 && m[2] === 0 && m[3] === 1) {
              return "translate(".concat(pf(m[4]), " ").concat(pf(m[5]), ")");
            }
          }

          return "matrix(".concat(pf(m[0]), " ").concat(pf(m[1]), " ").concat(pf(m[2]), " ").concat(pf(m[3]), " ").concat(pf(m[4]), " ") + "".concat(pf(m[5]), ")");
        }

        var clipCount = 0;
        var maskCount = 0;
        var shadingCount = 0;

        exports.SVGGraphics = SVGGraphics = function () {
          function SVGGraphics(commonObjs, objs) {
            var forceDataSchema = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

            _classCallCheck(this, SVGGraphics);

            this.svgFactory = new _display_utils.DOMSVGFactory();
            this.current = new SVGExtraState();
            this.transformMatrix = _util.IDENTITY_MATRIX;
            this.transformStack = [];
            this.extraStack = [];
            this.commonObjs = commonObjs;
            this.objs = objs;
            this.pendingClip = null;
            this.pendingEOFill = false;
            this.embedFonts = false;
            this.embeddedFonts = Object.create(null);
            this.cssStyle = null;
            this.forceDataSchema = !!forceDataSchema;
            this._operatorIdMapping = [];

            for (var op in _util.OPS) {
              this._operatorIdMapping[_util.OPS[op]] = op;
            }
          }

          _createClass(SVGGraphics, [{
            key: "save",
            value: function save() {
              this.transformStack.push(this.transformMatrix);
              var old = this.current;
              this.extraStack.push(old);
              this.current = old.clone();
            }
          }, {
            key: "restore",
            value: function restore() {
              this.transformMatrix = this.transformStack.pop();
              this.current = this.extraStack.pop();
              this.pendingClip = null;
              this.tgrp = null;
            }
          }, {
            key: "group",
            value: function group(items) {
              this.save();
              this.executeOpTree(items);
              this.restore();
            }
          }, {
            key: "loadDependencies",
            value: function loadDependencies(operatorList) {
              var _this42 = this;

              var fnArray = operatorList.fnArray;
              var argsArray = operatorList.argsArray;

              for (var i = 0, ii = fnArray.length; i < ii; i++) {
                if (fnArray[i] !== _util.OPS.dependency) {
                  continue;
                }

                var _iterator29 = _createForOfIteratorHelper(argsArray[i]),
                    _step29;

                try {
                  var _loop = function _loop() {
                    var obj = _step29.value;
                    var objsPool = obj.startsWith("g_") ? _this42.commonObjs : _this42.objs;
                    var promise = new Promise(function (resolve) {
                      objsPool.get(obj, resolve);
                    });

                    _this42.current.dependencies.push(promise);
                  };

                  for (_iterator29.s(); !(_step29 = _iterator29.n()).done;) {
                    _loop();
                  }
                } catch (err) {
                  _iterator29.e(err);
                } finally {
                  _iterator29.f();
                }
              }

              return Promise.all(this.current.dependencies);
            }
          }, {
            key: "transform",
            value: function transform(a, b, c, d, e, f) {
              var transformMatrix = [a, b, c, d, e, f];
              this.transformMatrix = _util.Util.transform(this.transformMatrix, transformMatrix);
              this.tgrp = null;
            }
          }, {
            key: "getSVG",
            value: function getSVG(operatorList, viewport) {
              var _this43 = this;

              this.viewport = viewport;

              var svgElement = this._initialize(viewport);

              return this.loadDependencies(operatorList).then(function () {
                _this43.transformMatrix = _util.IDENTITY_MATRIX;

                _this43.executeOpTree(_this43.convertOpList(operatorList));

                return svgElement;
              });
            }
          }, {
            key: "convertOpList",
            value: function convertOpList(operatorList) {
              var operatorIdMapping = this._operatorIdMapping;
              var argsArray = operatorList.argsArray;
              var fnArray = operatorList.fnArray;
              var opList = [];

              for (var i = 0, ii = fnArray.length; i < ii; i++) {
                var fnId = fnArray[i];
                opList.push({
                  fnId: fnId,
                  fn: operatorIdMapping[fnId],
                  args: argsArray[i]
                });
              }

              return opListToTree(opList);
            }
          }, {
            key: "executeOpTree",
            value: function executeOpTree(opTree) {
              var _iterator30 = _createForOfIteratorHelper(opTree),
                  _step30;

              try {
                for (_iterator30.s(); !(_step30 = _iterator30.n()).done;) {
                  var opTreeElement = _step30.value;
                  var fn = opTreeElement.fn;
                  var fnId = opTreeElement.fnId;
                  var args = opTreeElement.args;

                  switch (fnId | 0) {
                    case _util.OPS.beginText:
                      this.beginText();
                      break;

                    case _util.OPS.dependency:
                      break;

                    case _util.OPS.setLeading:
                      this.setLeading(args);
                      break;

                    case _util.OPS.setLeadingMoveText:
                      this.setLeadingMoveText(args[0], args[1]);
                      break;

                    case _util.OPS.setFont:
                      this.setFont(args);
                      break;

                    case _util.OPS.showText:
                      this.showText(args[0]);
                      break;

                    case _util.OPS.showSpacedText:
                      this.showText(args[0]);
                      break;

                    case _util.OPS.endText:
                      this.endText();
                      break;

                    case _util.OPS.moveText:
                      this.moveText(args[0], args[1]);
                      break;

                    case _util.OPS.setCharSpacing:
                      this.setCharSpacing(args[0]);
                      break;

                    case _util.OPS.setWordSpacing:
                      this.setWordSpacing(args[0]);
                      break;

                    case _util.OPS.setHScale:
                      this.setHScale(args[0]);
                      break;

                    case _util.OPS.setTextMatrix:
                      this.setTextMatrix(args[0], args[1], args[2], args[3], args[4], args[5]);
                      break;

                    case _util.OPS.setTextRise:
                      this.setTextRise(args[0]);
                      break;

                    case _util.OPS.setTextRenderingMode:
                      this.setTextRenderingMode(args[0]);
                      break;

                    case _util.OPS.setLineWidth:
                      this.setLineWidth(args[0]);
                      break;

                    case _util.OPS.setLineJoin:
                      this.setLineJoin(args[0]);
                      break;

                    case _util.OPS.setLineCap:
                      this.setLineCap(args[0]);
                      break;

                    case _util.OPS.setMiterLimit:
                      this.setMiterLimit(args[0]);
                      break;

                    case _util.OPS.setFillRGBColor:
                      this.setFillRGBColor(args[0], args[1], args[2]);
                      break;

                    case _util.OPS.setStrokeRGBColor:
                      this.setStrokeRGBColor(args[0], args[1], args[2]);
                      break;

                    case _util.OPS.setStrokeColorN:
                      this.setStrokeColorN(args);
                      break;

                    case _util.OPS.setFillColorN:
                      this.setFillColorN(args);
                      break;

                    case _util.OPS.shadingFill:
                      this.shadingFill(args[0]);
                      break;

                    case _util.OPS.setDash:
                      this.setDash(args[0], args[1]);
                      break;

                    case _util.OPS.setRenderingIntent:
                      this.setRenderingIntent(args[0]);
                      break;

                    case _util.OPS.setFlatness:
                      this.setFlatness(args[0]);
                      break;

                    case _util.OPS.setGState:
                      this.setGState(args[0]);
                      break;

                    case _util.OPS.fill:
                      this.fill();
                      break;

                    case _util.OPS.eoFill:
                      this.eoFill();
                      break;

                    case _util.OPS.stroke:
                      this.stroke();
                      break;

                    case _util.OPS.fillStroke:
                      this.fillStroke();
                      break;

                    case _util.OPS.eoFillStroke:
                      this.eoFillStroke();
                      break;

                    case _util.OPS.clip:
                      this.clip("nonzero");
                      break;

                    case _util.OPS.eoClip:
                      this.clip("evenodd");
                      break;

                    case _util.OPS.paintSolidColorImageMask:
                      this.paintSolidColorImageMask();
                      break;

                    case _util.OPS.paintImageXObject:
                      this.paintImageXObject(args[0]);
                      break;

                    case _util.OPS.paintInlineImageXObject:
                      this.paintInlineImageXObject(args[0]);
                      break;

                    case _util.OPS.paintImageMaskXObject:
                      this.paintImageMaskXObject(args[0]);
                      break;

                    case _util.OPS.paintFormXObjectBegin:
                      this.paintFormXObjectBegin(args[0], args[1]);
                      break;

                    case _util.OPS.paintFormXObjectEnd:
                      this.paintFormXObjectEnd();
                      break;

                    case _util.OPS.closePath:
                      this.closePath();
                      break;

                    case _util.OPS.closeStroke:
                      this.closeStroke();
                      break;

                    case _util.OPS.closeFillStroke:
                      this.closeFillStroke();
                      break;

                    case _util.OPS.closeEOFillStroke:
                      this.closeEOFillStroke();
                      break;

                    case _util.OPS.nextLine:
                      this.nextLine();
                      break;

                    case _util.OPS.transform:
                      this.transform(args[0], args[1], args[2], args[3], args[4], args[5]);
                      break;

                    case _util.OPS.constructPath:
                      this.constructPath(args[0], args[1]);
                      break;

                    case _util.OPS.endPath:
                      this.endPath();
                      break;

                    case 92:
                      this.group(opTreeElement.items);
                      break;

                    default:
                      (0, _util.warn)("Unimplemented operator ".concat(fn));
                      break;
                  }
                }
              } catch (err) {
                _iterator30.e(err);
              } finally {
                _iterator30.f();
              }
            }
          }, {
            key: "setWordSpacing",
            value: function setWordSpacing(wordSpacing) {
              this.current.wordSpacing = wordSpacing;
            }
          }, {
            key: "setCharSpacing",
            value: function setCharSpacing(charSpacing) {
              this.current.charSpacing = charSpacing;
            }
          }, {
            key: "nextLine",
            value: function nextLine() {
              this.moveText(0, this.current.leading);
            }
          }, {
            key: "setTextMatrix",
            value: function setTextMatrix(a, b, c, d, e, f) {
              var current = this.current;
              current.textMatrix = current.lineMatrix = [a, b, c, d, e, f];
              current.textMatrixScale = Math.sqrt(a * a + b * b);
              current.x = current.lineX = 0;
              current.y = current.lineY = 0;
              current.xcoords = [];
              current.ycoords = [];
              current.tspan = this.svgFactory.createElement("svg:tspan");
              current.tspan.setAttributeNS(null, "font-family", current.fontFamily);
              current.tspan.setAttributeNS(null, "font-size", "".concat(pf(current.fontSize), "px"));
              current.tspan.setAttributeNS(null, "y", pf(-current.y));
              current.txtElement = this.svgFactory.createElement("svg:text");
              current.txtElement.appendChild(current.tspan);
            }
          }, {
            key: "beginText",
            value: function beginText() {
              var current = this.current;
              current.x = current.lineX = 0;
              current.y = current.lineY = 0;
              current.textMatrix = _util.IDENTITY_MATRIX;
              current.lineMatrix = _util.IDENTITY_MATRIX;
              current.textMatrixScale = 1;
              current.tspan = this.svgFactory.createElement("svg:tspan");
              current.txtElement = this.svgFactory.createElement("svg:text");
              current.txtgrp = this.svgFactory.createElement("svg:g");
              current.xcoords = [];
              current.ycoords = [];
            }
          }, {
            key: "moveText",
            value: function moveText(x, y) {
              var current = this.current;
              current.x = current.lineX += x;
              current.y = current.lineY += y;
              current.xcoords = [];
              current.ycoords = [];
              current.tspan = this.svgFactory.createElement("svg:tspan");
              current.tspan.setAttributeNS(null, "font-family", current.fontFamily);
              current.tspan.setAttributeNS(null, "font-size", "".concat(pf(current.fontSize), "px"));
              current.tspan.setAttributeNS(null, "y", pf(-current.y));
            }
          }, {
            key: "showText",
            value: function showText(glyphs) {
              var current = this.current;
              var font = current.font;
              var fontSize = current.fontSize;

              if (fontSize === 0) {
                return;
              }

              var fontSizeScale = current.fontSizeScale;
              var charSpacing = current.charSpacing;
              var wordSpacing = current.wordSpacing;
              var fontDirection = current.fontDirection;
              var textHScale = current.textHScale * fontDirection;
              var vertical = font.vertical;
              var spacingDir = vertical ? 1 : -1;
              var defaultVMetrics = font.defaultVMetrics;
              var widthAdvanceScale = fontSize * current.fontMatrix[0];
              var x = 0;

              var _iterator31 = _createForOfIteratorHelper(glyphs),
                  _step31;

              try {
                for (_iterator31.s(); !(_step31 = _iterator31.n()).done;) {
                  var glyph = _step31.value;

                  if (glyph === null) {
                    x += fontDirection * wordSpacing;
                    continue;
                  } else if ((0, _util.isNum)(glyph)) {
                    x += spacingDir * glyph * fontSize / 1000;
                    continue;
                  }

                  var spacing = (glyph.isSpace ? wordSpacing : 0) + charSpacing;
                  var character = glyph.fontChar;
                  var scaledX = void 0,
                      scaledY = void 0;
                  var width = glyph.width;

                  if (vertical) {
                    var vx = void 0;
                    var vmetric = glyph.vmetric || defaultVMetrics;
                    vx = glyph.vmetric ? vmetric[1] : width * 0.5;
                    vx = -vx * widthAdvanceScale;
                    var vy = vmetric[2] * widthAdvanceScale;
                    width = vmetric ? -vmetric[0] : width;
                    scaledX = vx / fontSizeScale;
                    scaledY = (x + vy) / fontSizeScale;
                  } else {
                    scaledX = x / fontSizeScale;
                    scaledY = 0;
                  }

                  if (glyph.isInFont || font.missingFile) {
                    current.xcoords.push(current.x + scaledX);

                    if (vertical) {
                      current.ycoords.push(-current.y + scaledY);
                    }

                    current.tspan.textContent += character;
                  }

                  var charWidth = void 0;

                  if (vertical) {
                    charWidth = width * widthAdvanceScale - spacing * fontDirection;
                  } else {
                    charWidth = width * widthAdvanceScale + spacing * fontDirection;
                  }

                  x += charWidth;
                }
              } catch (err) {
                _iterator31.e(err);
              } finally {
                _iterator31.f();
              }

              current.tspan.setAttributeNS(null, "x", current.xcoords.map(pf).join(" "));

              if (vertical) {
                current.tspan.setAttributeNS(null, "y", current.ycoords.map(pf).join(" "));
              } else {
                current.tspan.setAttributeNS(null, "y", pf(-current.y));
              }

              if (vertical) {
                current.y -= x;
              } else {
                current.x += x * textHScale;
              }

              current.tspan.setAttributeNS(null, "font-family", current.fontFamily);
              current.tspan.setAttributeNS(null, "font-size", "".concat(pf(current.fontSize), "px"));

              if (current.fontStyle !== SVG_DEFAULTS.fontStyle) {
                current.tspan.setAttributeNS(null, "font-style", current.fontStyle);
              }

              if (current.fontWeight !== SVG_DEFAULTS.fontWeight) {
                current.tspan.setAttributeNS(null, "font-weight", current.fontWeight);
              }

              var fillStrokeMode = current.textRenderingMode & _util.TextRenderingMode.FILL_STROKE_MASK;

              if (fillStrokeMode === _util.TextRenderingMode.FILL || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
                if (current.fillColor !== SVG_DEFAULTS.fillColor) {
                  current.tspan.setAttributeNS(null, "fill", current.fillColor);
                }

                if (current.fillAlpha < 1) {
                  current.tspan.setAttributeNS(null, "fill-opacity", current.fillAlpha);
                }
              } else if (current.textRenderingMode === _util.TextRenderingMode.ADD_TO_PATH) {
                current.tspan.setAttributeNS(null, "fill", "transparent");
              } else {
                current.tspan.setAttributeNS(null, "fill", "none");
              }

              if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
                var lineWidthScale = 1 / (current.textMatrixScale || 1);

                this._setStrokeAttributes(current.tspan, lineWidthScale);
              }

              var textMatrix = current.textMatrix;

              if (current.textRise !== 0) {
                textMatrix = textMatrix.slice();
                textMatrix[5] += current.textRise;
              }

              current.txtElement.setAttributeNS(null, "transform", "".concat(pm(textMatrix), " scale(").concat(pf(textHScale), ", -1)"));
              current.txtElement.setAttributeNS(XML_NS, "xml:space", "preserve");
              current.txtElement.appendChild(current.tspan);
              current.txtgrp.appendChild(current.txtElement);

              this._ensureTransformGroup().appendChild(current.txtElement);
            }
          }, {
            key: "setLeadingMoveText",
            value: function setLeadingMoveText(x, y) {
              this.setLeading(-y);
              this.moveText(x, y);
            }
          }, {
            key: "addFontStyle",
            value: function addFontStyle(fontObj) {
              if (!fontObj.data) {
                throw new Error("addFontStyle: No font data available, " + 'ensure that the "fontExtraProperties" API parameter is set.');
              }

              if (!this.cssStyle) {
                this.cssStyle = this.svgFactory.createElement("svg:style");
                this.cssStyle.setAttributeNS(null, "type", "text/css");
                this.defs.appendChild(this.cssStyle);
              }

              var url = (0, _util.createObjectURL)(fontObj.data, fontObj.mimetype, this.forceDataSchema);
              this.cssStyle.textContent += "@font-face { font-family: \"".concat(fontObj.loadedName, "\";") + " src: url(".concat(url, "); }\n");
            }
          }, {
            key: "setFont",
            value: function setFont(details) {
              var current = this.current;
              var fontObj = this.commonObjs.get(details[0]);
              var size = details[1];
              current.font = fontObj;

              if (this.embedFonts && !fontObj.missingFile && !this.embeddedFonts[fontObj.loadedName]) {
                this.addFontStyle(fontObj);
                this.embeddedFonts[fontObj.loadedName] = fontObj;
              }

              current.fontMatrix = fontObj.fontMatrix ? fontObj.fontMatrix : _util.FONT_IDENTITY_MATRIX;
              var bold = "normal";

              if (fontObj.black) {
                bold = "900";
              } else if (fontObj.bold) {
                bold = "bold";
              }

              var italic = fontObj.italic ? "italic" : "normal";

              if (size < 0) {
                size = -size;
                current.fontDirection = -1;
              } else {
                current.fontDirection = 1;
              }

              current.fontSize = size;
              current.fontFamily = fontObj.loadedName;
              current.fontWeight = bold;
              current.fontStyle = italic;
              current.tspan = this.svgFactory.createElement("svg:tspan");
              current.tspan.setAttributeNS(null, "y", pf(-current.y));
              current.xcoords = [];
              current.ycoords = [];
            }
          }, {
            key: "endText",
            value: function endText() {
              var current = this.current;

              if (current.textRenderingMode & _util.TextRenderingMode.ADD_TO_PATH_FLAG && current.txtElement && current.txtElement.hasChildNodes()) {
                current.element = current.txtElement;
                this.clip("nonzero");
                this.endPath();
              }
            }
          }, {
            key: "setLineWidth",
            value: function setLineWidth(width) {
              if (width > 0) {
                this.current.lineWidth = width;
              }
            }
          }, {
            key: "setLineCap",
            value: function setLineCap(style) {
              this.current.lineCap = LINE_CAP_STYLES[style];
            }
          }, {
            key: "setLineJoin",
            value: function setLineJoin(style) {
              this.current.lineJoin = LINE_JOIN_STYLES[style];
            }
          }, {
            key: "setMiterLimit",
            value: function setMiterLimit(limit) {
              this.current.miterLimit = limit;
            }
          }, {
            key: "setStrokeAlpha",
            value: function setStrokeAlpha(strokeAlpha) {
              this.current.strokeAlpha = strokeAlpha;
            }
          }, {
            key: "setStrokeRGBColor",
            value: function setStrokeRGBColor(r, g, b) {
              this.current.strokeColor = _util.Util.makeCssRgb(r, g, b);
            }
          }, {
            key: "setFillAlpha",
            value: function setFillAlpha(fillAlpha) {
              this.current.fillAlpha = fillAlpha;
            }
          }, {
            key: "setFillRGBColor",
            value: function setFillRGBColor(r, g, b) {
              this.current.fillColor = _util.Util.makeCssRgb(r, g, b);
              this.current.tspan = this.svgFactory.createElement("svg:tspan");
              this.current.xcoords = [];
              this.current.ycoords = [];
            }
          }, {
            key: "setStrokeColorN",
            value: function setStrokeColorN(args) {
              this.current.strokeColor = this._makeColorN_Pattern(args);
            }
          }, {
            key: "setFillColorN",
            value: function setFillColorN(args) {
              this.current.fillColor = this._makeColorN_Pattern(args);
            }
          }, {
            key: "shadingFill",
            value: function shadingFill(args) {
              var width = this.viewport.width;
              var height = this.viewport.height;

              var inv = _util.Util.inverseTransform(this.transformMatrix);

              var bl = _util.Util.applyTransform([0, 0], inv);

              var br = _util.Util.applyTransform([0, height], inv);

              var ul = _util.Util.applyTransform([width, 0], inv);

              var ur = _util.Util.applyTransform([width, height], inv);

              var x0 = Math.min(bl[0], br[0], ul[0], ur[0]);
              var y0 = Math.min(bl[1], br[1], ul[1], ur[1]);
              var x1 = Math.max(bl[0], br[0], ul[0], ur[0]);
              var y1 = Math.max(bl[1], br[1], ul[1], ur[1]);
              var rect = this.svgFactory.createElement("svg:rect");
              rect.setAttributeNS(null, "x", x0);
              rect.setAttributeNS(null, "y", y0);
              rect.setAttributeNS(null, "width", x1 - x0);
              rect.setAttributeNS(null, "height", y1 - y0);
              rect.setAttributeNS(null, "fill", this._makeShadingPattern(args));

              if (this.current.fillAlpha < 1) {
                rect.setAttributeNS(null, "fill-opacity", this.current.fillAlpha);
              }

              this._ensureTransformGroup().appendChild(rect);
            }
          }, {
            key: "_makeColorN_Pattern",
            value: function _makeColorN_Pattern(args) {
              if (args[0] === "TilingPattern") {
                return this._makeTilingPattern(args);
              }

              return this._makeShadingPattern(args);
            }
          }, {
            key: "_makeTilingPattern",
            value: function _makeTilingPattern(args) {
              var color = args[1];
              var operatorList = args[2];
              var matrix = args[3] || _util.IDENTITY_MATRIX;

              var _args$ = _slicedToArray(args[4], 4),
                  x0 = _args$[0],
                  y0 = _args$[1],
                  x1 = _args$[2],
                  y1 = _args$[3];

              var xstep = args[5];
              var ystep = args[6];
              var paintType = args[7];
              var tilingId = "shading".concat(shadingCount++);

              var _util$Util$applyTrans = _util.Util.applyTransform([x0, y0], matrix),
                  _util$Util$applyTrans2 = _slicedToArray(_util$Util$applyTrans, 2),
                  tx0 = _util$Util$applyTrans2[0],
                  ty0 = _util$Util$applyTrans2[1];

              var _util$Util$applyTrans3 = _util.Util.applyTransform([x1, y1], matrix),
                  _util$Util$applyTrans4 = _slicedToArray(_util$Util$applyTrans3, 2),
                  tx1 = _util$Util$applyTrans4[0],
                  ty1 = _util$Util$applyTrans4[1];

              var _util$Util$singularVa = _util.Util.singularValueDecompose2dScale(matrix),
                  _util$Util$singularVa2 = _slicedToArray(_util$Util$singularVa, 2),
                  xscale = _util$Util$singularVa2[0],
                  yscale = _util$Util$singularVa2[1];

              var txstep = xstep * xscale;
              var tystep = ystep * yscale;
              var tiling = this.svgFactory.createElement("svg:pattern");
              tiling.setAttributeNS(null, "id", tilingId);
              tiling.setAttributeNS(null, "patternUnits", "userSpaceOnUse");
              tiling.setAttributeNS(null, "width", txstep);
              tiling.setAttributeNS(null, "height", tystep);
              tiling.setAttributeNS(null, "x", "".concat(tx0));
              tiling.setAttributeNS(null, "y", "".concat(ty0));
              var svg = this.svg;
              var transformMatrix = this.transformMatrix;
              var fillColor = this.current.fillColor;
              var strokeColor = this.current.strokeColor;
              var bbox = this.svgFactory.create(tx1 - tx0, ty1 - ty0);
              this.svg = bbox;
              this.transformMatrix = matrix;

              if (paintType === 2) {
                var _util$Util;

                var cssColor = (_util$Util = _util.Util).makeCssRgb.apply(_util$Util, _toConsumableArray(color));

                this.current.fillColor = cssColor;
                this.current.strokeColor = cssColor;
              }

              this.executeOpTree(this.convertOpList(operatorList));
              this.svg = svg;
              this.transformMatrix = transformMatrix;
              this.current.fillColor = fillColor;
              this.current.strokeColor = strokeColor;
              tiling.appendChild(bbox.childNodes[0]);
              this.defs.appendChild(tiling);
              return "url(#".concat(tilingId, ")");
            }
          }, {
            key: "_makeShadingPattern",
            value: function _makeShadingPattern(args) {
              switch (args[0]) {
                case "RadialAxial":
                  var shadingId = "shading".concat(shadingCount++);
                  var colorStops = args[3];
                  var gradient;

                  switch (args[1]) {
                    case "axial":
                      var point0 = args[4];
                      var point1 = args[5];
                      gradient = this.svgFactory.createElement("svg:linearGradient");
                      gradient.setAttributeNS(null, "id", shadingId);
                      gradient.setAttributeNS(null, "gradientUnits", "userSpaceOnUse");
                      gradient.setAttributeNS(null, "x1", point0[0]);
                      gradient.setAttributeNS(null, "y1", point0[1]);
                      gradient.setAttributeNS(null, "x2", point1[0]);
                      gradient.setAttributeNS(null, "y2", point1[1]);
                      break;

                    case "radial":
                      var focalPoint = args[4];
                      var circlePoint = args[5];
                      var focalRadius = args[6];
                      var circleRadius = args[7];
                      gradient = this.svgFactory.createElement("svg:radialGradient");
                      gradient.setAttributeNS(null, "id", shadingId);
                      gradient.setAttributeNS(null, "gradientUnits", "userSpaceOnUse");
                      gradient.setAttributeNS(null, "cx", circlePoint[0]);
                      gradient.setAttributeNS(null, "cy", circlePoint[1]);
                      gradient.setAttributeNS(null, "r", circleRadius);
                      gradient.setAttributeNS(null, "fx", focalPoint[0]);
                      gradient.setAttributeNS(null, "fy", focalPoint[1]);
                      gradient.setAttributeNS(null, "fr", focalRadius);
                      break;

                    default:
                      throw new Error("Unknown RadialAxial type: ".concat(args[1]));
                  }

                  var _iterator32 = _createForOfIteratorHelper(colorStops),
                      _step32;

                  try {
                    for (_iterator32.s(); !(_step32 = _iterator32.n()).done;) {
                      var colorStop = _step32.value;
                      var stop = this.svgFactory.createElement("svg:stop");
                      stop.setAttributeNS(null, "offset", colorStop[0]);
                      stop.setAttributeNS(null, "stop-color", colorStop[1]);
                      gradient.appendChild(stop);
                    }
                  } catch (err) {
                    _iterator32.e(err);
                  } finally {
                    _iterator32.f();
                  }

                  this.defs.appendChild(gradient);
                  return "url(#".concat(shadingId, ")");

                case "Mesh":
                  (0, _util.warn)("Unimplemented pattern Mesh");
                  return null;

                case "Dummy":
                  return "hotpink";

                default:
                  throw new Error("Unknown IR type: ".concat(args[0]));
              }
            }
          }, {
            key: "setDash",
            value: function setDash(dashArray, dashPhase) {
              this.current.dashArray = dashArray;
              this.current.dashPhase = dashPhase;
            }
          }, {
            key: "constructPath",
            value: function constructPath(ops, args) {
              var current = this.current;
              var x = current.x,
                  y = current.y;
              var d = [];
              var j = 0;

              var _iterator33 = _createForOfIteratorHelper(ops),
                  _step33;

              try {
                for (_iterator33.s(); !(_step33 = _iterator33.n()).done;) {
                  var op = _step33.value;

                  switch (op | 0) {
                    case _util.OPS.rectangle:
                      x = args[j++];
                      y = args[j++];
                      var width = args[j++];
                      var height = args[j++];
                      var xw = x + width;
                      var yh = y + height;
                      d.push("M", pf(x), pf(y), "L", pf(xw), pf(y), "L", pf(xw), pf(yh), "L", pf(x), pf(yh), "Z");
                      break;

                    case _util.OPS.moveTo:
                      x = args[j++];
                      y = args[j++];
                      d.push("M", pf(x), pf(y));
                      break;

                    case _util.OPS.lineTo:
                      x = args[j++];
                      y = args[j++];
                      d.push("L", pf(x), pf(y));
                      break;

                    case _util.OPS.curveTo:
                      x = args[j + 4];
                      y = args[j + 5];
                      d.push("C", pf(args[j]), pf(args[j + 1]), pf(args[j + 2]), pf(args[j + 3]), pf(x), pf(y));
                      j += 6;
                      break;

                    case _util.OPS.curveTo2:
                      d.push("C", pf(x), pf(y), pf(args[j]), pf(args[j + 1]), pf(args[j + 2]), pf(args[j + 3]));
                      x = args[j + 2];
                      y = args[j + 3];
                      j += 4;
                      break;

                    case _util.OPS.curveTo3:
                      x = args[j + 2];
                      y = args[j + 3];
                      d.push("C", pf(args[j]), pf(args[j + 1]), pf(x), pf(y), pf(x), pf(y));
                      j += 4;
                      break;

                    case _util.OPS.closePath:
                      d.push("Z");
                      break;
                  }
                }
              } catch (err) {
                _iterator33.e(err);
              } finally {
                _iterator33.f();
              }

              d = d.join(" ");

              if (current.path && ops.length > 0 && ops[0] !== _util.OPS.rectangle && ops[0] !== _util.OPS.moveTo) {
                d = current.path.getAttributeNS(null, "d") + d;
              } else {
                current.path = this.svgFactory.createElement("svg:path");

                this._ensureTransformGroup().appendChild(current.path);
              }

              current.path.setAttributeNS(null, "d", d);
              current.path.setAttributeNS(null, "fill", "none");
              current.element = current.path;
              current.setCurrentPoint(x, y);
            }
          }, {
            key: "endPath",
            value: function endPath() {
              var current = this.current;
              current.path = null;

              if (!this.pendingClip) {
                return;
              }

              if (!current.element) {
                this.pendingClip = null;
                return;
              }

              var clipId = "clippath".concat(clipCount++);
              var clipPath = this.svgFactory.createElement("svg:clipPath");
              clipPath.setAttributeNS(null, "id", clipId);
              clipPath.setAttributeNS(null, "transform", pm(this.transformMatrix));
              var clipElement = current.element.cloneNode(true);

              if (this.pendingClip === "evenodd") {
                clipElement.setAttributeNS(null, "clip-rule", "evenodd");
              } else {
                clipElement.setAttributeNS(null, "clip-rule", "nonzero");
              }

              this.pendingClip = null;
              clipPath.appendChild(clipElement);
              this.defs.appendChild(clipPath);

              if (current.activeClipUrl) {
                current.clipGroup = null;
                this.extraStack.forEach(function (prev) {
                  prev.clipGroup = null;
                });
                clipPath.setAttributeNS(null, "clip-path", current.activeClipUrl);
              }

              current.activeClipUrl = "url(#".concat(clipId, ")");
              this.tgrp = null;
            }
          }, {
            key: "clip",
            value: function clip(type) {
              this.pendingClip = type;
            }
          }, {
            key: "closePath",
            value: function closePath() {
              var current = this.current;

              if (current.path) {
                var d = "".concat(current.path.getAttributeNS(null, "d"), "Z");
                current.path.setAttributeNS(null, "d", d);
              }
            }
          }, {
            key: "setLeading",
            value: function setLeading(leading) {
              this.current.leading = -leading;
            }
          }, {
            key: "setTextRise",
            value: function setTextRise(textRise) {
              this.current.textRise = textRise;
            }
          }, {
            key: "setTextRenderingMode",
            value: function setTextRenderingMode(textRenderingMode) {
              this.current.textRenderingMode = textRenderingMode;
            }
          }, {
            key: "setHScale",
            value: function setHScale(scale) {
              this.current.textHScale = scale / 100;
            }
          }, {
            key: "setRenderingIntent",
            value: function setRenderingIntent(intent) {}
          }, {
            key: "setFlatness",
            value: function setFlatness(flatness) {}
          }, {
            key: "setGState",
            value: function setGState(states) {
              var _iterator34 = _createForOfIteratorHelper(states),
                  _step34;

              try {
                for (_iterator34.s(); !(_step34 = _iterator34.n()).done;) {
                  var _step34$value = _slicedToArray(_step34.value, 2),
                      key = _step34$value[0],
                      value = _step34$value[1];

                  switch (key) {
                    case "LW":
                      this.setLineWidth(value);
                      break;

                    case "LC":
                      this.setLineCap(value);
                      break;

                    case "LJ":
                      this.setLineJoin(value);
                      break;

                    case "ML":
                      this.setMiterLimit(value);
                      break;

                    case "D":
                      this.setDash(value[0], value[1]);
                      break;

                    case "RI":
                      this.setRenderingIntent(value);
                      break;

                    case "FL":
                      this.setFlatness(value);
                      break;

                    case "Font":
                      this.setFont(value);
                      break;

                    case "CA":
                      this.setStrokeAlpha(value);
                      break;

                    case "ca":
                      this.setFillAlpha(value);
                      break;

                    default:
                      (0, _util.warn)("Unimplemented graphic state operator ".concat(key));
                      break;
                  }
                }
              } catch (err) {
                _iterator34.e(err);
              } finally {
                _iterator34.f();
              }
            }
          }, {
            key: "fill",
            value: function fill() {
              var current = this.current;

              if (current.element) {
                current.element.setAttributeNS(null, "fill", current.fillColor);
                current.element.setAttributeNS(null, "fill-opacity", current.fillAlpha);
                this.endPath();
              }
            }
          }, {
            key: "stroke",
            value: function stroke() {
              var current = this.current;

              if (current.element) {
                this._setStrokeAttributes(current.element);

                current.element.setAttributeNS(null, "fill", "none");
                this.endPath();
              }
            }
          }, {
            key: "_setStrokeAttributes",
            value: function _setStrokeAttributes(element) {
              var lineWidthScale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
              var current = this.current;
              var dashArray = current.dashArray;

              if (lineWidthScale !== 1 && dashArray.length > 0) {
                dashArray = dashArray.map(function (value) {
                  return lineWidthScale * value;
                });
              }

              element.setAttributeNS(null, "stroke", current.strokeColor);
              element.setAttributeNS(null, "stroke-opacity", current.strokeAlpha);
              element.setAttributeNS(null, "stroke-miterlimit", pf(current.miterLimit));
              element.setAttributeNS(null, "stroke-linecap", current.lineCap);
              element.setAttributeNS(null, "stroke-linejoin", current.lineJoin);
              element.setAttributeNS(null, "stroke-width", pf(lineWidthScale * current.lineWidth) + "px");
              element.setAttributeNS(null, "stroke-dasharray", dashArray.map(pf).join(" "));
              element.setAttributeNS(null, "stroke-dashoffset", pf(lineWidthScale * current.dashPhase) + "px");
            }
          }, {
            key: "eoFill",
            value: function eoFill() {
              if (this.current.element) {
                this.current.element.setAttributeNS(null, "fill-rule", "evenodd");
              }

              this.fill();
            }
          }, {
            key: "fillStroke",
            value: function fillStroke() {
              this.stroke();
              this.fill();
            }
          }, {
            key: "eoFillStroke",
            value: function eoFillStroke() {
              if (this.current.element) {
                this.current.element.setAttributeNS(null, "fill-rule", "evenodd");
              }

              this.fillStroke();
            }
          }, {
            key: "closeStroke",
            value: function closeStroke() {
              this.closePath();
              this.stroke();
            }
          }, {
            key: "closeFillStroke",
            value: function closeFillStroke() {
              this.closePath();
              this.fillStroke();
            }
          }, {
            key: "closeEOFillStroke",
            value: function closeEOFillStroke() {
              this.closePath();
              this.eoFillStroke();
            }
          }, {
            key: "paintSolidColorImageMask",
            value: function paintSolidColorImageMask() {
              var rect = this.svgFactory.createElement("svg:rect");
              rect.setAttributeNS(null, "x", "0");
              rect.setAttributeNS(null, "y", "0");
              rect.setAttributeNS(null, "width", "1px");
              rect.setAttributeNS(null, "height", "1px");
              rect.setAttributeNS(null, "fill", this.current.fillColor);

              this._ensureTransformGroup().appendChild(rect);
            }
          }, {
            key: "paintImageXObject",
            value: function paintImageXObject(objId) {
              var imgData = objId.startsWith("g_") ? this.commonObjs.get(objId) : this.objs.get(objId);

              if (!imgData) {
                (0, _util.warn)("Dependent image with object ID ".concat(objId, " is not ready yet"));
                return;
              }

              this.paintInlineImageXObject(imgData);
            }
          }, {
            key: "paintInlineImageXObject",
            value: function paintInlineImageXObject(imgData, mask) {
              var width = imgData.width;
              var height = imgData.height;
              var imgSrc = convertImgDataToPng(imgData, this.forceDataSchema, !!mask);
              var cliprect = this.svgFactory.createElement("svg:rect");
              cliprect.setAttributeNS(null, "x", "0");
              cliprect.setAttributeNS(null, "y", "0");
              cliprect.setAttributeNS(null, "width", pf(width));
              cliprect.setAttributeNS(null, "height", pf(height));
              this.current.element = cliprect;
              this.clip("nonzero");
              var imgEl = this.svgFactory.createElement("svg:image");
              imgEl.setAttributeNS(XLINK_NS, "xlink:href", imgSrc);
              imgEl.setAttributeNS(null, "x", "0");
              imgEl.setAttributeNS(null, "y", pf(-height));
              imgEl.setAttributeNS(null, "width", pf(width) + "px");
              imgEl.setAttributeNS(null, "height", pf(height) + "px");
              imgEl.setAttributeNS(null, "transform", "scale(".concat(pf(1 / width), " ").concat(pf(-1 / height), ")"));

              if (mask) {
                mask.appendChild(imgEl);
              } else {
                this._ensureTransformGroup().appendChild(imgEl);
              }
            }
          }, {
            key: "paintImageMaskXObject",
            value: function paintImageMaskXObject(imgData) {
              var current = this.current;
              var width = imgData.width;
              var height = imgData.height;
              var fillColor = current.fillColor;
              current.maskId = "mask".concat(maskCount++);
              var mask = this.svgFactory.createElement("svg:mask");
              mask.setAttributeNS(null, "id", current.maskId);
              var rect = this.svgFactory.createElement("svg:rect");
              rect.setAttributeNS(null, "x", "0");
              rect.setAttributeNS(null, "y", "0");
              rect.setAttributeNS(null, "width", pf(width));
              rect.setAttributeNS(null, "height", pf(height));
              rect.setAttributeNS(null, "fill", fillColor);
              rect.setAttributeNS(null, "mask", "url(#".concat(current.maskId, ")"));
              this.defs.appendChild(mask);

              this._ensureTransformGroup().appendChild(rect);

              this.paintInlineImageXObject(imgData, mask);
            }
          }, {
            key: "paintFormXObjectBegin",
            value: function paintFormXObjectBegin(matrix, bbox) {
              if (Array.isArray(matrix) && matrix.length === 6) {
                this.transform(matrix[0], matrix[1], matrix[2], matrix[3], matrix[4], matrix[5]);
              }

              if (bbox) {
                var width = bbox[2] - bbox[0];
                var height = bbox[3] - bbox[1];
                var cliprect = this.svgFactory.createElement("svg:rect");
                cliprect.setAttributeNS(null, "x", bbox[0]);
                cliprect.setAttributeNS(null, "y", bbox[1]);
                cliprect.setAttributeNS(null, "width", pf(width));
                cliprect.setAttributeNS(null, "height", pf(height));
                this.current.element = cliprect;
                this.clip("nonzero");
                this.endPath();
              }
            }
          }, {
            key: "paintFormXObjectEnd",
            value: function paintFormXObjectEnd() {}
          }, {
            key: "_initialize",
            value: function _initialize(viewport) {
              var svg = this.svgFactory.create(viewport.width, viewport.height);
              var definitions = this.svgFactory.createElement("svg:defs");
              svg.appendChild(definitions);
              this.defs = definitions;
              var rootGroup = this.svgFactory.createElement("svg:g");
              rootGroup.setAttributeNS(null, "transform", pm(viewport.transform));
              svg.appendChild(rootGroup);
              this.svg = rootGroup;
              return svg;
            }
          }, {
            key: "_ensureClipGroup",
            value: function _ensureClipGroup() {
              if (!this.current.clipGroup) {
                var clipGroup = this.svgFactory.createElement("svg:g");
                clipGroup.setAttributeNS(null, "clip-path", this.current.activeClipUrl);
                this.svg.appendChild(clipGroup);
                this.current.clipGroup = clipGroup;
              }

              return this.current.clipGroup;
            }
          }, {
            key: "_ensureTransformGroup",
            value: function _ensureTransformGroup() {
              if (!this.tgrp) {
                this.tgrp = this.svgFactory.createElement("svg:g");
                this.tgrp.setAttributeNS(null, "transform", pm(this.transformMatrix));

                if (this.current.activeClipUrl) {
                  this._ensureClipGroup().appendChild(this.tgrp);
                } else {
                  this.svg.appendChild(this.tgrp);
                }
              }

              return this.tgrp;
            }
          }]);

          return SVGGraphics;
        }();
      }
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.PDFNodeStream = void 0;

      var _util = __w_pdfjs_require__(2);

      var _network_utils = __w_pdfjs_require__(23);

      var fs = require$$5;
      var http = require$$5;
      var https = require$$5;
      var url = require$$5;
      var fileUriRegex = /^file:\/\/\/[a-zA-Z]:\//;

      function parseUrl(sourceUrl) {
        var parsedUrl = url.parse(sourceUrl);

        if (parsedUrl.protocol === "file:" || parsedUrl.host) {
          return parsedUrl;
        }

        if (/^[a-z]:[/\\]/i.test(sourceUrl)) {
          return url.parse("file:///".concat(sourceUrl));
        }

        if (!parsedUrl.host) {
          parsedUrl.protocol = "file:";
        }

        return parsedUrl;
      }

      var PDFNodeStream = function () {
        function PDFNodeStream(source) {
          _classCallCheck(this, PDFNodeStream);

          this.source = source;
          this.url = parseUrl(source.url);
          this.isHttp = this.url.protocol === "http:" || this.url.protocol === "https:";
          this.isFsUrl = this.url.protocol === "file:";
          this.httpHeaders = this.isHttp && source.httpHeaders || {};
          this._fullRequestReader = null;
          this._rangeRequestReaders = [];
        }

        _createClass(PDFNodeStream, [{
          key: "_progressiveDataLength",
          get: function get() {
            return this._fullRequestReader ? this._fullRequestReader._loaded : 0;
          }
        }, {
          key: "getFullReader",
          value: function getFullReader() {
            (0, _util.assert)(!this._fullRequestReader, "PDFNodeStream.getFullReader can only be called once.");
            this._fullRequestReader = this.isFsUrl ? new PDFNodeStreamFsFullReader(this) : new PDFNodeStreamFullReader(this);
            return this._fullRequestReader;
          }
        }, {
          key: "getRangeReader",
          value: function getRangeReader(start, end) {
            if (end <= this._progressiveDataLength) {
              return null;
            }

            var rangeReader = this.isFsUrl ? new PDFNodeStreamFsRangeReader(this, start, end) : new PDFNodeStreamRangeReader(this, start, end);

            this._rangeRequestReaders.push(rangeReader);

            return rangeReader;
          }
        }, {
          key: "cancelAllRequests",
          value: function cancelAllRequests(reason) {
            if (this._fullRequestReader) {
              this._fullRequestReader.cancel(reason);
            }

            var readers = this._rangeRequestReaders.slice(0);

            readers.forEach(function (reader) {
              reader.cancel(reason);
            });
          }
        }]);

        return PDFNodeStream;
      }();

      exports.PDFNodeStream = PDFNodeStream;

      var BaseFullReader = function () {
        function BaseFullReader(stream) {
          _classCallCheck(this, BaseFullReader);

          this._url = stream.url;
          this._done = false;
          this._storedError = null;
          this.onProgress = null;
          var source = stream.source;
          this._contentLength = source.length;
          this._loaded = 0;
          this._filename = null;
          this._disableRange = source.disableRange || false;
          this._rangeChunkSize = source.rangeChunkSize;

          if (!this._rangeChunkSize && !this._disableRange) {
            this._disableRange = true;
          }

          this._isStreamingSupported = !source.disableStream;
          this._isRangeSupported = !source.disableRange;
          this._readableStream = null;
          this._readCapability = (0, _util.createPromiseCapability)();
          this._headersCapability = (0, _util.createPromiseCapability)();
        }

        _createClass(BaseFullReader, [{
          key: "headersReady",
          get: function get() {
            return this._headersCapability.promise;
          }
        }, {
          key: "filename",
          get: function get() {
            return this._filename;
          }
        }, {
          key: "contentLength",
          get: function get() {
            return this._contentLength;
          }
        }, {
          key: "isRangeSupported",
          get: function get() {
            return this._isRangeSupported;
          }
        }, {
          key: "isStreamingSupported",
          get: function get() {
            return this._isStreamingSupported;
          }
        }, {
          key: "read",
          value: function () {
            var _read3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee9() {
              var chunk, buffer;
              return regeneratorRuntime.wrap(function _callee9$(_context9) {
                while (1) {
                  switch (_context9.prev = _context9.next) {
                    case 0:
                      _context9.next = 2;
                      return this._readCapability.promise;

                    case 2:
                      if (!this._done) {
                        _context9.next = 4;
                        break;
                      }

                      return _context9.abrupt("return", {
                        value: undefined,
                        done: true
                      });

                    case 4:
                      if (!this._storedError) {
                        _context9.next = 6;
                        break;
                      }

                      throw this._storedError;

                    case 6:
                      chunk = this._readableStream.read();

                      if (!(chunk === null)) {
                        _context9.next = 10;
                        break;
                      }

                      this._readCapability = (0, _util.createPromiseCapability)();
                      return _context9.abrupt("return", this.read());

                    case 10:
                      this._loaded += chunk.length;

                      if (this.onProgress) {
                        this.onProgress({
                          loaded: this._loaded,
                          total: this._contentLength
                        });
                      }

                      buffer = new Uint8Array(chunk).buffer;
                      return _context9.abrupt("return", {
                        value: buffer,
                        done: false
                      });

                    case 14:
                    case "end":
                      return _context9.stop();
                  }
                }
              }, _callee9, this);
            }));

            function read() {
              return _read3.apply(this, arguments);
            }

            return read;
          }()
        }, {
          key: "cancel",
          value: function cancel(reason) {
            if (!this._readableStream) {
              this._error(reason);

              return;
            }

            this._readableStream.destroy(reason);
          }
        }, {
          key: "_error",
          value: function _error(reason) {
            this._storedError = reason;

            this._readCapability.resolve();
          }
        }, {
          key: "_setReadableStream",
          value: function _setReadableStream(readableStream) {
            var _this44 = this;

            this._readableStream = readableStream;
            readableStream.on("readable", function () {
              _this44._readCapability.resolve();
            });
            readableStream.on("end", function () {
              readableStream.destroy();
              _this44._done = true;

              _this44._readCapability.resolve();
            });
            readableStream.on("error", function (reason) {
              _this44._error(reason);
            });

            if (!this._isStreamingSupported && this._isRangeSupported) {
              this._error(new _util.AbortException("streaming is disabled"));
            }

            if (this._storedError) {
              this._readableStream.destroy(this._storedError);
            }
          }
        }]);

        return BaseFullReader;
      }();

      var BaseRangeReader = function () {
        function BaseRangeReader(stream) {
          _classCallCheck(this, BaseRangeReader);

          this._url = stream.url;
          this._done = false;
          this._storedError = null;
          this.onProgress = null;
          this._loaded = 0;
          this._readableStream = null;
          this._readCapability = (0, _util.createPromiseCapability)();
          var source = stream.source;
          this._isStreamingSupported = !source.disableStream;
        }

        _createClass(BaseRangeReader, [{
          key: "isStreamingSupported",
          get: function get() {
            return this._isStreamingSupported;
          }
        }, {
          key: "read",
          value: function () {
            var _read4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee10() {
              var chunk, buffer;
              return regeneratorRuntime.wrap(function _callee10$(_context10) {
                while (1) {
                  switch (_context10.prev = _context10.next) {
                    case 0:
                      _context10.next = 2;
                      return this._readCapability.promise;

                    case 2:
                      if (!this._done) {
                        _context10.next = 4;
                        break;
                      }

                      return _context10.abrupt("return", {
                        value: undefined,
                        done: true
                      });

                    case 4:
                      if (!this._storedError) {
                        _context10.next = 6;
                        break;
                      }

                      throw this._storedError;

                    case 6:
                      chunk = this._readableStream.read();

                      if (!(chunk === null)) {
                        _context10.next = 10;
                        break;
                      }

                      this._readCapability = (0, _util.createPromiseCapability)();
                      return _context10.abrupt("return", this.read());

                    case 10:
                      this._loaded += chunk.length;

                      if (this.onProgress) {
                        this.onProgress({
                          loaded: this._loaded
                        });
                      }

                      buffer = new Uint8Array(chunk).buffer;
                      return _context10.abrupt("return", {
                        value: buffer,
                        done: false
                      });

                    case 14:
                    case "end":
                      return _context10.stop();
                  }
                }
              }, _callee10, this);
            }));

            function read() {
              return _read4.apply(this, arguments);
            }

            return read;
          }()
        }, {
          key: "cancel",
          value: function cancel(reason) {
            if (!this._readableStream) {
              this._error(reason);

              return;
            }

            this._readableStream.destroy(reason);
          }
        }, {
          key: "_error",
          value: function _error(reason) {
            this._storedError = reason;

            this._readCapability.resolve();
          }
        }, {
          key: "_setReadableStream",
          value: function _setReadableStream(readableStream) {
            var _this45 = this;

            this._readableStream = readableStream;
            readableStream.on("readable", function () {
              _this45._readCapability.resolve();
            });
            readableStream.on("end", function () {
              readableStream.destroy();
              _this45._done = true;

              _this45._readCapability.resolve();
            });
            readableStream.on("error", function (reason) {
              _this45._error(reason);
            });

            if (this._storedError) {
              this._readableStream.destroy(this._storedError);
            }
          }
        }]);

        return BaseRangeReader;
      }();

      function createRequestOptions(parsedUrl, headers) {
        return {
          protocol: parsedUrl.protocol,
          auth: parsedUrl.auth,
          host: parsedUrl.hostname,
          port: parsedUrl.port,
          path: parsedUrl.path,
          method: "GET",
          headers: headers
        };
      }

      var PDFNodeStreamFullReader = function (_BaseFullReader) {
        _inherits(PDFNodeStreamFullReader, _BaseFullReader);

        var _super38 = _createSuper(PDFNodeStreamFullReader);

        function PDFNodeStreamFullReader(stream) {
          var _this46;

          _classCallCheck(this, PDFNodeStreamFullReader);

          _this46 = _super38.call(this, stream);

          var handleResponse = function handleResponse(response) {
            if (response.statusCode === 404) {
              var error = new _util.MissingPDFException("Missing PDF \"".concat(_this46._url, "\"."));
              _this46._storedError = error;

              _this46._headersCapability.reject(error);

              return;
            }

            _this46._headersCapability.resolve();

            _this46._setReadableStream(response);

            var getResponseHeader = function getResponseHeader(name) {
              return _this46._readableStream.headers[name.toLowerCase()];
            };

            var _ref37 = (0, _network_utils.validateRangeRequestCapabilities)({
              getResponseHeader: getResponseHeader,
              isHttp: stream.isHttp,
              rangeChunkSize: _this46._rangeChunkSize,
              disableRange: _this46._disableRange
            }),
                allowRangeRequests = _ref37.allowRangeRequests,
                suggestedLength = _ref37.suggestedLength;

            _this46._isRangeSupported = allowRangeRequests;
            _this46._contentLength = suggestedLength || _this46._contentLength;
            _this46._filename = (0, _network_utils.extractFilenameFromHeader)(getResponseHeader);
          };

          _this46._request = null;

          if (_this46._url.protocol === "http:") {
            _this46._request = http.request(createRequestOptions(_this46._url, stream.httpHeaders), handleResponse);
          } else {
            _this46._request = https.request(createRequestOptions(_this46._url, stream.httpHeaders), handleResponse);
          }

          _this46._request.on("error", function (reason) {
            _this46._storedError = reason;

            _this46._headersCapability.reject(reason);
          });

          _this46._request.end();

          return _this46;
        }

        return PDFNodeStreamFullReader;
      }(BaseFullReader);

      var PDFNodeStreamRangeReader = function (_BaseRangeReader) {
        _inherits(PDFNodeStreamRangeReader, _BaseRangeReader);

        var _super39 = _createSuper(PDFNodeStreamRangeReader);

        function PDFNodeStreamRangeReader(stream, start, end) {
          var _this47;

          _classCallCheck(this, PDFNodeStreamRangeReader);

          _this47 = _super39.call(this, stream);
          _this47._httpHeaders = {};

          for (var property in stream.httpHeaders) {
            var value = stream.httpHeaders[property];

            if (typeof value === "undefined") {
              continue;
            }

            _this47._httpHeaders[property] = value;
          }

          _this47._httpHeaders.Range = "bytes=".concat(start, "-").concat(end - 1);

          var handleResponse = function handleResponse(response) {
            if (response.statusCode === 404) {
              var error = new _util.MissingPDFException("Missing PDF \"".concat(_this47._url, "\"."));
              _this47._storedError = error;
              return;
            }

            _this47._setReadableStream(response);
          };

          _this47._request = null;

          if (_this47._url.protocol === "http:") {
            _this47._request = http.request(createRequestOptions(_this47._url, _this47._httpHeaders), handleResponse);
          } else {
            _this47._request = https.request(createRequestOptions(_this47._url, _this47._httpHeaders), handleResponse);
          }

          _this47._request.on("error", function (reason) {
            _this47._storedError = reason;
          });

          _this47._request.end();

          return _this47;
        }

        return PDFNodeStreamRangeReader;
      }(BaseRangeReader);

      var PDFNodeStreamFsFullReader = function (_BaseFullReader2) {
        _inherits(PDFNodeStreamFsFullReader, _BaseFullReader2);

        var _super40 = _createSuper(PDFNodeStreamFsFullReader);

        function PDFNodeStreamFsFullReader(stream) {
          var _this48;

          _classCallCheck(this, PDFNodeStreamFsFullReader);

          _this48 = _super40.call(this, stream);
          var path = decodeURIComponent(_this48._url.path);

          if (fileUriRegex.test(_this48._url.href)) {
            path = path.replace(/^\//, "");
          }

          fs.lstat(path, function (error, stat) {
            if (error) {
              if (error.code === "ENOENT") {
                error = new _util.MissingPDFException("Missing PDF \"".concat(path, "\"."));
              }

              _this48._storedError = error;

              _this48._headersCapability.reject(error);

              return;
            }

            _this48._contentLength = stat.size;

            _this48._setReadableStream(fs.createReadStream(path));

            _this48._headersCapability.resolve();
          });
          return _this48;
        }

        return PDFNodeStreamFsFullReader;
      }(BaseFullReader);

      var PDFNodeStreamFsRangeReader = function (_BaseRangeReader2) {
        _inherits(PDFNodeStreamFsRangeReader, _BaseRangeReader2);

        var _super41 = _createSuper(PDFNodeStreamFsRangeReader);

        function PDFNodeStreamFsRangeReader(stream, start, end) {
          var _this49;

          _classCallCheck(this, PDFNodeStreamFsRangeReader);

          _this49 = _super41.call(this, stream);
          var path = decodeURIComponent(_this49._url.path);

          if (fileUriRegex.test(_this49._url.href)) {
            path = path.replace(/^\//, "");
          }

          _this49._setReadableStream(fs.createReadStream(path, {
            start: start,
            end: end - 1
          }));

          return _this49;
        }

        return PDFNodeStreamFsRangeReader;
      }(BaseRangeReader);
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.createResponseStatusError = createResponseStatusError;
      exports.extractFilenameFromHeader = extractFilenameFromHeader;
      exports.validateRangeRequestCapabilities = validateRangeRequestCapabilities;
      exports.validateResponseStatus = validateResponseStatus;

      var _util = __w_pdfjs_require__(2);

      var _content_disposition = __w_pdfjs_require__(24);

      function validateRangeRequestCapabilities(_ref38) {
        var getResponseHeader = _ref38.getResponseHeader,
            isHttp = _ref38.isHttp,
            rangeChunkSize = _ref38.rangeChunkSize,
            disableRange = _ref38.disableRange;
        (0, _util.assert)(rangeChunkSize > 0, "Range chunk size must be larger than zero");
        var returnValues = {
          allowRangeRequests: false,
          suggestedLength: undefined
        };
        var length = parseInt(getResponseHeader("Content-Length"), 10);

        if (!Number.isInteger(length)) {
          return returnValues;
        }

        returnValues.suggestedLength = length;

        if (length <= 2 * rangeChunkSize) {
          return returnValues;
        }

        if (disableRange || !isHttp) {
          return returnValues;
        }

        if (getResponseHeader("Accept-Ranges") !== "bytes") {
          return returnValues;
        }

        var contentEncoding = getResponseHeader("Content-Encoding") || "identity";

        if (contentEncoding !== "identity") {
          return returnValues;
        }

        returnValues.allowRangeRequests = true;
        return returnValues;
      }

      function extractFilenameFromHeader(getResponseHeader) {
        var contentDisposition = getResponseHeader("Content-Disposition");

        if (contentDisposition) {
          var filename = (0, _content_disposition.getFilenameFromContentDispositionHeader)(contentDisposition);

          if (filename.includes("%")) {
            try {
              filename = decodeURIComponent(filename);
            } catch (ex) {}
          }

          if (/\.pdf$/i.test(filename)) {
            return filename;
          }
        }

        return null;
      }

      function createResponseStatusError(status, url) {
        if (status === 404 || status === 0 && url.startsWith("file:")) {
          return new _util.MissingPDFException('Missing PDF "' + url + '".');
        }

        return new _util.UnexpectedResponseException("Unexpected server response (" + status + ') while retrieving PDF "' + url + '".', status);
      }

      function validateResponseStatus(status) {
        return status === 200 || status === 206;
      }
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.getFilenameFromContentDispositionHeader = getFilenameFromContentDispositionHeader;

      function getFilenameFromContentDispositionHeader(contentDisposition) {
        var needsEncodingFixup = true;
        var tmp = toParamRegExp("filename\\*", "i").exec(contentDisposition);

        if (tmp) {
          tmp = tmp[1];
          var filename = rfc2616unquote(tmp);
          filename = unescape(filename);
          filename = rfc5987decode(filename);
          filename = rfc2047decode(filename);
          return fixupEncoding(filename);
        }

        tmp = rfc2231getparam(contentDisposition);

        if (tmp) {
          var _filename = rfc2047decode(tmp);

          return fixupEncoding(_filename);
        }

        tmp = toParamRegExp("filename", "i").exec(contentDisposition);

        if (tmp) {
          tmp = tmp[1];

          var _filename2 = rfc2616unquote(tmp);

          _filename2 = rfc2047decode(_filename2);
          return fixupEncoding(_filename2);
        }

        function toParamRegExp(attributePattern, flags) {
          return new RegExp("(?:^|;)\\s*" + attributePattern + "\\s*=\\s*" + "(" + '[^";\\s][^;\\s]*' + "|" + '"(?:[^"\\\\]|\\\\"?)+"?' + ")", flags);
        }

        function textdecode(encoding, value) {
          if (encoding) {
            if (!/^[\x00-\xFF]+$/.test(value)) {
              return value;
            }

            try {
              var decoder = new TextDecoder(encoding, {
                fatal: true
              });
              var bytes = Array.from(value, function (ch) {
                return ch.charCodeAt(0) & 0xff;
              });
              value = decoder.decode(new Uint8Array(bytes));
              needsEncodingFixup = false;
            } catch (e) {
              if (/^utf-?8$/i.test(encoding)) {
                try {
                  value = decodeURIComponent(escape(value));
                  needsEncodingFixup = false;
                } catch (err) {}
              }
            }
          }

          return value;
        }

        function fixupEncoding(value) {
          if (needsEncodingFixup && /[\x80-\xff]/.test(value)) {
            value = textdecode("utf-8", value);

            if (needsEncodingFixup) {
              value = textdecode("iso-8859-1", value);
            }
          }

          return value;
        }

        function rfc2231getparam(contentDispositionStr) {
          var matches = [];
          var match;
          var iter = toParamRegExp("filename\\*((?!0\\d)\\d+)(\\*?)", "ig");

          while ((match = iter.exec(contentDispositionStr)) !== null) {
            var _match = match,
                _match2 = _slicedToArray(_match, 4),
                n = _match2[1],
                quot = _match2[2],
                part = _match2[3];

            n = parseInt(n, 10);

            if (n in matches) {
              if (n === 0) {
                break;
              }

              continue;
            }

            matches[n] = [quot, part];
          }

          var parts = [];

          for (var _n = 0; _n < matches.length; ++_n) {
            if (!(_n in matches)) {
              break;
            }

            var _matches$_n = _slicedToArray(matches[_n], 2),
                _quot = _matches$_n[0],
                _part = _matches$_n[1];

            _part = rfc2616unquote(_part);

            if (_quot) {
              _part = unescape(_part);

              if (_n === 0) {
                _part = rfc5987decode(_part);
              }
            }

            parts.push(_part);
          }

          return parts.join("");
        }

        function rfc2616unquote(value) {
          if (value.startsWith('"')) {
            var parts = value.slice(1).split('\\"');

            for (var i = 0; i < parts.length; ++i) {
              var quotindex = parts[i].indexOf('"');

              if (quotindex !== -1) {
                parts[i] = parts[i].slice(0, quotindex);
                parts.length = i + 1;
              }

              parts[i] = parts[i].replace(/\\(.)/g, "$1");
            }

            value = parts.join('"');
          }

          return value;
        }

        function rfc5987decode(extvalue) {
          var encodingend = extvalue.indexOf("'");

          if (encodingend === -1) {
            return extvalue;
          }

          var encoding = extvalue.slice(0, encodingend);
          var langvalue = extvalue.slice(encodingend + 1);
          var value = langvalue.replace(/^[^']*'/, "");
          return textdecode(encoding, value);
        }

        function rfc2047decode(value) {
          if (!value.startsWith("=?") || /[\x00-\x19\x80-\xff]/.test(value)) {
            return value;
          }

          return value.replace(/=\?([\w-]*)\?([QqBb])\?((?:[^?]|\?(?!=))*)\?=/g, function (matches, charset, encoding, text) {
            if (encoding === "q" || encoding === "Q") {
              text = text.replace(/_/g, " ");
              text = text.replace(/=([0-9a-fA-F]{2})/g, function (match, hex) {
                return String.fromCharCode(parseInt(hex, 16));
              });
              return textdecode(charset, text);
            }

            try {
              text = atob(text);
            } catch (e) {}

            return textdecode(charset, text);
          });
        }

        return "";
      }
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.PDFNetworkStream = void 0;

      var _util = __w_pdfjs_require__(2);

      var _network_utils = __w_pdfjs_require__(23);

      var OK_RESPONSE = 200;
      var PARTIAL_CONTENT_RESPONSE = 206;

      function getArrayBuffer(xhr) {
        var data = xhr.response;

        if (typeof data !== "string") {
          return data;
        }

        var array = (0, _util.stringToBytes)(data);
        return array.buffer;
      }

      var NetworkManager = function () {
        function NetworkManager(url, args) {
          _classCallCheck(this, NetworkManager);

          this.url = url;
          args = args || {};
          this.isHttp = /^https?:/i.test(url);
          this.httpHeaders = this.isHttp && args.httpHeaders || {};
          this.withCredentials = args.withCredentials || false;

          this.getXhr = args.getXhr || function NetworkManager_getXhr() {
            return new XMLHttpRequest();
          };

          this.currXhrId = 0;
          this.pendingRequests = Object.create(null);
        }

        _createClass(NetworkManager, [{
          key: "requestRange",
          value: function requestRange(begin, end, listeners) {
            var args = {
              begin: begin,
              end: end
            };

            for (var prop in listeners) {
              args[prop] = listeners[prop];
            }

            return this.request(args);
          }
        }, {
          key: "requestFull",
          value: function requestFull(listeners) {
            return this.request(listeners);
          }
        }, {
          key: "request",
          value: function request(args) {
            var xhr = this.getXhr();
            var xhrId = this.currXhrId++;
            var pendingRequest = this.pendingRequests[xhrId] = {
              xhr: xhr
            };
            xhr.open("GET", this.url);
            xhr.withCredentials = this.withCredentials;

            for (var property in this.httpHeaders) {
              var value = this.httpHeaders[property];

              if (typeof value === "undefined") {
                continue;
              }

              xhr.setRequestHeader(property, value);
            }

            if (this.isHttp && "begin" in args && "end" in args) {
              xhr.setRequestHeader("Range", "bytes=".concat(args.begin, "-").concat(args.end - 1));
              pendingRequest.expectedStatus = PARTIAL_CONTENT_RESPONSE;
            } else {
              pendingRequest.expectedStatus = OK_RESPONSE;
            }

            xhr.responseType = "arraybuffer";

            if (args.onError) {
              xhr.onerror = function (evt) {
                args.onError(xhr.status);
              };
            }

            xhr.onreadystatechange = this.onStateChange.bind(this, xhrId);
            xhr.onprogress = this.onProgress.bind(this, xhrId);
            pendingRequest.onHeadersReceived = args.onHeadersReceived;
            pendingRequest.onDone = args.onDone;
            pendingRequest.onError = args.onError;
            pendingRequest.onProgress = args.onProgress;
            xhr.send(null);
            return xhrId;
          }
        }, {
          key: "onProgress",
          value: function onProgress(xhrId, evt) {
            var pendingRequest = this.pendingRequests[xhrId];

            if (!pendingRequest) {
              return;
            }

            if (pendingRequest.onProgress) {
              pendingRequest.onProgress(evt);
            }
          }
        }, {
          key: "onStateChange",
          value: function onStateChange(xhrId, evt) {
            var pendingRequest = this.pendingRequests[xhrId];

            if (!pendingRequest) {
              return;
            }

            var xhr = pendingRequest.xhr;

            if (xhr.readyState >= 2 && pendingRequest.onHeadersReceived) {
              pendingRequest.onHeadersReceived();
              delete pendingRequest.onHeadersReceived;
            }

            if (xhr.readyState !== 4) {
              return;
            }

            if (!(xhrId in this.pendingRequests)) {
              return;
            }

            delete this.pendingRequests[xhrId];

            if (xhr.status === 0 && this.isHttp) {
              if (pendingRequest.onError) {
                pendingRequest.onError(xhr.status);
              }

              return;
            }

            var xhrStatus = xhr.status || OK_RESPONSE;
            var ok_response_on_range_request = xhrStatus === OK_RESPONSE && pendingRequest.expectedStatus === PARTIAL_CONTENT_RESPONSE;

            if (!ok_response_on_range_request && xhrStatus !== pendingRequest.expectedStatus) {
              if (pendingRequest.onError) {
                pendingRequest.onError(xhr.status);
              }

              return;
            }

            var chunk = getArrayBuffer(xhr);

            if (xhrStatus === PARTIAL_CONTENT_RESPONSE) {
              var rangeHeader = xhr.getResponseHeader("Content-Range");
              var matches = /bytes (\d+)-(\d+)\/(\d+)/.exec(rangeHeader);
              pendingRequest.onDone({
                begin: parseInt(matches[1], 10),
                chunk: chunk
              });
            } else if (chunk) {
              pendingRequest.onDone({
                begin: 0,
                chunk: chunk
              });
            } else if (pendingRequest.onError) {
              pendingRequest.onError(xhr.status);
            }
          }
        }, {
          key: "getRequestXhr",
          value: function getRequestXhr(xhrId) {
            return this.pendingRequests[xhrId].xhr;
          }
        }, {
          key: "isPendingRequest",
          value: function isPendingRequest(xhrId) {
            return xhrId in this.pendingRequests;
          }
        }, {
          key: "abortRequest",
          value: function abortRequest(xhrId) {
            var xhr = this.pendingRequests[xhrId].xhr;
            delete this.pendingRequests[xhrId];
            xhr.abort();
          }
        }]);

        return NetworkManager;
      }();

      var PDFNetworkStream = function () {
        function PDFNetworkStream(source) {
          _classCallCheck(this, PDFNetworkStream);

          this._source = source;
          this._manager = new NetworkManager(source.url, {
            httpHeaders: source.httpHeaders,
            withCredentials: source.withCredentials
          });
          this._rangeChunkSize = source.rangeChunkSize;
          this._fullRequestReader = null;
          this._rangeRequestReaders = [];
        }

        _createClass(PDFNetworkStream, [{
          key: "_onRangeRequestReaderClosed",
          value: function _onRangeRequestReaderClosed(reader) {
            var i = this._rangeRequestReaders.indexOf(reader);

            if (i >= 0) {
              this._rangeRequestReaders.splice(i, 1);
            }
          }
        }, {
          key: "getFullReader",
          value: function getFullReader() {
            (0, _util.assert)(!this._fullRequestReader, "PDFNetworkStream.getFullReader can only be called once.");
            this._fullRequestReader = new PDFNetworkStreamFullRequestReader(this._manager, this._source);
            return this._fullRequestReader;
          }
        }, {
          key: "getRangeReader",
          value: function getRangeReader(begin, end) {
            var reader = new PDFNetworkStreamRangeRequestReader(this._manager, begin, end);
            reader.onClosed = this._onRangeRequestReaderClosed.bind(this);

            this._rangeRequestReaders.push(reader);

            return reader;
          }
        }, {
          key: "cancelAllRequests",
          value: function cancelAllRequests(reason) {
            if (this._fullRequestReader) {
              this._fullRequestReader.cancel(reason);
            }

            var readers = this._rangeRequestReaders.slice(0);

            readers.forEach(function (reader) {
              reader.cancel(reason);
            });
          }
        }]);

        return PDFNetworkStream;
      }();

      exports.PDFNetworkStream = PDFNetworkStream;

      var PDFNetworkStreamFullRequestReader = function () {
        function PDFNetworkStreamFullRequestReader(manager, source) {
          _classCallCheck(this, PDFNetworkStreamFullRequestReader);

          this._manager = manager;
          var args = {
            onHeadersReceived: this._onHeadersReceived.bind(this),
            onDone: this._onDone.bind(this),
            onError: this._onError.bind(this),
            onProgress: this._onProgress.bind(this)
          };
          this._url = source.url;
          this._fullRequestId = manager.requestFull(args);
          this._headersReceivedCapability = (0, _util.createPromiseCapability)();
          this._disableRange = source.disableRange || false;
          this._contentLength = source.length;
          this._rangeChunkSize = source.rangeChunkSize;

          if (!this._rangeChunkSize && !this._disableRange) {
            this._disableRange = true;
          }

          this._isStreamingSupported = false;
          this._isRangeSupported = false;
          this._cachedChunks = [];
          this._requests = [];
          this._done = false;
          this._storedError = undefined;
          this._filename = null;
          this.onProgress = null;
        }

        _createClass(PDFNetworkStreamFullRequestReader, [{
          key: "_onHeadersReceived",
          value: function _onHeadersReceived() {
            var fullRequestXhrId = this._fullRequestId;

            var fullRequestXhr = this._manager.getRequestXhr(fullRequestXhrId);

            var getResponseHeader = function getResponseHeader(name) {
              return fullRequestXhr.getResponseHeader(name);
            };

            var _ref39 = (0, _network_utils.validateRangeRequestCapabilities)({
              getResponseHeader: getResponseHeader,
              isHttp: this._manager.isHttp,
              rangeChunkSize: this._rangeChunkSize,
              disableRange: this._disableRange
            }),
                allowRangeRequests = _ref39.allowRangeRequests,
                suggestedLength = _ref39.suggestedLength;

            if (allowRangeRequests) {
              this._isRangeSupported = true;
            }

            this._contentLength = suggestedLength || this._contentLength;
            this._filename = (0, _network_utils.extractFilenameFromHeader)(getResponseHeader);

            if (this._isRangeSupported) {
              this._manager.abortRequest(fullRequestXhrId);
            }

            this._headersReceivedCapability.resolve();
          }
        }, {
          key: "_onDone",
          value: function _onDone(args) {
            if (args) {
              if (this._requests.length > 0) {
                var requestCapability = this._requests.shift();

                requestCapability.resolve({
                  value: args.chunk,
                  done: false
                });
              } else {
                this._cachedChunks.push(args.chunk);
              }
            }

            this._done = true;

            if (this._cachedChunks.length > 0) {
              return;
            }

            this._requests.forEach(function (requestCapability) {
              requestCapability.resolve({
                value: undefined,
                done: true
              });
            });

            this._requests = [];
          }
        }, {
          key: "_onError",
          value: function _onError(status) {
            var url = this._url;
            var exception = (0, _network_utils.createResponseStatusError)(status, url);
            this._storedError = exception;

            this._headersReceivedCapability.reject(exception);

            this._requests.forEach(function (requestCapability) {
              requestCapability.reject(exception);
            });

            this._requests = [];
            this._cachedChunks = [];
          }
        }, {
          key: "_onProgress",
          value: function _onProgress(data) {
            if (this.onProgress) {
              this.onProgress({
                loaded: data.loaded,
                total: data.lengthComputable ? data.total : this._contentLength
              });
            }
          }
        }, {
          key: "filename",
          get: function get() {
            return this._filename;
          }
        }, {
          key: "isRangeSupported",
          get: function get() {
            return this._isRangeSupported;
          }
        }, {
          key: "isStreamingSupported",
          get: function get() {
            return this._isStreamingSupported;
          }
        }, {
          key: "contentLength",
          get: function get() {
            return this._contentLength;
          }
        }, {
          key: "headersReady",
          get: function get() {
            return this._headersReceivedCapability.promise;
          }
        }, {
          key: "read",
          value: function () {
            var _read5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee11() {
              var chunk, requestCapability;
              return regeneratorRuntime.wrap(function _callee11$(_context11) {
                while (1) {
                  switch (_context11.prev = _context11.next) {
                    case 0:
                      if (!this._storedError) {
                        _context11.next = 2;
                        break;
                      }

                      throw this._storedError;

                    case 2:
                      if (!(this._cachedChunks.length > 0)) {
                        _context11.next = 5;
                        break;
                      }

                      chunk = this._cachedChunks.shift();
                      return _context11.abrupt("return", {
                        value: chunk,
                        done: false
                      });

                    case 5:
                      if (!this._done) {
                        _context11.next = 7;
                        break;
                      }

                      return _context11.abrupt("return", {
                        value: undefined,
                        done: true
                      });

                    case 7:
                      requestCapability = (0, _util.createPromiseCapability)();

                      this._requests.push(requestCapability);

                      return _context11.abrupt("return", requestCapability.promise);

                    case 10:
                    case "end":
                      return _context11.stop();
                  }
                }
              }, _callee11, this);
            }));

            function read() {
              return _read5.apply(this, arguments);
            }

            return read;
          }()
        }, {
          key: "cancel",
          value: function cancel(reason) {
            this._done = true;

            this._headersReceivedCapability.reject(reason);

            this._requests.forEach(function (requestCapability) {
              requestCapability.resolve({
                value: undefined,
                done: true
              });
            });

            this._requests = [];

            if (this._manager.isPendingRequest(this._fullRequestId)) {
              this._manager.abortRequest(this._fullRequestId);
            }

            this._fullRequestReader = null;
          }
        }]);

        return PDFNetworkStreamFullRequestReader;
      }();

      var PDFNetworkStreamRangeRequestReader = function () {
        function PDFNetworkStreamRangeRequestReader(manager, begin, end) {
          _classCallCheck(this, PDFNetworkStreamRangeRequestReader);

          this._manager = manager;
          var args = {
            onDone: this._onDone.bind(this),
            onProgress: this._onProgress.bind(this)
          };
          this._requestId = manager.requestRange(begin, end, args);
          this._requests = [];
          this._queuedChunk = null;
          this._done = false;
          this.onProgress = null;
          this.onClosed = null;
        }

        _createClass(PDFNetworkStreamRangeRequestReader, [{
          key: "_close",
          value: function _close() {
            if (this.onClosed) {
              this.onClosed(this);
            }
          }
        }, {
          key: "_onDone",
          value: function _onDone(data) {
            var chunk = data.chunk;

            if (this._requests.length > 0) {
              var requestCapability = this._requests.shift();

              requestCapability.resolve({
                value: chunk,
                done: false
              });
            } else {
              this._queuedChunk = chunk;
            }

            this._done = true;

            this._requests.forEach(function (requestCapability) {
              requestCapability.resolve({
                value: undefined,
                done: true
              });
            });

            this._requests = [];

            this._close();
          }
        }, {
          key: "_onProgress",
          value: function _onProgress(evt) {
            if (!this.isStreamingSupported && this.onProgress) {
              this.onProgress({
                loaded: evt.loaded
              });
            }
          }
        }, {
          key: "isStreamingSupported",
          get: function get() {
            return false;
          }
        }, {
          key: "read",
          value: function () {
            var _read6 = _asyncToGenerator(regeneratorRuntime.mark(function _callee12() {
              var chunk, requestCapability;
              return regeneratorRuntime.wrap(function _callee12$(_context12) {
                while (1) {
                  switch (_context12.prev = _context12.next) {
                    case 0:
                      if (!(this._queuedChunk !== null)) {
                        _context12.next = 4;
                        break;
                      }

                      chunk = this._queuedChunk;
                      this._queuedChunk = null;
                      return _context12.abrupt("return", {
                        value: chunk,
                        done: false
                      });

                    case 4:
                      if (!this._done) {
                        _context12.next = 6;
                        break;
                      }

                      return _context12.abrupt("return", {
                        value: undefined,
                        done: true
                      });

                    case 6:
                      requestCapability = (0, _util.createPromiseCapability)();

                      this._requests.push(requestCapability);

                      return _context12.abrupt("return", requestCapability.promise);

                    case 9:
                    case "end":
                      return _context12.stop();
                  }
                }
              }, _callee12, this);
            }));

            function read() {
              return _read6.apply(this, arguments);
            }

            return read;
          }()
        }, {
          key: "cancel",
          value: function cancel(reason) {
            this._done = true;

            this._requests.forEach(function (requestCapability) {
              requestCapability.resolve({
                value: undefined,
                done: true
              });
            });

            this._requests = [];

            if (this._manager.isPendingRequest(this._requestId)) {
              this._manager.abortRequest(this._requestId);
            }

            this._close();
          }
        }]);

        return PDFNetworkStreamRangeRequestReader;
      }();
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.PDFFetchStream = void 0;

      var _util = __w_pdfjs_require__(2);

      var _network_utils = __w_pdfjs_require__(23);

      function createFetchOptions(headers, withCredentials, abortController) {
        return {
          method: "GET",
          headers: headers,
          signal: abortController && abortController.signal,
          mode: "cors",
          credentials: withCredentials ? "include" : "same-origin",
          redirect: "follow"
        };
      }

      function createHeaders(httpHeaders) {
        var headers = new Headers();

        for (var property in httpHeaders) {
          var value = httpHeaders[property];

          if (typeof value === "undefined") {
            continue;
          }

          headers.append(property, value);
        }

        return headers;
      }

      var PDFFetchStream = function () {
        function PDFFetchStream(source) {
          _classCallCheck(this, PDFFetchStream);

          this.source = source;
          this.isHttp = /^https?:/i.test(source.url);
          this.httpHeaders = this.isHttp && source.httpHeaders || {};
          this._fullRequestReader = null;
          this._rangeRequestReaders = [];
        }

        _createClass(PDFFetchStream, [{
          key: "_progressiveDataLength",
          get: function get() {
            return this._fullRequestReader ? this._fullRequestReader._loaded : 0;
          }
        }, {
          key: "getFullReader",
          value: function getFullReader() {
            (0, _util.assert)(!this._fullRequestReader, "PDFFetchStream.getFullReader can only be called once.");
            this._fullRequestReader = new PDFFetchStreamReader(this);
            return this._fullRequestReader;
          }
        }, {
          key: "getRangeReader",
          value: function getRangeReader(begin, end) {
            if (end <= this._progressiveDataLength) {
              return null;
            }

            var reader = new PDFFetchStreamRangeReader(this, begin, end);

            this._rangeRequestReaders.push(reader);

            return reader;
          }
        }, {
          key: "cancelAllRequests",
          value: function cancelAllRequests(reason) {
            if (this._fullRequestReader) {
              this._fullRequestReader.cancel(reason);
            }

            var readers = this._rangeRequestReaders.slice(0);

            readers.forEach(function (reader) {
              reader.cancel(reason);
            });
          }
        }]);

        return PDFFetchStream;
      }();

      exports.PDFFetchStream = PDFFetchStream;

      var PDFFetchStreamReader = function () {
        function PDFFetchStreamReader(stream) {
          var _this50 = this;

          _classCallCheck(this, PDFFetchStreamReader);

          this._stream = stream;
          this._reader = null;
          this._loaded = 0;
          this._filename = null;
          var source = stream.source;
          this._withCredentials = source.withCredentials || false;
          this._contentLength = source.length;
          this._headersCapability = (0, _util.createPromiseCapability)();
          this._disableRange = source.disableRange || false;
          this._rangeChunkSize = source.rangeChunkSize;

          if (!this._rangeChunkSize && !this._disableRange) {
            this._disableRange = true;
          }

          if (typeof AbortController !== "undefined") {
            this._abortController = new AbortController();
          }

          this._isStreamingSupported = !source.disableStream;
          this._isRangeSupported = !source.disableRange;
          this._headers = createHeaders(this._stream.httpHeaders);
          var url = source.url;
          fetch(url, createFetchOptions(this._headers, this._withCredentials, this._abortController)).then(function (response) {
            if (!(0, _network_utils.validateResponseStatus)(response.status)) {
              throw (0, _network_utils.createResponseStatusError)(response.status, url);
            }

            _this50._reader = response.body.getReader();

            _this50._headersCapability.resolve();

            var getResponseHeader = function getResponseHeader(name) {
              return response.headers.get(name);
            };

            var _ref40 = (0, _network_utils.validateRangeRequestCapabilities)({
              getResponseHeader: getResponseHeader,
              isHttp: _this50._stream.isHttp,
              rangeChunkSize: _this50._rangeChunkSize,
              disableRange: _this50._disableRange
            }),
                allowRangeRequests = _ref40.allowRangeRequests,
                suggestedLength = _ref40.suggestedLength;

            _this50._isRangeSupported = allowRangeRequests;
            _this50._contentLength = suggestedLength || _this50._contentLength;
            _this50._filename = (0, _network_utils.extractFilenameFromHeader)(getResponseHeader);

            if (!_this50._isStreamingSupported && _this50._isRangeSupported) {
              _this50.cancel(new _util.AbortException("Streaming is disabled."));
            }
          }).catch(this._headersCapability.reject);
          this.onProgress = null;
        }

        _createClass(PDFFetchStreamReader, [{
          key: "headersReady",
          get: function get() {
            return this._headersCapability.promise;
          }
        }, {
          key: "filename",
          get: function get() {
            return this._filename;
          }
        }, {
          key: "contentLength",
          get: function get() {
            return this._contentLength;
          }
        }, {
          key: "isRangeSupported",
          get: function get() {
            return this._isRangeSupported;
          }
        }, {
          key: "isStreamingSupported",
          get: function get() {
            return this._isStreamingSupported;
          }
        }, {
          key: "read",
          value: function () {
            var _read7 = _asyncToGenerator(regeneratorRuntime.mark(function _callee13() {
              var _yield$this$_reader$r, value, done, buffer;

              return regeneratorRuntime.wrap(function _callee13$(_context13) {
                while (1) {
                  switch (_context13.prev = _context13.next) {
                    case 0:
                      _context13.next = 2;
                      return this._headersCapability.promise;

                    case 2:
                      _context13.next = 4;
                      return this._reader.read();

                    case 4:
                      _yield$this$_reader$r = _context13.sent;
                      value = _yield$this$_reader$r.value;
                      done = _yield$this$_reader$r.done;

                      if (!done) {
                        _context13.next = 9;
                        break;
                      }

                      return _context13.abrupt("return", {
                        value: value,
                        done: done
                      });

                    case 9:
                      this._loaded += value.byteLength;

                      if (this.onProgress) {
                        this.onProgress({
                          loaded: this._loaded,
                          total: this._contentLength
                        });
                      }

                      buffer = new Uint8Array(value).buffer;
                      return _context13.abrupt("return", {
                        value: buffer,
                        done: false
                      });

                    case 13:
                    case "end":
                      return _context13.stop();
                  }
                }
              }, _callee13, this);
            }));

            function read() {
              return _read7.apply(this, arguments);
            }

            return read;
          }()
        }, {
          key: "cancel",
          value: function cancel(reason) {
            if (this._reader) {
              this._reader.cancel(reason);
            }

            if (this._abortController) {
              this._abortController.abort();
            }
          }
        }]);

        return PDFFetchStreamReader;
      }();

      var PDFFetchStreamRangeReader = function () {
        function PDFFetchStreamRangeReader(stream, begin, end) {
          var _this51 = this;

          _classCallCheck(this, PDFFetchStreamRangeReader);

          this._stream = stream;
          this._reader = null;
          this._loaded = 0;
          var source = stream.source;
          this._withCredentials = source.withCredentials || false;
          this._readCapability = (0, _util.createPromiseCapability)();
          this._isStreamingSupported = !source.disableStream;

          if (typeof AbortController !== "undefined") {
            this._abortController = new AbortController();
          }

          this._headers = createHeaders(this._stream.httpHeaders);

          this._headers.append("Range", "bytes=".concat(begin, "-").concat(end - 1));

          var url = source.url;
          fetch(url, createFetchOptions(this._headers, this._withCredentials, this._abortController)).then(function (response) {
            if (!(0, _network_utils.validateResponseStatus)(response.status)) {
              throw (0, _network_utils.createResponseStatusError)(response.status, url);
            }

            _this51._readCapability.resolve();

            _this51._reader = response.body.getReader();
          }).catch(function (reason) {
            if (reason && reason.name === "AbortError") {
              return;
            }

            throw reason;
          });
          this.onProgress = null;
        }

        _createClass(PDFFetchStreamRangeReader, [{
          key: "isStreamingSupported",
          get: function get() {
            return this._isStreamingSupported;
          }
        }, {
          key: "read",
          value: function () {
            var _read8 = _asyncToGenerator(regeneratorRuntime.mark(function _callee14() {
              var _yield$this$_reader$r2, value, done, buffer;

              return regeneratorRuntime.wrap(function _callee14$(_context14) {
                while (1) {
                  switch (_context14.prev = _context14.next) {
                    case 0:
                      _context14.next = 2;
                      return this._readCapability.promise;

                    case 2:
                      _context14.next = 4;
                      return this._reader.read();

                    case 4:
                      _yield$this$_reader$r2 = _context14.sent;
                      value = _yield$this$_reader$r2.value;
                      done = _yield$this$_reader$r2.done;

                      if (!done) {
                        _context14.next = 9;
                        break;
                      }

                      return _context14.abrupt("return", {
                        value: value,
                        done: done
                      });

                    case 9:
                      this._loaded += value.byteLength;

                      if (this.onProgress) {
                        this.onProgress({
                          loaded: this._loaded
                        });
                      }

                      buffer = new Uint8Array(value).buffer;
                      return _context14.abrupt("return", {
                        value: buffer,
                        done: false
                      });

                    case 13:
                    case "end":
                      return _context14.stop();
                  }
                }
              }, _callee14, this);
            }));

            function read() {
              return _read8.apply(this, arguments);
            }

            return read;
          }()
        }, {
          key: "cancel",
          value: function cancel(reason) {
            if (this._reader) {
              this._reader.cancel(reason);
            }

            if (this._abortController) {
              this._abortController.abort();
            }
          }
        }]);

        return PDFFetchStreamRangeReader;
      }();
    }]);
  });
});
var pdf_module = pdf;

window['pdfjs-dist/build/pdf'] = pdf_module;

var commonjsGlobal$1 = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getAugmentedNamespace$1(n) {
  if (n.__esModule) return n;
  var a = Object.defineProperty({}, '__esModule', {
    value: true
  });
  Object.keys(n).forEach(function (k) {
    var d = Object.getOwnPropertyDescriptor(n, k);
    Object.defineProperty(a, k, d.get ? d : {
      enumerable: true,
      get: function get() {
        return n[k];
      }
    });
  });
  return a;
}

function createCommonjsModule$1(fn) {
  var module = {
    exports: {}
  };
  return fn(module, module.exports), module.exports;
}

var _rollup_plugin_ignore_empty_module_placeholder = {};

var _rollup_plugin_ignore_empty_module_placeholder$1 = Object.freeze({
  __proto__: null,
  'default': _rollup_plugin_ignore_empty_module_placeholder
});

var require$$0 = getAugmentedNamespace$1(_rollup_plugin_ignore_empty_module_placeholder$1);
var pdf_viewer = createCommonjsModule$1(function (module, exports) {
  (function webpackUniversalModuleDefinition(root, factory) {
    module.exports = factory();
  })(commonjsGlobal$1, function () {
    return function (modules) {
      var installedModules = {};

      function __w_pdfjs_require__(moduleId) {
        if (installedModules[moduleId]) {
          return installedModules[moduleId].exports;
        }

        var module = installedModules[moduleId] = {
          i: moduleId,
          l: false,
          exports: {}
        };
        modules[moduleId].call(module.exports, module, module.exports, __w_pdfjs_require__);
        module.l = true;
        return module.exports;
      }

      __w_pdfjs_require__.m = modules;
      __w_pdfjs_require__.c = installedModules;

      __w_pdfjs_require__.d = function (exports, name, getter) {
        if (!__w_pdfjs_require__.o(exports, name)) {
          Object.defineProperty(exports, name, {
            enumerable: true,
            get: getter
          });
        }
      };

      __w_pdfjs_require__.r = function (exports) {
        if (typeof Symbol !== 'undefined' && Symbol.toStringTag) {
          Object.defineProperty(exports, Symbol.toStringTag, {
            value: 'Module'
          });
        }

        Object.defineProperty(exports, '__esModule', {
          value: true
        });
      };

      __w_pdfjs_require__.t = function (value, mode) {
        if (mode & 1) value = __w_pdfjs_require__(value);
        if (mode & 8) return value;
        if (mode & 4 && _typeof(value) === 'object' && value && value.__esModule) return value;
        var ns = Object.create(null);

        __w_pdfjs_require__.r(ns);

        Object.defineProperty(ns, 'default', {
          enumerable: true,
          value: value
        });
        if (mode & 2 && typeof value != 'string') for (var key in value) {
          __w_pdfjs_require__.d(ns, key, function (key) {
            return value[key];
          }.bind(null, key));
        }
        return ns;
      };

      __w_pdfjs_require__.n = function (module) {
        var getter = module && module.__esModule ? function getDefault() {
          return module['default'];
        } : function getModuleExports() {
          return module;
        };

        __w_pdfjs_require__.d(getter, 'a', getter);

        return getter;
      };

      __w_pdfjs_require__.o = function (object, property) {
        return Object.prototype.hasOwnProperty.call(object, property);
      };

      __w_pdfjs_require__.p = "";
      return __w_pdfjs_require__(__w_pdfjs_require__.s = 0);
    }([function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "AnnotationLayerBuilder", {
        enumerable: true,
        get: function get() {
          return _annotation_layer_builder.AnnotationLayerBuilder;
        }
      });
      Object.defineProperty(exports, "DefaultAnnotationLayerFactory", {
        enumerable: true,
        get: function get() {
          return _annotation_layer_builder.DefaultAnnotationLayerFactory;
        }
      });
      Object.defineProperty(exports, "DefaultTextLayerFactory", {
        enumerable: true,
        get: function get() {
          return _text_layer_builder.DefaultTextLayerFactory;
        }
      });
      Object.defineProperty(exports, "TextLayerBuilder", {
        enumerable: true,
        get: function get() {
          return _text_layer_builder.TextLayerBuilder;
        }
      });
      Object.defineProperty(exports, "EventBus", {
        enumerable: true,
        get: function get() {
          return _ui_utils.EventBus;
        }
      });
      Object.defineProperty(exports, "NullL10n", {
        enumerable: true,
        get: function get() {
          return _ui_utils.NullL10n;
        }
      });
      Object.defineProperty(exports, "ProgressBar", {
        enumerable: true,
        get: function get() {
          return _ui_utils.ProgressBar;
        }
      });
      Object.defineProperty(exports, "PDFLinkService", {
        enumerable: true,
        get: function get() {
          return _pdf_link_service.PDFLinkService;
        }
      });
      Object.defineProperty(exports, "SimpleLinkService", {
        enumerable: true,
        get: function get() {
          return _pdf_link_service.SimpleLinkService;
        }
      });
      Object.defineProperty(exports, "DownloadManager", {
        enumerable: true,
        get: function get() {
          return _download_manager.DownloadManager;
        }
      });
      Object.defineProperty(exports, "GenericL10n", {
        enumerable: true,
        get: function get() {
          return _genericl10n.GenericL10n;
        }
      });
      Object.defineProperty(exports, "PDFFindController", {
        enumerable: true,
        get: function get() {
          return _pdf_find_controller.PDFFindController;
        }
      });
      Object.defineProperty(exports, "PDFHistory", {
        enumerable: true,
        get: function get() {
          return _pdf_history.PDFHistory;
        }
      });
      Object.defineProperty(exports, "PDFPageView", {
        enumerable: true,
        get: function get() {
          return _pdf_page_view.PDFPageView;
        }
      });
      Object.defineProperty(exports, "PDFSinglePageViewer", {
        enumerable: true,
        get: function get() {
          return _pdf_single_page_viewer.PDFSinglePageViewer;
        }
      });
      Object.defineProperty(exports, "PDFViewer", {
        enumerable: true,
        get: function get() {
          return _pdf_viewer.PDFViewer;
        }
      });

      var _annotation_layer_builder = __w_pdfjs_require__(1);

      var _text_layer_builder = __w_pdfjs_require__(5);

      var _ui_utils = __w_pdfjs_require__(3);

      var _pdf_link_service = __w_pdfjs_require__(4);

      var _download_manager = __w_pdfjs_require__(6);

      var _genericl10n = __w_pdfjs_require__(8);

      var _pdf_find_controller = __w_pdfjs_require__(10);

      var _pdf_history = __w_pdfjs_require__(12);

      var _pdf_page_view = __w_pdfjs_require__(13);

      var _pdf_single_page_viewer = __w_pdfjs_require__(15);

      var _pdf_viewer = __w_pdfjs_require__(17);
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.DefaultAnnotationLayerFactory = exports.AnnotationLayerBuilder = void 0;

      var _pdfjsLib = __w_pdfjs_require__(2);

      var _ui_utils = __w_pdfjs_require__(3);

      var _pdf_link_service = __w_pdfjs_require__(4);

      var AnnotationLayerBuilder = function () {
        function AnnotationLayerBuilder(_ref) {
          var pageDiv = _ref.pageDiv,
              pdfPage = _ref.pdfPage,
              linkService = _ref.linkService,
              downloadManager = _ref.downloadManager,
              _ref$annotationStorag = _ref.annotationStorage,
              annotationStorage = _ref$annotationStorag === void 0 ? null : _ref$annotationStorag,
              _ref$imageResourcesPa = _ref.imageResourcesPath,
              imageResourcesPath = _ref$imageResourcesPa === void 0 ? "" : _ref$imageResourcesPa,
              _ref$renderInteractiv = _ref.renderInteractiveForms,
              renderInteractiveForms = _ref$renderInteractiv === void 0 ? true : _ref$renderInteractiv,
              _ref$l10n = _ref.l10n,
              l10n = _ref$l10n === void 0 ? _ui_utils.NullL10n : _ref$l10n;

          _classCallCheck(this, AnnotationLayerBuilder);

          this.pageDiv = pageDiv;
          this.pdfPage = pdfPage;
          this.linkService = linkService;
          this.downloadManager = downloadManager;
          this.imageResourcesPath = imageResourcesPath;
          this.renderInteractiveForms = renderInteractiveForms;
          this.l10n = l10n;
          this.annotationStorage = annotationStorage;
          this.div = null;
          this._cancelled = false;
        }

        _createClass(AnnotationLayerBuilder, [{
          key: "render",
          value: function render(viewport) {
            var _this = this;

            var intent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "display";
            return this.pdfPage.getAnnotations({
              intent: intent
            }).then(function (annotations) {
              if (_this._cancelled) {
                return;
              }

              if (annotations.length === 0) {
                return;
              }

              var parameters = {
                viewport: viewport.clone({
                  dontFlip: true
                }),
                div: _this.div,
                annotations: annotations,
                page: _this.pdfPage,
                imageResourcesPath: _this.imageResourcesPath,
                renderInteractiveForms: _this.renderInteractiveForms,
                linkService: _this.linkService,
                downloadManager: _this.downloadManager,
                annotationStorage: _this.annotationStorage
              };

              if (_this.div) {
                _pdfjsLib.AnnotationLayer.update(parameters);
              } else {
                _this.div = document.createElement("div");
                _this.div.className = "annotationLayer";

                _this.pageDiv.appendChild(_this.div);

                parameters.div = _this.div;

                _pdfjsLib.AnnotationLayer.render(parameters);

                _this.l10n.translate(_this.div);
              }
            });
          }
        }, {
          key: "cancel",
          value: function cancel() {
            this._cancelled = true;
          }
        }, {
          key: "hide",
          value: function hide() {
            if (!this.div) {
              return;
            }

            this.div.setAttribute("hidden", "true");
          }
        }]);

        return AnnotationLayerBuilder;
      }();

      exports.AnnotationLayerBuilder = AnnotationLayerBuilder;

      var DefaultAnnotationLayerFactory = function () {
        function DefaultAnnotationLayerFactory() {
          _classCallCheck(this, DefaultAnnotationLayerFactory);
        }

        _createClass(DefaultAnnotationLayerFactory, [{
          key: "createAnnotationLayerBuilder",
          value: function createAnnotationLayerBuilder(pageDiv, pdfPage) {
            var annotationStorage = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
            var imageResourcesPath = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "";
            var renderInteractiveForms = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : true;
            var l10n = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : _ui_utils.NullL10n;
            return new AnnotationLayerBuilder({
              pageDiv: pageDiv,
              pdfPage: pdfPage,
              imageResourcesPath: imageResourcesPath,
              renderInteractiveForms: renderInteractiveForms,
              linkService: new _pdf_link_service.SimpleLinkService(),
              l10n: l10n,
              annotationStorage: annotationStorage
            });
          }
        }]);

        return DefaultAnnotationLayerFactory;
      }();

      exports.DefaultAnnotationLayerFactory = DefaultAnnotationLayerFactory;
    }, function (module, exports, __w_pdfjs_require__) {
      var pdfjsLib;

      if (typeof window !== "undefined" && window["pdfjs-dist/build/pdf"]) {
        pdfjsLib = window["pdfjs-dist/build/pdf"];
      } else {
        pdfjsLib = require$$0;
      }

      module.exports = pdfjsLib;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.isValidRotation = isValidRotation;
      exports.isValidScrollMode = isValidScrollMode;
      exports.isValidSpreadMode = isValidSpreadMode;
      exports.isPortraitOrientation = isPortraitOrientation;
      exports.clamp = clamp;
      exports.getPDFFileNameFromURL = getPDFFileNameFromURL;
      exports.noContextMenuHandler = noContextMenuHandler;
      exports.parseQueryString = parseQueryString;
      exports.backtrackBeforeAllVisibleElements = backtrackBeforeAllVisibleElements;
      exports.getVisibleElements = getVisibleElements;
      exports.roundToDivide = roundToDivide;
      exports.getPageSizeInches = getPageSizeInches;
      exports.approximateFraction = approximateFraction;
      exports.getOutputScale = getOutputScale;
      exports.scrollIntoView = scrollIntoView;
      exports.watchScroll = watchScroll;
      exports.binarySearchFirstItem = binarySearchFirstItem;
      exports.normalizeWheelEventDirection = normalizeWheelEventDirection;
      exports.normalizeWheelEventDelta = normalizeWheelEventDelta;
      exports.waitOnEventOrTimeout = waitOnEventOrTimeout;
      exports.moveToEndOfArray = moveToEndOfArray;
      exports.WaitOnType = exports.animationStarted = exports.ProgressBar = exports.EventBus = exports.NullL10n = exports.SpreadMode = exports.ScrollMode = exports.TextLayerMode = exports.RendererType = exports.PresentationModeState = exports.VERTICAL_PADDING = exports.SCROLLBAR_PADDING = exports.MAX_AUTO_SCALE = exports.UNKNOWN_SCALE = exports.MAX_SCALE = exports.MIN_SCALE = exports.DEFAULT_SCALE = exports.DEFAULT_SCALE_VALUE = exports.CSS_UNITS = exports.AutoPrintRegExp = void 0;
      var CSS_UNITS = 96.0 / 72.0;
      exports.CSS_UNITS = CSS_UNITS;
      var DEFAULT_SCALE_VALUE = "auto";
      exports.DEFAULT_SCALE_VALUE = DEFAULT_SCALE_VALUE;
      var DEFAULT_SCALE = 1.0;
      exports.DEFAULT_SCALE = DEFAULT_SCALE;
      var MIN_SCALE = 0.1;
      exports.MIN_SCALE = MIN_SCALE;
      var MAX_SCALE = 10.0;
      exports.MAX_SCALE = MAX_SCALE;
      var UNKNOWN_SCALE = 0;
      exports.UNKNOWN_SCALE = UNKNOWN_SCALE;
      var MAX_AUTO_SCALE = 1.25;
      exports.MAX_AUTO_SCALE = MAX_AUTO_SCALE;
      var SCROLLBAR_PADDING = 40;
      exports.SCROLLBAR_PADDING = SCROLLBAR_PADDING;
      var VERTICAL_PADDING = 5;
      exports.VERTICAL_PADDING = VERTICAL_PADDING;
      var PresentationModeState = {
        UNKNOWN: 0,
        NORMAL: 1,
        CHANGING: 2,
        FULLSCREEN: 3
      };
      exports.PresentationModeState = PresentationModeState;
      var RendererType = {
        CANVAS: "canvas",
        SVG: "svg"
      };
      exports.RendererType = RendererType;
      var TextLayerMode = {
        DISABLE: 0,
        ENABLE: 1,
        ENABLE_ENHANCE: 2
      };
      exports.TextLayerMode = TextLayerMode;
      var ScrollMode = {
        UNKNOWN: -1,
        VERTICAL: 0,
        HORIZONTAL: 1,
        WRAPPED: 2
      };
      exports.ScrollMode = ScrollMode;
      var SpreadMode = {
        UNKNOWN: -1,
        NONE: 0,
        ODD: 1,
        EVEN: 2
      };
      exports.SpreadMode = SpreadMode;
      var AutoPrintRegExp = /\bprint\s*\(/;
      exports.AutoPrintRegExp = AutoPrintRegExp;

      function formatL10nValue(text, args) {
        if (!args) {
          return text;
        }

        return text.replace(/\{\{\s*(\w+)\s*\}\}/g, function (all, name) {
          return name in args ? args[name] : "{{" + name + "}}";
        });
      }

      var NullL10n = {
        getLanguage: function getLanguage() {
          return _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    return _context.abrupt("return", "en-us");

                  case 1:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }))();
        },
        getDirection: function getDirection() {
          return _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    return _context2.abrupt("return", "ltr");

                  case 1:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2);
          }))();
        },
        get: function get(property, args, fallback) {
          return _asyncToGenerator(regeneratorRuntime.mark(function _callee3() {
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    return _context3.abrupt("return", formatL10nValue(fallback, args));

                  case 1:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3);
          }))();
        },
        translate: function translate(element) {
          return _asyncToGenerator(regeneratorRuntime.mark(function _callee4() {
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                  case "end":
                    return _context4.stop();
                }
              }
            }, _callee4);
          }))();
        }
      };
      exports.NullL10n = NullL10n;

      function getOutputScale(ctx) {
        var devicePixelRatio = window.devicePixelRatio || 1;
        var backingStoreRatio = ctx.webkitBackingStorePixelRatio || ctx.mozBackingStorePixelRatio || ctx.msBackingStorePixelRatio || ctx.oBackingStorePixelRatio || ctx.backingStorePixelRatio || 1;
        var pixelRatio = devicePixelRatio / backingStoreRatio;
        return {
          sx: pixelRatio,
          sy: pixelRatio,
          scaled: pixelRatio !== 1
        };
      }

      function scrollIntoView(element, spot) {
        var skipOverflowHiddenElements = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
        var parent = element.offsetParent;

        if (!parent) {
          console.error("offsetParent is not set -- cannot scroll");
          return;
        }

        var offsetY = element.offsetTop + element.clientTop;
        var offsetX = element.offsetLeft + element.clientLeft;

        while (parent.clientHeight === parent.scrollHeight && parent.clientWidth === parent.scrollWidth || skipOverflowHiddenElements && getComputedStyle(parent).overflow === "hidden") {
          if (parent.dataset._scaleY) {
            offsetY /= parent.dataset._scaleY;
            offsetX /= parent.dataset._scaleX;
          }

          offsetY += parent.offsetTop;
          offsetX += parent.offsetLeft;
          parent = parent.offsetParent;

          if (!parent) {
            return;
          }
        }

        if (spot) {
          if (spot.top !== undefined) {
            offsetY += spot.top;
          }

          if (spot.left !== undefined) {
            offsetX += spot.left;
            parent.scrollLeft = offsetX;
          }
        }

        parent.scrollTop = offsetY;
      }

      function watchScroll(viewAreaElement, callback) {
        var debounceScroll = function debounceScroll(evt) {
          if (rAF) {
            return;
          }

          rAF = window.requestAnimationFrame(function viewAreaElementScrolled() {
            rAF = null;
            var currentX = viewAreaElement.scrollLeft;
            var lastX = state.lastX;

            if (currentX !== lastX) {
              state.right = currentX > lastX;
            }

            state.lastX = currentX;
            var currentY = viewAreaElement.scrollTop;
            var lastY = state.lastY;

            if (currentY !== lastY) {
              state.down = currentY > lastY;
            }

            state.lastY = currentY;
            callback(state);
          });
        };

        var state = {
          right: true,
          down: true,
          lastX: viewAreaElement.scrollLeft,
          lastY: viewAreaElement.scrollTop,
          _eventHandler: debounceScroll
        };
        var rAF = null;
        viewAreaElement.addEventListener("scroll", debounceScroll, true);
        return state;
      }

      function parseQueryString(query) {
        var parts = query.split("&");
        var params = Object.create(null);

        for (var i = 0, ii = parts.length; i < ii; ++i) {
          var param = parts[i].split("=");
          var key = param[0].toLowerCase();
          var value = param.length > 1 ? param[1] : null;
          params[decodeURIComponent(key)] = decodeURIComponent(value);
        }

        return params;
      }

      function binarySearchFirstItem(items, condition) {
        var minIndex = 0;
        var maxIndex = items.length - 1;

        if (maxIndex < 0 || !condition(items[maxIndex])) {
          return items.length;
        }

        if (condition(items[minIndex])) {
          return minIndex;
        }

        while (minIndex < maxIndex) {
          var currentIndex = minIndex + maxIndex >> 1;
          var currentItem = items[currentIndex];

          if (condition(currentItem)) {
            maxIndex = currentIndex;
          } else {
            minIndex = currentIndex + 1;
          }
        }

        return minIndex;
      }

      function approximateFraction(x) {
        if (Math.floor(x) === x) {
          return [x, 1];
        }

        var xinv = 1 / x;
        var limit = 8;

        if (xinv > limit) {
          return [1, limit];
        } else if (Math.floor(xinv) === xinv) {
          return [1, xinv];
        }

        var x_ = x > 1 ? xinv : x;
        var a = 0,
            b = 1,
            c = 1,
            d = 1;

        while (true) {
          var p = a + c,
              q = b + d;

          if (q > limit) {
            break;
          }

          if (x_ <= p / q) {
            c = p;
            d = q;
          } else {
            a = p;
            b = q;
          }
        }

        var result;

        if (x_ - a / b < c / d - x_) {
          result = x_ === x ? [a, b] : [b, a];
        } else {
          result = x_ === x ? [c, d] : [d, c];
        }

        return result;
      }

      function roundToDivide(x, div) {
        var r = x % div;
        return r === 0 ? x : Math.round(x - r + div);
      }

      function getPageSizeInches(_ref2) {
        var view = _ref2.view,
            userUnit = _ref2.userUnit,
            rotate = _ref2.rotate;

        var _view = _slicedToArray(view, 4),
            x1 = _view[0],
            y1 = _view[1],
            x2 = _view[2],
            y2 = _view[3];

        var changeOrientation = rotate % 180 !== 0;
        var width = (x2 - x1) / 72 * userUnit;
        var height = (y2 - y1) / 72 * userUnit;
        return {
          width: changeOrientation ? height : width,
          height: changeOrientation ? width : height
        };
      }

      function backtrackBeforeAllVisibleElements(index, views, top) {
        if (index < 2) {
          return index;
        }

        var elt = views[index].div;
        var pageTop = elt.offsetTop + elt.clientTop;

        if (pageTop >= top) {
          elt = views[index - 1].div;
          pageTop = elt.offsetTop + elt.clientTop;
        }

        for (var i = index - 2; i >= 0; --i) {
          elt = views[i].div;

          if (elt.offsetTop + elt.clientTop + elt.clientHeight <= pageTop) {
            break;
          }

          index = i;
        }

        return index;
      }

      function getVisibleElements(scrollEl, views) {
        var sortByVisibility = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
        var horizontal = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
        var top = scrollEl.scrollTop,
            bottom = top + scrollEl.clientHeight;
        var left = scrollEl.scrollLeft,
            right = left + scrollEl.clientWidth;

        function isElementBottomAfterViewTop(view) {
          var element = view.div;
          var elementBottom = element.offsetTop + element.clientTop + element.clientHeight;
          return elementBottom > top;
        }

        function isElementRightAfterViewLeft(view) {
          var element = view.div;
          var elementRight = element.offsetLeft + element.clientLeft + element.clientWidth;
          return elementRight > left;
        }

        var visible = [],
            numViews = views.length;
        var firstVisibleElementInd = numViews === 0 ? 0 : binarySearchFirstItem(views, horizontal ? isElementRightAfterViewLeft : isElementBottomAfterViewTop);

        if (firstVisibleElementInd > 0 && firstVisibleElementInd < numViews && !horizontal) {
          firstVisibleElementInd = backtrackBeforeAllVisibleElements(firstVisibleElementInd, views, top);
        }

        var lastEdge = horizontal ? right : -1;

        for (var i = firstVisibleElementInd; i < numViews; i++) {
          var view = views[i],
              element = view.div;
          var currentWidth = element.offsetLeft + element.clientLeft;
          var currentHeight = element.offsetTop + element.clientTop;
          var viewWidth = element.clientWidth,
              viewHeight = element.clientHeight;
          var viewRight = currentWidth + viewWidth;
          var viewBottom = currentHeight + viewHeight;

          if (lastEdge === -1) {
            if (viewBottom >= bottom) {
              lastEdge = viewBottom;
            }
          } else if ((horizontal ? currentWidth : currentHeight) > lastEdge) {
            break;
          }

          if (viewBottom <= top || currentHeight >= bottom || viewRight <= left || currentWidth >= right) {
            continue;
          }

          var hiddenHeight = Math.max(0, top - currentHeight) + Math.max(0, viewBottom - bottom);
          var hiddenWidth = Math.max(0, left - currentWidth) + Math.max(0, viewRight - right);
          var percent = (viewHeight - hiddenHeight) * (viewWidth - hiddenWidth) * 100 / viewHeight / viewWidth | 0;
          visible.push({
            id: view.id,
            x: currentWidth,
            y: currentHeight,
            view: view,
            percent: percent
          });
        }

        var first = visible[0],
            last = visible[visible.length - 1];

        if (sortByVisibility) {
          visible.sort(function (a, b) {
            var pc = a.percent - b.percent;

            if (Math.abs(pc) > 0.001) {
              return -pc;
            }

            return a.id - b.id;
          });
        }

        return {
          first: first,
          last: last,
          views: visible
        };
      }

      function noContextMenuHandler(evt) {
        evt.preventDefault();
      }

      function isDataSchema(url) {
        var i = 0;
        var ii = url.length;

        while (i < ii && url[i].trim() === "") {
          i++;
        }

        return url.substring(i, i + 5).toLowerCase() === "data:";
      }

      function getPDFFileNameFromURL(url) {
        var defaultFilename = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "document.pdf";

        if (typeof url !== "string") {
          return defaultFilename;
        }

        if (isDataSchema(url)) {
          console.warn("getPDFFileNameFromURL: " + 'ignoring "data:" URL for performance reasons.');
          return defaultFilename;
        }

        var reURI = /^(?:(?:[^:]+:)?\/\/[^\/]+)?([^?#]*)(\?[^#]*)?(#.*)?$/;
        var reFilename = /[^\/?#=]+\.pdf\b(?!.*\.pdf\b)/i;
        var splitURI = reURI.exec(url);
        var suggestedFilename = reFilename.exec(splitURI[1]) || reFilename.exec(splitURI[2]) || reFilename.exec(splitURI[3]);

        if (suggestedFilename) {
          suggestedFilename = suggestedFilename[0];

          if (suggestedFilename.includes("%")) {
            try {
              suggestedFilename = reFilename.exec(decodeURIComponent(suggestedFilename))[0];
            } catch (ex) {}
          }
        }

        return suggestedFilename || defaultFilename;
      }

      function normalizeWheelEventDirection(evt) {
        var delta = Math.sqrt(evt.deltaX * evt.deltaX + evt.deltaY * evt.deltaY);
        var angle = Math.atan2(evt.deltaY, evt.deltaX);

        if (-0.25 * Math.PI < angle && angle < 0.75 * Math.PI) {
          delta = -delta;
        }

        return delta;
      }

      function normalizeWheelEventDelta(evt) {
        var delta = normalizeWheelEventDirection(evt);
        var MOUSE_DOM_DELTA_PIXEL_MODE = 0;
        var MOUSE_DOM_DELTA_LINE_MODE = 1;
        var MOUSE_PIXELS_PER_LINE = 30;
        var MOUSE_LINES_PER_PAGE = 30;

        if (evt.deltaMode === MOUSE_DOM_DELTA_PIXEL_MODE) {
          delta /= MOUSE_PIXELS_PER_LINE * MOUSE_LINES_PER_PAGE;
        } else if (evt.deltaMode === MOUSE_DOM_DELTA_LINE_MODE) {
          delta /= MOUSE_LINES_PER_PAGE;
        }

        return delta;
      }

      function isValidRotation(angle) {
        return Number.isInteger(angle) && angle % 90 === 0;
      }

      function isValidScrollMode(mode) {
        return Number.isInteger(mode) && Object.values(ScrollMode).includes(mode) && mode !== ScrollMode.UNKNOWN;
      }

      function isValidSpreadMode(mode) {
        return Number.isInteger(mode) && Object.values(SpreadMode).includes(mode) && mode !== SpreadMode.UNKNOWN;
      }

      function isPortraitOrientation(size) {
        return size.width <= size.height;
      }

      var WaitOnType = {
        EVENT: "event",
        TIMEOUT: "timeout"
      };
      exports.WaitOnType = WaitOnType;

      function waitOnEventOrTimeout(_ref3) {
        var target = _ref3.target,
            name = _ref3.name,
            _ref3$delay = _ref3.delay,
            delay = _ref3$delay === void 0 ? 0 : _ref3$delay;
        return new Promise(function (resolve, reject) {
          if (_typeof(target) !== "object" || !(name && typeof name === "string") || !(Number.isInteger(delay) && delay >= 0)) {
            throw new Error("waitOnEventOrTimeout - invalid parameters.");
          }

          function handler(type) {
            if (target instanceof EventBus) {
              target._off(name, eventHandler);
            } else {
              target.removeEventListener(name, eventHandler);
            }

            if (timeout) {
              clearTimeout(timeout);
            }

            resolve(type);
          }

          var eventHandler = handler.bind(null, WaitOnType.EVENT);

          if (target instanceof EventBus) {
            target._on(name, eventHandler);
          } else {
            target.addEventListener(name, eventHandler);
          }

          var timeoutHandler = handler.bind(null, WaitOnType.TIMEOUT);
          var timeout = setTimeout(timeoutHandler, delay);
        });
      }

      var animationStarted = new Promise(function (resolve) {
        window.requestAnimationFrame(resolve);
      });
      exports.animationStarted = animationStarted;

      var EventBus = function () {
        function EventBus(options) {
          _classCallCheck(this, EventBus);

          this._listeners = Object.create(null);
        }

        _createClass(EventBus, [{
          key: "on",
          value: function on(eventName, listener) {
            this._on(eventName, listener, {
              external: true
            });
          }
        }, {
          key: "off",
          value: function off(eventName, listener) {
            this._off(eventName, listener, {
              external: true
            });
          }
        }, {
          key: "dispatch",
          value: function dispatch(eventName) {
            var eventListeners = this._listeners[eventName];

            if (!eventListeners || eventListeners.length === 0) {
              return;
            }

            var args = Array.prototype.slice.call(arguments, 1);
            var externalListeners;
            eventListeners.slice(0).forEach(function (_ref4) {
              var listener = _ref4.listener,
                  external = _ref4.external;

              if (external) {
                if (!externalListeners) {
                  externalListeners = [];
                }

                externalListeners.push(listener);
                return;
              }

              listener.apply(null, args);
            });

            if (externalListeners) {
              externalListeners.forEach(function (listener) {
                listener.apply(null, args);
              });
              externalListeners = null;
            }
          }
        }, {
          key: "_on",
          value: function _on(eventName, listener) {
            var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
            var eventListeners = this._listeners[eventName];

            if (!eventListeners) {
              this._listeners[eventName] = eventListeners = [];
            }

            eventListeners.push({
              listener: listener,
              external: (options && options.external) === true
            });
          }
        }, {
          key: "_off",
          value: function _off(eventName, listener) {
            var eventListeners = this._listeners[eventName];

            if (!eventListeners) {
              return;
            }

            for (var i = 0, ii = eventListeners.length; i < ii; i++) {
              if (eventListeners[i].listener === listener) {
                eventListeners.splice(i, 1);
                return;
              }
            }
          }
        }]);

        return EventBus;
      }();

      exports.EventBus = EventBus;

      function clamp(v, min, max) {
        return Math.min(Math.max(v, min), max);
      }

      var ProgressBar = function () {
        function ProgressBar(id) {
          var _ref5 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
              height = _ref5.height,
              width = _ref5.width,
              units = _ref5.units;

          _classCallCheck(this, ProgressBar);

          this.visible = true;
          this.div = document.querySelector(id + " .progress");
          this.bar = this.div.parentNode;
          this.height = height || 100;
          this.width = width || 100;
          this.units = units || "%";
          this.div.style.height = this.height + this.units;
          this.percent = 0;
        }

        _createClass(ProgressBar, [{
          key: "_updateBar",
          value: function _updateBar() {
            if (this._indeterminate) {
              this.div.classList.add("indeterminate");
              this.div.style.width = this.width + this.units;
              return;
            }

            this.div.classList.remove("indeterminate");
            var progressSize = this.width * this._percent / 100;
            this.div.style.width = progressSize + this.units;
          }
        }, {
          key: "percent",
          get: function get() {
            return this._percent;
          },
          set: function set(val) {
            this._indeterminate = isNaN(val);
            this._percent = clamp(val, 0, 100);

            this._updateBar();
          }
        }, {
          key: "setWidth",
          value: function setWidth(viewer) {
            if (!viewer) {
              return;
            }

            var container = viewer.parentNode;
            var scrollbarWidth = container.offsetWidth - viewer.offsetWidth;

            if (scrollbarWidth > 0) {
              this.bar.style.width = "calc(100% - ".concat(scrollbarWidth, "px)");
            }
          }
        }, {
          key: "hide",
          value: function hide() {
            if (!this.visible) {
              return;
            }

            this.visible = false;
            this.bar.classList.add("hidden");
            document.body.classList.remove("loadingInProgress");
          }
        }, {
          key: "show",
          value: function show() {
            if (this.visible) {
              return;
            }

            this.visible = true;
            document.body.classList.add("loadingInProgress");
            this.bar.classList.remove("hidden");
          }
        }]);

        return ProgressBar;
      }();

      exports.ProgressBar = ProgressBar;

      function moveToEndOfArray(arr, condition) {
        var moved = [],
            len = arr.length;
        var write = 0;

        for (var read = 0; read < len; ++read) {
          if (condition(arr[read])) {
            moved.push(arr[read]);
          } else {
            arr[write] = arr[read];
            ++write;
          }
        }

        for (var _read = 0; write < len; ++_read, ++write) {
          arr[write] = moved[_read];
        }
      }
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.SimpleLinkService = exports.PDFLinkService = void 0;

      var _ui_utils = __w_pdfjs_require__(3);

      var PDFLinkService = function () {
        function PDFLinkService() {
          var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
              eventBus = _ref6.eventBus,
              _ref6$externalLinkTar = _ref6.externalLinkTarget,
              externalLinkTarget = _ref6$externalLinkTar === void 0 ? null : _ref6$externalLinkTar,
              _ref6$externalLinkRel = _ref6.externalLinkRel,
              externalLinkRel = _ref6$externalLinkRel === void 0 ? null : _ref6$externalLinkRel,
              _ref6$externalLinkEna = _ref6.externalLinkEnabled,
              externalLinkEnabled = _ref6$externalLinkEna === void 0 ? true : _ref6$externalLinkEna,
              _ref6$ignoreDestinati = _ref6.ignoreDestinationZoom,
              ignoreDestinationZoom = _ref6$ignoreDestinati === void 0 ? false : _ref6$ignoreDestinati;

          _classCallCheck(this, PDFLinkService);

          this.eventBus = eventBus;
          this.externalLinkTarget = externalLinkTarget;
          this.externalLinkRel = externalLinkRel;
          this.externalLinkEnabled = externalLinkEnabled;
          this._ignoreDestinationZoom = ignoreDestinationZoom;
          this.baseUrl = null;
          this.pdfDocument = null;
          this.pdfViewer = null;
          this.pdfHistory = null;
          this._pagesRefCache = null;
        }

        _createClass(PDFLinkService, [{
          key: "setDocument",
          value: function setDocument(pdfDocument) {
            var baseUrl = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
            this.baseUrl = baseUrl;
            this.pdfDocument = pdfDocument;
            this._pagesRefCache = Object.create(null);
          }
        }, {
          key: "setViewer",
          value: function setViewer(pdfViewer) {
            this.pdfViewer = pdfViewer;
          }
        }, {
          key: "setHistory",
          value: function setHistory(pdfHistory) {
            this.pdfHistory = pdfHistory;
          }
        }, {
          key: "pagesCount",
          get: function get() {
            return this.pdfDocument ? this.pdfDocument.numPages : 0;
          }
        }, {
          key: "page",
          get: function get() {
            return this.pdfViewer.currentPageNumber;
          },
          set: function set(value) {
            this.pdfViewer.currentPageNumber = value;
          }
        }, {
          key: "rotation",
          get: function get() {
            return this.pdfViewer.pagesRotation;
          },
          set: function set(value) {
            this.pdfViewer.pagesRotation = value;
          }
        }, {
          key: "navigateTo",
          value: function navigateTo(dest) {
            var _this2 = this;

            var goToDestination = function goToDestination(_ref7) {
              var namedDest = _ref7.namedDest,
                  explicitDest = _ref7.explicitDest;
              var destRef = explicitDest[0];
              var pageNumber;

              if (destRef instanceof Object) {
                pageNumber = _this2._cachedPageNumber(destRef);

                if (pageNumber === null) {
                  _this2.pdfDocument.getPageIndex(destRef).then(function (pageIndex) {
                    _this2.cachePageRef(pageIndex + 1, destRef);

                    goToDestination({
                      namedDest: namedDest,
                      explicitDest: explicitDest
                    });
                  }).catch(function () {
                    console.error("PDFLinkService.navigateTo: \"".concat(destRef, "\" is not ") + "a valid page reference, for dest=\"".concat(dest, "\"."));
                  });

                  return;
                }
              } else if (Number.isInteger(destRef)) {
                pageNumber = destRef + 1;
              } else {
                console.error("PDFLinkService.navigateTo: \"".concat(destRef, "\" is not ") + "a valid destination reference, for dest=\"".concat(dest, "\"."));
                return;
              }

              if (!pageNumber || pageNumber < 1 || pageNumber > _this2.pagesCount) {
                console.error("PDFLinkService.navigateTo: \"".concat(pageNumber, "\" is not ") + "a valid page number, for dest=\"".concat(dest, "\"."));
                return;
              }

              if (_this2.pdfHistory) {
                _this2.pdfHistory.pushCurrentPosition();

                _this2.pdfHistory.push({
                  namedDest: namedDest,
                  explicitDest: explicitDest,
                  pageNumber: pageNumber
                });
              }

              _this2.pdfViewer.scrollPageIntoView({
                pageNumber: pageNumber,
                destArray: explicitDest,
                ignoreDestinationZoom: _this2._ignoreDestinationZoom
              });
            };

            new Promise(function (resolve, reject) {
              if (typeof dest === "string") {
                _this2.pdfDocument.getDestination(dest).then(function (destArray) {
                  resolve({
                    namedDest: dest,
                    explicitDest: destArray
                  });
                });

                return;
              }

              resolve({
                namedDest: "",
                explicitDest: dest
              });
            }).then(function (data) {
              if (!Array.isArray(data.explicitDest)) {
                console.error("PDFLinkService.navigateTo: \"".concat(data.explicitDest, "\" is") + " not a valid destination array, for dest=\"".concat(dest, "\"."));
                return;
              }

              goToDestination(data);
            });
          }
        }, {
          key: "getDestinationHash",
          value: function getDestinationHash(dest) {
            if (typeof dest === "string") {
              return this.getAnchorUrl("#" + escape(dest));
            }

            if (Array.isArray(dest)) {
              var str = JSON.stringify(dest);
              return this.getAnchorUrl("#" + escape(str));
            }

            return this.getAnchorUrl("");
          }
        }, {
          key: "getAnchorUrl",
          value: function getAnchorUrl(anchor) {
            return (this.baseUrl || "") + anchor;
          }
        }, {
          key: "setHash",
          value: function setHash(hash) {
            var pageNumber, dest;

            if (hash.includes("=")) {
              var params = (0, _ui_utils.parseQueryString)(hash);

              if ("search" in params) {
                this.eventBus.dispatch("findfromurlhash", {
                  source: this,
                  query: params.search.replace(/"/g, ""),
                  phraseSearch: params.phrase === "true"
                });
              }

              if ("page" in params) {
                pageNumber = params.page | 0 || 1;
              }

              if ("zoom" in params) {
                var zoomArgs = params.zoom.split(",");
                var zoomArg = zoomArgs[0];
                var zoomArgNumber = parseFloat(zoomArg);

                if (!zoomArg.includes("Fit")) {
                  dest = [null, {
                    name: "XYZ"
                  }, zoomArgs.length > 1 ? zoomArgs[1] | 0 : null, zoomArgs.length > 2 ? zoomArgs[2] | 0 : null, zoomArgNumber ? zoomArgNumber / 100 : zoomArg];
                } else {
                  if (zoomArg === "Fit" || zoomArg === "FitB") {
                    dest = [null, {
                      name: zoomArg
                    }];
                  } else if (zoomArg === "FitH" || zoomArg === "FitBH" || zoomArg === "FitV" || zoomArg === "FitBV") {
                    dest = [null, {
                      name: zoomArg
                    }, zoomArgs.length > 1 ? zoomArgs[1] | 0 : null];
                  } else if (zoomArg === "FitR") {
                    if (zoomArgs.length !== 5) {
                      console.error('PDFLinkService.setHash: Not enough parameters for "FitR".');
                    } else {
                      dest = [null, {
                        name: zoomArg
                      }, zoomArgs[1] | 0, zoomArgs[2] | 0, zoomArgs[3] | 0, zoomArgs[4] | 0];
                    }
                  } else {
                    console.error("PDFLinkService.setHash: \"".concat(zoomArg, "\" is not ") + "a valid zoom value.");
                  }
                }
              }

              if (dest) {
                this.pdfViewer.scrollPageIntoView({
                  pageNumber: pageNumber || this.page,
                  destArray: dest,
                  allowNegativeOffset: true
                });
              } else if (pageNumber) {
                this.page = pageNumber;
              }

              if ("pagemode" in params) {
                this.eventBus.dispatch("pagemode", {
                  source: this,
                  mode: params.pagemode
                });
              }

              if ("nameddest" in params) {
                this.navigateTo(params.nameddest);
              }
            } else {
              dest = unescape(hash);

              try {
                dest = JSON.parse(dest);

                if (!Array.isArray(dest)) {
                  dest = dest.toString();
                }
              } catch (ex) {}

              if (typeof dest === "string" || isValidExplicitDestination(dest)) {
                this.navigateTo(dest);
                return;
              }

              console.error("PDFLinkService.setHash: \"".concat(unescape(hash), "\" is not ") + "a valid destination.");
            }
          }
        }, {
          key: "executeNamedAction",
          value: function executeNamedAction(action) {
            switch (action) {
              case "GoBack":
                if (this.pdfHistory) {
                  this.pdfHistory.back();
                }

                break;

              case "GoForward":
                if (this.pdfHistory) {
                  this.pdfHistory.forward();
                }

                break;

              case "NextPage":
                if (this.page < this.pagesCount) {
                  this.page++;
                }

                break;

              case "PrevPage":
                if (this.page > 1) {
                  this.page--;
                }

                break;

              case "LastPage":
                this.page = this.pagesCount;
                break;

              case "FirstPage":
                this.page = 1;
                break;
            }

            this.eventBus.dispatch("namedaction", {
              source: this,
              action: action
            });
          }
        }, {
          key: "cachePageRef",
          value: function cachePageRef(pageNum, pageRef) {
            if (!pageRef) {
              return;
            }

            var refStr = pageRef.gen === 0 ? "".concat(pageRef.num, "R") : "".concat(pageRef.num, "R").concat(pageRef.gen);
            this._pagesRefCache[refStr] = pageNum;
          }
        }, {
          key: "_cachedPageNumber",
          value: function _cachedPageNumber(pageRef) {
            var refStr = pageRef.gen === 0 ? "".concat(pageRef.num, "R") : "".concat(pageRef.num, "R").concat(pageRef.gen);
            return this._pagesRefCache && this._pagesRefCache[refStr] || null;
          }
        }, {
          key: "isPageVisible",
          value: function isPageVisible(pageNumber) {
            return this.pdfViewer.isPageVisible(pageNumber);
          }
        }]);

        return PDFLinkService;
      }();

      exports.PDFLinkService = PDFLinkService;

      function isValidExplicitDestination(dest) {
        if (!Array.isArray(dest)) {
          return false;
        }

        var destLength = dest.length;

        if (destLength < 2) {
          return false;
        }

        var page = dest[0];

        if (!(_typeof(page) === "object" && Number.isInteger(page.num) && Number.isInteger(page.gen)) && !(Number.isInteger(page) && page >= 0)) {
          return false;
        }

        var zoom = dest[1];

        if (!(_typeof(zoom) === "object" && typeof zoom.name === "string")) {
          return false;
        }

        var allowNull = true;

        switch (zoom.name) {
          case "XYZ":
            if (destLength !== 5) {
              return false;
            }

            break;

          case "Fit":
          case "FitB":
            return destLength === 2;

          case "FitH":
          case "FitBH":
          case "FitV":
          case "FitBV":
            if (destLength !== 3) {
              return false;
            }

            break;

          case "FitR":
            if (destLength !== 6) {
              return false;
            }

            allowNull = false;
            break;

          default:
            return false;
        }

        for (var i = 2; i < destLength; i++) {
          var param = dest[i];

          if (!(typeof param === "number" || allowNull && param === null)) {
            return false;
          }
        }

        return true;
      }

      var SimpleLinkService = function () {
        function SimpleLinkService() {
          _classCallCheck(this, SimpleLinkService);

          this.externalLinkTarget = null;
          this.externalLinkRel = null;
          this.externalLinkEnabled = true;
          this._ignoreDestinationZoom = false;
        }

        _createClass(SimpleLinkService, [{
          key: "pagesCount",
          get: function get() {
            return 0;
          }
        }, {
          key: "page",
          get: function get() {
            return 0;
          },
          set: function set(value) {}
        }, {
          key: "rotation",
          get: function get() {
            return 0;
          },
          set: function set(value) {}
        }, {
          key: "navigateTo",
          value: function navigateTo(dest) {}
        }, {
          key: "getDestinationHash",
          value: function getDestinationHash(dest) {
            return "#";
          }
        }, {
          key: "getAnchorUrl",
          value: function getAnchorUrl(hash) {
            return "#";
          }
        }, {
          key: "setHash",
          value: function setHash(hash) {}
        }, {
          key: "executeNamedAction",
          value: function executeNamedAction(action) {}
        }, {
          key: "cachePageRef",
          value: function cachePageRef(pageNum, pageRef) {}
        }, {
          key: "isPageVisible",
          value: function isPageVisible(pageNumber) {
            return true;
          }
        }]);

        return SimpleLinkService;
      }();

      exports.SimpleLinkService = SimpleLinkService;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.DefaultTextLayerFactory = exports.TextLayerBuilder = void 0;

      var _pdfjsLib = __w_pdfjs_require__(2);

      var EXPAND_DIVS_TIMEOUT = 300;

      var TextLayerBuilder = function () {
        function TextLayerBuilder(_ref8) {
          var textLayerDiv = _ref8.textLayerDiv,
              eventBus = _ref8.eventBus,
              pageIndex = _ref8.pageIndex,
              viewport = _ref8.viewport,
              _ref8$findController = _ref8.findController,
              findController = _ref8$findController === void 0 ? null : _ref8$findController,
              _ref8$enhanceTextSele = _ref8.enhanceTextSelection,
              enhanceTextSelection = _ref8$enhanceTextSele === void 0 ? false : _ref8$enhanceTextSele;

          _classCallCheck(this, TextLayerBuilder);

          this.textLayerDiv = textLayerDiv;
          this.eventBus = eventBus;
          this.textContent = null;
          this.textContentItemsStr = [];
          this.textContentStream = null;
          this.renderingDone = false;
          this.pageIdx = pageIndex;
          this.pageNumber = this.pageIdx + 1;
          this.matches = [];
          this.viewport = viewport;
          this.textDivs = [];
          this.findController = findController;
          this.textLayerRenderTask = null;
          this.enhanceTextSelection = enhanceTextSelection;
          this._onUpdateTextLayerMatches = null;

          this._bindMouse();
        }

        _createClass(TextLayerBuilder, [{
          key: "_finishRendering",
          value: function _finishRendering() {
            this.renderingDone = true;

            if (!this.enhanceTextSelection) {
              var endOfContent = document.createElement("div");
              endOfContent.className = "endOfContent";
              this.textLayerDiv.appendChild(endOfContent);
            }

            this.eventBus.dispatch("textlayerrendered", {
              source: this,
              pageNumber: this.pageNumber,
              numTextDivs: this.textDivs.length
            });
          }
        }, {
          key: "render",
          value: function render() {
            var _this3 = this;

            var timeout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

            if (!(this.textContent || this.textContentStream) || this.renderingDone) {
              return;
            }

            this.cancel();
            this.textDivs = [];
            var textLayerFrag = document.createDocumentFragment();
            this.textLayerRenderTask = (0, _pdfjsLib.renderTextLayer)({
              textContent: this.textContent,
              textContentStream: this.textContentStream,
              container: textLayerFrag,
              viewport: this.viewport,
              textDivs: this.textDivs,
              textContentItemsStr: this.textContentItemsStr,
              timeout: timeout,
              enhanceTextSelection: this.enhanceTextSelection
            });
            this.textLayerRenderTask.promise.then(function () {
              _this3.textLayerDiv.appendChild(textLayerFrag);

              _this3._finishRendering();

              _this3._updateMatches();
            }, function (reason) {});

            if (!this._onUpdateTextLayerMatches) {
              this._onUpdateTextLayerMatches = function (evt) {
                if (evt.pageIndex === _this3.pageIdx || evt.pageIndex === -1) {
                  _this3._updateMatches();
                }
              };

              this.eventBus._on("updatetextlayermatches", this._onUpdateTextLayerMatches);
            }
          }
        }, {
          key: "cancel",
          value: function cancel() {
            if (this.textLayerRenderTask) {
              this.textLayerRenderTask.cancel();
              this.textLayerRenderTask = null;
            }

            if (this._onUpdateTextLayerMatches) {
              this.eventBus._off("updatetextlayermatches", this._onUpdateTextLayerMatches);

              this._onUpdateTextLayerMatches = null;
            }
          }
        }, {
          key: "setTextContentStream",
          value: function setTextContentStream(readableStream) {
            this.cancel();
            this.textContentStream = readableStream;
          }
        }, {
          key: "setTextContent",
          value: function setTextContent(textContent) {
            this.cancel();
            this.textContent = textContent;
          }
        }, {
          key: "_convertMatches",
          value: function _convertMatches(matches, matchesLength) {
            if (!matches) {
              return [];
            }

            var findController = this.findController,
                textContentItemsStr = this.textContentItemsStr;
            var i = 0,
                iIndex = 0;
            var end = textContentItemsStr.length - 1;
            var queryLen = findController.state.query.length;
            var result = [];

            for (var m = 0, mm = matches.length; m < mm; m++) {
              var matchIdx = matches[m];

              while (i !== end && matchIdx >= iIndex + textContentItemsStr[i].length) {
                iIndex += textContentItemsStr[i].length;
                i++;
              }

              if (i === textContentItemsStr.length) {
                console.error("Could not find a matching mapping");
              }

              var match = {
                begin: {
                  divIdx: i,
                  offset: matchIdx - iIndex
                }
              };

              if (matchesLength) {
                matchIdx += matchesLength[m];
              } else {
                matchIdx += queryLen;
              }

              while (i !== end && matchIdx > iIndex + textContentItemsStr[i].length) {
                iIndex += textContentItemsStr[i].length;
                i++;
              }

              match.end = {
                divIdx: i,
                offset: matchIdx - iIndex
              };
              result.push(match);
            }

            return result;
          }
        }, {
          key: "_renderMatches",
          value: function _renderMatches(matches) {
            if (matches.length === 0) {
              return;
            }

            var findController = this.findController,
                pageIdx = this.pageIdx,
                textContentItemsStr = this.textContentItemsStr,
                textDivs = this.textDivs;
            var isSelectedPage = pageIdx === findController.selected.pageIdx;
            var selectedMatchIdx = findController.selected.matchIdx;
            var highlightAll = findController.state.highlightAll;
            var prevEnd = null;
            var infinity = {
              divIdx: -1,
              offset: undefined
            };

            function beginText(begin, className) {
              var divIdx = begin.divIdx;
              textDivs[divIdx].textContent = "";
              appendTextToDiv(divIdx, 0, begin.offset, className);
            }

            function appendTextToDiv(divIdx, fromOffset, toOffset, className) {
              var div = textDivs[divIdx];
              var content = textContentItemsStr[divIdx].substring(fromOffset, toOffset);
              var node = document.createTextNode(content);

              if (className) {
                var span = document.createElement("span");
                span.className = className;
                span.appendChild(node);
                div.appendChild(span);
                return;
              }

              div.appendChild(node);
            }

            var i0 = selectedMatchIdx,
                i1 = i0 + 1;

            if (highlightAll) {
              i0 = 0;
              i1 = matches.length;
            } else if (!isSelectedPage) {
              return;
            }

            for (var i = i0; i < i1; i++) {
              var match = matches[i];
              var begin = match.begin;
              var end = match.end;
              var isSelected = isSelectedPage && i === selectedMatchIdx;
              var highlightSuffix = isSelected ? " selected" : "";

              if (isSelected) {
                findController.scrollMatchIntoView({
                  element: textDivs[begin.divIdx],
                  pageIndex: pageIdx,
                  matchIndex: selectedMatchIdx
                });
              }

              if (!prevEnd || begin.divIdx !== prevEnd.divIdx) {
                if (prevEnd !== null) {
                  appendTextToDiv(prevEnd.divIdx, prevEnd.offset, infinity.offset);
                }

                beginText(begin);
              } else {
                appendTextToDiv(prevEnd.divIdx, prevEnd.offset, begin.offset);
              }

              if (begin.divIdx === end.divIdx) {
                appendTextToDiv(begin.divIdx, begin.offset, end.offset, "highlight" + highlightSuffix);
              } else {
                appendTextToDiv(begin.divIdx, begin.offset, infinity.offset, "highlight begin" + highlightSuffix);

                for (var n0 = begin.divIdx + 1, n1 = end.divIdx; n0 < n1; n0++) {
                  textDivs[n0].className = "highlight middle" + highlightSuffix;
                }

                beginText(end, "highlight end" + highlightSuffix);
              }

              prevEnd = end;
            }

            if (prevEnd) {
              appendTextToDiv(prevEnd.divIdx, prevEnd.offset, infinity.offset);
            }
          }
        }, {
          key: "_updateMatches",
          value: function _updateMatches() {
            if (!this.renderingDone) {
              return;
            }

            var findController = this.findController,
                matches = this.matches,
                pageIdx = this.pageIdx,
                textContentItemsStr = this.textContentItemsStr,
                textDivs = this.textDivs;
            var clearedUntilDivIdx = -1;

            for (var i = 0, ii = matches.length; i < ii; i++) {
              var match = matches[i];
              var begin = Math.max(clearedUntilDivIdx, match.begin.divIdx);

              for (var n = begin, end = match.end.divIdx; n <= end; n++) {
                var div = textDivs[n];
                div.textContent = textContentItemsStr[n];
                div.className = "";
              }

              clearedUntilDivIdx = match.end.divIdx + 1;
            }

            if (!findController || !findController.highlightMatches) {
              return;
            }

            var pageMatches = findController.pageMatches[pageIdx] || null;
            var pageMatchesLength = findController.pageMatchesLength[pageIdx] || null;
            this.matches = this._convertMatches(pageMatches, pageMatchesLength);

            this._renderMatches(this.matches);
          }
        }, {
          key: "_bindMouse",
          value: function _bindMouse() {
            var _this4 = this;

            var div = this.textLayerDiv;
            var expandDivsTimer = null;
            div.addEventListener("mousedown", function (evt) {
              if (_this4.enhanceTextSelection && _this4.textLayerRenderTask) {
                _this4.textLayerRenderTask.expandTextDivs(true);

                if (expandDivsTimer) {
                  clearTimeout(expandDivsTimer);
                  expandDivsTimer = null;
                }

                return;
              }

              var end = div.querySelector(".endOfContent");

              if (!end) {
                return;
              }

              var adjustTop = evt.target !== div;
              adjustTop = adjustTop && window.getComputedStyle(end).getPropertyValue("-moz-user-select") !== "none";

              if (adjustTop) {
                var divBounds = div.getBoundingClientRect();
                var r = Math.max(0, (evt.pageY - divBounds.top) / divBounds.height);
                end.style.top = (r * 100).toFixed(2) + "%";
              }

              end.classList.add("active");
            });
            div.addEventListener("mouseup", function () {
              if (_this4.enhanceTextSelection && _this4.textLayerRenderTask) {
                expandDivsTimer = setTimeout(function () {
                  if (_this4.textLayerRenderTask) {
                    _this4.textLayerRenderTask.expandTextDivs(false);
                  }

                  expandDivsTimer = null;
                }, EXPAND_DIVS_TIMEOUT);
                return;
              }

              var end = div.querySelector(".endOfContent");

              if (!end) {
                return;
              }

              end.style.top = "";
              end.classList.remove("active");
            });
          }
        }]);

        return TextLayerBuilder;
      }();

      exports.TextLayerBuilder = TextLayerBuilder;

      var DefaultTextLayerFactory = function () {
        function DefaultTextLayerFactory() {
          _classCallCheck(this, DefaultTextLayerFactory);
        }

        _createClass(DefaultTextLayerFactory, [{
          key: "createTextLayerBuilder",
          value: function createTextLayerBuilder(textLayerDiv, pageIndex, viewport) {
            var enhanceTextSelection = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
            var eventBus = arguments.length > 4 ? arguments[4] : undefined;
            return new TextLayerBuilder({
              textLayerDiv: textLayerDiv,
              pageIndex: pageIndex,
              viewport: viewport,
              enhanceTextSelection: enhanceTextSelection,
              eventBus: eventBus
            });
          }
        }]);

        return DefaultTextLayerFactory;
      }();

      exports.DefaultTextLayerFactory = DefaultTextLayerFactory;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.DownloadManager = void 0;

      var _pdfjsLib = __w_pdfjs_require__(2);

      var _viewer_compatibility = __w_pdfjs_require__(7);

      function _download(blobUrl, filename) {
        var a = document.createElement("a");

        if (!a.click) {
          throw new Error('DownloadManager: "a.click()" is not supported.');
        }

        a.href = blobUrl;
        a.target = "_parent";

        if ("download" in a) {
          a.download = filename;
        }

        (document.body || document.documentElement).appendChild(a);
        a.click();
        a.remove();
      }

      var DownloadManager = function () {
        function DownloadManager() {
          _classCallCheck(this, DownloadManager);
        }

        _createClass(DownloadManager, [{
          key: "downloadUrl",
          value: function downloadUrl(url, filename) {
            if (!(0, _pdfjsLib.createValidAbsoluteUrl)(url, "http://example.com")) {
              return;
            }

            _download(url + "#pdfjs.action=download", filename);
          }
        }, {
          key: "downloadData",
          value: function downloadData(data, filename, contentType) {
            if (navigator.msSaveBlob) {
              navigator.msSaveBlob(new Blob([data], {
                type: contentType
              }), filename);
              return;
            }

            var blobUrl = (0, _pdfjsLib.createObjectURL)(data, contentType, _viewer_compatibility.viewerCompatibilityParams.disableCreateObjectURL);

            _download(blobUrl, filename);
          }
        }, {
          key: "download",
          value: function download(blob, url, filename) {

            if (navigator.msSaveBlob) {
              if (!navigator.msSaveBlob(blob, filename)) {
                this.downloadUrl(url, filename);
              }

              return;
            }

            if (_viewer_compatibility.viewerCompatibilityParams.disableCreateObjectURL) {
              this.downloadUrl(url, filename);
              return;
            }

            var blobUrl = URL.createObjectURL(blob);

            _download(blobUrl, filename);
          }
        }]);

        return DownloadManager;
      }();

      exports.DownloadManager = DownloadManager;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.viewerCompatibilityParams = void 0;
      var compatibilityParams = Object.create(null);
      {
        var userAgent = typeof navigator !== "undefined" && navigator.userAgent || "";
        var platform = typeof navigator !== "undefined" && navigator.platform || "";
        var maxTouchPoints = typeof navigator !== "undefined" && navigator.maxTouchPoints || 1;
        var isAndroid = /Android/.test(userAgent);
        var isIE = /Trident/.test(userAgent);
        var isIOS = /\b(iPad|iPhone|iPod)(?=;)/.test(userAgent) || platform === "MacIntel" && maxTouchPoints > 1;
        var isIOSChrome = /CriOS/.test(userAgent);

        (function checkOnBlobSupport() {
          if (isIE || isIOSChrome) {
            compatibilityParams.disableCreateObjectURL = true;
          }
        })();

        (function checkCanvasSizeLimitation() {
          if (isIOS || isAndroid) {
            compatibilityParams.maxCanvasPixels = 5242880;
          }
        })();
      }
      var viewerCompatibilityParams = Object.freeze(compatibilityParams);
      exports.viewerCompatibilityParams = viewerCompatibilityParams;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.GenericL10n = void 0;

      __w_pdfjs_require__(9);

      var webL10n = document.webL10n;

      var GenericL10n = function () {
        function GenericL10n(lang) {
          _classCallCheck(this, GenericL10n);

          this._lang = lang;
          this._ready = new Promise(function (resolve, reject) {
            webL10n.setLanguage(lang, function () {
              resolve(webL10n);
            });
          });
        }

        _createClass(GenericL10n, [{
          key: "getLanguage",
          value: function () {
            var _getLanguage = _asyncToGenerator(regeneratorRuntime.mark(function _callee5() {
              var l10n;
              return regeneratorRuntime.wrap(function _callee5$(_context5) {
                while (1) {
                  switch (_context5.prev = _context5.next) {
                    case 0:
                      _context5.next = 2;
                      return this._ready;

                    case 2:
                      l10n = _context5.sent;
                      return _context5.abrupt("return", l10n.getLanguage());

                    case 4:
                    case "end":
                      return _context5.stop();
                  }
                }
              }, _callee5, this);
            }));

            function getLanguage() {
              return _getLanguage.apply(this, arguments);
            }

            return getLanguage;
          }()
        }, {
          key: "getDirection",
          value: function () {
            var _getDirection = _asyncToGenerator(regeneratorRuntime.mark(function _callee6() {
              var l10n;
              return regeneratorRuntime.wrap(function _callee6$(_context6) {
                while (1) {
                  switch (_context6.prev = _context6.next) {
                    case 0:
                      _context6.next = 2;
                      return this._ready;

                    case 2:
                      l10n = _context6.sent;
                      return _context6.abrupt("return", l10n.getDirection());

                    case 4:
                    case "end":
                      return _context6.stop();
                  }
                }
              }, _callee6, this);
            }));

            function getDirection() {
              return _getDirection.apply(this, arguments);
            }

            return getDirection;
          }()
        }, {
          key: "get",
          value: function () {
            var _get = _asyncToGenerator(regeneratorRuntime.mark(function _callee7(property, args, fallback) {
              var l10n;
              return regeneratorRuntime.wrap(function _callee7$(_context7) {
                while (1) {
                  switch (_context7.prev = _context7.next) {
                    case 0:
                      _context7.next = 2;
                      return this._ready;

                    case 2:
                      l10n = _context7.sent;
                      return _context7.abrupt("return", l10n.get(property, args, fallback));

                    case 4:
                    case "end":
                      return _context7.stop();
                  }
                }
              }, _callee7, this);
            }));

            function get(_x, _x2, _x3) {
              return _get.apply(this, arguments);
            }

            return get;
          }()
        }, {
          key: "translate",
          value: function () {
            var _translate = _asyncToGenerator(regeneratorRuntime.mark(function _callee8(element) {
              var l10n;
              return regeneratorRuntime.wrap(function _callee8$(_context8) {
                while (1) {
                  switch (_context8.prev = _context8.next) {
                    case 0:
                      _context8.next = 2;
                      return this._ready;

                    case 2:
                      l10n = _context8.sent;
                      return _context8.abrupt("return", l10n.translate(element));

                    case 4:
                    case "end":
                      return _context8.stop();
                  }
                }
              }, _callee8, this);
            }));

            function translate(_x4) {
              return _translate.apply(this, arguments);
            }

            return translate;
          }()
        }]);

        return GenericL10n;
      }();

      exports.GenericL10n = GenericL10n;
    }, function (module, exports, __w_pdfjs_require__) {
      document.webL10n = function (window, document, undefined$1) {
        var gL10nData = {};
        var gTextData = '';
        var gTextProp = 'textContent';
        var gLanguage = '';
        var gMacros = {};
        var gReadyState = 'loading';
        var gAsyncResourceLoading = true;

        function getL10nResourceLinks() {
          return document.querySelectorAll('link[type="application/l10n"]');
        }

        function getL10nDictionary() {
          var script = document.querySelector('script[type="application/l10n"]');
          return script ? JSON.parse(script.innerHTML) : null;
        }

        function getTranslatableChildren(element) {
          return element ? element.querySelectorAll('*[data-l10n-id]') : [];
        }

        function getL10nAttributes(element) {
          if (!element) return {};
          var l10nId = element.getAttribute('data-l10n-id');
          var l10nArgs = element.getAttribute('data-l10n-args');
          var args = {};

          if (l10nArgs) {
            try {
              args = JSON.parse(l10nArgs);
            } catch (e) {
              console.warn('could not parse arguments for #' + l10nId);
            }
          }

          return {
            id: l10nId,
            args: args
          };
        }

        function xhrLoadText(url, onSuccess, onFailure) {
          onSuccess = onSuccess || function _onSuccess(data) {};

          onFailure = onFailure || function _onFailure() {};

          var xhr = new XMLHttpRequest();
          xhr.open('GET', url, gAsyncResourceLoading);

          if (xhr.overrideMimeType) {
            xhr.overrideMimeType('text/plain; charset=utf-8');
          }

          xhr.onreadystatechange = function () {
            if (xhr.readyState == 4) {
              if (xhr.status == 200 || xhr.status === 0) {
                onSuccess(xhr.responseText);
              } else {
                onFailure();
              }
            }
          };

          xhr.onerror = onFailure;
          xhr.ontimeout = onFailure;

          try {
            xhr.send(null);
          } catch (e) {
            onFailure();
          }
        }

        function parseResource(href, lang, successCallback, failureCallback) {
          var baseURL = href.replace(/[^\/]*$/, '') || './';

          function evalString(text) {
            if (text.lastIndexOf('\\') < 0) return text;
            return text.replace(/\\\\/g, '\\').replace(/\\n/g, '\n').replace(/\\r/g, '\r').replace(/\\t/g, '\t').replace(/\\b/g, '\b').replace(/\\f/g, '\f').replace(/\\{/g, '{').replace(/\\}/g, '}').replace(/\\"/g, '"').replace(/\\'/g, "'");
          }

          function parseProperties(text, parsedPropertiesCallback) {
            var dictionary = {};
            var reBlank = /^\s*|\s*$/;
            var reComment = /^\s*#|^\s*$/;
            var reSection = /^\s*\[(.*)\]\s*$/;
            var reImport = /^\s*@import\s+url\((.*)\)\s*$/i;
            var reSplit = /^([^=\s]*)\s*=\s*(.+)$/;

            function parseRawLines(rawText, extendedSyntax, parsedRawLinesCallback) {
              var entries = rawText.replace(reBlank, '').split(/[\r\n]+/);
              var currentLang = '*';
              var genericLang = lang.split('-', 1)[0];
              var skipLang = false;
              var match = '';

              function nextEntry() {
                while (true) {
                  if (!entries.length) {
                    parsedRawLinesCallback();
                    return;
                  }

                  var line = entries.shift();
                  if (reComment.test(line)) continue;

                  if (extendedSyntax) {
                    match = reSection.exec(line);

                    if (match) {
                      currentLang = match[1].toLowerCase();
                      skipLang = currentLang !== '*' && currentLang !== lang && currentLang !== genericLang;
                      continue;
                    } else if (skipLang) {
                      continue;
                    }

                    match = reImport.exec(line);

                    if (match) {
                      loadImport(baseURL + match[1], nextEntry);
                      return;
                    }
                  }

                  var tmp = line.match(reSplit);

                  if (tmp && tmp.length == 3) {
                    dictionary[tmp[1]] = evalString(tmp[2]);
                  }
                }
              }

              nextEntry();
            }

            function loadImport(url, callback) {
              xhrLoadText(url, function (content) {
                parseRawLines(content, false, callback);
              }, function () {
                console.warn(url + ' not found.');
                callback();
              });
            }

            parseRawLines(text, true, function () {
              parsedPropertiesCallback(dictionary);
            });
          }

          xhrLoadText(href, function (response) {
            gTextData += response;
            parseProperties(response, function (data) {
              for (var key in data) {
                var id,
                    prop,
                    index = key.lastIndexOf('.');

                if (index > 0) {
                  id = key.substring(0, index);
                  prop = key.substring(index + 1);
                } else {
                  id = key;
                  prop = gTextProp;
                }

                if (!gL10nData[id]) {
                  gL10nData[id] = {};
                }

                gL10nData[id][prop] = data[key];
              }

              if (successCallback) {
                successCallback();
              }
            });
          }, failureCallback);
        }

        function loadLocale(lang, callback) {
          if (lang) {
            lang = lang.toLowerCase();
          }

          callback = callback || function _callback() {};

          clear();
          gLanguage = lang;
          var langLinks = getL10nResourceLinks();
          var langCount = langLinks.length;

          if (langCount === 0) {
            var dict = getL10nDictionary();

            if (dict && dict.locales && dict.default_locale) {
              console.log('using the embedded JSON directory, early way out');
              gL10nData = dict.locales[lang];

              if (!gL10nData) {
                var defaultLocale = dict.default_locale.toLowerCase();

                for (var anyCaseLang in dict.locales) {
                  anyCaseLang = anyCaseLang.toLowerCase();

                  if (anyCaseLang === lang) {
                    gL10nData = dict.locales[lang];
                    break;
                  } else if (anyCaseLang === defaultLocale) {
                    gL10nData = dict.locales[defaultLocale];
                  }
                }
              }

              callback();
            } else {
              console.log('no resource to load, early way out');
            }

            gReadyState = 'complete';
            return;
          }

          var onResourceLoaded = null;
          var gResourceCount = 0;

          onResourceLoaded = function onResourceLoaded() {
            gResourceCount++;

            if (gResourceCount >= langCount) {
              callback();
              gReadyState = 'complete';
            }
          };

          function L10nResourceLink(link) {
            var href = link.href;

            this.load = function (lang, callback) {
              parseResource(href, lang, callback, function () {
                console.warn(href + ' not found.');
                console.warn('"' + lang + '" resource not found');
                gLanguage = '';
                callback();
              });
            };
          }

          for (var i = 0; i < langCount; i++) {
            var resource = new L10nResourceLink(langLinks[i]);
            resource.load(lang, onResourceLoaded);
          }
        }

        function clear() {
          gL10nData = {};
          gTextData = '';
          gLanguage = '';
        }

        function getPluralRules(lang) {
          var locales2rules = {
            'af': 3,
            'ak': 4,
            'am': 4,
            'ar': 1,
            'asa': 3,
            'az': 0,
            'be': 11,
            'bem': 3,
            'bez': 3,
            'bg': 3,
            'bh': 4,
            'bm': 0,
            'bn': 3,
            'bo': 0,
            'br': 20,
            'brx': 3,
            'bs': 11,
            'ca': 3,
            'cgg': 3,
            'chr': 3,
            'cs': 12,
            'cy': 17,
            'da': 3,
            'de': 3,
            'dv': 3,
            'dz': 0,
            'ee': 3,
            'el': 3,
            'en': 3,
            'eo': 3,
            'es': 3,
            'et': 3,
            'eu': 3,
            'fa': 0,
            'ff': 5,
            'fi': 3,
            'fil': 4,
            'fo': 3,
            'fr': 5,
            'fur': 3,
            'fy': 3,
            'ga': 8,
            'gd': 24,
            'gl': 3,
            'gsw': 3,
            'gu': 3,
            'guw': 4,
            'gv': 23,
            'ha': 3,
            'haw': 3,
            'he': 2,
            'hi': 4,
            'hr': 11,
            'hu': 0,
            'id': 0,
            'ig': 0,
            'ii': 0,
            'is': 3,
            'it': 3,
            'iu': 7,
            'ja': 0,
            'jmc': 3,
            'jv': 0,
            'ka': 0,
            'kab': 5,
            'kaj': 3,
            'kcg': 3,
            'kde': 0,
            'kea': 0,
            'kk': 3,
            'kl': 3,
            'km': 0,
            'kn': 0,
            'ko': 0,
            'ksb': 3,
            'ksh': 21,
            'ku': 3,
            'kw': 7,
            'lag': 18,
            'lb': 3,
            'lg': 3,
            'ln': 4,
            'lo': 0,
            'lt': 10,
            'lv': 6,
            'mas': 3,
            'mg': 4,
            'mk': 16,
            'ml': 3,
            'mn': 3,
            'mo': 9,
            'mr': 3,
            'ms': 0,
            'mt': 15,
            'my': 0,
            'nah': 3,
            'naq': 7,
            'nb': 3,
            'nd': 3,
            'ne': 3,
            'nl': 3,
            'nn': 3,
            'no': 3,
            'nr': 3,
            'nso': 4,
            'ny': 3,
            'nyn': 3,
            'om': 3,
            'or': 3,
            'pa': 3,
            'pap': 3,
            'pl': 13,
            'ps': 3,
            'pt': 3,
            'rm': 3,
            'ro': 9,
            'rof': 3,
            'ru': 11,
            'rwk': 3,
            'sah': 0,
            'saq': 3,
            'se': 7,
            'seh': 3,
            'ses': 0,
            'sg': 0,
            'sh': 11,
            'shi': 19,
            'sk': 12,
            'sl': 14,
            'sma': 7,
            'smi': 7,
            'smj': 7,
            'smn': 7,
            'sms': 7,
            'sn': 3,
            'so': 3,
            'sq': 3,
            'sr': 11,
            'ss': 3,
            'ssy': 3,
            'st': 3,
            'sv': 3,
            'sw': 3,
            'syr': 3,
            'ta': 3,
            'te': 3,
            'teo': 3,
            'th': 0,
            'ti': 4,
            'tig': 3,
            'tk': 3,
            'tl': 4,
            'tn': 3,
            'to': 0,
            'tr': 0,
            'ts': 3,
            'tzm': 22,
            'uk': 11,
            'ur': 3,
            've': 3,
            'vi': 0,
            'vun': 3,
            'wa': 4,
            'wae': 3,
            'wo': 0,
            'xh': 3,
            'xog': 3,
            'yo': 0,
            'zh': 0,
            'zu': 3
          };

          function isIn(n, list) {
            return list.indexOf(n) !== -1;
          }

          function isBetween(n, start, end) {
            return start <= n && n <= end;
          }

          var pluralRules = {
            '0': function _(n) {
              return 'other';
            },
            '1': function _(n) {
              if (isBetween(n % 100, 3, 10)) return 'few';
              if (n === 0) return 'zero';
              if (isBetween(n % 100, 11, 99)) return 'many';
              if (n == 2) return 'two';
              if (n == 1) return 'one';
              return 'other';
            },
            '2': function _(n) {
              if (n !== 0 && n % 10 === 0) return 'many';
              if (n == 2) return 'two';
              if (n == 1) return 'one';
              return 'other';
            },
            '3': function _(n) {
              if (n == 1) return 'one';
              return 'other';
            },
            '4': function _(n) {
              if (isBetween(n, 0, 1)) return 'one';
              return 'other';
            },
            '5': function _(n) {
              if (isBetween(n, 0, 2) && n != 2) return 'one';
              return 'other';
            },
            '6': function _(n) {
              if (n === 0) return 'zero';
              if (n % 10 == 1 && n % 100 != 11) return 'one';
              return 'other';
            },
            '7': function _(n) {
              if (n == 2) return 'two';
              if (n == 1) return 'one';
              return 'other';
            },
            '8': function _(n) {
              if (isBetween(n, 3, 6)) return 'few';
              if (isBetween(n, 7, 10)) return 'many';
              if (n == 2) return 'two';
              if (n == 1) return 'one';
              return 'other';
            },
            '9': function _(n) {
              if (n === 0 || n != 1 && isBetween(n % 100, 1, 19)) return 'few';
              if (n == 1) return 'one';
              return 'other';
            },
            '10': function _(n) {
              if (isBetween(n % 10, 2, 9) && !isBetween(n % 100, 11, 19)) return 'few';
              if (n % 10 == 1 && !isBetween(n % 100, 11, 19)) return 'one';
              return 'other';
            },
            '11': function _(n) {
              if (isBetween(n % 10, 2, 4) && !isBetween(n % 100, 12, 14)) return 'few';
              if (n % 10 === 0 || isBetween(n % 10, 5, 9) || isBetween(n % 100, 11, 14)) return 'many';
              if (n % 10 == 1 && n % 100 != 11) return 'one';
              return 'other';
            },
            '12': function _(n) {
              if (isBetween(n, 2, 4)) return 'few';
              if (n == 1) return 'one';
              return 'other';
            },
            '13': function _(n) {
              if (isBetween(n % 10, 2, 4) && !isBetween(n % 100, 12, 14)) return 'few';
              if (n != 1 && isBetween(n % 10, 0, 1) || isBetween(n % 10, 5, 9) || isBetween(n % 100, 12, 14)) return 'many';
              if (n == 1) return 'one';
              return 'other';
            },
            '14': function _(n) {
              if (isBetween(n % 100, 3, 4)) return 'few';
              if (n % 100 == 2) return 'two';
              if (n % 100 == 1) return 'one';
              return 'other';
            },
            '15': function _(n) {
              if (n === 0 || isBetween(n % 100, 2, 10)) return 'few';
              if (isBetween(n % 100, 11, 19)) return 'many';
              if (n == 1) return 'one';
              return 'other';
            },
            '16': function _(n) {
              if (n % 10 == 1 && n != 11) return 'one';
              return 'other';
            },
            '17': function _(n) {
              if (n == 3) return 'few';
              if (n === 0) return 'zero';
              if (n == 6) return 'many';
              if (n == 2) return 'two';
              if (n == 1) return 'one';
              return 'other';
            },
            '18': function _(n) {
              if (n === 0) return 'zero';
              if (isBetween(n, 0, 2) && n !== 0 && n != 2) return 'one';
              return 'other';
            },
            '19': function _(n) {
              if (isBetween(n, 2, 10)) return 'few';
              if (isBetween(n, 0, 1)) return 'one';
              return 'other';
            },
            '20': function _(n) {
              if ((isBetween(n % 10, 3, 4) || n % 10 == 9) && !(isBetween(n % 100, 10, 19) || isBetween(n % 100, 70, 79) || isBetween(n % 100, 90, 99))) return 'few';
              if (n % 1000000 === 0 && n !== 0) return 'many';
              if (n % 10 == 2 && !isIn(n % 100, [12, 72, 92])) return 'two';
              if (n % 10 == 1 && !isIn(n % 100, [11, 71, 91])) return 'one';
              return 'other';
            },
            '21': function _(n) {
              if (n === 0) return 'zero';
              if (n == 1) return 'one';
              return 'other';
            },
            '22': function _(n) {
              if (isBetween(n, 0, 1) || isBetween(n, 11, 99)) return 'one';
              return 'other';
            },
            '23': function _(n) {
              if (isBetween(n % 10, 1, 2) || n % 20 === 0) return 'one';
              return 'other';
            },
            '24': function _(n) {
              if (isBetween(n, 3, 10) || isBetween(n, 13, 19)) return 'few';
              if (isIn(n, [2, 12])) return 'two';
              if (isIn(n, [1, 11])) return 'one';
              return 'other';
            }
          };
          var index = locales2rules[lang.replace(/-.*$/, '')];

          if (!(index in pluralRules)) {
            console.warn('plural form unknown for [' + lang + ']');
            return function () {
              return 'other';
            };
          }

          return pluralRules[index];
        }

        gMacros.plural = function (str, param, key, prop) {
          var n = parseFloat(param);
          if (isNaN(n)) return str;
          if (prop != gTextProp) return str;

          if (!gMacros._pluralRules) {
            gMacros._pluralRules = getPluralRules(gLanguage);
          }

          var index = '[' + gMacros._pluralRules(n) + ']';

          if (n === 0 && key + '[zero]' in gL10nData) {
            str = gL10nData[key + '[zero]'][prop];
          } else if (n == 1 && key + '[one]' in gL10nData) {
            str = gL10nData[key + '[one]'][prop];
          } else if (n == 2 && key + '[two]' in gL10nData) {
            str = gL10nData[key + '[two]'][prop];
          } else if (key + index in gL10nData) {
            str = gL10nData[key + index][prop];
          } else if (key + '[other]' in gL10nData) {
            str = gL10nData[key + '[other]'][prop];
          }

          return str;
        };

        function getL10nData(key, args, fallback) {
          var data = gL10nData[key];

          if (!data) {
            console.warn('#' + key + ' is undefined.');

            if (!fallback) {
              return null;
            }

            data = fallback;
          }

          var rv = {};

          for (var prop in data) {
            var str = data[prop];
            str = substIndexes(str, args, key, prop);
            str = substArguments(str, args, key);
            rv[prop] = str;
          }

          return rv;
        }

        function substIndexes(str, args, key, prop) {
          var reIndex = /\{\[\s*([a-zA-Z]+)\(([a-zA-Z]+)\)\s*\]\}/;
          var reMatch = reIndex.exec(str);
          if (!reMatch || !reMatch.length) return str;
          var macroName = reMatch[1];
          var paramName = reMatch[2];
          var param;

          if (args && paramName in args) {
            param = args[paramName];
          } else if (paramName in gL10nData) {
            param = gL10nData[paramName];
          }

          if (macroName in gMacros) {
            var macro = gMacros[macroName];
            str = macro(str, param, key, prop);
          }

          return str;
        }

        function substArguments(str, args, key) {
          var reArgs = /\{\{\s*(.+?)\s*\}\}/g;
          return str.replace(reArgs, function (matched_text, arg) {
            if (args && arg in args) {
              return args[arg];
            }

            if (arg in gL10nData) {
              return gL10nData[arg];
            }

            console.log('argument {{' + arg + '}} for #' + key + ' is undefined.');
            return matched_text;
          });
        }

        function translateElement(element) {
          var l10n = getL10nAttributes(element);
          if (!l10n.id) return;
          var data = getL10nData(l10n.id, l10n.args);

          if (!data) {
            console.warn('#' + l10n.id + ' is undefined.');
            return;
          }

          if (data[gTextProp]) {
            if (getChildElementCount(element) === 0) {
              element[gTextProp] = data[gTextProp];
            } else {
              var children = element.childNodes;
              var found = false;

              for (var i = 0, l = children.length; i < l; i++) {
                if (children[i].nodeType === 3 && /\S/.test(children[i].nodeValue)) {
                  if (found) {
                    children[i].nodeValue = '';
                  } else {
                    children[i].nodeValue = data[gTextProp];
                    found = true;
                  }
                }
              }

              if (!found) {
                var textNode = document.createTextNode(data[gTextProp]);
                element.insertBefore(textNode, element.firstChild);
              }
            }

            delete data[gTextProp];
          }

          for (var k in data) {
            element[k] = data[k];
          }
        }

        function getChildElementCount(element) {
          if (element.children) {
            return element.children.length;
          }

          if (typeof element.childElementCount !== 'undefined') {
            return element.childElementCount;
          }

          var count = 0;

          for (var i = 0; i < element.childNodes.length; i++) {
            count += element.nodeType === 1 ? 1 : 0;
          }

          return count;
        }

        function translateFragment(element) {
          element = element || document.documentElement;
          var children = getTranslatableChildren(element);
          var elementCount = children.length;

          for (var i = 0; i < elementCount; i++) {
            translateElement(children[i]);
          }

          translateElement(element);
        }

        return {
          get: function get(key, args, fallbackString) {
            var index = key.lastIndexOf('.');
            var prop = gTextProp;

            if (index > 0) {
              prop = key.substring(index + 1);
              key = key.substring(0, index);
            }

            var fallback;

            if (fallbackString) {
              fallback = {};
              fallback[prop] = fallbackString;
            }

            var data = getL10nData(key, args, fallback);

            if (data && prop in data) {
              return data[prop];
            }

            return '{{' + key + '}}';
          },
          getData: function getData() {
            return gL10nData;
          },
          getText: function getText() {
            return gTextData;
          },
          getLanguage: function getLanguage() {
            return gLanguage;
          },
          setLanguage: function setLanguage(lang, callback) {
            loadLocale(lang, function () {
              if (callback) callback();
            });
          },
          getDirection: function getDirection() {
            var rtlList = ['ar', 'he', 'fa', 'ps', 'ur'];
            var shortCode = gLanguage.split('-', 1)[0];
            return rtlList.indexOf(shortCode) >= 0 ? 'rtl' : 'ltr';
          },
          translate: translateFragment,
          getReadyState: function getReadyState() {
            return gReadyState;
          },
          ready: function ready(callback) {
            if (!callback) {
              return;
            } else if (gReadyState == 'complete' || gReadyState == 'interactive') {
              window.setTimeout(function () {
                callback();
              });
            } else if (document.addEventListener) {
              document.addEventListener('localized', function once() {
                document.removeEventListener('localized', once);
                callback();
              });
            }
          }
        };
      }(window, document);
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.PDFFindController = exports.FindState = void 0;

      var _pdfjsLib = __w_pdfjs_require__(2);

      var _pdf_find_utils = __w_pdfjs_require__(11);

      var _ui_utils = __w_pdfjs_require__(3);

      var FindState = {
        FOUND: 0,
        NOT_FOUND: 1,
        WRAPPED: 2,
        PENDING: 3
      };
      exports.FindState = FindState;
      var FIND_TIMEOUT = 250;
      var MATCH_SCROLL_OFFSET_TOP = -50;
      var MATCH_SCROLL_OFFSET_LEFT = -400;
      var CHARACTERS_TO_NORMALIZE = {
        "\u2018": "'",
        "\u2019": "'",
        "\u201A": "'",
        "\u201B": "'",
        "\u201C": '"',
        "\u201D": '"',
        "\u201E": '"',
        "\u201F": '"',
        "\xBC": "1/4",
        "\xBD": "1/2",
        "\xBE": "3/4"
      };
      var normalizationRegex = null;

      function normalize(text) {
        if (!normalizationRegex) {
          var replace = Object.keys(CHARACTERS_TO_NORMALIZE).join("");
          normalizationRegex = new RegExp("[".concat(replace, "]"), "g");
        }

        return text.replace(normalizationRegex, function (ch) {
          return CHARACTERS_TO_NORMALIZE[ch];
        });
      }

      var PDFFindController = function () {
        function PDFFindController(_ref9) {
          var linkService = _ref9.linkService,
              eventBus = _ref9.eventBus;

          _classCallCheck(this, PDFFindController);

          this._linkService = linkService;
          this._eventBus = eventBus;

          this._reset();

          eventBus._on("findbarclose", this._onFindBarClose.bind(this));
        }

        _createClass(PDFFindController, [{
          key: "highlightMatches",
          get: function get() {
            return this._highlightMatches;
          }
        }, {
          key: "pageMatches",
          get: function get() {
            return this._pageMatches;
          }
        }, {
          key: "pageMatchesLength",
          get: function get() {
            return this._pageMatchesLength;
          }
        }, {
          key: "selected",
          get: function get() {
            return this._selected;
          }
        }, {
          key: "state",
          get: function get() {
            return this._state;
          }
        }, {
          key: "setDocument",
          value: function setDocument(pdfDocument) {
            if (this._pdfDocument) {
              this._reset();
            }

            if (!pdfDocument) {
              return;
            }

            this._pdfDocument = pdfDocument;

            this._firstPageCapability.resolve();
          }
        }, {
          key: "executeCommand",
          value: function executeCommand(cmd, state) {
            var _this5 = this;

            if (!state) {
              return;
            }

            var pdfDocument = this._pdfDocument;

            if (this._state === null || this._shouldDirtyMatch(cmd, state)) {
              this._dirtyMatch = true;
            }

            this._state = state;

            if (cmd !== "findhighlightallchange") {
              this._updateUIState(FindState.PENDING);
            }

            this._firstPageCapability.promise.then(function () {
              if (!_this5._pdfDocument || pdfDocument && _this5._pdfDocument !== pdfDocument) {
                return;
              }

              _this5._extractText();

              var findbarClosed = !_this5._highlightMatches;
              var pendingTimeout = !!_this5._findTimeout;

              if (_this5._findTimeout) {
                clearTimeout(_this5._findTimeout);
                _this5._findTimeout = null;
              }

              if (cmd === "find") {
                _this5._findTimeout = setTimeout(function () {
                  _this5._nextMatch();

                  _this5._findTimeout = null;
                }, FIND_TIMEOUT);
              } else if (_this5._dirtyMatch) {
                _this5._nextMatch();
              } else if (cmd === "findagain") {
                _this5._nextMatch();

                if (findbarClosed && _this5._state.highlightAll) {
                  _this5._updateAllPages();
                }
              } else if (cmd === "findhighlightallchange") {
                if (pendingTimeout) {
                  _this5._nextMatch();
                } else {
                  _this5._highlightMatches = true;
                }

                _this5._updateAllPages();
              } else {
                _this5._nextMatch();
              }
            });
          }
        }, {
          key: "scrollMatchIntoView",
          value: function scrollMatchIntoView(_ref10) {
            var _ref10$element = _ref10.element,
                element = _ref10$element === void 0 ? null : _ref10$element,
                _ref10$pageIndex = _ref10.pageIndex,
                pageIndex = _ref10$pageIndex === void 0 ? -1 : _ref10$pageIndex,
                _ref10$matchIndex = _ref10.matchIndex,
                matchIndex = _ref10$matchIndex === void 0 ? -1 : _ref10$matchIndex;

            if (!this._scrollMatches || !element) {
              return;
            } else if (matchIndex === -1 || matchIndex !== this._selected.matchIdx) {
              return;
            } else if (pageIndex === -1 || pageIndex !== this._selected.pageIdx) {
              return;
            }

            this._scrollMatches = false;
            var spot = {
              top: MATCH_SCROLL_OFFSET_TOP,
              left: MATCH_SCROLL_OFFSET_LEFT
            };
            (0, _ui_utils.scrollIntoView)(element, spot, true);
          }
        }, {
          key: "_reset",
          value: function _reset() {
            this._highlightMatches = false;
            this._scrollMatches = false;
            this._pdfDocument = null;
            this._pageMatches = [];
            this._pageMatchesLength = [];
            this._state = null;
            this._selected = {
              pageIdx: -1,
              matchIdx: -1
            };
            this._offset = {
              pageIdx: null,
              matchIdx: null,
              wrapped: false
            };
            this._extractTextPromises = [];
            this._pageContents = [];
            this._matchesCountTotal = 0;
            this._pagesToSearch = null;
            this._pendingFindMatches = Object.create(null);
            this._resumePageIdx = null;
            this._dirtyMatch = false;
            clearTimeout(this._findTimeout);
            this._findTimeout = null;
            this._firstPageCapability = (0, _pdfjsLib.createPromiseCapability)();
          }
        }, {
          key: "_query",
          get: function get() {
            if (this._state.query !== this._rawQuery) {
              this._rawQuery = this._state.query;
              this._normalizedQuery = normalize(this._state.query);
            }

            return this._normalizedQuery;
          }
        }, {
          key: "_shouldDirtyMatch",
          value: function _shouldDirtyMatch(cmd, state) {
            if (state.query !== this._state.query) {
              return true;
            }

            switch (cmd) {
              case "findagain":
                var pageNumber = this._selected.pageIdx + 1;
                var linkService = this._linkService;

                if (pageNumber >= 1 && pageNumber <= linkService.pagesCount && pageNumber !== linkService.page && !linkService.isPageVisible(pageNumber)) {
                  return true;
                }

                return false;

              case "findhighlightallchange":
                return false;
            }

            return true;
          }
        }, {
          key: "_prepareMatches",
          value: function _prepareMatches(matchesWithLength, matches, matchesLength) {
            function isSubTerm(currentIndex) {
              var currentElem = matchesWithLength[currentIndex];
              var nextElem = matchesWithLength[currentIndex + 1];

              if (currentIndex < matchesWithLength.length - 1 && currentElem.match === nextElem.match) {
                currentElem.skipped = true;
                return true;
              }

              for (var i = currentIndex - 1; i >= 0; i--) {
                var prevElem = matchesWithLength[i];

                if (prevElem.skipped) {
                  continue;
                }

                if (prevElem.match + prevElem.matchLength < currentElem.match) {
                  break;
                }

                if (prevElem.match + prevElem.matchLength >= currentElem.match + currentElem.matchLength) {
                  currentElem.skipped = true;
                  return true;
                }
              }

              return false;
            }

            matchesWithLength.sort(function (a, b) {
              return a.match === b.match ? a.matchLength - b.matchLength : a.match - b.match;
            });

            for (var i = 0, len = matchesWithLength.length; i < len; i++) {
              if (isSubTerm(i)) {
                continue;
              }

              matches.push(matchesWithLength[i].match);
              matchesLength.push(matchesWithLength[i].matchLength);
            }
          }
        }, {
          key: "_isEntireWord",
          value: function _isEntireWord(content, startIdx, length) {
            if (startIdx > 0) {
              var first = content.charCodeAt(startIdx);
              var limit = content.charCodeAt(startIdx - 1);

              if ((0, _pdf_find_utils.getCharacterType)(first) === (0, _pdf_find_utils.getCharacterType)(limit)) {
                return false;
              }
            }

            var endIdx = startIdx + length - 1;

            if (endIdx < content.length - 1) {
              var last = content.charCodeAt(endIdx);

              var _limit = content.charCodeAt(endIdx + 1);

              if ((0, _pdf_find_utils.getCharacterType)(last) === (0, _pdf_find_utils.getCharacterType)(_limit)) {
                return false;
              }
            }

            return true;
          }
        }, {
          key: "_calculatePhraseMatch",
          value: function _calculatePhraseMatch(query, pageIndex, pageContent, entireWord) {
            var matches = [];
            var queryLen = query.length;
            var matchIdx = -queryLen;

            while (true) {
              matchIdx = pageContent.indexOf(query, matchIdx + queryLen);

              if (matchIdx === -1) {
                break;
              }

              if (entireWord && !this._isEntireWord(pageContent, matchIdx, queryLen)) {
                continue;
              }

              matches.push(matchIdx);
            }

            this._pageMatches[pageIndex] = matches;
          }
        }, {
          key: "_calculateWordMatch",
          value: function _calculateWordMatch(query, pageIndex, pageContent, entireWord) {
            var matchesWithLength = [];
            var queryArray = query.match(/\S+/g);

            for (var i = 0, len = queryArray.length; i < len; i++) {
              var subquery = queryArray[i];
              var subqueryLen = subquery.length;
              var matchIdx = -subqueryLen;

              while (true) {
                matchIdx = pageContent.indexOf(subquery, matchIdx + subqueryLen);

                if (matchIdx === -1) {
                  break;
                }

                if (entireWord && !this._isEntireWord(pageContent, matchIdx, subqueryLen)) {
                  continue;
                }

                matchesWithLength.push({
                  match: matchIdx,
                  matchLength: subqueryLen,
                  skipped: false
                });
              }
            }

            this._pageMatchesLength[pageIndex] = [];
            this._pageMatches[pageIndex] = [];

            this._prepareMatches(matchesWithLength, this._pageMatches[pageIndex], this._pageMatchesLength[pageIndex]);
          }
        }, {
          key: "_calculateMatch",
          value: function _calculateMatch(pageIndex) {
            var pageContent = this._pageContents[pageIndex];
            var query = this._query;
            var _this$_state = this._state,
                caseSensitive = _this$_state.caseSensitive,
                entireWord = _this$_state.entireWord,
                phraseSearch = _this$_state.phraseSearch;

            if (query.length === 0) {
              return;
            }

            if (!caseSensitive) {
              pageContent = pageContent.toLowerCase();
              query = query.toLowerCase();
            }

            if (phraseSearch) {
              this._calculatePhraseMatch(query, pageIndex, pageContent, entireWord);
            } else {
              this._calculateWordMatch(query, pageIndex, pageContent, entireWord);
            }

            if (this._state.highlightAll) {
              this._updatePage(pageIndex);
            }

            if (this._resumePageIdx === pageIndex) {
              this._resumePageIdx = null;

              this._nextPageMatch();
            }

            var pageMatchesCount = this._pageMatches[pageIndex].length;

            if (pageMatchesCount > 0) {
              this._matchesCountTotal += pageMatchesCount;

              this._updateUIResultsCount();
            }
          }
        }, {
          key: "_extractText",
          value: function _extractText() {
            var _this6 = this;

            if (this._extractTextPromises.length > 0) {
              return;
            }

            var promise = Promise.resolve();

            var _loop = function _loop(i, ii) {
              var extractTextCapability = (0, _pdfjsLib.createPromiseCapability)();
              _this6._extractTextPromises[i] = extractTextCapability.promise;
              promise = promise.then(function () {
                return _this6._pdfDocument.getPage(i + 1).then(function (pdfPage) {
                  return pdfPage.getTextContent({
                    normalizeWhitespace: true
                  });
                }).then(function (textContent) {
                  var textItems = textContent.items;
                  var strBuf = [];

                  for (var j = 0, jj = textItems.length; j < jj; j++) {
                    strBuf.push(textItems[j].str);
                  }

                  _this6._pageContents[i] = normalize(strBuf.join(""));
                  extractTextCapability.resolve(i);
                }, function (reason) {
                  console.error("Unable to get text content for page ".concat(i + 1), reason);
                  _this6._pageContents[i] = "";
                  extractTextCapability.resolve(i);
                });
              });
            };

            for (var i = 0, ii = this._linkService.pagesCount; i < ii; i++) {
              _loop(i);
            }
          }
        }, {
          key: "_updatePage",
          value: function _updatePage(index) {
            if (this._scrollMatches && this._selected.pageIdx === index) {
              this._linkService.page = index + 1;
            }

            this._eventBus.dispatch("updatetextlayermatches", {
              source: this,
              pageIndex: index
            });
          }
        }, {
          key: "_updateAllPages",
          value: function _updateAllPages() {
            this._eventBus.dispatch("updatetextlayermatches", {
              source: this,
              pageIndex: -1
            });
          }
        }, {
          key: "_nextMatch",
          value: function _nextMatch() {
            var _this7 = this;

            var previous = this._state.findPrevious;
            var currentPageIndex = this._linkService.page - 1;
            var numPages = this._linkService.pagesCount;
            this._highlightMatches = true;

            if (this._dirtyMatch) {
              this._dirtyMatch = false;
              this._selected.pageIdx = this._selected.matchIdx = -1;
              this._offset.pageIdx = currentPageIndex;
              this._offset.matchIdx = null;
              this._offset.wrapped = false;
              this._resumePageIdx = null;
              this._pageMatches.length = 0;
              this._pageMatchesLength.length = 0;
              this._matchesCountTotal = 0;

              this._updateAllPages();

              for (var i = 0; i < numPages; i++) {
                if (this._pendingFindMatches[i] === true) {
                  continue;
                }

                this._pendingFindMatches[i] = true;

                this._extractTextPromises[i].then(function (pageIdx) {
                  delete _this7._pendingFindMatches[pageIdx];

                  _this7._calculateMatch(pageIdx);
                });
              }
            }

            if (this._query === "") {
              this._updateUIState(FindState.FOUND);

              return;
            }

            if (this._resumePageIdx) {
              return;
            }

            var offset = this._offset;
            this._pagesToSearch = numPages;

            if (offset.matchIdx !== null) {
              var numPageMatches = this._pageMatches[offset.pageIdx].length;

              if (!previous && offset.matchIdx + 1 < numPageMatches || previous && offset.matchIdx > 0) {
                offset.matchIdx = previous ? offset.matchIdx - 1 : offset.matchIdx + 1;

                this._updateMatch(true);

                return;
              }

              this._advanceOffsetPage(previous);
            }

            this._nextPageMatch();
          }
        }, {
          key: "_matchesReady",
          value: function _matchesReady(matches) {
            var offset = this._offset;
            var numMatches = matches.length;
            var previous = this._state.findPrevious;

            if (numMatches) {
              offset.matchIdx = previous ? numMatches - 1 : 0;

              this._updateMatch(true);

              return true;
            }

            this._advanceOffsetPage(previous);

            if (offset.wrapped) {
              offset.matchIdx = null;

              if (this._pagesToSearch < 0) {
                this._updateMatch(false);

                return true;
              }
            }

            return false;
          }
        }, {
          key: "_nextPageMatch",
          value: function _nextPageMatch() {
            if (this._resumePageIdx !== null) {
              console.error("There can only be one pending page.");
            }

            var matches = null;

            do {
              var pageIdx = this._offset.pageIdx;
              matches = this._pageMatches[pageIdx];

              if (!matches) {
                this._resumePageIdx = pageIdx;
                break;
              }
            } while (!this._matchesReady(matches));
          }
        }, {
          key: "_advanceOffsetPage",
          value: function _advanceOffsetPage(previous) {
            var offset = this._offset;
            var numPages = this._linkService.pagesCount;
            offset.pageIdx = previous ? offset.pageIdx - 1 : offset.pageIdx + 1;
            offset.matchIdx = null;
            this._pagesToSearch--;

            if (offset.pageIdx >= numPages || offset.pageIdx < 0) {
              offset.pageIdx = previous ? numPages - 1 : 0;
              offset.wrapped = true;
            }
          }
        }, {
          key: "_updateMatch",
          value: function _updateMatch() {
            var found = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
            var state = FindState.NOT_FOUND;
            var wrapped = this._offset.wrapped;
            this._offset.wrapped = false;

            if (found) {
              var previousPage = this._selected.pageIdx;
              this._selected.pageIdx = this._offset.pageIdx;
              this._selected.matchIdx = this._offset.matchIdx;
              state = wrapped ? FindState.WRAPPED : FindState.FOUND;

              if (previousPage !== -1 && previousPage !== this._selected.pageIdx) {
                this._updatePage(previousPage);
              }
            }

            this._updateUIState(state, this._state.findPrevious);

            if (this._selected.pageIdx !== -1) {
              this._scrollMatches = true;

              this._updatePage(this._selected.pageIdx);
            }
          }
        }, {
          key: "_onFindBarClose",
          value: function _onFindBarClose(evt) {
            var _this8 = this;

            var pdfDocument = this._pdfDocument;

            this._firstPageCapability.promise.then(function () {
              if (!_this8._pdfDocument || pdfDocument && _this8._pdfDocument !== pdfDocument) {
                return;
              }

              if (_this8._findTimeout) {
                clearTimeout(_this8._findTimeout);
                _this8._findTimeout = null;
              }

              if (_this8._resumePageIdx) {
                _this8._resumePageIdx = null;
                _this8._dirtyMatch = true;
              }

              _this8._updateUIState(FindState.FOUND);

              _this8._highlightMatches = false;

              _this8._updateAllPages();
            });
          }
        }, {
          key: "_requestMatchesCount",
          value: function _requestMatchesCount() {
            var _this$_selected = this._selected,
                pageIdx = _this$_selected.pageIdx,
                matchIdx = _this$_selected.matchIdx;
            var current = 0,
                total = this._matchesCountTotal;

            if (matchIdx !== -1) {
              for (var i = 0; i < pageIdx; i++) {
                current += this._pageMatches[i] && this._pageMatches[i].length || 0;
              }

              current += matchIdx + 1;
            }

            if (current < 1 || current > total) {
              current = total = 0;
            }

            return {
              current: current,
              total: total
            };
          }
        }, {
          key: "_updateUIResultsCount",
          value: function _updateUIResultsCount() {
            this._eventBus.dispatch("updatefindmatchescount", {
              source: this,
              matchesCount: this._requestMatchesCount()
            });
          }
        }, {
          key: "_updateUIState",
          value: function _updateUIState(state, previous) {
            this._eventBus.dispatch("updatefindcontrolstate", {
              source: this,
              state: state,
              previous: previous,
              matchesCount: this._requestMatchesCount(),
              rawQuery: this._state ? this._state.query : null
            });
          }
        }]);

        return PDFFindController;
      }();

      exports.PDFFindController = PDFFindController;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.getCharacterType = getCharacterType;
      exports.CharacterType = void 0;
      var CharacterType = {
        SPACE: 0,
        ALPHA_LETTER: 1,
        PUNCT: 2,
        HAN_LETTER: 3,
        KATAKANA_LETTER: 4,
        HIRAGANA_LETTER: 5,
        HALFWIDTH_KATAKANA_LETTER: 6,
        THAI_LETTER: 7
      };
      exports.CharacterType = CharacterType;

      function isAlphabeticalScript(charCode) {
        return charCode < 0x2e80;
      }

      function isAscii(charCode) {
        return (charCode & 0xff80) === 0;
      }

      function isAsciiAlpha(charCode) {
        return charCode >= 0x61 && charCode <= 0x7a || charCode >= 0x41 && charCode <= 0x5a;
      }

      function isAsciiDigit(charCode) {
        return charCode >= 0x30 && charCode <= 0x39;
      }

      function isAsciiSpace(charCode) {
        return charCode === 0x20 || charCode === 0x09 || charCode === 0x0d || charCode === 0x0a;
      }

      function isHan(charCode) {
        return charCode >= 0x3400 && charCode <= 0x9fff || charCode >= 0xf900 && charCode <= 0xfaff;
      }

      function isKatakana(charCode) {
        return charCode >= 0x30a0 && charCode <= 0x30ff;
      }

      function isHiragana(charCode) {
        return charCode >= 0x3040 && charCode <= 0x309f;
      }

      function isHalfwidthKatakana(charCode) {
        return charCode >= 0xff60 && charCode <= 0xff9f;
      }

      function isThai(charCode) {
        return (charCode & 0xff80) === 0x0e00;
      }

      function getCharacterType(charCode) {
        if (isAlphabeticalScript(charCode)) {
          if (isAscii(charCode)) {
            if (isAsciiSpace(charCode)) {
              return CharacterType.SPACE;
            } else if (isAsciiAlpha(charCode) || isAsciiDigit(charCode) || charCode === 0x5f) {
              return CharacterType.ALPHA_LETTER;
            }

            return CharacterType.PUNCT;
          } else if (isThai(charCode)) {
            return CharacterType.THAI_LETTER;
          } else if (charCode === 0xa0) {
            return CharacterType.SPACE;
          }

          return CharacterType.ALPHA_LETTER;
        }

        if (isHan(charCode)) {
          return CharacterType.HAN_LETTER;
        } else if (isKatakana(charCode)) {
          return CharacterType.KATAKANA_LETTER;
        } else if (isHiragana(charCode)) {
          return CharacterType.HIRAGANA_LETTER;
        } else if (isHalfwidthKatakana(charCode)) {
          return CharacterType.HALFWIDTH_KATAKANA_LETTER;
        }

        return CharacterType.ALPHA_LETTER;
      }
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.isDestHashesEqual = isDestHashesEqual;
      exports.isDestArraysEqual = isDestArraysEqual;
      exports.PDFHistory = void 0;

      var _ui_utils = __w_pdfjs_require__(3);

      var HASH_CHANGE_TIMEOUT = 1000;
      var POSITION_UPDATED_THRESHOLD = 50;
      var UPDATE_VIEWAREA_TIMEOUT = 1000;

      function getCurrentHash() {
        return document.location.hash;
      }

      var PDFHistory = function () {
        function PDFHistory(_ref11) {
          var _this9 = this;

          var linkService = _ref11.linkService,
              eventBus = _ref11.eventBus;

          _classCallCheck(this, PDFHistory);

          this.linkService = linkService;
          this.eventBus = eventBus;
          this._initialized = false;
          this._fingerprint = "";
          this.reset();
          this._boundEvents = null;
          this._isViewerInPresentationMode = false;

          this.eventBus._on("presentationmodechanged", function (evt) {
            _this9._isViewerInPresentationMode = evt.active || evt.switchInProgress;
          });

          this.eventBus._on("pagesinit", function () {
            _this9._isPagesLoaded = false;

            var onPagesLoaded = function onPagesLoaded(evt) {
              _this9.eventBus._off("pagesloaded", onPagesLoaded);

              _this9._isPagesLoaded = !!evt.pagesCount;
            };

            _this9.eventBus._on("pagesloaded", onPagesLoaded);
          });
        }

        _createClass(PDFHistory, [{
          key: "initialize",
          value: function initialize(_ref12) {
            var fingerprint = _ref12.fingerprint,
                _ref12$resetHistory = _ref12.resetHistory,
                resetHistory = _ref12$resetHistory === void 0 ? false : _ref12$resetHistory,
                _ref12$updateUrl = _ref12.updateUrl,
                updateUrl = _ref12$updateUrl === void 0 ? false : _ref12$updateUrl;

            if (!fingerprint || typeof fingerprint !== "string") {
              console.error('PDFHistory.initialize: The "fingerprint" must be a non-empty string.');
              return;
            }

            if (this._initialized) {
              this.reset();
            }

            var reInitialized = this._fingerprint !== "" && this._fingerprint !== fingerprint;
            this._fingerprint = fingerprint;
            this._updateUrl = updateUrl === true;
            this._initialized = true;

            this._bindEvents();

            var state = window.history.state;
            this._popStateInProgress = false;
            this._blockHashChange = 0;
            this._currentHash = getCurrentHash();
            this._numPositionUpdates = 0;
            this._uid = this._maxUid = 0;
            this._destination = null;
            this._position = null;

            if (!this._isValidState(state, true) || resetHistory) {
              var _this$_parseCurrentHa = this._parseCurrentHash(true),
                  hash = _this$_parseCurrentHa.hash,
                  page = _this$_parseCurrentHa.page,
                  rotation = _this$_parseCurrentHa.rotation;

              if (!hash || reInitialized || resetHistory) {
                this._pushOrReplaceState(null, true);

                return;
              }

              this._pushOrReplaceState({
                hash: hash,
                page: page,
                rotation: rotation
              }, true);

              return;
            }

            var destination = state.destination;

            this._updateInternalState(destination, state.uid, true);

            if (this._uid > this._maxUid) {
              this._maxUid = this._uid;
            }

            if (destination.rotation !== undefined) {
              this._initialRotation = destination.rotation;
            }

            if (destination.dest) {
              this._initialBookmark = JSON.stringify(destination.dest);
              this._destination.page = null;
            } else if (destination.hash) {
              this._initialBookmark = destination.hash;
            } else if (destination.page) {
              this._initialBookmark = "page=".concat(destination.page);
            }
          }
        }, {
          key: "reset",
          value: function reset() {
            if (this._initialized) {
              this._pageHide();

              this._initialized = false;

              this._unbindEvents();
            }

            if (this._updateViewareaTimeout) {
              clearTimeout(this._updateViewareaTimeout);
              this._updateViewareaTimeout = null;
            }

            this._initialBookmark = null;
            this._initialRotation = null;
          }
        }, {
          key: "push",
          value: function push(_ref13) {
            var _this10 = this;

            var _ref13$namedDest = _ref13.namedDest,
                namedDest = _ref13$namedDest === void 0 ? null : _ref13$namedDest,
                explicitDest = _ref13.explicitDest,
                pageNumber = _ref13.pageNumber;

            if (!this._initialized) {
              return;
            }

            if (namedDest && typeof namedDest !== "string") {
              console.error("PDFHistory.push: " + "\"".concat(namedDest, "\" is not a valid namedDest parameter."));
              return;
            } else if (!Array.isArray(explicitDest)) {
              console.error("PDFHistory.push: " + "\"".concat(explicitDest, "\" is not a valid explicitDest parameter."));
              return;
            } else if (!(Number.isInteger(pageNumber) && pageNumber > 0 && pageNumber <= this.linkService.pagesCount)) {
              if (pageNumber !== null || this._destination) {
                console.error("PDFHistory.push: " + "\"".concat(pageNumber, "\" is not a valid pageNumber parameter."));
                return;
              }
            }

            var hash = namedDest || JSON.stringify(explicitDest);

            if (!hash) {
              return;
            }

            var forceReplace = false;

            if (this._destination && (isDestHashesEqual(this._destination.hash, hash) || isDestArraysEqual(this._destination.dest, explicitDest))) {
              if (this._destination.page) {
                return;
              }

              forceReplace = true;
            }

            if (this._popStateInProgress && !forceReplace) {
              return;
            }

            this._pushOrReplaceState({
              dest: explicitDest,
              hash: hash,
              page: pageNumber,
              rotation: this.linkService.rotation
            }, forceReplace);

            if (!this._popStateInProgress) {
              this._popStateInProgress = true;
              Promise.resolve().then(function () {
                _this10._popStateInProgress = false;
              });
            }
          }
        }, {
          key: "pushCurrentPosition",
          value: function pushCurrentPosition() {
            if (!this._initialized || this._popStateInProgress) {
              return;
            }

            this._tryPushCurrentPosition();
          }
        }, {
          key: "back",
          value: function back() {
            if (!this._initialized || this._popStateInProgress) {
              return;
            }

            var state = window.history.state;

            if (this._isValidState(state) && state.uid > 0) {
              window.history.back();
            }
          }
        }, {
          key: "forward",
          value: function forward() {
            if (!this._initialized || this._popStateInProgress) {
              return;
            }

            var state = window.history.state;

            if (this._isValidState(state) && state.uid < this._maxUid) {
              window.history.forward();
            }
          }
        }, {
          key: "popStateInProgress",
          get: function get() {
            return this._initialized && (this._popStateInProgress || this._blockHashChange > 0);
          }
        }, {
          key: "initialBookmark",
          get: function get() {
            return this._initialized ? this._initialBookmark : null;
          }
        }, {
          key: "initialRotation",
          get: function get() {
            return this._initialized ? this._initialRotation : null;
          }
        }, {
          key: "_pushOrReplaceState",
          value: function _pushOrReplaceState(destination) {
            var forceReplace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
            var shouldReplace = forceReplace || !this._destination;
            var newState = {
              fingerprint: this._fingerprint,
              uid: shouldReplace ? this._uid : this._uid + 1,
              destination: destination
            };

            this._updateInternalState(destination, newState.uid);

            var newUrl;

            if (this._updateUrl && destination && destination.hash) {
              var baseUrl = document.location.href.split("#")[0];

              if (!baseUrl.startsWith("file://")) {
                newUrl = "".concat(baseUrl, "#").concat(destination.hash);
              }
            }

            if (shouldReplace) {
              window.history.replaceState(newState, "", newUrl);
            } else {
              this._maxUid = this._uid;
              window.history.pushState(newState, "", newUrl);
            }
          }
        }, {
          key: "_tryPushCurrentPosition",
          value: function _tryPushCurrentPosition() {
            var temporary = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

            if (!this._position) {
              return;
            }

            var position = this._position;

            if (temporary) {
              position = Object.assign(Object.create(null), this._position);
              position.temporary = true;
            }

            if (!this._destination) {
              this._pushOrReplaceState(position);

              return;
            }

            if (this._destination.temporary) {
              this._pushOrReplaceState(position, true);

              return;
            }

            if (this._destination.hash === position.hash) {
              return;
            }

            if (!this._destination.page && this._numPositionUpdates <= POSITION_UPDATED_THRESHOLD) {
              return;
            }

            var forceReplace = false;

            if (this._destination.page >= position.first && this._destination.page <= position.page) {
              if (this._destination.dest || !this._destination.first) {
                return;
              }

              forceReplace = true;
            }

            this._pushOrReplaceState(position, forceReplace);
          }
        }, {
          key: "_isValidState",
          value: function _isValidState(state) {
            var checkReload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            if (!state) {
              return false;
            }

            if (state.fingerprint !== this._fingerprint) {
              if (checkReload) {
                if (typeof state.fingerprint !== "string" || state.fingerprint.length !== this._fingerprint.length) {
                  return false;
                }

                var _performance$getEntri = performance.getEntriesByType("navigation"),
                    _performance$getEntri2 = _slicedToArray(_performance$getEntri, 1),
                    perfEntry = _performance$getEntri2[0];

                if (!perfEntry || perfEntry.type !== "reload") {
                  return false;
                }
              } else {
                return false;
              }
            }

            if (!Number.isInteger(state.uid) || state.uid < 0) {
              return false;
            }

            if (state.destination === null || _typeof(state.destination) !== "object") {
              return false;
            }

            return true;
          }
        }, {
          key: "_updateInternalState",
          value: function _updateInternalState(destination, uid) {
            var removeTemporary = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

            if (this._updateViewareaTimeout) {
              clearTimeout(this._updateViewareaTimeout);
              this._updateViewareaTimeout = null;
            }

            if (removeTemporary && destination && destination.temporary) {
              delete destination.temporary;
            }

            this._destination = destination;
            this._uid = uid;
            this._numPositionUpdates = 0;
          }
        }, {
          key: "_parseCurrentHash",
          value: function _parseCurrentHash() {
            var checkNameddest = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
            var hash = unescape(getCurrentHash()).substring(1);
            var params = (0, _ui_utils.parseQueryString)(hash);
            var nameddest = params.nameddest || "";
            var page = params.page | 0;

            if (!(Number.isInteger(page) && page > 0 && page <= this.linkService.pagesCount) || checkNameddest && nameddest.length > 0) {
              page = null;
            }

            return {
              hash: hash,
              page: page,
              rotation: this.linkService.rotation
            };
          }
        }, {
          key: "_updateViewarea",
          value: function _updateViewarea(_ref14) {
            var _this11 = this;

            var location = _ref14.location;

            if (this._updateViewareaTimeout) {
              clearTimeout(this._updateViewareaTimeout);
              this._updateViewareaTimeout = null;
            }

            this._position = {
              hash: this._isViewerInPresentationMode ? "page=".concat(location.pageNumber) : location.pdfOpenParams.substring(1),
              page: this.linkService.page,
              first: location.pageNumber,
              rotation: location.rotation
            };

            if (this._popStateInProgress) {
              return;
            }

            if (this._isPagesLoaded && this._destination && !this._destination.page) {
              this._numPositionUpdates++;
            }

            {
              this._updateViewareaTimeout = setTimeout(function () {
                if (!_this11._popStateInProgress) {
                  _this11._tryPushCurrentPosition(true);
                }

                _this11._updateViewareaTimeout = null;
              }, UPDATE_VIEWAREA_TIMEOUT);
            }
          }
        }, {
          key: "_popState",
          value: function _popState(_ref15) {
            var _this12 = this;

            var state = _ref15.state;
            var newHash = getCurrentHash(),
                hashChanged = this._currentHash !== newHash;
            this._currentHash = newHash;

            if (!state) {
              this._uid++;

              var _this$_parseCurrentHa2 = this._parseCurrentHash(),
                  hash = _this$_parseCurrentHa2.hash,
                  page = _this$_parseCurrentHa2.page,
                  rotation = _this$_parseCurrentHa2.rotation;

              this._pushOrReplaceState({
                hash: hash,
                page: page,
                rotation: rotation
              }, true);

              return;
            }

            if (!this._isValidState(state)) {
              return;
            }

            this._popStateInProgress = true;

            if (hashChanged) {
              this._blockHashChange++;
              (0, _ui_utils.waitOnEventOrTimeout)({
                target: window,
                name: "hashchange",
                delay: HASH_CHANGE_TIMEOUT
              }).then(function () {
                _this12._blockHashChange--;
              });
            }

            var destination = state.destination;

            this._updateInternalState(destination, state.uid, true);

            if (this._uid > this._maxUid) {
              this._maxUid = this._uid;
            }

            if ((0, _ui_utils.isValidRotation)(destination.rotation)) {
              this.linkService.rotation = destination.rotation;
            }

            if (destination.dest) {
              this.linkService.navigateTo(destination.dest);
            } else if (destination.hash) {
              this.linkService.setHash(destination.hash);
            } else if (destination.page) {
              this.linkService.page = destination.page;
            }

            Promise.resolve().then(function () {
              _this12._popStateInProgress = false;
            });
          }
        }, {
          key: "_pageHide",
          value: function _pageHide() {
            if (!this._destination || this._destination.temporary) {
              this._tryPushCurrentPosition();
            }
          }
        }, {
          key: "_bindEvents",
          value: function _bindEvents() {
            if (this._boundEvents) {
              return;
            }

            this._boundEvents = {
              updateViewarea: this._updateViewarea.bind(this),
              popState: this._popState.bind(this),
              pageHide: this._pageHide.bind(this)
            };

            this.eventBus._on("updateviewarea", this._boundEvents.updateViewarea);

            window.addEventListener("popstate", this._boundEvents.popState);
            window.addEventListener("pagehide", this._boundEvents.pageHide);
          }
        }, {
          key: "_unbindEvents",
          value: function _unbindEvents() {
            if (!this._boundEvents) {
              return;
            }

            this.eventBus._off("updateviewarea", this._boundEvents.updateViewarea);

            window.removeEventListener("popstate", this._boundEvents.popState);
            window.removeEventListener("pagehide", this._boundEvents.pageHide);
            this._boundEvents = null;
          }
        }]);

        return PDFHistory;
      }();

      exports.PDFHistory = PDFHistory;

      function isDestHashesEqual(destHash, pushHash) {
        if (typeof destHash !== "string" || typeof pushHash !== "string") {
          return false;
        }

        if (destHash === pushHash) {
          return true;
        }

        var _ref16 = (0, _ui_utils.parseQueryString)(destHash),
            nameddest = _ref16.nameddest;

        if (nameddest === pushHash) {
          return true;
        }

        return false;
      }

      function isDestArraysEqual(firstDest, secondDest) {
        function isEntryEqual(first, second) {
          if (_typeof(first) !== _typeof(second)) {
            return false;
          }

          if (Array.isArray(first) || Array.isArray(second)) {
            return false;
          }

          if (first !== null && _typeof(first) === "object" && second !== null) {
            if (Object.keys(first).length !== Object.keys(second).length) {
              return false;
            }

            for (var key in first) {
              if (!isEntryEqual(first[key], second[key])) {
                return false;
              }
            }

            return true;
          }

          return first === second || Number.isNaN(first) && Number.isNaN(second);
        }

        if (!(Array.isArray(firstDest) && Array.isArray(secondDest))) {
          return false;
        }

        if (firstDest.length !== secondDest.length) {
          return false;
        }

        for (var i = 0, ii = firstDest.length; i < ii; i++) {
          if (!isEntryEqual(firstDest[i], secondDest[i])) {
            return false;
          }
        }

        return true;
      }
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.PDFPageView = void 0;

      var _ui_utils = __w_pdfjs_require__(3);

      var _pdfjsLib = __w_pdfjs_require__(2);

      var _pdf_rendering_queue = __w_pdfjs_require__(14);

      var _viewer_compatibility = __w_pdfjs_require__(7);

      var MAX_CANVAS_PIXELS = _viewer_compatibility.viewerCompatibilityParams.maxCanvasPixels || 16777216;

      var PDFPageView = function () {
        function PDFPageView(options) {
          _classCallCheck(this, PDFPageView);

          var container = options.container;
          var defaultViewport = options.defaultViewport;
          this.id = options.id;
          this.renderingId = "page" + this.id;
          this.pdfPage = null;
          this.pageLabel = null;
          this.rotation = 0;
          this.scale = options.scale || _ui_utils.DEFAULT_SCALE;
          this.viewport = defaultViewport;
          this.pdfPageRotate = defaultViewport.rotation;
          this._annotationStorage = options.annotationStorage || null;
          this._optionalContentConfigPromise = options.optionalContentConfigPromise || null;
          this.hasRestrictedScaling = false;
          this.textLayerMode = Number.isInteger(options.textLayerMode) ? options.textLayerMode : _ui_utils.TextLayerMode.ENABLE;
          this.imageResourcesPath = options.imageResourcesPath || "";
          this.renderInteractiveForms = typeof options.renderInteractiveForms === "boolean" ? options.renderInteractiveForms : true;
          this.useOnlyCssZoom = options.useOnlyCssZoom || false;
          this.maxCanvasPixels = options.maxCanvasPixels || MAX_CANVAS_PIXELS;
          this.eventBus = options.eventBus;
          this.renderingQueue = options.renderingQueue;
          this.textLayerFactory = options.textLayerFactory;
          this.annotationLayerFactory = options.annotationLayerFactory;
          this.renderer = options.renderer || _ui_utils.RendererType.CANVAS;
          this.enableWebGL = options.enableWebGL || false;
          this.l10n = options.l10n || _ui_utils.NullL10n;
          this.paintTask = null;
          this.paintedViewportMap = new WeakMap();
          this.renderingState = _pdf_rendering_queue.RenderingStates.INITIAL;
          this.resume = null;
          this.error = null;
          this.annotationLayer = null;
          this.textLayer = null;
          this.zoomLayer = null;
          var div = document.createElement("div");
          div.className = "page";
          div.style.width = Math.floor(this.viewport.width) + "px";
          div.style.height = Math.floor(this.viewport.height) + "px";
          div.setAttribute("data-page-number", this.id);
          this.div = div;
          container.appendChild(div);
        }

        _createClass(PDFPageView, [{
          key: "setPdfPage",
          value: function setPdfPage(pdfPage) {
            this.pdfPage = pdfPage;
            this.pdfPageRotate = pdfPage.rotate;
            var totalRotation = (this.rotation + this.pdfPageRotate) % 360;
            this.viewport = pdfPage.getViewport({
              scale: this.scale * _ui_utils.CSS_UNITS,
              rotation: totalRotation
            });
            this.stats = pdfPage.stats;
            this.reset();
          }
        }, {
          key: "destroy",
          value: function destroy() {
            this.reset();

            if (this.pdfPage) {
              this.pdfPage.cleanup();
            }
          }
        }, {
          key: "_renderAnnotationLayer",
          value: function () {
            var _renderAnnotationLayer2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee9() {
              var error;
              return regeneratorRuntime.wrap(function _callee9$(_context9) {
                while (1) {
                  switch (_context9.prev = _context9.next) {
                    case 0:
                      error = null;
                      _context9.prev = 1;
                      _context9.next = 4;
                      return this.annotationLayer.render(this.viewport, "display");

                    case 4:
                      _context9.next = 9;
                      break;

                    case 6:
                      _context9.prev = 6;
                      _context9.t0 = _context9["catch"](1);
                      error = _context9.t0;

                    case 9:
                      _context9.prev = 9;
                      this.eventBus.dispatch("annotationlayerrendered", {
                        source: this,
                        pageNumber: this.id,
                        error: error
                      });
                      return _context9.finish(9);

                    case 12:
                    case "end":
                      return _context9.stop();
                  }
                }
              }, _callee9, this, [[1, 6, 9, 12]]);
            }));

            function _renderAnnotationLayer() {
              return _renderAnnotationLayer2.apply(this, arguments);
            }

            return _renderAnnotationLayer;
          }()
        }, {
          key: "_resetZoomLayer",
          value: function _resetZoomLayer() {
            var removeFromDOM = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

            if (!this.zoomLayer) {
              return;
            }

            var zoomLayerCanvas = this.zoomLayer.firstChild;
            this.paintedViewportMap.delete(zoomLayerCanvas);
            zoomLayerCanvas.width = 0;
            zoomLayerCanvas.height = 0;

            if (removeFromDOM) {
              this.zoomLayer.remove();
            }

            this.zoomLayer = null;
          }
        }, {
          key: "reset",
          value: function reset() {
            var keepZoomLayer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
            var keepAnnotations = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
            this.cancelRendering(keepAnnotations);
            this.renderingState = _pdf_rendering_queue.RenderingStates.INITIAL;
            var div = this.div;
            div.style.width = Math.floor(this.viewport.width) + "px";
            div.style.height = Math.floor(this.viewport.height) + "px";
            var childNodes = div.childNodes;
            var currentZoomLayerNode = keepZoomLayer && this.zoomLayer || null;
            var currentAnnotationNode = keepAnnotations && this.annotationLayer && this.annotationLayer.div || null;

            for (var i = childNodes.length - 1; i >= 0; i--) {
              var node = childNodes[i];

              if (currentZoomLayerNode === node || currentAnnotationNode === node) {
                continue;
              }

              div.removeChild(node);
            }

            div.removeAttribute("data-loaded");

            if (currentAnnotationNode) {
              this.annotationLayer.hide();
            } else if (this.annotationLayer) {
              this.annotationLayer.cancel();
              this.annotationLayer = null;
            }

            if (!currentZoomLayerNode) {
              if (this.canvas) {
                this.paintedViewportMap.delete(this.canvas);
                this.canvas.width = 0;
                this.canvas.height = 0;
                delete this.canvas;
              }

              this._resetZoomLayer();
            }

            if (this.svg) {
              this.paintedViewportMap.delete(this.svg);
              delete this.svg;
            }

            this.loadingIconDiv = document.createElement("div");
            this.loadingIconDiv.className = "loadingIcon";
            div.appendChild(this.loadingIconDiv);
          }
        }, {
          key: "update",
          value: function update(scale, rotation) {
            var optionalContentConfigPromise = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
            this.scale = scale || this.scale;

            if (typeof rotation !== "undefined") {
              this.rotation = rotation;
            }

            if (optionalContentConfigPromise instanceof Promise) {
              this._optionalContentConfigPromise = optionalContentConfigPromise;
            }

            var totalRotation = (this.rotation + this.pdfPageRotate) % 360;
            this.viewport = this.viewport.clone({
              scale: this.scale * _ui_utils.CSS_UNITS,
              rotation: totalRotation
            });

            if (this.svg) {
              this.cssTransform(this.svg, true);
              this.eventBus.dispatch("pagerendered", {
                source: this,
                pageNumber: this.id,
                cssTransform: true,
                timestamp: performance.now()
              });
              return;
            }

            var isScalingRestricted = false;

            if (this.canvas && this.maxCanvasPixels > 0) {
              var outputScale = this.outputScale;

              if ((Math.floor(this.viewport.width) * outputScale.sx | 0) * (Math.floor(this.viewport.height) * outputScale.sy | 0) > this.maxCanvasPixels) {
                isScalingRestricted = true;
              }
            }

            if (this.canvas) {
              if (this.useOnlyCssZoom || this.hasRestrictedScaling && isScalingRestricted) {
                this.cssTransform(this.canvas, true);
                this.eventBus.dispatch("pagerendered", {
                  source: this,
                  pageNumber: this.id,
                  cssTransform: true,
                  timestamp: performance.now()
                });
                return;
              }

              if (!this.zoomLayer && !this.canvas.hasAttribute("hidden")) {
                this.zoomLayer = this.canvas.parentNode;
                this.zoomLayer.style.position = "absolute";
              }
            }

            if (this.zoomLayer) {
              this.cssTransform(this.zoomLayer.firstChild);
            }

            this.reset(true, true);
          }
        }, {
          key: "cancelRendering",
          value: function cancelRendering() {
            var keepAnnotations = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

            if (this.paintTask) {
              this.paintTask.cancel();
              this.paintTask = null;
            }

            this.resume = null;

            if (this.textLayer) {
              this.textLayer.cancel();
              this.textLayer = null;
            }

            if (!keepAnnotations && this.annotationLayer) {
              this.annotationLayer.cancel();
              this.annotationLayer = null;
            }
          }
        }, {
          key: "cssTransform",
          value: function cssTransform(target) {
            var redrawAnnotations = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
            var width = this.viewport.width;
            var height = this.viewport.height;
            var div = this.div;
            target.style.width = target.parentNode.style.width = div.style.width = Math.floor(width) + "px";
            target.style.height = target.parentNode.style.height = div.style.height = Math.floor(height) + "px";
            var relativeRotation = this.viewport.rotation - this.paintedViewportMap.get(target).rotation;
            var absRotation = Math.abs(relativeRotation);
            var scaleX = 1,
                scaleY = 1;

            if (absRotation === 90 || absRotation === 270) {
              scaleX = height / width;
              scaleY = width / height;
            }

            var cssTransform = "rotate(" + relativeRotation + "deg) " + "scale(" + scaleX + "," + scaleY + ")";
            target.style.transform = cssTransform;

            if (this.textLayer) {
              var textLayerViewport = this.textLayer.viewport;
              var textRelativeRotation = this.viewport.rotation - textLayerViewport.rotation;
              var textAbsRotation = Math.abs(textRelativeRotation);
              var scale = width / textLayerViewport.width;

              if (textAbsRotation === 90 || textAbsRotation === 270) {
                scale = width / textLayerViewport.height;
              }

              var textLayerDiv = this.textLayer.textLayerDiv;
              var transX, transY;

              switch (textAbsRotation) {
                case 0:
                  transX = transY = 0;
                  break;

                case 90:
                  transX = 0;
                  transY = "-" + textLayerDiv.style.height;
                  break;

                case 180:
                  transX = "-" + textLayerDiv.style.width;
                  transY = "-" + textLayerDiv.style.height;
                  break;

                case 270:
                  transX = "-" + textLayerDiv.style.width;
                  transY = 0;
                  break;

                default:
                  console.error("Bad rotation value.");
                  break;
              }

              textLayerDiv.style.transform = "rotate(" + textAbsRotation + "deg) " + "scale(" + scale + ", " + scale + ") " + "translate(" + transX + ", " + transY + ")";
              textLayerDiv.style.transformOrigin = "0% 0%";
            }

            if (redrawAnnotations && this.annotationLayer) {
              this._renderAnnotationLayer();
            }
          }
        }, {
          key: "width",
          get: function get() {
            return this.viewport.width;
          }
        }, {
          key: "height",
          get: function get() {
            return this.viewport.height;
          }
        }, {
          key: "getPagePoint",
          value: function getPagePoint(x, y) {
            return this.viewport.convertToPdfPoint(x, y);
          }
        }, {
          key: "draw",
          value: function draw() {
            var _this13 = this;

            if (this.renderingState !== _pdf_rendering_queue.RenderingStates.INITIAL) {
              console.error("Must be in new state before drawing");
              this.reset();
            }

            var div = this.div,
                pdfPage = this.pdfPage;

            if (!pdfPage) {
              this.renderingState = _pdf_rendering_queue.RenderingStates.FINISHED;

              if (this.loadingIconDiv) {
                div.removeChild(this.loadingIconDiv);
                delete this.loadingIconDiv;
              }

              return Promise.reject(new Error("pdfPage is not loaded"));
            }

            this.renderingState = _pdf_rendering_queue.RenderingStates.RUNNING;
            var canvasWrapper = document.createElement("div");
            canvasWrapper.style.width = div.style.width;
            canvasWrapper.style.height = div.style.height;
            canvasWrapper.classList.add("canvasWrapper");

            if (this.annotationLayer && this.annotationLayer.div) {
              div.insertBefore(canvasWrapper, this.annotationLayer.div);
            } else {
              div.appendChild(canvasWrapper);
            }

            var textLayer = null;

            if (this.textLayerMode !== _ui_utils.TextLayerMode.DISABLE && this.textLayerFactory) {
              var textLayerDiv = document.createElement("div");
              textLayerDiv.className = "textLayer";
              textLayerDiv.style.width = canvasWrapper.style.width;
              textLayerDiv.style.height = canvasWrapper.style.height;

              if (this.annotationLayer && this.annotationLayer.div) {
                div.insertBefore(textLayerDiv, this.annotationLayer.div);
              } else {
                div.appendChild(textLayerDiv);
              }

              textLayer = this.textLayerFactory.createTextLayerBuilder(textLayerDiv, this.id - 1, this.viewport, this.textLayerMode === _ui_utils.TextLayerMode.ENABLE_ENHANCE, this.eventBus);
            }

            this.textLayer = textLayer;
            var renderContinueCallback = null;

            if (this.renderingQueue) {
              renderContinueCallback = function renderContinueCallback(cont) {
                if (!_this13.renderingQueue.isHighestPriority(_this13)) {
                  _this13.renderingState = _pdf_rendering_queue.RenderingStates.PAUSED;

                  _this13.resume = function () {
                    _this13.renderingState = _pdf_rendering_queue.RenderingStates.RUNNING;
                    cont();
                  };

                  return;
                }

                cont();
              };
            }

            var finishPaintTask = function () {
              var _ref17 = _asyncToGenerator(regeneratorRuntime.mark(function _callee10(error) {
                return regeneratorRuntime.wrap(function _callee10$(_context10) {
                  while (1) {
                    switch (_context10.prev = _context10.next) {
                      case 0:
                        if (paintTask === _this13.paintTask) {
                          _this13.paintTask = null;
                        }

                        if (!(error instanceof _pdfjsLib.RenderingCancelledException)) {
                          _context10.next = 4;
                          break;
                        }

                        _this13.error = null;
                        return _context10.abrupt("return");

                      case 4:
                        _this13.renderingState = _pdf_rendering_queue.RenderingStates.FINISHED;

                        if (_this13.loadingIconDiv) {
                          div.removeChild(_this13.loadingIconDiv);
                          delete _this13.loadingIconDiv;
                        }

                        _this13._resetZoomLayer(true);

                        _this13.error = error;
                        _this13.stats = pdfPage.stats;

                        _this13.eventBus.dispatch("pagerendered", {
                          source: _this13,
                          pageNumber: _this13.id,
                          cssTransform: false,
                          timestamp: performance.now()
                        });

                        if (!error) {
                          _context10.next = 12;
                          break;
                        }

                        throw error;

                      case 12:
                      case "end":
                        return _context10.stop();
                    }
                  }
                }, _callee10);
              }));

              return function finishPaintTask(_x5) {
                return _ref17.apply(this, arguments);
              };
            }();

            var paintTask = this.renderer === _ui_utils.RendererType.SVG ? this.paintOnSvg(canvasWrapper) : this.paintOnCanvas(canvasWrapper);
            paintTask.onRenderContinue = renderContinueCallback;
            this.paintTask = paintTask;
            var resultPromise = paintTask.promise.then(function () {
              return finishPaintTask(null).then(function () {
                if (textLayer) {
                  var readableStream = pdfPage.streamTextContent({
                    normalizeWhitespace: true
                  });
                  textLayer.setTextContentStream(readableStream);
                  textLayer.render();
                }
              });
            }, function (reason) {
              return finishPaintTask(reason);
            });

            if (this.annotationLayerFactory) {
              if (!this.annotationLayer) {
                this.annotationLayer = this.annotationLayerFactory.createAnnotationLayerBuilder(div, pdfPage, this._annotationStorage, this.imageResourcesPath, this.renderInteractiveForms, this.l10n);
              }

              this._renderAnnotationLayer();
            }

            div.setAttribute("data-loaded", true);
            this.eventBus.dispatch("pagerender", {
              source: this,
              pageNumber: this.id
            });
            return resultPromise;
          }
        }, {
          key: "paintOnCanvas",
          value: function paintOnCanvas(canvasWrapper) {
            var renderCapability = (0, _pdfjsLib.createPromiseCapability)();
            var result = {
              promise: renderCapability.promise,
              onRenderContinue: function onRenderContinue(cont) {
                cont();
              },
              cancel: function cancel() {
                renderTask.cancel();
              }
            };
            var viewport = this.viewport;
            var canvas = document.createElement("canvas");
            this.l10n.get("page_canvas", {
              page: this.id
            }, "Page {{page}}").then(function (msg) {
              canvas.setAttribute("aria-label", msg);
            });
            canvas.setAttribute("hidden", "hidden");
            var isCanvasHidden = true;

            var showCanvas = function showCanvas() {
              if (isCanvasHidden) {
                canvas.removeAttribute("hidden");
                isCanvasHidden = false;
              }
            };

            canvasWrapper.appendChild(canvas);
            this.canvas = canvas;
            canvas.mozOpaque = true;
            var ctx = canvas.getContext("2d", {
              alpha: false
            });
            var outputScale = (0, _ui_utils.getOutputScale)(ctx);
            this.outputScale = outputScale;

            if (this.useOnlyCssZoom) {
              var actualSizeViewport = viewport.clone({
                scale: _ui_utils.CSS_UNITS
              });
              outputScale.sx *= actualSizeViewport.width / viewport.width;
              outputScale.sy *= actualSizeViewport.height / viewport.height;
              outputScale.scaled = true;
            }

            if (this.maxCanvasPixels > 0) {
              var pixelsInViewport = viewport.width * viewport.height;
              var maxScale = Math.sqrt(this.maxCanvasPixels / pixelsInViewport);

              if (outputScale.sx > maxScale || outputScale.sy > maxScale) {
                outputScale.sx = maxScale;
                outputScale.sy = maxScale;
                outputScale.scaled = true;
                this.hasRestrictedScaling = true;
              } else {
                this.hasRestrictedScaling = false;
              }
            }

            var sfx = (0, _ui_utils.approximateFraction)(outputScale.sx);
            var sfy = (0, _ui_utils.approximateFraction)(outputScale.sy);
            canvas.width = (0, _ui_utils.roundToDivide)(viewport.width * outputScale.sx, sfx[0]);
            canvas.height = (0, _ui_utils.roundToDivide)(viewport.height * outputScale.sy, sfy[0]);
            canvas.style.width = (0, _ui_utils.roundToDivide)(viewport.width, sfx[1]) + "px";
            canvas.style.height = (0, _ui_utils.roundToDivide)(viewport.height, sfy[1]) + "px";
            this.paintedViewportMap.set(canvas, viewport);
            var transform = !outputScale.scaled ? null : [outputScale.sx, 0, 0, outputScale.sy, 0, 0];
            var renderContext = {
              canvasContext: ctx,
              transform: transform,
              viewport: this.viewport,
              enableWebGL: this.enableWebGL,
              renderInteractiveForms: this.renderInteractiveForms,
              optionalContentConfigPromise: this._optionalContentConfigPromise
            };
            var renderTask = this.pdfPage.render(renderContext);

            renderTask.onContinue = function (cont) {
              showCanvas();

              if (result.onRenderContinue) {
                result.onRenderContinue(cont);
              } else {
                cont();
              }
            };

            renderTask.promise.then(function () {
              showCanvas();
              renderCapability.resolve(undefined);
            }, function (error) {
              showCanvas();
              renderCapability.reject(error);
            });
            return result;
          }
        }, {
          key: "paintOnSvg",
          value: function paintOnSvg(wrapper) {
            var _this14 = this;

            var cancelled = false;

            var ensureNotCancelled = function ensureNotCancelled() {
              if (cancelled) {
                throw new _pdfjsLib.RenderingCancelledException("Rendering cancelled, page ".concat(_this14.id), "svg");
              }
            };

            var pdfPage = this.pdfPage;
            var actualSizeViewport = this.viewport.clone({
              scale: _ui_utils.CSS_UNITS
            });
            var promise = pdfPage.getOperatorList().then(function (opList) {
              ensureNotCancelled();
              var svgGfx = new _pdfjsLib.SVGGraphics(pdfPage.commonObjs, pdfPage.objs);
              return svgGfx.getSVG(opList, actualSizeViewport).then(function (svg) {
                ensureNotCancelled();
                _this14.svg = svg;

                _this14.paintedViewportMap.set(svg, actualSizeViewport);

                svg.style.width = wrapper.style.width;
                svg.style.height = wrapper.style.height;
                _this14.renderingState = _pdf_rendering_queue.RenderingStates.FINISHED;
                wrapper.appendChild(svg);
              });
            });
            return {
              promise: promise,
              onRenderContinue: function onRenderContinue(cont) {
                cont();
              },
              cancel: function cancel() {
                cancelled = true;
              }
            };
          }
        }, {
          key: "setPageLabel",
          value: function setPageLabel(label) {
            this.pageLabel = typeof label === "string" ? label : null;

            if (this.pageLabel !== null) {
              this.div.setAttribute("data-page-label", this.pageLabel);
            } else {
              this.div.removeAttribute("data-page-label");
            }
          }
        }]);

        return PDFPageView;
      }();

      exports.PDFPageView = PDFPageView;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.PDFRenderingQueue = exports.RenderingStates = void 0;
      var CLEANUP_TIMEOUT = 30000;
      var RenderingStates = {
        INITIAL: 0,
        RUNNING: 1,
        PAUSED: 2,
        FINISHED: 3
      };
      exports.RenderingStates = RenderingStates;

      var PDFRenderingQueue = function () {
        function PDFRenderingQueue() {
          _classCallCheck(this, PDFRenderingQueue);

          this.pdfViewer = null;
          this.pdfThumbnailViewer = null;
          this.onIdle = null;
          this.highestPriorityPage = null;
          this.idleTimeout = null;
          this.printing = false;
          this.isThumbnailViewEnabled = false;
        }

        _createClass(PDFRenderingQueue, [{
          key: "setViewer",
          value: function setViewer(pdfViewer) {
            this.pdfViewer = pdfViewer;
          }
        }, {
          key: "setThumbnailViewer",
          value: function setThumbnailViewer(pdfThumbnailViewer) {
            this.pdfThumbnailViewer = pdfThumbnailViewer;
          }
        }, {
          key: "isHighestPriority",
          value: function isHighestPriority(view) {
            return this.highestPriorityPage === view.renderingId;
          }
        }, {
          key: "renderHighestPriority",
          value: function renderHighestPriority(currentlyVisiblePages) {
            if (this.idleTimeout) {
              clearTimeout(this.idleTimeout);
              this.idleTimeout = null;
            }

            if (this.pdfViewer.forceRendering(currentlyVisiblePages)) {
              return;
            }

            if (this.pdfThumbnailViewer && this.isThumbnailViewEnabled) {
              if (this.pdfThumbnailViewer.forceRendering()) {
                return;
              }
            }

            if (this.printing) {
              return;
            }

            if (this.onIdle) {
              this.idleTimeout = setTimeout(this.onIdle.bind(this), CLEANUP_TIMEOUT);
            }
          }
        }, {
          key: "getHighestPriority",
          value: function getHighestPriority(visible, views, scrolledDown) {
            var visibleViews = visible.views;
            var numVisible = visibleViews.length;

            if (numVisible === 0) {
              return null;
            }

            for (var i = 0; i < numVisible; ++i) {
              var view = visibleViews[i].view;

              if (!this.isViewFinished(view)) {
                return view;
              }
            }

            if (scrolledDown) {
              var nextPageIndex = visible.last.id;

              if (views[nextPageIndex] && !this.isViewFinished(views[nextPageIndex])) {
                return views[nextPageIndex];
              }
            } else {
              var previousPageIndex = visible.first.id - 2;

              if (views[previousPageIndex] && !this.isViewFinished(views[previousPageIndex])) {
                return views[previousPageIndex];
              }
            }

            return null;
          }
        }, {
          key: "isViewFinished",
          value: function isViewFinished(view) {
            return view.renderingState === RenderingStates.FINISHED;
          }
        }, {
          key: "renderView",
          value: function renderView(view) {
            var _this15 = this;

            switch (view.renderingState) {
              case RenderingStates.FINISHED:
                return false;

              case RenderingStates.PAUSED:
                this.highestPriorityPage = view.renderingId;
                view.resume();
                break;

              case RenderingStates.RUNNING:
                this.highestPriorityPage = view.renderingId;
                break;

              case RenderingStates.INITIAL:
                this.highestPriorityPage = view.renderingId;
                view.draw().finally(function () {
                  _this15.renderHighestPriority();
                }).catch(function (reason) {
                  console.error("renderView: \"".concat(reason, "\""));
                });
                break;
            }

            return true;
          }
        }]);

        return PDFRenderingQueue;
      }();

      exports.PDFRenderingQueue = PDFRenderingQueue;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.PDFSinglePageViewer = void 0;

      var _base_viewer = __w_pdfjs_require__(16);

      var _pdfjsLib = __w_pdfjs_require__(2);

      var PDFSinglePageViewer = function (_base_viewer$BaseView) {
        _inherits(PDFSinglePageViewer, _base_viewer$BaseView);

        var _super = _createSuper(PDFSinglePageViewer);

        function PDFSinglePageViewer(options) {
          var _this16;

          _classCallCheck(this, PDFSinglePageViewer);

          _this16 = _super.call(this, options);

          _this16.eventBus._on("pagesinit", function (evt) {
            _this16._ensurePageViewVisible();
          });

          return _this16;
        }

        _createClass(PDFSinglePageViewer, [{
          key: "_viewerElement",
          get: function get() {
            return (0, _pdfjsLib.shadow)(this, "_viewerElement", this._shadowViewer);
          }
        }, {
          key: "_resetView",
          value: function _resetView() {
            _get(_getPrototypeOf(PDFSinglePageViewer.prototype), "_resetView", this).call(this);

            this._previousPageNumber = 1;
            this._shadowViewer = document.createDocumentFragment();
            this._updateScrollDown = null;
          }
        }, {
          key: "_ensurePageViewVisible",
          value: function _ensurePageViewVisible() {
            var pageView = this._pages[this._currentPageNumber - 1];
            var previousPageView = this._pages[this._previousPageNumber - 1];
            var viewerNodes = this.viewer.childNodes;

            switch (viewerNodes.length) {
              case 0:
                this.viewer.appendChild(pageView.div);
                break;

              case 1:
                if (viewerNodes[0] !== previousPageView.div) {
                  throw new Error("_ensurePageViewVisible: Unexpected previously visible page.");
                }

                if (pageView === previousPageView) {
                  break;
                }

                this._shadowViewer.appendChild(previousPageView.div);

                this.viewer.appendChild(pageView.div);
                this.container.scrollTop = 0;
                break;

              default:
                throw new Error("_ensurePageViewVisible: Only one page should be visible at a time.");
            }

            this._previousPageNumber = this._currentPageNumber;
          }
        }, {
          key: "_scrollUpdate",
          value: function _scrollUpdate() {
            if (this._updateScrollDown) {
              this._updateScrollDown();
            }

            _get(_getPrototypeOf(PDFSinglePageViewer.prototype), "_scrollUpdate", this).call(this);
          }
        }, {
          key: "_scrollIntoView",
          value: function _scrollIntoView(_ref18) {
            var _this17 = this;

            var pageDiv = _ref18.pageDiv,
                _ref18$pageSpot = _ref18.pageSpot,
                pageSpot = _ref18$pageSpot === void 0 ? null : _ref18$pageSpot,
                _ref18$pageNumber = _ref18.pageNumber,
                pageNumber = _ref18$pageNumber === void 0 ? null : _ref18$pageNumber;

            if (pageNumber) {
              this._setCurrentPageNumber(pageNumber);
            }

            var scrolledDown = this._currentPageNumber >= this._previousPageNumber;

            this._ensurePageViewVisible();

            this.update();

            _get(_getPrototypeOf(PDFSinglePageViewer.prototype), "_scrollIntoView", this).call(this, {
              pageDiv: pageDiv,
              pageSpot: pageSpot,
              pageNumber: pageNumber
            });

            this._updateScrollDown = function () {
              _this17.scroll.down = scrolledDown;
              _this17._updateScrollDown = null;
            };
          }
        }, {
          key: "_getVisiblePages",
          value: function _getVisiblePages() {
            return this._getCurrentVisiblePage();
          }
        }, {
          key: "_updateHelper",
          value: function _updateHelper(visiblePages) {}
        }, {
          key: "_isScrollModeHorizontal",
          get: function get() {
            return (0, _pdfjsLib.shadow)(this, "_isScrollModeHorizontal", false);
          }
        }, {
          key: "_updateScrollMode",
          value: function _updateScrollMode() {}
        }, {
          key: "_updateSpreadMode",
          value: function _updateSpreadMode() {}
        }]);

        return PDFSinglePageViewer;
      }(_base_viewer.BaseViewer);

      exports.PDFSinglePageViewer = PDFSinglePageViewer;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.BaseViewer = void 0;

      var _ui_utils = __w_pdfjs_require__(3);

      var _pdf_rendering_queue = __w_pdfjs_require__(14);

      var _annotation_layer_builder = __w_pdfjs_require__(1);

      var _pdfjsLib = __w_pdfjs_require__(2);

      var _pdf_page_view = __w_pdfjs_require__(13);

      var _pdf_link_service = __w_pdfjs_require__(4);

      var _text_layer_builder = __w_pdfjs_require__(5);

      var DEFAULT_CACHE_SIZE = 10;

      function PDFPageViewBuffer(size) {
        var data = [];

        this.push = function (view) {
          var i = data.indexOf(view);

          if (i >= 0) {
            data.splice(i, 1);
          }

          data.push(view);

          if (data.length > size) {
            data.shift().destroy();
          }
        };

        this.resize = function (newSize, pagesToKeep) {
          size = newSize;

          if (pagesToKeep) {
            var pageIdsToKeep = new Set();

            for (var i = 0, iMax = pagesToKeep.length; i < iMax; ++i) {
              pageIdsToKeep.add(pagesToKeep[i].id);
            }

            (0, _ui_utils.moveToEndOfArray)(data, function (page) {
              return pageIdsToKeep.has(page.id);
            });
          }

          while (data.length > size) {
            data.shift().destroy();
          }
        };
      }

      function isSameScale(oldScale, newScale) {
        if (newScale === oldScale) {
          return true;
        }

        if (Math.abs(newScale - oldScale) < 1e-15) {
          return true;
        }

        return false;
      }

      var BaseViewer = function () {
        function BaseViewer(options) {
          var _this18 = this;

          _classCallCheck(this, BaseViewer);

          if (this.constructor === BaseViewer) {
            throw new Error("Cannot initialize BaseViewer.");
          }

          this._name = this.constructor.name;
          this.container = options.container;
          this.viewer = options.viewer || options.container.firstElementChild;

          if (!(this.container instanceof HTMLDivElement && this.viewer instanceof HTMLDivElement)) {
            throw new Error("Invalid `container` and/or `viewer` option.");
          }

          this.eventBus = options.eventBus;
          this.linkService = options.linkService || new _pdf_link_service.SimpleLinkService();
          this.downloadManager = options.downloadManager || null;
          this.findController = options.findController || null;
          this.removePageBorders = options.removePageBorders || false;
          this.textLayerMode = Number.isInteger(options.textLayerMode) ? options.textLayerMode : _ui_utils.TextLayerMode.ENABLE;
          this.imageResourcesPath = options.imageResourcesPath || "";
          this.renderInteractiveForms = typeof options.renderInteractiveForms === "boolean" ? options.renderInteractiveForms : true;
          this.enablePrintAutoRotate = options.enablePrintAutoRotate || false;
          this.renderer = options.renderer || _ui_utils.RendererType.CANVAS;
          this.enableWebGL = options.enableWebGL || false;
          this.useOnlyCssZoom = options.useOnlyCssZoom || false;
          this.maxCanvasPixels = options.maxCanvasPixels;
          this.l10n = options.l10n || _ui_utils.NullL10n;
          this.defaultRenderingQueue = !options.renderingQueue;

          if (this.defaultRenderingQueue) {
            this.renderingQueue = new _pdf_rendering_queue.PDFRenderingQueue();
            this.renderingQueue.setViewer(this);
          } else {
            this.renderingQueue = options.renderingQueue;
          }

          this.scroll = (0, _ui_utils.watchScroll)(this.container, this._scrollUpdate.bind(this));
          this.presentationModeState = _ui_utils.PresentationModeState.UNKNOWN;
          this._onBeforeDraw = this._onAfterDraw = null;

          this._resetView();

          if (this.removePageBorders) {
            this.viewer.classList.add("removePageBorders");
          }

          Promise.resolve().then(function () {
            _this18.eventBus.dispatch("baseviewerinit", {
              source: _this18
            });
          });
        }

        _createClass(BaseViewer, [{
          key: "pagesCount",
          get: function get() {
            return this._pages.length;
          }
        }, {
          key: "getPageView",
          value: function getPageView(index) {
            return this._pages[index];
          }
        }, {
          key: "pageViewsReady",
          get: function get() {
            if (!this._pagesCapability.settled) {
              return false;
            }

            return this._pages.every(function (pageView) {
              return pageView && pageView.pdfPage;
            });
          }
        }, {
          key: "currentPageNumber",
          get: function get() {
            return this._currentPageNumber;
          },
          set: function set(val) {
            if (!Number.isInteger(val)) {
              throw new Error("Invalid page number.");
            }

            if (!this.pdfDocument) {
              return;
            }

            if (!this._setCurrentPageNumber(val, true)) {
              console.error("".concat(this._name, ".currentPageNumber: \"").concat(val, "\" is not a valid page."));
            }
          }
        }, {
          key: "_setCurrentPageNumber",
          value: function _setCurrentPageNumber(val) {
            var resetCurrentPageView = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            if (this._currentPageNumber === val) {
              if (resetCurrentPageView) {
                this._resetCurrentPageView();
              }

              return true;
            }

            if (!(0 < val && val <= this.pagesCount)) {
              return false;
            }

            this._currentPageNumber = val;
            this.eventBus.dispatch("pagechanging", {
              source: this,
              pageNumber: val,
              pageLabel: this._pageLabels && this._pageLabels[val - 1]
            });

            if (resetCurrentPageView) {
              this._resetCurrentPageView();
            }

            return true;
          }
        }, {
          key: "currentPageLabel",
          get: function get() {
            return this._pageLabels && this._pageLabels[this._currentPageNumber - 1];
          },
          set: function set(val) {
            if (!this.pdfDocument) {
              return;
            }

            var page = val | 0;

            if (this._pageLabels) {
              var i = this._pageLabels.indexOf(val);

              if (i >= 0) {
                page = i + 1;
              }
            }

            if (!this._setCurrentPageNumber(page, true)) {
              console.error("".concat(this._name, ".currentPageLabel: \"").concat(val, "\" is not a valid page."));
            }
          }
        }, {
          key: "currentScale",
          get: function get() {
            return this._currentScale !== _ui_utils.UNKNOWN_SCALE ? this._currentScale : _ui_utils.DEFAULT_SCALE;
          },
          set: function set(val) {
            if (isNaN(val)) {
              throw new Error("Invalid numeric scale.");
            }

            if (!this.pdfDocument) {
              return;
            }

            this._setScale(val, false);
          }
        }, {
          key: "currentScaleValue",
          get: function get() {
            return this._currentScaleValue;
          },
          set: function set(val) {
            if (!this.pdfDocument) {
              return;
            }

            this._setScale(val, false);
          }
        }, {
          key: "pagesRotation",
          get: function get() {
            return this._pagesRotation;
          },
          set: function set(rotation) {
            if (!(0, _ui_utils.isValidRotation)(rotation)) {
              throw new Error("Invalid pages rotation angle.");
            }

            if (!this.pdfDocument) {
              return;
            }

            if (this._pagesRotation === rotation) {
              return;
            }

            this._pagesRotation = rotation;
            var pageNumber = this._currentPageNumber;

            for (var i = 0, ii = this._pages.length; i < ii; i++) {
              var pageView = this._pages[i];
              pageView.update(pageView.scale, rotation);
            }

            if (this._currentScaleValue) {
              this._setScale(this._currentScaleValue, true);
            }

            this.eventBus.dispatch("rotationchanging", {
              source: this,
              pagesRotation: rotation,
              pageNumber: pageNumber
            });

            if (this.defaultRenderingQueue) {
              this.update();
            }
          }
        }, {
          key: "firstPagePromise",
          get: function get() {
            return this.pdfDocument ? this._firstPageCapability.promise : null;
          }
        }, {
          key: "onePageRendered",
          get: function get() {
            return this.pdfDocument ? this._onePageRenderedCapability.promise : null;
          }
        }, {
          key: "pagesPromise",
          get: function get() {
            return this.pdfDocument ? this._pagesCapability.promise : null;
          }
        }, {
          key: "_viewerElement",
          get: function get() {
            throw new Error("Not implemented: _viewerElement");
          }
        }, {
          key: "_onePageRenderedOrForceFetch",
          value: function _onePageRenderedOrForceFetch() {
            if (!this.container.offsetParent || this._getVisiblePages().views.length === 0) {
              return Promise.resolve();
            }

            return this._onePageRenderedCapability.promise;
          }
        }, {
          key: "setDocument",
          value: function setDocument(pdfDocument) {
            var _this19 = this;

            if (this.pdfDocument) {
              this._cancelRendering();

              this._resetView();

              if (this.findController) {
                this.findController.setDocument(null);
              }
            }

            this.pdfDocument = pdfDocument;

            if (!pdfDocument) {
              return;
            }

            var pagesCount = pdfDocument.numPages;
            var firstPagePromise = pdfDocument.getPage(1);
            var annotationStorage = pdfDocument.annotationStorage;
            var optionalContentConfigPromise = pdfDocument.getOptionalContentConfig();

            this._pagesCapability.promise.then(function () {
              _this19.eventBus.dispatch("pagesloaded", {
                source: _this19,
                pagesCount: pagesCount
              });
            });

            this._onBeforeDraw = function (evt) {
              var pageView = _this19._pages[evt.pageNumber - 1];

              if (!pageView) {
                return;
              }

              _this19._buffer.push(pageView);
            };

            this.eventBus._on("pagerender", this._onBeforeDraw);

            this._onAfterDraw = function (evt) {
              if (evt.cssTransform || _this19._onePageRenderedCapability.settled) {
                return;
              }

              _this19._onePageRenderedCapability.resolve();

              _this19.eventBus._off("pagerendered", _this19._onAfterDraw);

              _this19._onAfterDraw = null;
            };

            this.eventBus._on("pagerendered", this._onAfterDraw);

            firstPagePromise.then(function (firstPdfPage) {
              _this19._firstPageCapability.resolve(firstPdfPage);

              _this19._optionalContentConfigPromise = optionalContentConfigPromise;
              var scale = _this19.currentScale;
              var viewport = firstPdfPage.getViewport({
                scale: scale * _ui_utils.CSS_UNITS
              });
              var textLayerFactory = _this19.textLayerMode !== _ui_utils.TextLayerMode.DISABLE ? _this19 : null;

              for (var pageNum = 1; pageNum <= pagesCount; ++pageNum) {
                var pageView = new _pdf_page_view.PDFPageView({
                  container: _this19._viewerElement,
                  eventBus: _this19.eventBus,
                  id: pageNum,
                  scale: scale,
                  defaultViewport: viewport.clone(),
                  annotationStorage: annotationStorage,
                  optionalContentConfigPromise: optionalContentConfigPromise,
                  renderingQueue: _this19.renderingQueue,
                  textLayerFactory: textLayerFactory,
                  textLayerMode: _this19.textLayerMode,
                  annotationLayerFactory: _this19,
                  imageResourcesPath: _this19.imageResourcesPath,
                  renderInteractiveForms: _this19.renderInteractiveForms,
                  renderer: _this19.renderer,
                  enableWebGL: _this19.enableWebGL,
                  useOnlyCssZoom: _this19.useOnlyCssZoom,
                  maxCanvasPixels: _this19.maxCanvasPixels,
                  l10n: _this19.l10n
                });

                _this19._pages.push(pageView);
              }

              var firstPageView = _this19._pages[0];

              if (firstPageView) {
                firstPageView.setPdfPage(firstPdfPage);

                _this19.linkService.cachePageRef(1, firstPdfPage.ref);
              }

              if (_this19._spreadMode !== _ui_utils.SpreadMode.NONE) {
                _this19._updateSpreadMode();
              }

              _this19._onePageRenderedOrForceFetch().then(function () {
                if (_this19.findController) {
                  _this19.findController.setDocument(pdfDocument);
                }

                if (pdfDocument.loadingParams.disableAutoFetch || pagesCount > 7500) {
                  _this19._pagesCapability.resolve();

                  return;
                }

                var getPagesLeft = pagesCount - 1;

                if (getPagesLeft <= 0) {
                  _this19._pagesCapability.resolve();

                  return;
                }

                var _loop2 = function _loop2(_pageNum) {
                  pdfDocument.getPage(_pageNum).then(function (pdfPage) {
                    var pageView = _this19._pages[_pageNum - 1];

                    if (!pageView.pdfPage) {
                      pageView.setPdfPage(pdfPage);
                    }

                    _this19.linkService.cachePageRef(_pageNum, pdfPage.ref);

                    if (--getPagesLeft === 0) {
                      _this19._pagesCapability.resolve();
                    }
                  }, function (reason) {
                    console.error("Unable to get page ".concat(_pageNum, " to initialize viewer"), reason);

                    if (--getPagesLeft === 0) {
                      _this19._pagesCapability.resolve();
                    }
                  });
                };

                for (var _pageNum = 2; _pageNum <= pagesCount; ++_pageNum) {
                  _loop2(_pageNum);
                }
              });

              _this19.eventBus.dispatch("pagesinit", {
                source: _this19
              });

              if (_this19.defaultRenderingQueue) {
                _this19.update();
              }
            }).catch(function (reason) {
              console.error("Unable to initialize viewer", reason);
            });
          }
        }, {
          key: "setPageLabels",
          value: function setPageLabels(labels) {
            if (!this.pdfDocument) {
              return;
            }

            if (!labels) {
              this._pageLabels = null;
            } else if (!(Array.isArray(labels) && this.pdfDocument.numPages === labels.length)) {
              this._pageLabels = null;
              console.error("".concat(this._name, ".setPageLabels: Invalid page labels."));
            } else {
              this._pageLabels = labels;
            }

            for (var i = 0, ii = this._pages.length; i < ii; i++) {
              var pageView = this._pages[i];
              var label = this._pageLabels && this._pageLabels[i];
              pageView.setPageLabel(label);
            }
          }
        }, {
          key: "_resetView",
          value: function _resetView() {
            this._pages = [];
            this._currentPageNumber = 1;
            this._currentScale = _ui_utils.UNKNOWN_SCALE;
            this._currentScaleValue = null;
            this._pageLabels = null;
            this._buffer = new PDFPageViewBuffer(DEFAULT_CACHE_SIZE);
            this._location = null;
            this._pagesRotation = 0;
            this._optionalContentConfigPromise = null;
            this._pagesRequests = new WeakMap();
            this._firstPageCapability = (0, _pdfjsLib.createPromiseCapability)();
            this._onePageRenderedCapability = (0, _pdfjsLib.createPromiseCapability)();
            this._pagesCapability = (0, _pdfjsLib.createPromiseCapability)();
            this._scrollMode = _ui_utils.ScrollMode.VERTICAL;
            this._spreadMode = _ui_utils.SpreadMode.NONE;

            if (this._onBeforeDraw) {
              this.eventBus._off("pagerender", this._onBeforeDraw);

              this._onBeforeDraw = null;
            }

            if (this._onAfterDraw) {
              this.eventBus._off("pagerendered", this._onAfterDraw);

              this._onAfterDraw = null;
            }

            this.viewer.textContent = "";

            this._updateScrollMode();
          }
        }, {
          key: "_scrollUpdate",
          value: function _scrollUpdate() {
            if (this.pagesCount === 0) {
              return;
            }

            this.update();
          }
        }, {
          key: "_scrollIntoView",
          value: function _scrollIntoView(_ref19) {
            var pageDiv = _ref19.pageDiv,
                _ref19$pageSpot = _ref19.pageSpot,
                pageSpot = _ref19$pageSpot === void 0 ? null : _ref19$pageSpot;
                _ref19.pageNumber;
            (0, _ui_utils.scrollIntoView)(pageDiv, pageSpot);
          }
        }, {
          key: "_setScaleUpdatePages",
          value: function _setScaleUpdatePages(newScale, newValue) {
            var noScroll = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
            var preset = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
            this._currentScaleValue = newValue.toString();

            if (isSameScale(this._currentScale, newScale)) {
              if (preset) {
                this.eventBus.dispatch("scalechanging", {
                  source: this,
                  scale: newScale,
                  presetValue: newValue
                });
              }

              return;
            }

            for (var i = 0, ii = this._pages.length; i < ii; i++) {
              this._pages[i].update(newScale);
            }

            this._currentScale = newScale;

            if (!noScroll) {
              var page = this._currentPageNumber,
                  dest;

              if (this._location && !(this.isInPresentationMode || this.isChangingPresentationMode)) {
                page = this._location.pageNumber;
                dest = [null, {
                  name: "XYZ"
                }, this._location.left, this._location.top, null];
              }

              this.scrollPageIntoView({
                pageNumber: page,
                destArray: dest,
                allowNegativeOffset: true
              });
            }

            this.eventBus.dispatch("scalechanging", {
              source: this,
              scale: newScale,
              presetValue: preset ? newValue : undefined
            });

            if (this.defaultRenderingQueue) {
              this.update();
            }
          }
        }, {
          key: "_setScale",
          value: function _setScale(value) {
            var noScroll = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
            var scale = parseFloat(value);

            if (scale > 0) {
              this._setScaleUpdatePages(scale, value, noScroll, false);
            } else {
              var currentPage = this._pages[this._currentPageNumber - 1];

              if (!currentPage) {
                return;
              }

              var noPadding = this.isInPresentationMode || this.removePageBorders;
              var hPadding = noPadding ? 0 : _ui_utils.SCROLLBAR_PADDING;
              var vPadding = noPadding ? 0 : _ui_utils.VERTICAL_PADDING;

              if (!noPadding && this._isScrollModeHorizontal) {
                var _ref20 = [vPadding, hPadding];
                hPadding = _ref20[0];
                vPadding = _ref20[1];
              }

              var pageWidthScale = (this.container.clientWidth - hPadding) / currentPage.width * currentPage.scale;
              var pageHeightScale = (this.container.clientHeight - vPadding) / currentPage.height * currentPage.scale;

              switch (value) {
                case "page-actual":
                  scale = 1;
                  break;

                case "page-width":
                  scale = pageWidthScale;
                  break;

                case "page-height":
                  scale = pageHeightScale;
                  break;

                case "page-fit":
                  scale = Math.min(pageWidthScale, pageHeightScale);
                  break;

                case "auto":
                  var horizontalScale = (0, _ui_utils.isPortraitOrientation)(currentPage) ? pageWidthScale : Math.min(pageHeightScale, pageWidthScale);
                  scale = Math.min(_ui_utils.MAX_AUTO_SCALE, horizontalScale);
                  break;

                default:
                  console.error("".concat(this._name, "._setScale: \"").concat(value, "\" is an unknown zoom value."));
                  return;
              }

              this._setScaleUpdatePages(scale, value, noScroll, true);
            }
          }
        }, {
          key: "_resetCurrentPageView",
          value: function _resetCurrentPageView() {
            if (this.isInPresentationMode) {
              this._setScale(this._currentScaleValue, true);
            }

            var pageView = this._pages[this._currentPageNumber - 1];

            this._scrollIntoView({
              pageDiv: pageView.div
            });
          }
        }, {
          key: "scrollPageIntoView",
          value: function scrollPageIntoView(_ref21) {
            var pageNumber = _ref21.pageNumber,
                _ref21$destArray = _ref21.destArray,
                destArray = _ref21$destArray === void 0 ? null : _ref21$destArray,
                _ref21$allowNegativeO = _ref21.allowNegativeOffset,
                allowNegativeOffset = _ref21$allowNegativeO === void 0 ? false : _ref21$allowNegativeO,
                _ref21$ignoreDestinat = _ref21.ignoreDestinationZoom,
                ignoreDestinationZoom = _ref21$ignoreDestinat === void 0 ? false : _ref21$ignoreDestinat;

            if (!this.pdfDocument) {
              return;
            }

            var pageView = Number.isInteger(pageNumber) && this._pages[pageNumber - 1];

            if (!pageView) {
              console.error("".concat(this._name, ".scrollPageIntoView: ") + "\"".concat(pageNumber, "\" is not a valid pageNumber parameter."));
              return;
            }

            if (this.isInPresentationMode || !destArray) {
              this._setCurrentPageNumber(pageNumber, true);

              return;
            }

            var x = 0,
                y = 0;
            var width = 0,
                height = 0,
                widthScale,
                heightScale;
            var changeOrientation = pageView.rotation % 180 !== 0;
            var pageWidth = (changeOrientation ? pageView.height : pageView.width) / pageView.scale / _ui_utils.CSS_UNITS;
            var pageHeight = (changeOrientation ? pageView.width : pageView.height) / pageView.scale / _ui_utils.CSS_UNITS;
            var scale = 0;

            switch (destArray[1].name) {
              case "XYZ":
                x = destArray[2];
                y = destArray[3];
                scale = destArray[4];
                x = x !== null ? x : 0;
                y = y !== null ? y : pageHeight;
                break;

              case "Fit":
              case "FitB":
                scale = "page-fit";
                break;

              case "FitH":
              case "FitBH":
                y = destArray[2];
                scale = "page-width";

                if (y === null && this._location) {
                  x = this._location.left;
                  y = this._location.top;
                }

                break;

              case "FitV":
              case "FitBV":
                x = destArray[2];
                width = pageWidth;
                height = pageHeight;
                scale = "page-height";
                break;

              case "FitR":
                x = destArray[2];
                y = destArray[3];
                width = destArray[4] - x;
                height = destArray[5] - y;
                var hPadding = this.removePageBorders ? 0 : _ui_utils.SCROLLBAR_PADDING;
                var vPadding = this.removePageBorders ? 0 : _ui_utils.VERTICAL_PADDING;
                widthScale = (this.container.clientWidth - hPadding) / width / _ui_utils.CSS_UNITS;
                heightScale = (this.container.clientHeight - vPadding) / height / _ui_utils.CSS_UNITS;
                scale = Math.min(Math.abs(widthScale), Math.abs(heightScale));
                break;

              default:
                console.error("".concat(this._name, ".scrollPageIntoView: ") + "\"".concat(destArray[1].name, "\" is not a valid destination type."));
                return;
            }

            if (!ignoreDestinationZoom) {
              if (scale && scale !== this._currentScale) {
                this.currentScaleValue = scale;
              } else if (this._currentScale === _ui_utils.UNKNOWN_SCALE) {
                this.currentScaleValue = _ui_utils.DEFAULT_SCALE_VALUE;
              }
            }

            if (scale === "page-fit" && !destArray[4]) {
              this._scrollIntoView({
                pageDiv: pageView.div,
                pageNumber: pageNumber
              });

              return;
            }

            var boundingRect = [pageView.viewport.convertToViewportPoint(x, y), pageView.viewport.convertToViewportPoint(x + width, y + height)];
            var left = Math.min(boundingRect[0][0], boundingRect[1][0]);
            var top = Math.min(boundingRect[0][1], boundingRect[1][1]);

            if (!allowNegativeOffset) {
              left = Math.max(left, 0);
              top = Math.max(top, 0);
            }

            this._scrollIntoView({
              pageDiv: pageView.div,
              pageSpot: {
                left: left,
                top: top
              },
              pageNumber: pageNumber
            });
          }
        }, {
          key: "_updateLocation",
          value: function _updateLocation(firstPage) {
            var currentScale = this._currentScale;
            var currentScaleValue = this._currentScaleValue;
            var normalizedScaleValue = parseFloat(currentScaleValue) === currentScale ? Math.round(currentScale * 10000) / 100 : currentScaleValue;
            var pageNumber = firstPage.id;
            var pdfOpenParams = "#page=" + pageNumber;
            pdfOpenParams += "&zoom=" + normalizedScaleValue;
            var currentPageView = this._pages[pageNumber - 1];
            var container = this.container;
            var topLeft = currentPageView.getPagePoint(container.scrollLeft - firstPage.x, container.scrollTop - firstPage.y);
            var intLeft = Math.round(topLeft[0]);
            var intTop = Math.round(topLeft[1]);
            pdfOpenParams += "," + intLeft + "," + intTop;
            this._location = {
              pageNumber: pageNumber,
              scale: normalizedScaleValue,
              top: intTop,
              left: intLeft,
              rotation: this._pagesRotation,
              pdfOpenParams: pdfOpenParams
            };
          }
        }, {
          key: "_updateHelper",
          value: function _updateHelper(visiblePages) {
            throw new Error("Not implemented: _updateHelper");
          }
        }, {
          key: "update",
          value: function update() {
            var visible = this._getVisiblePages();

            var visiblePages = visible.views,
                numVisiblePages = visiblePages.length;

            if (numVisiblePages === 0) {
              return;
            }

            var newCacheSize = Math.max(DEFAULT_CACHE_SIZE, 2 * numVisiblePages + 1);

            this._buffer.resize(newCacheSize, visiblePages);

            this.renderingQueue.renderHighestPriority(visible);

            this._updateHelper(visiblePages);

            this._updateLocation(visible.first);

            this.eventBus.dispatch("updateviewarea", {
              source: this,
              location: this._location
            });
          }
        }, {
          key: "containsElement",
          value: function containsElement(element) {
            return this.container.contains(element);
          }
        }, {
          key: "focus",
          value: function focus() {
            this.container.focus();
          }
        }, {
          key: "_isScrollModeHorizontal",
          get: function get() {
            return this.isInPresentationMode ? false : this._scrollMode === _ui_utils.ScrollMode.HORIZONTAL;
          }
        }, {
          key: "isInPresentationMode",
          get: function get() {
            return this.presentationModeState === _ui_utils.PresentationModeState.FULLSCREEN;
          }
        }, {
          key: "isChangingPresentationMode",
          get: function get() {
            return this.presentationModeState === _ui_utils.PresentationModeState.CHANGING;
          }
        }, {
          key: "isHorizontalScrollbarEnabled",
          get: function get() {
            return this.isInPresentationMode ? false : this.container.scrollWidth > this.container.clientWidth;
          }
        }, {
          key: "isVerticalScrollbarEnabled",
          get: function get() {
            return this.isInPresentationMode ? false : this.container.scrollHeight > this.container.clientHeight;
          }
        }, {
          key: "_getCurrentVisiblePage",
          value: function _getCurrentVisiblePage() {
            if (!this.pagesCount) {
              return {
                views: []
              };
            }

            var pageView = this._pages[this._currentPageNumber - 1];
            var element = pageView.div;
            var view = {
              id: pageView.id,
              x: element.offsetLeft + element.clientLeft,
              y: element.offsetTop + element.clientTop,
              view: pageView
            };
            return {
              first: view,
              last: view,
              views: [view]
            };
          }
        }, {
          key: "_getVisiblePages",
          value: function _getVisiblePages() {
            return (0, _ui_utils.getVisibleElements)(this.container, this._pages, true, this._isScrollModeHorizontal);
          }
        }, {
          key: "isPageVisible",
          value: function isPageVisible(pageNumber) {
            if (!this.pdfDocument) {
              return false;
            }

            if (pageNumber < 1 || pageNumber > this.pagesCount) {
              console.error("".concat(this._name, ".isPageVisible: \"").concat(pageNumber, "\" is out of bounds."));
              return false;
            }

            return this._getVisiblePages().views.some(function (view) {
              return view.id === pageNumber;
            });
          }
        }, {
          key: "cleanup",
          value: function cleanup() {
            for (var i = 0, ii = this._pages.length; i < ii; i++) {
              if (this._pages[i] && this._pages[i].renderingState !== _pdf_rendering_queue.RenderingStates.FINISHED) {
                this._pages[i].reset();
              }
            }
          }
        }, {
          key: "_cancelRendering",
          value: function _cancelRendering() {
            for (var i = 0, ii = this._pages.length; i < ii; i++) {
              if (this._pages[i]) {
                this._pages[i].cancelRendering();
              }
            }
          }
        }, {
          key: "_ensurePdfPageLoaded",
          value: function _ensurePdfPageLoaded(pageView) {
            var _this20 = this;

            if (pageView.pdfPage) {
              return Promise.resolve(pageView.pdfPage);
            }

            if (this._pagesRequests.has(pageView)) {
              return this._pagesRequests.get(pageView);
            }

            var promise = this.pdfDocument.getPage(pageView.id).then(function (pdfPage) {
              if (!pageView.pdfPage) {
                pageView.setPdfPage(pdfPage);
              }

              _this20._pagesRequests.delete(pageView);

              return pdfPage;
            }).catch(function (reason) {
              console.error("Unable to get page for page view", reason);

              _this20._pagesRequests.delete(pageView);
            });

            this._pagesRequests.set(pageView, promise);

            return promise;
          }
        }, {
          key: "forceRendering",
          value: function forceRendering(currentlyVisiblePages) {
            var _this21 = this;

            var visiblePages = currentlyVisiblePages || this._getVisiblePages();

            var scrollAhead = this._isScrollModeHorizontal ? this.scroll.right : this.scroll.down;
            var pageView = this.renderingQueue.getHighestPriority(visiblePages, this._pages, scrollAhead);

            if (pageView) {
              this._ensurePdfPageLoaded(pageView).then(function () {
                _this21.renderingQueue.renderView(pageView);
              });

              return true;
            }

            return false;
          }
        }, {
          key: "createTextLayerBuilder",
          value: function createTextLayerBuilder(textLayerDiv, pageIndex, viewport) {
            var enhanceTextSelection = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
            var eventBus = arguments.length > 4 ? arguments[4] : undefined;
            return new _text_layer_builder.TextLayerBuilder({
              textLayerDiv: textLayerDiv,
              eventBus: eventBus,
              pageIndex: pageIndex,
              viewport: viewport,
              findController: this.isInPresentationMode ? null : this.findController,
              enhanceTextSelection: this.isInPresentationMode ? false : enhanceTextSelection
            });
          }
        }, {
          key: "createAnnotationLayerBuilder",
          value: function createAnnotationLayerBuilder(pageDiv, pdfPage) {
            var annotationStorage = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
            var imageResourcesPath = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "";
            var renderInteractiveForms = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
            var l10n = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : _ui_utils.NullL10n;
            return new _annotation_layer_builder.AnnotationLayerBuilder({
              pageDiv: pageDiv,
              pdfPage: pdfPage,
              annotationStorage: annotationStorage,
              imageResourcesPath: imageResourcesPath,
              renderInteractiveForms: renderInteractiveForms,
              linkService: this.linkService,
              downloadManager: this.downloadManager,
              l10n: l10n
            });
          }
        }, {
          key: "hasEqualPageSizes",
          get: function get() {
            var firstPageView = this._pages[0];

            for (var i = 1, ii = this._pages.length; i < ii; ++i) {
              var pageView = this._pages[i];

              if (pageView.width !== firstPageView.width || pageView.height !== firstPageView.height) {
                return false;
              }
            }

            return true;
          }
        }, {
          key: "getPagesOverview",
          value: function getPagesOverview() {
            var pagesOverview = this._pages.map(function (pageView) {
              var viewport = pageView.pdfPage.getViewport({
                scale: 1
              });
              return {
                width: viewport.width,
                height: viewport.height,
                rotation: viewport.rotation
              };
            });

            if (!this.enablePrintAutoRotate) {
              return pagesOverview;
            }

            return pagesOverview.map(function (size) {
              if ((0, _ui_utils.isPortraitOrientation)(size)) {
                return size;
              }

              return {
                width: size.height,
                height: size.width,
                rotation: (size.rotation + 90) % 360
              };
            });
          }
        }, {
          key: "optionalContentConfigPromise",
          get: function get() {
            if (!this.pdfDocument) {
              return Promise.resolve(null);
            }

            if (!this._optionalContentConfigPromise) {
              return this.pdfDocument.getOptionalContentConfig();
            }

            return this._optionalContentConfigPromise;
          },
          set: function set(promise) {
            if (!(promise instanceof Promise)) {
              throw new Error("Invalid optionalContentConfigPromise: ".concat(promise));
            }

            if (!this.pdfDocument) {
              return;
            }

            if (!this._optionalContentConfigPromise) {
              return;
            }

            this._optionalContentConfigPromise = promise;

            var _iterator = _createForOfIteratorHelper(this._pages),
                _step;

            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                var pageView = _step.value;
                pageView.update(pageView.scale, pageView.rotation, promise);
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }

            this.update();
            this.eventBus.dispatch("optionalcontentconfigchanged", {
              source: this,
              promise: promise
            });
          }
        }, {
          key: "scrollMode",
          get: function get() {
            return this._scrollMode;
          },
          set: function set(mode) {
            if (this._scrollMode === mode) {
              return;
            }

            if (!(0, _ui_utils.isValidScrollMode)(mode)) {
              throw new Error("Invalid scroll mode: ".concat(mode));
            }

            this._scrollMode = mode;
            this.eventBus.dispatch("scrollmodechanged", {
              source: this,
              mode: mode
            });

            this._updateScrollMode(this._currentPageNumber);
          }
        }, {
          key: "_updateScrollMode",
          value: function _updateScrollMode() {
            var pageNumber = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
            var scrollMode = this._scrollMode,
                viewer = this.viewer;
            viewer.classList.toggle("scrollHorizontal", scrollMode === _ui_utils.ScrollMode.HORIZONTAL);
            viewer.classList.toggle("scrollWrapped", scrollMode === _ui_utils.ScrollMode.WRAPPED);

            if (!this.pdfDocument || !pageNumber) {
              return;
            }

            if (this._currentScaleValue && isNaN(this._currentScaleValue)) {
              this._setScale(this._currentScaleValue, true);
            }

            this._setCurrentPageNumber(pageNumber, true);

            this.update();
          }
        }, {
          key: "spreadMode",
          get: function get() {
            return this._spreadMode;
          },
          set: function set(mode) {
            if (this._spreadMode === mode) {
              return;
            }

            if (!(0, _ui_utils.isValidSpreadMode)(mode)) {
              throw new Error("Invalid spread mode: ".concat(mode));
            }

            this._spreadMode = mode;
            this.eventBus.dispatch("spreadmodechanged", {
              source: this,
              mode: mode
            });

            this._updateSpreadMode(this._currentPageNumber);
          }
        }, {
          key: "_updateSpreadMode",
          value: function _updateSpreadMode() {
            var pageNumber = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

            if (!this.pdfDocument) {
              return;
            }

            var viewer = this.viewer,
                pages = this._pages;
            viewer.textContent = "";

            if (this._spreadMode === _ui_utils.SpreadMode.NONE) {
              for (var i = 0, iMax = pages.length; i < iMax; ++i) {
                viewer.appendChild(pages[i].div);
              }
            } else {
              var parity = this._spreadMode - 1;
              var spread = null;

              for (var _i = 0, _iMax = pages.length; _i < _iMax; ++_i) {
                if (spread === null) {
                  spread = document.createElement("div");
                  spread.className = "spread";
                  viewer.appendChild(spread);
                } else if (_i % 2 === parity) {
                  spread = spread.cloneNode(false);
                  viewer.appendChild(spread);
                }

                spread.appendChild(pages[_i].div);
              }
            }

            if (!pageNumber) {
              return;
            }

            this._setCurrentPageNumber(pageNumber, true);

            this.update();
          }
        }]);

        return BaseViewer;
      }();

      exports.BaseViewer = BaseViewer;
    }, function (module, exports, __w_pdfjs_require__) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.PDFViewer = void 0;

      var _base_viewer = __w_pdfjs_require__(16);

      var _pdfjsLib = __w_pdfjs_require__(2);

      var PDFViewer = function (_base_viewer$BaseView2) {
        _inherits(PDFViewer, _base_viewer$BaseView2);

        var _super2 = _createSuper(PDFViewer);

        function PDFViewer() {
          _classCallCheck(this, PDFViewer);

          return _super2.apply(this, arguments);
        }

        _createClass(PDFViewer, [{
          key: "_viewerElement",
          get: function get() {
            return (0, _pdfjsLib.shadow)(this, "_viewerElement", this.viewer);
          }
        }, {
          key: "_scrollIntoView",
          value: function _scrollIntoView(_ref22) {
            var pageDiv = _ref22.pageDiv,
                _ref22$pageSpot = _ref22.pageSpot,
                pageSpot = _ref22$pageSpot === void 0 ? null : _ref22$pageSpot,
                _ref22$pageNumber = _ref22.pageNumber,
                pageNumber = _ref22$pageNumber === void 0 ? null : _ref22$pageNumber;

            if (!pageSpot && !this.isInPresentationMode) {
              var left = pageDiv.offsetLeft + pageDiv.clientLeft;
              var right = left + pageDiv.clientWidth;
              var _this$container = this.container,
                  scrollLeft = _this$container.scrollLeft,
                  clientWidth = _this$container.clientWidth;

              if (this._isScrollModeHorizontal || left < scrollLeft || right > scrollLeft + clientWidth) {
                pageSpot = {
                  left: 0,
                  top: 0
                };
              }
            }

            _get(_getPrototypeOf(PDFViewer.prototype), "_scrollIntoView", this).call(this, {
              pageDiv: pageDiv,
              pageSpot: pageSpot,
              pageNumber: pageNumber
            });
          }
        }, {
          key: "_getVisiblePages",
          value: function _getVisiblePages() {
            if (this.isInPresentationMode) {
              return this._getCurrentVisiblePage();
            }

            return _get(_getPrototypeOf(PDFViewer.prototype), "_getVisiblePages", this).call(this);
          }
        }, {
          key: "_updateHelper",
          value: function _updateHelper(visiblePages) {
            if (this.isInPresentationMode) {
              return;
            }

            var currentId = this._currentPageNumber;
            var stillFullyVisible = false;

            var _iterator2 = _createForOfIteratorHelper(visiblePages),
                _step2;

            try {
              for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                var page = _step2.value;

                if (page.percent < 100) {
                  break;
                }

                if (page.id === currentId) {
                  stillFullyVisible = true;
                  break;
                }
              }
            } catch (err) {
              _iterator2.e(err);
            } finally {
              _iterator2.f();
            }

            if (!stillFullyVisible) {
              currentId = visiblePages[0].id;
            }

            this._setCurrentPageNumber(currentId);
          }
        }]);

        return PDFViewer;
      }(_base_viewer.BaseViewer);

      exports.PDFViewer = PDFViewer;
    }]);
  });
});
var pdf_viewer_module = pdf_viewer;

delete window['pdfjs-dist/build/pdf'];

//

const MIN_SCALE = 0.1;
const MAX_SCALE = 10;

var script$g = {
    name: 'PDFViewer',
    mixins: [
        i18nWrapperMixin
    ],
    components: {
        MDIcon: __vue_component__
    },
    props: {
        url: String
    },
    inject: ['pdfjsWorkerSrc', 'pdfjsCMapUrl'],
    data() {
        return {
            mdiMinus: js.mdiMinus,
            mdiPlus: js.mdiPlus,
            pdfViewer: null,
            pdfDocument: null,
            scaleOptions: [
                { label: this._$t('verification.digitalTwin.pdfViewer.scale.auto'), value: 'auto' },
                { label: this._$t('verification.digitalTwin.pdfViewer.scale.pageActual'), value: 'page-actual' },
                { label: this._$t('verification.digitalTwin.pdfViewer.scale.pageFit'), value: 'page-fit' },
                { label: this._$t('verification.digitalTwin.pdfViewer.scale.pageWidth'), value: 'page-width' },
                { label: '50%', value: 0.5 },
                { label: '75%', value: 0.75 },
                { label: '100%', value: 1 },
                { label: '125%', value: 1.25 },
                { label: '150%', value: 1.5 },
                { label: '200%', value: 2 },
                { label: '300%', value: 3 },
                { label: '400%', value: 4 }
            ],
            currentScale: 'auto',
            customScale: { label: '', value: 0 }
        }
    },
    computed: {
        currentPage() {
            return (this.pdfViewer) ? this.pdfViewer.currentPageNumber : 0
        },
        pageCount() {
            return (this.pdfDocument) ? this.pdfDocument.numPages : 0
        }
    },
    watch: {
        currentScale() {
            this.pdfViewer.currentScaleValue = this.currentScale;
        }
    },
    methods: {
        decreaseScale() {
            let newScale = this.pdfViewer.currentScale;
            newScale -= 0.1;
            newScale = newScale.toFixed(2);
            newScale = Math.floor(newScale * 10) / 10;

            this.currentScale = (newScale < MIN_SCALE) ? MIN_SCALE : newScale;
            this.updateCustomScale();
        },
        increaseScale() {
            let newScale = this.pdfViewer.currentScale;
            newScale += 0.1;
            newScale = newScale.toFixed(2);
            newScale = Math.ceil(newScale * 10) / 10;

            this.currentScale = (newScale > MAX_SCALE) ? MAX_SCALE : newScale;
            this.updateCustomScale();
        },
        updateCustomScale() {
            if (!this.scaleOptions.find(option => option.value === this.currentScale)) {
                this.customScale.label = (this.currentScale * 100).toFixed(0) + '%';
                this.customScale.value = this.currentScale;
            }
        }
    },
    created() {
        pdf_module.GlobalWorkerOptions.workerSrc = this.pdfjsWorkerSrc;
    },
    async mounted() {
        const eventBus = new pdf_viewer_module.EventBus();
        this.pdfViewer = new pdf_viewer_module.PDFViewer({
            container: this.$refs.viewerContainer,
            eventBus
        });

        eventBus.on('pagesinit', () => {
            this.pdfViewer.currentScaleValue = this.currentScale;
        });

        const documentLoadingTask = pdf_module.getDocument({
            url: this.url,
            cMapUrl: this.pdfjsCMapUrl,
            cMapPacked: true
        });
        this.pdfDocument = await documentLoadingTask.promise;

        this.pdfViewer.setDocument(this.pdfDocument);
    }
};

/* script */
const __vue_script__$g = script$g;

/* template */
var __vue_render__$g = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"pdf-viewer"},[_c('div',{ref:"viewerContainer",staticClass:"viewer-container"},[_c('div',{staticClass:"viewer"})]),_vm._v(" "),_c('div',{staticClass:"controls"},[_c('div',{staticClass:"pages"},[_vm._v("\n            "+_vm._s(_vm._$t('verification.digitalTwin.pdfViewer.page'))+"\n            "),_c('span',{staticClass:"current"},[_vm._v(_vm._s(_vm.currentPage))]),_vm._v(" / "),_c('span',{staticClass:"total"},[_vm._v(_vm._s(_vm.pageCount))])]),_vm._v(" "),_c('div',{staticClass:"scale"},[_c('button',{staticClass:"btn secondary",attrs:{"type":"button"},on:{"click":_vm.decreaseScale}},[_c('MDIcon',{attrs:{"icon":_vm.mdiMinus}})],1),_vm._v(" "),_c('button',{staticClass:"btn secondary",attrs:{"type":"button"},on:{"click":_vm.increaseScale}},[_c('MDIcon',{attrs:{"icon":_vm.mdiPlus}})],1),_vm._v(" "),_c('select',{directives:[{name:"model",rawName:"v-model",value:(_vm.currentScale),expression:"currentScale"}],staticClass:"scale-selector",on:{"change":function($event){var $$selectedVal = Array.prototype.filter.call($event.target.options,function(o){return o.selected}).map(function(o){var val = "_value" in o ? o._value : o.value;return val}); _vm.currentScale=$event.target.multiple ? $$selectedVal : $$selectedVal[0];}}},[_vm._l((_vm.scaleOptions),function(option){return _c('option',{key:option.value,domProps:{"value":option.value}},[_vm._v(_vm._s(option.label)+"\n                ")])}),_vm._v(" "),_c('option',{staticClass:"hidden",attrs:{"disabled":""},domProps:{"value":_vm.customScale.value}},[_vm._v(_vm._s(_vm.customScale.label))])],2)])])])};
var __vue_staticRenderFns__$g = [];

  /* style */
  const __vue_inject_styles__$g = undefined;
  /* scoped */
  const __vue_scope_id__$g = undefined;
  /* module identifier */
  const __vue_module_identifier__$g = undefined;
  /* functional template */
  const __vue_is_functional_template__$g = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$g = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$g, staticRenderFns: __vue_staticRenderFns__$g },
    __vue_inject_styles__$g,
    __vue_script__$g,
    __vue_scope_id__$g,
    __vue_is_functional_template__$g,
    __vue_module_identifier__$g,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script$h = {
    name: 'VerificationItem',
    mixins: [
        i18nWrapperMixin
    ],
    components: {
        ShadowCard: __vue_component__$4,
        NotFoundCard: __vue_component__$7,
        TechnicalProblemCard: __vue_component__$8,
        FaqCard: __vue_component__$9,
        ContactCard: __vue_component__$a,
        CertifyingCard: __vue_component__$b,
        SigningCard: __vue_component__$c,
        FileConfirmationCard: __vue_component__$d,
        FileDeclinedCard: __vue_component__$e,
        FileErrorCard: __vue_component__$f,
        PDFViewer: __vue_component__$g
    },
    data() {
        return {
            showFaq: false,
            showContact: false,
            confirmationStep: true,
            digitalTwin: {
                confirmationStep: true,
                fileApproved: false
            }
        }
    },
    props: {
        verificationItem: {
            type: Object,
            required: true
        },
        verifierInformation: {
            type: Object,
            required: true
        },
        digitalTwinInformation: {
            type: Object,
            required: false
        }
    },
    computed: {
        isLoading() {
            return !this.verificationItem.hashed
        },
        isTechnicalProblem() {
            if (this.isLoading) {
                return false
            }

            if (!this.verificationItem.events || (this.verificationItem.events && this.verificationItem.events.length === 0)) {
                return (this.verificationItem.offchainError || this.verificationItem.error)
            } else {
                return (this.verificationItem.offchainError && this.verificationItem.error)
            }
        },
        isNotFound() {
            return (
                !this.isLoading &&
                !this.isTechnicalProblem &&
                (!this.verificationItem.events || (this.verificationItem.events && this.verificationItem.events.length === 0))
            )
        },
        isSigning() {
            return (this.verificationItem.events && this.verificationItem.events.filter(event => event.scope === 'sign').length > 0)
        },
        digitalTwinDownloadFileName() {
            if (!this.digitalTwinInformation.active) {
                return null
            }

            const shortHash = this.verificationItem.hash.substr(2, 8);

            return `digital_twin_${shortHash}.pdf`
        }
    },
    methods: {
        toggleHelp(type) {
            switch (type) {
                case 'faq':
                    this.showContact = false;
                    this.showFaq = !this.showFaq;
                    break
                case 'contact':
                    this.showFaq = false;
                    this.showContact = !this.showContact;
            }
        },
        digitalTwinApproveOrDecline(approved) {
            this.digitalTwin.confirmationStep = false;
            this.digitalTwin.fileApproved = approved;
        },
        digitalTwinRecheck() {
            this.digitalTwin.confirmationStep = true;
            this.digitalTwin.fileApproved = false;
            this.showFaq = false;
            this.showContact = false;
        }
    }
};

var img$6 = "data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='632.421' height='103.961' viewBox='0 0 632.421 103.961' fill='%23203346'%3e%3cpath d='M0 21.02L21.02.167 42.04 21.02 21.02 41.87zm83.226 0L104.245.167l21.02 20.852-21.02 20.852z'/%3e%3cpath d='M20.805 41.66l21.02-20.852 21.02 20.852-21.02 20.852z'/%3e%3cpath d='M62.42 41.66l21.02-20.852 21.02 20.852L83.44 62.5zM0 62.3l21.02-20.85L42.038 62.3 21.02 83.153z'/%3e%3cpath d='M20.805 82.943h42.038l-21.02 20.852z'/%3e%3cpath d='M62.632 82.733l21.02 20.852z'/%3e%3cpath d='M20.805 82.943l21.02-20.852 21.02 20.852z' opacity='.5'/%3e%3cpath d='M62.42 82.943L83.44 62.09l21.02 20.852z' opacity='.5'/%3e%3cpath d='M62.42 82.943h42.038l-21.02 20.852z'/%3e%3cpath d='M83.226 62.3l21.02-20.852 21.02 20.852-21.02 20.852zM212.98 76.812c-1.314 4.777-4.3 8.918-8.435 11.66a26 26 0 0 1-14.494 3.937 27.67 27.67 0 0 1-13.839-3.33 22.25 22.25 0 0 1-9.048-9.545 32.22 32.22 0 0 1-3.154-14.747 32.22 32.22 0 0 1 3.153-14.745c1.98-4.012 5.117-7.338 9.008-9.545a27.26 27.26 0 0 1 13.716-3.332c4.992-.158 9.933 1.05 14.3 3.493 3.903 2.327 6.783 6.04 8.066 10.4l-10.235 4.306q-1.3-4.793-4.094-6.906a12.18 12.18 0 0 0-7.534-2.112q-6.88 0-10.766 4.793-3.887 4.793-3.893 13.648 0 8.855 3.767 13.648 3.767 4.793 10.644 4.794 9.907 0 12.447-9.5zm46.76-5.7a28.6 28.6 0 0 1-.328 4.387h-28.988q1.718 8.613 10.236 8.613a11.66 11.66 0 0 0 5.814-1.3 6.95 6.95 0 0 0 3.194-3.737l9.172 3.33c-1.248 3.18-3.584 5.814-6.592 7.433a23.73 23.73 0 0 1-11.587 2.557q-10.154 0-15.723-5.567-5.57-5.567-5.57-15.55 0-9.992 5.4-15.557 5.4-5.565 15.233-5.568 9.5 0 14.617 5.443 5.117 5.443 5.12 15.516zm-19.817-12.75c-2.4-.123-4.745.727-6.5 2.356-1.773 1.923-2.853 4.382-3.07 6.988h19.08a11.72 11.72 0 0 0-3.112-6.944 8.76 8.76 0 0 0-6.387-2.4zm52.4-8.206c1.526-.084 3.048.224 4.422.893l-1.392 9.747c-1.568-.9-3.358-1.314-5.16-1.218a9.49 9.49 0 0 0-6.92 2.884q-2.907 2.884-2.907 8.083v21.043h-11.22v-40.62h9.745l.74 7.96q3.354-8.773 12.7-8.773zm37.915 38.915a14.81 14.81 0 0 1-4.954 2.437c-2.034.6-4.144.902-6.265.893q-13.674 0-13.674-12.267v-20.88H297.9v-8.287h7.454v-9.342l11.22-3.087v12.43h13.266v8.287h-13.267v19.1q0 5.605 5.65 5.605c2.306.033 4.546-.775 6.3-2.273zm12.693-43.958q-6.96 0-6.96-5.93 0-6.012 6.96-6.012 6.96 0 6.96 6.012 0 5.93-6.96 5.93zm5.57 46.47H337.3v-40.62h11.22zm25.55-40.62H387v8.287h-12.45v32.333h-11.218V59.265h-7.124v-8.287h7.124v-4.874q0-6.662 4.176-10.2 4.176-3.538 11.3-3.534c1.668-.016 3.332.175 4.954.568a10.1 10.1 0 0 1 3.562 1.544l-1.556 7.393a8.42 8.42 0 0 0-4.668-1.218q-7.044 0-7.044 6.256zm55.52 33.877a9.79 9.79 0 0 0 2.784-.325l-.82 6.746a11.82 11.82 0 0 1-5.326 1.136q-7.858 0-9.414-6.094a11.16 11.16 0 0 1-5.566 4.553c-2.847 1.1-5.88 1.614-8.928 1.544q-5.978 0-9.334-2.68a9.3 9.3 0 0 1-3.357-7.718q0-9.912 15.97-12.836l9.827-1.868v-1.954c.1-1.897-.564-3.754-1.842-5.16a6.78 6.78 0 0 0-5.118-1.91c-2.165-.095-4.307.472-6.142 1.625-1.715 1.287-2.885 3.172-3.276 5.28l-8.93-3.737a13.47 13.47 0 0 1 5.9-8.287q4.586-3.006 11.956-3.006 8.762 0 13.676 3.778 4.914 3.778 4.913 11.17v16.656c-.078.852.188 1.7.737 2.356.637.537 1.462.8 2.292.73zm-23.748 0a12.83 12.83 0 0 0 6.592-1.747 5.32 5.32 0 0 0 2.99-4.752v-4.224l-8.762 1.95a10.35 10.35 0 0 0-4.135 1.747 3.7 3.7 0 0 0-1.35 3.047c-.074 1.126.38 2.222 1.228 2.965a5.21 5.21 0 0 0 3.44 1.015zm51.918-34.7q8.107 0 12.6 3.25c2.97 2.12 5.135 5.184 6.142 8.692l-10.48 3.737q-1.474-7.393-7.943-7.393a8.86 8.86 0 0 0-7.411 3.29q-2.58 3.3-2.577 9.623.002 6.333 2.62 9.545a8.9 8.9 0 0 0 7.288 3.22q7.206 0 8.517-7.23l10.154 3.25a14.6 14.6 0 0 1-6.106 8.938q-4.8 3.33-12.407 3.33-10.154 0-15.723-5.567-5.57-5.567-5.57-15.554 0-9.992 5.527-15.557 5.527-5.565 15.357-5.563zm55.93 38.915a14.81 14.81 0 0 1-4.949 2.446 21.81 21.81 0 0 1-6.264.893q-13.676 0-13.676-12.267v-20.88h-7.46V50.98h7.452v-9.34l11.22-3.087v12.43h13.266v8.287h-13.264v19.1q0 5.605 5.65 5.605c2.306.033 4.546-.775 6.3-2.273zm12.693-43.954q-6.96 0-6.96-5.928 0-6.012 6.96-6.012 6.96 0 6.96 6.012 0 5.93-6.963 5.93zm5.568 46.47h-11.22V50.96h11.22zm30.708-41.42q9.907 0 15.437 5.605 5.53 5.605 5.528 15.517 0 9.912-5.528 15.517-5.528 5.605-15.437 5.605-9.907 0-15.436-5.605-5.53-5.605-5.523-15.517 0-9.912 5.528-15.517 5.528-5.605 15.43-5.605zm0 8.287a8.63 8.63 0 0 0-7.247 3.208q-2.5 3.208-2.5 9.623 0 6.415 2.5 9.623a8.64 8.64 0 0 0 7.245 3.209 8.63 8.63 0 0 0 7.248-3.209q2.5-3.2 2.5-9.623 0-6.414-2.5-9.623a8.64 8.64 0 0 0-7.246-3.204zm55.032-8.287q6.633 0 10.686 3.818 4.053 3.818 4.054 10.964v26.65h-11.22v-23.4q0-9.26-7.288-9.26a9.05 9.05 0 0 0-6.674 2.762q-2.743 2.762-2.743 8.45V91.59h-11.22V50.97h10.072l.328 7.23c1.24-2.523 3.2-4.617 5.65-6.012a16.72 16.72 0 0 1 8.353-2.031zM62.625 82.736l20.975 20.8H41.65z'/%3e%3c/svg%3e";

/* script */
const __vue_script__$h = script$h;
var __vue_render__$h = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"item-container",class:{ 'confirmation-step': _vm.digitalTwin.confirmationStep, 'error': _vm.digitalTwinInformation.error }},[_c('div',{staticClass:"card-container"},[(_vm.digitalTwinInformation.active)?_c('div',{staticClass:"header"},[_c('img',{attrs:{"src":img$6,"alt":"Certifaction"}})]):_vm._e(),_vm._v(" "),(_vm.isLoading)?_c('ShadowCard'):(_vm.showFaq)?_c('FaqCard',{on:{"toggle-help":_vm.toggleHelp}}):(_vm.showContact)?_c('ContactCard',{attrs:{"certifaction-api-url":_vm.verifierInformation.certifactionApiUrl},on:{"toggle-help":_vm.toggleHelp}}):(_vm.isTechnicalProblem)?_c('TechnicalProblemCard',{attrs:{"verification-item":_vm.verificationItem},on:{"toggle-help":_vm.toggleHelp}}):(_vm.isNotFound)?_c('NotFoundCard',{attrs:{"verification-item":_vm.verificationItem},on:{"toggle-help":_vm.toggleHelp}}):[(_vm.digitalTwinInformation.error)?_c('FileErrorCard',{on:{"toggle-help":_vm.toggleHelp}}):(_vm.digitalTwinInformation.active && _vm.digitalTwin.confirmationStep)?_c('FileConfirmationCard',{attrs:{"file-name":_vm.verificationItem.name},on:{"approve-or-decline":_vm.digitalTwinApproveOrDecline}}):[(_vm.digitalTwinInformation.active && !_vm.digitalTwin.fileApproved)?_c('FileDeclinedCard',{attrs:{"file-name":_vm.verificationItem.name},on:{"toggle-help":_vm.toggleHelp}}):(_vm.isSigning)?_c('SigningCard',{attrs:{"verification-item":_vm.verificationItem,"net":_vm.verifierInformation.net},on:{"toggle-help":_vm.toggleHelp}}):_c('CertifyingCard',{attrs:{"verification-item":_vm.verificationItem,"net":_vm.verifierInformation.net},on:{"toggle-help":_vm.toggleHelp}})]],_vm._v(" "),(_vm.digitalTwinInformation.active && !_vm.digitalTwin.confirmationStep)?_c('div',{staticClass:"action-box"},[_c('div',{staticClass:"actions navigate"},[_c('button',{staticClass:"btn light",on:{"click":_vm.digitalTwinRecheck}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.digitalTwin.actionBox.actions.recheck')))])]),_vm._v(" "),_c('a',{staticClass:"btn primary",attrs:{"href":_vm.digitalTwinInformation.fileUrl,"download":_vm.digitalTwinDownloadFileName}},[_c('span',[_vm._v(_vm._s(_vm._$t('verification.digitalTwin.actionBox.actions.download')))])])])]):_vm._e()],2),_vm._v(" "),(_vm.digitalTwinInformation.active && !_vm.digitalTwinInformation.error && !_vm.isLoading)?_c('PDFViewer',{attrs:{"url":_vm.digitalTwinInformation.fileUrl}}):_vm._e()],1)};
var __vue_staticRenderFns__$h = [];

  /* style */
  const __vue_inject_styles__$h = undefined;
  /* scoped */
  const __vue_scope_id__$h = undefined;
  /* module identifier */
  const __vue_module_identifier__$h = undefined;
  /* functional template */
  const __vue_is_functional_template__$h = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$h = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$h, staticRenderFns: __vue_staticRenderFns__$h },
    __vue_inject_styles__$h,
    __vue_script__$h,
    __vue_scope_id__$h,
    __vue_is_functional_template__$h,
    __vue_module_identifier__$h,
    false,
    undefined,
    undefined,
    undefined
  );

var demoDocuments = {
  notFound: {
    name: 'Demo_Document_NotFound.pdf',
    hash: '0x8db3dfe7de59e35f5f8be5fde6da543b57ccc017388def7c0a1db7af24db4abf',
    issuerAddress: null,
    issuerName: null,
    issuerImg: null,
    issuerVerified: false,
    revoked: false,
    expiry: null,
    loaded: true
  },
  technicalProblem: {
    name: 'Demo_Document_TechnicalProblem.pdf',
    hash: '0x8db3dfe7de59e35f5f8be5fde6da543b57ccc017388def7c0a1db7af24db4abf',
    issuerAddress: null,
    issuerName: null,
    issuerImg: null,
    issuerVerified: false,
    revoked: false,
    expiry: null,
    loaded: true,
    offchainError: true
  },
  verifiedProcessing: {
    hashed: true,
    name: 'Demo_Document_Verified_Processing.pdf',
    hash: '0x33e63485a8594ee7d1cfbb418a6f5acf7532faca38aa8a36b23eec8f6a53d179',
    on_blockchain: false,
    issuerAddress: undefined,
    issuerName: 'Demo University',
    issuerImg: null,
    issuerVerified: true,
    revoked: false,
    expiry: undefined,
    status: 'registering',
    loaded: true
  },
  verified: {
    hashed: true,
    name: 'Demo_Document_Verified.pdf',
    hash: '0x33e63485a8594ee7d1cfbb418a6f5acf7532faca38aa8a36b23eec8f6a53d179',
    on_blockchain: true,
    issuerAddress: '0xD0f6C73Bf87d1A00797A8A1DF2dF0Dad89D2411f',
    issuerName: 'Demo University',
    issuerImg: null,
    issuerVerified: true,
    revoked: false,
    expiry: null,
    registrationEvent: {
      address: '0x5ee4ec3cbee909050e68c7ff7a8b422cfbd72244',
      blockHash: '0xa95f5fce5e6ebfcbdb8bbd932e412fd376dc8b7189b8d8572fe9d4d8994961de',
      blockNumber: 7937331,
      transactionHash: '0x9b7e8f75ae271d8d659eb7bbd6d090fad3c784f862a5a83368fbc970bfa0a215 ',
      event: 'FileRegisteredEvent',
      signature: '0x98b03391b6b42a1d067881e3d2a22b2091e0412a0e2c40cf687d1c036beb6e11'
    },
    registrationBlock: {
      hash: '0x9b7e8f75ae271d8d659eb7bbd6d090fad3c784f862a5a83368fbc970bfa0a215',
      timestamp: 1560246087
    },
    loaded: true
  },
  verifiedSelfDeclared: {
    hashed: true,
    name: 'Demo_Document_Verified_Self_Declared.pdf',
    hash: '0x33e63485a8594ee7d1cfbb418a6f5acf7532faca38aa8a36b23eec8f6a53d179',
    on_blockchain: true,
    issuerAddress: '0xD0f6C73Bf87d1A00797A8A1DF2dF0Dad89D2411f',
    issuerName: 'Demo University',
    issuerImg: null,
    issuerVerified: false,
    revoked: false,
    expiry: null,
    registrationEvent: {
      address: '0x5ee4ec3cbee909050e68c7ff7a8b422cfbd72244',
      blockHash: '0xa95f5fce5e6ebfcbdb8bbd932e412fd376dc8b7189b8d8572fe9d4d8994961de',
      blockNumber: 7937331,
      transactionHash: '0x9b7e8f75ae271d8d659eb7bbd6d090fad3c784f862a5a83368fbc970bfa0a215 ',
      event: 'FileRegisteredEvent',
      signature: '0x98b03391b6b42a1d067881e3d2a22b2091e0412a0e2c40cf687d1c036beb6e11'
    },
    registrationBlock: {
      hash: '0x9b7e8f75ae271d8d659eb7bbd6d090fad3c784f862a5a83368fbc970bfa0a215',
      timestamp: 1560246087
    },
    loaded: true
  },
  revokedVerified: {
    hashed: true,
    name: 'Demo_Document_RevokedVerified.pdf',
    hash: '0x33e63485a8594ee7d1cfbb418a6f5acf7532faca38aa8a36b23eec8f6a53d179',
    on_blockchain: true,
    issuerAddress: '0xD0f6C73Bf87d1A00797A8A1DF2dF0Dad89D2411f',
    issuerName: 'Demo University',
    issuerImg: null,
    issuerVerified: true,
    revoked: true,
    expiry: null,
    registrationEvent: {
      address: '0x5ee4ec3cbee909050e68c7ff7a8b422cfbd72244',
      blockHash: '0xa95f5fce5e6ebfcbdb8bbd932e412fd376dc8b7189b8d8572fe9d4d8994961de',
      blockNumber: 7937331,
      transactionHash: '0x9b7e8f75ae271d8d659eb7bbd6d090fad3c784f862a5a83368fbc970bfa0a215',
      event: 'FileRegisteredEvent',
      signature: '0x98b03391b6b42a1d067881e3d2a22b2091e0412a0e2c40cf687d1c036beb6e11'
    },
    registrationBlock: {
      hash: '0x9b7e8f75ae271d8d659eb7bbd6d090fad3c784f862a5a83368fbc970bfa0a215',
      timestamp: 1560246087
    },
    revocationEvent: {
      address: '0x5ee4ec3cbee909050e68c7ff7a8b422cfbd72244',
      blockHash: '0xa95f5fce5e6ebfcbdb8bbd932e412fd376dc8b7189b8d8572fe9d4d8994961de',
      blockNumber: 7937331,
      transactionHash: '0x9b7e8f75ae271d8d659eb7bbd6d090fad3c784f862a5a83368fbc970bfa0a215',
      event: 'FileRegisteredEvent',
      signature: '0x98b03391b6b42a1d067881e3d2a22b2091e0412a0e2c40cf687d1c036beb6e11'
    },
    revocationBlock: {
      hash: '0x9b7e8f75ae271d8d659eb7bbd6d090fad3c784f862a5a83368fbc970bfa0a215',
      timestamp: 1560346087
    },
    loaded: true
  }
};

//

var script$i = {
    name: 'CertifactionVerification',
    mixins: [
        i18nWrapperMixin
    ],
    components: {
        VerificationDemo: __vue_component__$1,
        VerificationFileSelector: __vue_component__$2,
        VerificationDropBox: __vue_component__$3,
        VerificationItem: __vue_component__$h
    },
    props: {
        demo: {
            type: Boolean,
            required: false,
            default: false
        },
        pdfWasmUrl: {
            type: String,
            required: true
        },
        pdfjsWorkerSrc: {
            type: String,
            required: true
        },
        pdfjsCMapUrl: {
            type: String,
            required: true
        },
        providerUrl: {
            type: String,
            required: false
        },
        legacyContractAddress: {
            type: String,
            required: false
        },
        legacyContractFallbackAddresses: {
            type: Array,
            required: false
        },
        claimContractAddress: {
            type: String,
            required: false
        },
        acceptedIssuerKey: {
            type: String,
            required: false
        },
        certifactionApiUrl: {
            type: String,
            required: false
        },
        offchainVerifier: {
            type: Object,
            required: false,
            validator(value) {
                verificationCore.Interface.ensureImplements(value, verificationCore.VerifierInterface);
                return true
            }
        }
    },
    provide() {
        return {
            pdfjsWorkerSrc: this.pdfjsWorkerSrc,
            pdfjsCMapUrl: this.pdfjsCMapUrl
        }
    },
    data() {
        return {
            certifactionEthVerifier: new verificationCore.CertifactionEthVerifier(
                this.providerUrl,
                this.legacyContractAddress,
                this.legacyContractFallbackAddresses,
                this.claimContractAddress,
                this.acceptedIssuerKey,
                this.certifactionApiUrl
            ),
            pdfService: new verificationCore.PdfService(self.location.origin, this.pdfWasmUrl),
            verificationItems: [],
            draggingDemoDoc: undefined,
            dropbox: {
                draggingOver: false,
                dragLeaveLocked: false
            },
            itemTimeouts: {},
            digitalTwin: {
                error: false,
                fileUrl: null
            }
        }
    },
    computed: {
        filteredVerificationItems() {
            return this.verificationItems.map(item => {
                if (item.hash === undefined && !item.error) {
                    return {
                        hashed: false
                    }
                }
                return {
                    hashed: true,
                    ...item
                }
            })
        },
        verifierInformation() {
            return {
                net: this.certifactionEthVerifier.certifactionEthClient.eth.currentProvider.host.indexOf('ropsten') >= 0 ? 'ropsten.etherscan.io' : 'etherscan.io',
                certifactionApiUrl: this.certifactionApiUrl
            }
        },
        digitalTwinInformation() {
            const searchParams = new URLSearchParams(window.location.search);
            if (searchParams.has('file') && window.location.hash.length > 1) {
                return {
                    fileUrl: searchParams.get('file'),
                    decryptionKey: window.location.hash.split('#')[1]
                }
            }

            return null
        },
        digitalTwinModeActive() {
            return this.digitalTwinInformation !== null
        },
        digitalTwinStatus() {
            return { ...this.digitalTwin, ...{ active: this.digitalTwinModeActive } }
        }
    },
    methods: {
        async verify(files) {
            if (Object.values(this.itemTimeouts).length > 0) {
                Object.values(this.itemTimeouts).forEach(timeoutId => window.clearTimeout(timeoutId));
                this.itemTimeouts = {};
            }
            this.verificationItems = [];

            try {
                for (const file of files) {
                    this.verificationItems.push({ file, name: file.name });
                }

                for (const [key, item] of this.verificationItems.entries()) {
                    this.verifyItem(item, key);
                }

                await this.$nextTick();

                VueScrollTo__default['default'].scrollTo(this.$refs.results, 400);
            } catch (e) {
                console.error(`Error while verifying files: ${e.name} - ${e.message}`);
            }
        },
        async verifyItem(item, key) {
            const pdfBytes = await this.pdfService.readPdfBytes(item.file);
            const [fileHash, encryptionKeys] = await Promise.all([
                verificationCore.hashingService.hashFile(pdfBytes),
                this.pdfService.extractEncryptionKeys(pdfBytes)
            ]);
            const decryptionKey = (encryptionKeys !== null) ? encryptionKeys.claimPrivateKey : null;

            let verification = await this.certifactionEthVerifier.verify(fileHash, decryptionKey);

            if (this.offchainVerifier) {
                verification = await this.offchainVerification(verification, decryptionKey);
            }

            const oldResult = JSON.stringify(this.verificationItems[key]);
            const newResult = JSON.stringify({ ...item, ...verification });

            if (oldResult !== newResult) {
                Vue__default['default'].set(this.verificationItems, key, { ...item, ...verification });
                verification.loaded = true;
            }

            if (this.verificationItems[key].on_blockchain === false) {
                this.itemTimeouts[verification.hash] = window.setTimeout(() => {
                    this.verifyItem(item, key);
                }, 20000);
            }
        },
        async offchainVerification(verification, decryptionKey) {
            // TODO(Cyrill): Simplify offchain verification
            // Make a call to the off-chain validator
            try {
                const offchainVerification = await this.offchainVerifier.verify(verification.hash);

                if (offchainVerification) {
                    if (offchainVerification.encrypted && offchainVerification.claims && offchainVerification.claims.length > 0) {
                        const claimVerification = await this.certifactionEthVerifier.certifactionClaimVerifier.resolveAndVerifyClaims(offchainVerification.claims, decryptionKey);
                        offchainVerification.claims = claimVerification.claims;

                        if (!offchainVerification.revoked) {
                            offchainVerification.revoked = claimVerification.revoked;
                        }
                        if (!offchainVerification.issuerVerified && typeof claimVerification.issuerVerified === 'boolean') {
                            offchainVerification.issuerVerified = claimVerification.issuerVerified;
                        }
                        if (!offchainVerification.issuerAddress && claimVerification.issuerAddress) {
                            offchainVerification.issuerAddress = claimVerification.issuerAddress;
                        }
                        if (!offchainVerification.issuerName && claimVerification.issuerName) {
                            offchainVerification.issuerName = claimVerification.issuerName;
                        }
                        if (!offchainVerification.issuerVerifiedBy && claimVerification.issuerVerifiedBy) {
                            offchainVerification.issuerVerifiedBy = claimVerification.issuerVerifiedBy;
                        }
                        if (!offchainVerification.issuerVerifiedImg && claimVerification.issuerVerifiedImg) {
                            offchainVerification.issuerVerifiedImg = claimVerification.issuerVerifiedImg;
                        }

                        // Merge events from decrypted claims with the events from the verify endpoint
                        offchainVerification.events = claimVerification.events.map(claimEvent => {
                            const offchainEvent = offchainVerification.events.find(offchainEvent => offchainEvent.ref === claimEvent.ref);
                            const newEvent = { ...claimEvent };

                            if (offchainEvent.date) {
                                newEvent.date = offchainEvent.date;
                            }
                            if (offchainEvent.on_blockchain) {
                                newEvent.on_blockchain = offchainEvent.on_blockchain;
                            }

                            return newEvent
                        });
                    }

                    const identityVerifier = {};
                    if (offchainVerification.issuerVerifiedBy) {
                        identityVerifier.name = offchainVerification.issuerVerifiedBy;
                    }
                    if (offchainVerification.issuerVerifiedImg) {
                        identityVerifier.image = offchainVerification.issuerVerifiedImg;
                    }

                    if (verification.events && verification.events.length > 0 && offchainVerification.status !== 'registering') {
                        // If it's already verified on blockchain, do not override all values;
                        // just issuerName & issuer verifier can be taken from off-chain information
                        if (!verification.issuerName && offchainVerification.issuerName) {
                            verification.issuerName = offchainVerification.issuerName;
                        }
                        if (!verification.issuerVerified && typeof offchainVerification.issuerVerified === 'boolean') {
                            verification.issuerVerified = offchainVerification.issuerVerified;
                        }
                        if (!verification.issuerVerifiedBy && offchainVerification.issuerVerifiedBy) {
                            verification.issuerVerifiedBy = offchainVerification.issuerVerifiedBy;
                        }
                        if (!verification.issuerVerifiedImg && offchainVerification.issuerVerifiedImg) {
                            verification.issuerVerifiedImg = offchainVerification.issuerVerifiedImg;
                        }

                        if (typeof offchainVerification.on_blockchain === 'boolean') {
                            verification.on_blockchain = offchainVerification.on_blockchain;
                        }
                        if (typeof offchainVerification.revoked === 'boolean') {
                            verification.revoked = offchainVerification.revoked;
                        }

                        if (offchainVerification.events.length > 0) {
                            const mergedEvents = [];

                            verification.events = verification.events.map(event => {
                                const offchainEvent = offchainVerification.events.find(offchainEvent => offchainEvent.ref === event.ref);

                                if (!offchainEvent) {
                                    return event
                                }

                                const newEvent = { ...event };

                                if (offchainEvent.issuer) {
                                    const issuer = { ...event.issuer };
                                    if (!issuer.id && offchainEvent.issuer.id) {
                                        issuer.id = offchainEvent.issuer.id;
                                    }
                                    if (!issuer.name && offchainEvent.issuer.name) {
                                        issuer.name = offchainEvent.issuer.name;
                                    }

                                    if (offchainEvent.issuer.verified_by) {
                                        const verifiedBy = { ...event.issuer.verified_by };
                                        if (!verifiedBy.name && offchainEvent.issuer.verified_by.name) {
                                            verifiedBy.name = offchainEvent.issuer.verified_by.name;
                                        }
                                        if (!verifiedBy.image && offchainEvent.issuer.verified_by.image) {
                                            verifiedBy.image = offchainEvent.issuer.verified_by.image;
                                        } else if (!verifiedBy.image && offchainVerification.issuerVerifiedImg) {
                                            verifiedBy.image = offchainVerification.issuerVerifiedImg;
                                        }

                                        issuer.verified = true;
                                        issuer.verified_by = verifiedBy;
                                    }

                                    newEvent.issuer = issuer;
                                }

                                mergedEvents.push(offchainEvent.ref);

                                return newEvent
                            });

                            const unknownOffchainEvents = offchainVerification.events.filter(offchainEvent => mergedEvents.indexOf(offchainEvent.ref) < 0);
                            verification.events = [
                                ...verification.events,
                                ...unknownOffchainEvents
                            ];
                        }
                    } else {
                        // File not found on blockchain and offchain status is registering
                        verification = {
                            ...verification,
                            ...offchainVerification
                        };
                    }
                }
            } catch (e) {
                console.error(`Error while verifying by offchain verification: ${e.name} - ${e.message}`);
                verification.offchainError = true;
            }

            console.log(`Verification result for file ${verification.hash}:`, JSON.parse(JSON.stringify(verification)));

            return verification
        },
        async processDigitalTwinUrl() {
            if (!this.digitalTwinInformation.decryptionKey) {
                console.log('No decryption key');
                this.digitalTwin.error = true;
                return
            }

            axios__default['default'].defaults.headers.common['Certifaction-Analytics-Dt'] = true;

            try {
                const response = await axios__default['default'].get(this.digitalTwinInformation.fileUrl, { responseType: 'blob' });

                if (response.status === 200) {
                    const encryptedArrayBuffer = await response.data.arrayBuffer();
                    const decryptedPdfBytes = await this.pdfService.decryptPdf(new Uint8Array(encryptedArrayBuffer), this.digitalTwinInformation.decryptionKey);
                    const decryptedFile = new File([decryptedPdfBytes.buffer], '', {
                        type: 'application/pdf'
                    });

                    const filesNew = [];
                    filesNew.push(decryptedFile);

                    await this.verify(filesNew);

                    this.digitalTwin.fileUrl = URL.createObjectURL(decryptedFile);
                } else {
                    this.digitalTwin.error = true;
                }
            } catch (e) {
                console.error(`Error while processing digital twin url: ${e.name} - ${e.message}`);
                this.digitalTwin.error = true;
            }
        },
        onDraggingDemoDoc(demoDoc) {
            this.draggingDemoDoc = demoDoc;
        },
        async verifyDemo(type) {
            if (demoDocuments[type]) {
                this.verificationItems = [demoDocuments[type]];
                await this.$nextTick();
                VueScrollTo__default['default'].scrollTo(this.$refs.results, 400);
            }
        },
        handleDrop(e) {
            if (this.digitalTwinModeActive) {
                return
            }

            this.dropbox.draggingOver = false;
            this.verify(e.dataTransfer.files);
        },
        async dragOver() {
            if (this.digitalTwinModeActive) {
                return
            }

            if (!this.dropbox.draggingOver) {
                this.dropbox.draggingOver = true;
                this.dropbox.dragLeaveLocked = true;

                window.setTimeout(() => {
                    this.dropbox.dragLeaveLocked = false;
                }, 100);
            }
        },
        dragLeave() {
            if (!this.dropbox.dragLeaveLocked) {
                this.dropbox.draggingOver = false;
            }
        }
    },
    async mounted() {
        if (this.digitalTwinInformation) {
            await this.processDigitalTwinUrl();
        }
    }
};

/* script */
const __vue_script__$i = script$i;
var __vue_render__$i = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"certifaction-verification",class:{ dragover: _vm.dropbox.draggingOver },on:{"dragover":function($event){$event.preventDefault();return _vm.dragOver($event)},"dragleave":_vm.dragLeave,"drop":function($event){$event.preventDefault();return _vm.handleDrop($event)}}},[(!_vm.digitalTwinModeActive)?_c('VerificationDropBox',{attrs:{"first-verification":_vm.filteredVerificationItems.length === 0}}):_vm._e(),_vm._v(" "),(_vm.demo !== false && !_vm.digitalTwinModeActive)?_c('VerificationDemo',{on:{"verify-demo":_vm.verifyDemo,"dragging-demo-doc":_vm.onDraggingDemoDoc}}):_vm._e(),_vm._v(" "),(_vm.filteredVerificationItems.length)?_c('div',{ref:"results",staticClass:"verification-item-list",class:{ 'digital-twin': _vm.digitalTwinModeActive }},_vm._l((_vm.filteredVerificationItems),function(verificationItem){return _c('VerificationItem',{key:verificationItem.hash,attrs:{"verification-item":verificationItem,"verifier-information":_vm.verifierInformation,"digital-twin-information":_vm.digitalTwinStatus}})}),1):_vm._e(),_vm._v(" "),(!_vm.digitalTwinModeActive)?_c('VerificationFileSelector',{attrs:{"first-verification":_vm.filteredVerificationItems.length === 0},on:{"files-selected":_vm.verify}}):_vm._e(),_vm._v(" "),(!_vm.digitalTwinModeActive)?_c('div',{staticClass:"powered-by"},[_c('span',{staticClass:"label"},[_vm._v(_vm._s(_vm._$t('verification.poweredBy.label')))]),_vm._v(" "),_vm._m(0)]):_vm._e()],1)};
var __vue_staticRenderFns__$i = [function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('a',{attrs:{"href":"https://certifaction.com","target":"_blank"}},[_c('img',{attrs:{"src":img$6,"alt":"Certifaction"}})])}];

  /* style */
  const __vue_inject_styles__$i = undefined;
  /* scoped */
  const __vue_scope_id__$i = undefined;
  /* module identifier */
  const __vue_module_identifier__$i = undefined;
  /* functional template */
  const __vue_is_functional_template__$i = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$i = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$i, staticRenderFns: __vue_staticRenderFns__$i },
    __vue_inject_styles__$i,
    __vue_script__$i,
    __vue_scope_id__$i,
    __vue_is_functional_template__$i,
    __vue_module_identifier__$i,
    false,
    undefined,
    undefined,
    undefined
  );

exports.CertifactionVerification = __vue_component__$i;
//# sourceMappingURL=verification-vue-component.common.js.map
